/*
 * $QNXLicenseC: 
 * Copyright 2007, QNX Software Systems.  
 *  
 * Licensed under the Apache License, Version 2.0 (the "License"). You  
 * may not reproduce, modify or distribute this software except in  
 * compliance with the License. You may obtain a copy of the License  
 * at: http://www.apache.org/licenses/LICENSE-2.0  
 *  
 * Unless required by applicable law or agreed to in writing, software  
 * distributed under the License is distributed on an "AS IS" basis,  
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied. 
 * 
 * This file may contain contributions from others, either as  
 * contributors under the License or as licensors under other terms.   
 * Please review this entire file for other proprietary rights or license  
 * notices, as well as the QNX Development Suite License Guide at  
 * http://licensing.qnx.com/license-guide/ for other information. 
 * $ 
 */





#ifdef DEFN
	#define EXT
	#define INIT1(a)				= { a }
#else
	#define EXT extern
	#define INIT1(a)
#endif

#include <stdio.h>
#include <errno.h>
#include <signal.h>
#include <malloc.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/neutrino.h>
#include <termios.h>
#include <devctl.h>
#include <sys/dcmd_chr.h>
#include <sys/iomsg.h>
#include <atomic.h>
#include <hw/inout.h>
#include <hw/8250.h>
#include <sys/io-char.h>

typedef struct dev_8250 {
	TTYDEV			tty;
	struct dev_8250	*next;
	unsigned		intr;
	unsigned		clk;
	unsigned		div;
	unsigned char	rx_fifo; /* rx fifo size */
	unsigned char	tx_fifo; /* tx fifo size */
	unsigned char	fifo_override; /* fifo transmit override */
	uintptr_t		port[REG_MS+1];
} DEV_8250;

struct dev_list {
	struct dev_list	*next;
	DEV_8250		*device;
	int				iid;
};

EXT TTYCTRL						ttyctrl;
EXT struct dev_list				*devices;

/* Value used as an argument to TTO to override the check if the tx buffer
 * is empty.  This should only be used in the isr at the tx interrupt 
 * since this is the only time we can be sure that the tx fifo is empty.
 * This is required since there is no way to determine the number of char's
 * in the TX fifo - i.e. the amount of free space in the TX fifo.
 * Since the TX buffer empty flag is cleared in the II REG on both reading
 * the II REG and writing to the TX fifo, there shouldn't be any issues 
 * regarding nested TX interrupts overwriting data in the TX fifo. */
#define FIFO_XMIT_OVERRIDE		0x80

#include "proto.h"
#include <variant.h>

