/*
 * $QNXLicenseC: 
 * Copyright 2007, QNX Software Systems.  
 *  
 * Licensed under the Apache License, Version 2.0 (the "License"). You  
 * may not reproduce, modify or distribute this software except in  
 * compliance with the License. You may obtain a copy of the License  
 * at: http://www.apache.org/licenses/LICENSE-2.0  
 *  
 * Unless required by applicable law or agreed to in writing, software  
 * distributed under the License is distributed on an "AS IS" basis,  
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied. 
 * 
 * This file may contain contributions from others, either as  
 * contributors under the License or as licensors under other terms.   
 * Please review this entire file for other proprietary rights or license  
 * notices, as well as the QNX Development Suite License Guide at  
 * http://licensing.qnx.com/license-guide/ for other information. 
 * $ 
 */






/*
** File: f3s_usage.c
**
** Description:
**
** This file contains the usage function for the f3s flash file system
**
** Ident: $Id: usage.c,v 1.31.2.1 2005/07/08 13:35:35 mkisel Exp $
**
*/

/*
** Includes
*/

#include <sys/f3s_api.h>
#include <libc.h>

/*
** Function: f3s_usage
*/

void f3s_usage(int argc,
               char **argv,
               uint8_t *message)
{
  int error=EOK;

  /* check if a message is wanted */

  if (message)
  {
    error=EINVAL;

    printf("%s: invalid %s\n", *argv, message);
  }

  exit(error);
}

/*
** End
*/

