/*
 * $QNXLicenseC: 
 * Copyright 2007, QNX Software Systems.  
 *  
 * Licensed under the Apache License, Version 2.0 (the "License"). You  
 * may not reproduce, modify or distribute this software except in  
 * compliance with the License. You may obtain a copy of the License  
 * at: http://www.apache.org/licenses/LICENSE-2.0  
 *  
 * Unless required by applicable law or agreed to in writing, software  
 * distributed under the License is distributed on an "AS IS" basis,  
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied. 
 * 
 * This file may contain contributions from others, either as  
 * contributors under the License or as licensors under other terms.   
 * Please review this entire file for other proprietary rights or license  
 * notices, as well as the QNX Development Suite License Guide at  
 * http://licensing.qnx.com/license-guide/ for other information. 
 * $ 
 */


typedef struct _PCI_VENTABLE
{
	unsigned short	VenId ;
	char *	VenShort ;
	char *	VenFull ;
}  PCI_VENTABLE, *PPCI_VENTABLE ;

PCI_VENTABLE	PciVenTable [] =
{
	{ 0x0000, "", "Gammagraphx, Inc." } ,
	{ 0x001A, "", "Ascend Communications, Inc." } ,
	{ 0x0033, "", "Paradyne corp." } ,
	{ 0x003D, "", "Lockheed Martin-Marietta Corp" } ,
	{ 0x0059, "", "Tiger Jet Network Inc. (Wrong ID)" } ,
	{ 0x0070, "", "Hauppauge computer works Inc." } ,
	{ 0x0071, "", "Nebula Electronics Ltd." } ,
	{ 0x0095, "", "Silicon Image, Inc. (Wrong ID)" } ,
	{ 0x00A7, "", "Teles AG (Wrong ID)" } ,
	{ 0x0100, "", "Ncipher Corp Ltd" } ,
	{ 0x018A, "", "LevelOne" } ,
	{ 0x021B, "", "Compaq Computer Corporation" } ,
	{ 0x0270, "", "Hauppauge computer works Inc. (Wrong ID)" } ,
	{ 0x0291, "", "Davicom Semiconductor, Inc." } ,
	{ 0x02AC, "", "SpeedStream" } ,
	{ 0x0357, "", "TTTech AG" } ,
	{ 0x0432, "", "SCM Microsystems, Inc." } ,
	{ 0x045E, "", "Microsoft" } ,
	{ 0x04CF, "", "Myson Century, Inc" } ,
	{ 0x05E3, "", "CyberDoor" } ,
	{ 0x0675, "", "Dynalink" } ,
	{ 0x067B, "", "Prolific Technology, Inc." } ,
	{ 0x07E2, "", "ELMEG Communication Systems GmbH" } ,
	{ 0x0925, "", "VIA Technologies, Inc. (Wrong ID)" } ,
	{ 0x09C1, "", "Arris" } ,
	{ 0x0A89, "", "BREA Technologies Inc" } ,
	{ 0x0B49, "", "ASCII Corporation" } ,
	{ 0x0E11, "", "Compaq Computer Corporation" } ,
	{ 0x0E55, "", "HaSoTec GmbH" } ,
	{ 0x1000, "", "LSI Logic / Symbios Logic" } ,
	{ 0x1001, "", "Kolter Electronic" } ,
	{ 0x1002, "", "ATI Technologies Inc" } ,
	{ 0x1003, "", "ULSI Systems" } ,
	{ 0x1004, "", "VLSI Technology Inc" } ,
	{ 0x1005, "", "Avance Logic Inc. [ALI]" } ,
	{ 0x1006, "", "Reply Group" } ,
	{ 0x1007, "", "NetFrame Systems Inc" } ,
	{ 0x1008, "", "Epson" } ,
	{ 0x100A, "", "Phoenix Technologies" } ,
	{ 0x100B, "", "National Semiconductor Corporation" } ,
	{ 0x100C, "", "Tseng Labs Inc" } ,
	{ 0x100D, "", "AST Research Inc" } ,
	{ 0x100E, "", "Weitek" } ,
	{ 0x1010, "", "Video Logic, Ltd." } ,
	{ 0x1011, "", "Digital Equipment Corporation" } ,
	{ 0x1012, "", "Micronics Computers Inc" } ,
	{ 0x1013, "", "Cirrus Logic" } ,
	{ 0x1014, "", "IBM" } ,
	{ 0x1015, "", "LSI Logic Corp of Canada" } ,
	{ 0x1016, "", "ICL Personal Systems" } ,
	{ 0x1017, "", "SPEA Software AG" } ,
	{ 0x1018, "", "Unisys Systems" } ,
	{ 0x1019, "", "Elitegroup Computer Systems" } ,
	{ 0x101A, "", "AT&T GIS (NCR)" } ,
	{ 0x101B, "", "Vitesse Semiconductor" } ,
	{ 0x101C, "", "Western Digital" } ,
	{ 0x101E, "", "American Megatrends Inc." } ,
	{ 0x101F, "", "PictureTel" } ,
	{ 0x1020, "", "Hitachi Computer Products" } ,
	{ 0x1021, "", "OKI Electric Industry Co. Ltd." } ,
	{ 0x1022, "", "Advanced Micro Devices [AMD]" } ,
	{ 0x1023, "", "Trident Microsystems" } ,
	{ 0x1024, "", "Zenith Data Systems" } ,
	{ 0x1025, "", "Acer Incorporated [ALI]" } ,
	{ 0x1028, "", "Dell" } ,
	{ 0x1029, "", "Siemens Nixdorf IS" } ,
	{ 0x102A, "", "LSI Logic" } ,
	{ 0x102B, "", "Matrox Graphics, Inc." } ,
	{ 0x102C, "", "Chips and Technologies" } ,
	{ 0x102D, "", "Wyse Technology Inc." } ,
	{ 0x102E, "", "Olivetti Advanced Technology" } ,
	{ 0x102F, "", "Toshiba America" } ,
	{ 0x1030, "", "TMC Research" } ,
	{ 0x1031, "", "Miro Computer Products AG" } ,
	{ 0x1032, "", "Compaq" } ,
	{ 0x1033, "", "NEC Corporation" } ,
	{ 0x1034, "", "Framatome Connectors USA Inc." } ,
	{ 0x1035, "", "Comp. & Comm. Research Lab" } ,
	{ 0x1036, "", "Future Domain Corp." } ,
	{ 0x1037, "", "Hitachi Micro Systems" } ,
	{ 0x1038, "", "AMP, Inc" } ,
	{ 0x1039, "", "Silicon Integrated Systems [SiS]" } ,
	{ 0x103A, "", "Seiko Epson Corporation" } ,
	{ 0x103B, "", "Tatung Co. of America" } ,
	{ 0x103C, "", "Hewlett-Packard Company" } ,
	{ 0x103E, "", "Solliday Engineering" } ,
	{ 0x103F, "", "Synopsys/Logic Modeling Group" } ,
	{ 0x1040, "", "Accelgraphics Inc." } ,
	{ 0x1041, "", "Computrend" } ,
	{ 0x1042, "", "Micron" } ,
	{ 0x1043, "", "ASUSTeK Computer Inc." } ,
	{ 0x1044, "", "Adaptec (formerly DPT)" } ,
	{ 0x1045, "", "OPTi Inc." } ,
	{ 0x1046, "", "IPC Corporation, Ltd." } ,
	{ 0x1047, "", "Genoa Systems Corp" } ,
	{ 0x1048, "", "Elsa AG" } ,
	{ 0x1049, "", "Fountain Technologies, Inc." } ,
	{ 0x104A, "", "STMicroelectronics" } ,
	{ 0x104B, "", "BusLogic" } ,
	{ 0x104C, "", "Texas Instruments" } ,
	{ 0x104D, "", "Sony Corporation" } ,
	{ 0x104E, "", "Oak Technology, Inc" } ,
	{ 0x104F, "", "Co-time Computer Ltd" } ,
	{ 0x1050, "", "Winbond Electronics Corp" } ,
	{ 0x1051, "", "Anigma, Inc." } ,
	{ 0x1052, "", "?Young Micro Systems" } ,
	{ 0x1053, "", "Young Micro Systems" } ,
	{ 0x1054, "", "Hitachi, Ltd" } ,
	{ 0x1055, "", "Efar Microsystems" } ,
	{ 0x1056, "", "ICL" } ,
	{ 0x1057, "", "Motorola" } ,
	{ 0x1058, "", "Electronics & Telecommunications RSH" } ,
	{ 0x1059, "", "Teknor Industrial Computers Inc" } ,
	{ 0x105A, "", "Promise Technology, Inc." } ,
	{ 0x105B, "", "Foxconn International, Inc." } ,
	{ 0x105C, "", "Wipro Infotech Limited" } ,
	{ 0x105D, "", "Number 9 Computer Company" } ,
	{ 0x105E, "", "Vtech Computers Ltd" } ,
	{ 0x105F, "", "Infotronic America Inc" } ,
	{ 0x1060, "", "United Microelectronics [UMC]" } ,
	{ 0x1061, "", "I.I.T." } ,
	{ 0x1062, "", "Maspar Computer Corp" } ,
	{ 0x1063, "", "Ocean Office Automation" } ,
	{ 0x1064, "", "Alcatel" } ,
	{ 0x1065, "", "Texas Microsystems" } ,
	{ 0x1066, "", "PicoPower Technology" } ,
	{ 0x1067, "", "Mitsubishi Electric" } ,
	{ 0x1068, "", "Diversified Technology" } ,
	{ 0x1069, "", "Mylex Corporation" } ,
	{ 0x106A, "", "Aten Research Inc" } ,
	{ 0x106B, "", "Apple Computer Inc." } ,
	{ 0x106C, "", "Hynix Semiconductor" } ,
	{ 0x106D, "", "Sequent Computer Systems" } ,
	{ 0x106E, "", "DFI, Inc" } ,
	{ 0x106F, "", "City Gate Development Ltd" } ,
	{ 0x1070, "", "Daewoo Telecom Ltd" } ,
	{ 0x1071, "", "Mitac" } ,
	{ 0x1072, "", "GIT Co Ltd" } ,
	{ 0x1073, "", "Yamaha Corporation" } ,
	{ 0x1074, "", "NexGen Microsystems" } ,
	{ 0x1075, "", "Advanced Integrations Research" } ,
	{ 0x1076, "", "Chaintech Computer Co. Ltd" } ,
	{ 0x1077, "", "QLogic Corp." } ,
	{ 0x1078, "", "Cyrix Corporation" } ,
	{ 0x1079, "", "I-Bus" } ,
	{ 0x107A, "", "NetWorth" } ,
	{ 0x107B, "", "Gateway 2000" } ,
	{ 0x107C, "", "LG Electronics [Lucky Goldstar Co. Ltd]" } ,
	{ 0x107D, "", "LeadTek Research Inc." } ,
	{ 0x107E, "", "Interphase Corporation" } ,
	{ 0x107F, "", "Data Technology Corporation" } ,
	{ 0x1080, "", "Contaq Microsystems" } ,
	{ 0x1081, "", "Supermac Technology" } ,
	{ 0x1082, "", "EFA Corporation of America" } ,
	{ 0x1083, "", "Forex Computer Corporation" } ,
	{ 0x1084, "", "Parador" } ,
	{ 0x1085, "", "Tulip Computers Int.B.V." } ,
	{ 0x1086, "", "J. Bond Computer Systems" } ,
	{ 0x1087, "", "Cache Computer" } ,
	{ 0x1088, "", "Microcomputer Systems (M) Son" } ,
	{ 0x1089, "", "Data General Corporation" } ,
	{ 0x108A, "", "SBS Technologies" } ,
	{ 0x108C, "", "Oakleigh Systems Inc." } ,
	{ 0x108D, "", "Olicom" } ,
	{ 0x108E, "", "Sun Microsystems Computer Corp." } ,
	{ 0x108F, "", "Systemsoft" } ,
	{ 0x1090, "", "Compro Computer Services, Inc." } ,
	{ 0x1091, "", "Intergraph Corporation" } ,
	{ 0x1092, "", "Diamond Multimedia Systems" } ,
	{ 0x1093, "", "National Instruments" } ,
	{ 0x1094, "", "First International Computers [FIC]" } ,
	{ 0x1095, "", "Silicon Image, Inc." } ,
	{ 0x1096, "", "Alacron" } ,
	{ 0x1097, "", "Appian Technology" } ,
	{ 0x1098, "", "Quantum Designs (H.K.) Ltd" } ,
	{ 0x1099, "", "Samsung Electronics Co., Ltd" } ,
	{ 0x109A, "", "Packard Bell" } ,
	{ 0x109B, "", "Gemlight Computer Ltd." } ,
	{ 0x109C, "", "Megachips Corporation" } ,
	{ 0x109D, "", "Zida Technologies Ltd." } ,
	{ 0x109E, "", "Brooktree Corporation" } ,
	{ 0x109F, "", "Trigem Computer Inc." } ,
	{ 0x10A0, "", "Meidensha Corporation" } ,
	{ 0x10A1, "", "Juko Electronics Ind. Co. Ltd" } ,
	{ 0x10A2, "", "Quantum Corporation" } ,
	{ 0x10A3, "", "Everex Systems Inc" } ,
	{ 0x10A4, "", "Globe Manufacturing Sales" } ,
	{ 0x10A5, "", "Smart Link Ltd." } ,
	{ 0x10A6, "", "Informtech Industrial Ltd." } ,
	{ 0x10A7, "", "Benchmarq Microelectronics" } ,
	{ 0x10A8, "", "Sierra Semiconductor" } ,
	{ 0x10A9, "", "Silicon Graphics, Inc." } ,
	{ 0x10AA, "", "ACC Microelectronics" } ,
	{ 0x10AB, "", "Digicom" } ,
	{ 0x10AC, "", "Honeywell IAC" } ,
	{ 0x10AD, "", "Symphony Labs" } ,
	{ 0x10AE, "", "Cornerstone Technology" } ,
	{ 0x10AF, "", "Micro Computer Systems Inc" } ,
	{ 0x10B0, "", "CardExpert Technology" } ,
	{ 0x10B1, "", "Cabletron Systems Inc" } ,
	{ 0x10B2, "", "Raytheon Company" } ,
	{ 0x10B3, "", "Databook Inc" } ,
	{ 0x10B4, "", "STB Systems Inc" } ,
	{ 0x10B5, "", "PLX Technology, Inc." } ,
	{ 0x10B6, "", "Madge Networks" } ,
	{ 0x10B7, "", "3Com Corporation" } ,
	{ 0x10B8, "", "Standard Microsystems Corp [SMC]" } ,
	{ 0x10B9, "", "ALi Corporation" } ,
	{ 0x10BA, "", "Mitsubishi Electric Corp." } ,
	{ 0x10BB, "", "Dapha Electronics Corporation" } ,
	{ 0x10BC, "", "Advanced Logic Research" } ,
	{ 0x10BD, "", "Surecom Technology" } ,
	{ 0x10BE, "", "Tseng Labs International Co." } ,
	{ 0x10BF, "", "Most Inc" } ,
	{ 0x10C0, "", "Boca Research Inc." } ,
	{ 0x10C1, "", "ICM Co., Ltd." } ,
	{ 0x10C2, "", "Auspex Systems Inc." } ,
	{ 0x10C3, "", "Samsung Semiconductors, Inc." } ,
	{ 0x10C4, "", "Award Software International Inc." } ,
	{ 0x10C5, "", "Xerox Corporation" } ,
	{ 0x10C6, "", "Rambus Inc." } ,
	{ 0x10C7, "", "Media Vision" } ,
	{ 0x10C8, "", "Neomagic Corporation" } ,
	{ 0x10C9, "", "Dataexpert Corporation" } ,
	{ 0x10CA, "", "Fujitsu Microelectr., Inc." } ,
	{ 0x10CB, "", "Omron Corporation" } ,
	{ 0x10CC, "", "Mai Logic Incorporated" } ,
	{ 0x10CD, "", "Advanced System Products, Inc" } ,
	{ 0x10CE, "", "Radius" } ,
	{ 0x10CF, "", "Fujitsu Limited." } ,
	{ 0x10D1, "", "FuturePlus Systems Corp." } ,
	{ 0x10D2, "", "Molex Incorporated" } ,
	{ 0x10D3, "", "Jabil Circuit Inc" } ,
	{ 0x10D4, "", "Hualon Microelectronics" } ,
	{ 0x10D5, "", "Autologic Inc." } ,
	{ 0x10D6, "", "Cetia" } ,
	{ 0x10D7, "", "BCM Advanced Research" } ,
	{ 0x10D8, "", "Advanced Peripherals Labs" } ,
	{ 0x10D9, "", "Macronix, Inc. [MXIC]" } ,
	{ 0x10DA, "", "Compaq IPG-Austin" } ,
	{ 0x10DB, "", "Rohm LSI Systems, Inc." } ,
	{ 0x10DC, "", "CERN/ECP/EDU" } ,
	{ 0x10DD, "", "Evans & Sutherland" } ,
	{ 0x10DE, "", "nVidia Corporation" } ,
	{ 0x10DF, "", "Emulex Corporation" } ,
	{ 0x10E0, "", "Integrated Micro Solutions Inc." } ,
	{ 0x10E1, "", "Tekram Technology Co.,Ltd." } ,
	{ 0x10E2, "", "Aptix Corporation" } ,
	{ 0x10E3, "", "Tundra Semiconductor Corp." } ,
	{ 0x10E4, "", "Tandem Computers" } ,
	{ 0x10E5, "", "Micro Industries Corporation" } ,
	{ 0x10E6, "", "Gainbery Computer Products Inc." } ,
	{ 0x10E7, "", "Vadem" } ,
	{ 0x10E8, "", "Applied Micro Circuits Corp." } ,
	{ 0x10E9, "", "Alps Electric Co., Ltd." } ,
	{ 0x10EA, "", "Intergraphics Systems" } ,
	{ 0x10EB, "", "Artists Graphics" } ,
	{ 0x10EC, "", "Realtek Semiconductor Co., Ltd." } ,
	{ 0x10ED, "", "Ascii Corporation" } ,
	{ 0x10EE, "", "Xilinx Corporation" } ,
	{ 0x10EF, "", "Racore Computer Products, Inc." } ,
	{ 0x10F0, "", "Peritek Corporation" } ,
	{ 0x10F1, "", "Tyan Computer" } ,
	{ 0x10F2, "", "Achme Computer, Inc." } ,
	{ 0x10F3, "", "Alaris, Inc." } ,
	{ 0x10F4, "", "S-MOS Systems, Inc." } ,
	{ 0x10F5, "", "NKK Corporation" } ,
	{ 0x10F6, "", "Creative Electronic Systems SA" } ,
	{ 0x10F7, "", "Matsushita Electric Industrial Co., Ltd." } ,
	{ 0x10F8, "", "Altos India Ltd" } ,
	{ 0x10F9, "", "PC Direct" } ,
	{ 0x10FA, "", "Truevision" } ,
	{ 0x10FB, "", "Thesys Gesellschaft fuer Mikroelektronik mbH" } ,
	{ 0x10FC, "", "I-O Data Device, Inc." } ,
	{ 0x10FD, "", "Soyo Computer, Inc" } ,
	{ 0x10FE, "", "Fast Multimedia AG" } ,
	{ 0x10FF, "", "NCube" } ,
	{ 0x1100, "", "Jazz Multimedia" } ,
	{ 0x1101, "", "Initio Corporation" } ,
	{ 0x1102, "", "Creative Labs" } ,
	{ 0x1103, "", "Triones Technologies, Inc." } ,
	{ 0x1104, "", "RasterOps Corp." } ,
	{ 0x1105, "", "Sigma Designs, Inc." } ,
	{ 0x1106, "", "VIA Technologies, Inc." } ,
	{ 0x1107, "", "Stratus Computers" } ,
	{ 0x1108, "", "Proteon, Inc." } ,
	{ 0x1109, "", "Cogent Data Technologies, Inc." } ,
	{ 0x110A, "", "Siemens Nixdorf AG" } ,
	{ 0x110B, "", "Chromatic Research Inc." } ,
	{ 0x110C, "", "Mini-Max Technology, Inc." } ,
	{ 0x110D, "", "Znyx Advanced Systems" } ,
	{ 0x110E, "", "CPU Technology" } ,
	{ 0x110F, "", "Ross Technology" } ,
	{ 0x1110, "", "Powerhouse Systems" } ,
	{ 0x1111, "", "Santa Cruz Operation" } ,
	{ 0x1112, "", "Osicom Technologies Inc" } ,
	{ 0x1113, "", "Accton Technology Corporation" } ,
	{ 0x1114, "", "Atmel Corporation" } ,
	{ 0x1115, "", "3D Labs" } ,
	{ 0x1116, "", "Data Translation" } ,
	{ 0x1117, "", "Datacube, Inc" } ,
	{ 0x1118, "", "Berg Electronics" } ,
	{ 0x1119, "", "ICP Vortex Computersysteme GmbH" } ,
	{ 0x111A, "", "Efficient Networks, Inc" } ,
	{ 0x111B, "", "Teledyne Electronic Systems" } ,
	{ 0x111C, "", "Tricord Systems Inc." } ,
	{ 0x111D, "", "Integrated Device Technology, Inc." } ,
	{ 0x111E, "", "Eldec" } ,
	{ 0x111F, "", "Precision Digital Images" } ,
	{ 0x1120, "", "EMC Corporation" } ,
	{ 0x1121, "", "Zilog" } ,
	{ 0x1122, "", "Multi-tech Systems, Inc." } ,
	{ 0x1123, "", "Excellent Design, Inc." } ,
	{ 0x1124, "", "Leutron Vision AG" } ,
	{ 0x1125, "", "Eurocore" } ,
	{ 0x1126, "", "Vigra" } ,
	{ 0x1127, "", "FORE Systems Inc" } ,
	{ 0x1129, "", "Firmworks" } ,
	{ 0x112A, "", "Hermes Electronics Company, Ltd." } ,
	{ 0x112B, "", "Linotype - Hell AG" } ,
	{ 0x112C, "", "Zenith Data Systems" } ,
	{ 0x112D, "", "Ravicad" } ,
	{ 0x112E, "", "Infomedia Microelectronics Inc." } ,
	{ 0x112F, "", "Imaging Technology Inc" } ,
	{ 0x1130, "", "Computervision" } ,
	{ 0x1131, "", "Philips Semiconductors" } ,
	{ 0x1132, "", "Mitel Corp." } ,
	{ 0x1133, "", "Eicon Networks Corporation" } ,
	{ 0x1134, "", "Mercury Computer Systems" } ,
	{ 0x1135, "", "Fuji Xerox Co Ltd" } ,
	{ 0x1136, "", "Momentum Data Systems" } ,
	{ 0x1137, "", "Cisco Systems Inc" } ,
	{ 0x1138, "", "Ziatech Corporation" } ,
	{ 0x1139, "", "Dynamic Pictures, Inc" } ,
	{ 0x113A, "", "FWB Inc" } ,
	{ 0x113B, "", "Network Computing Devices" } ,
	{ 0x113C, "", "Cyclone Microsystems, Inc." } ,
	{ 0x113D, "", "Leading Edge Products Inc" } ,
	{ 0x113E, "", "Sanyo Electric Co - Computer Engineering Dept" } ,
	{ 0x113F, "", "Equinox Systems, Inc." } ,
	{ 0x1140, "", "Intervoice Inc" } ,
	{ 0x1141, "", "Crest Microsystem Inc" } ,
	{ 0x1142, "", "Alliance Semiconductor Corporation" } ,
	{ 0x1143, "", "NetPower, Inc" } ,
	{ 0x1144, "", "Cincinnati Milacron" } ,
	{ 0x1145, "", "Workbit Corporation" } ,
	{ 0x1146, "", "Force Computers" } ,
	{ 0x1147, "", "Interface Corp" } ,
	{ 0x1148, "", "SysKonnect" } ,
	{ 0x1149, "", "Win System Corporation" } ,
	{ 0x114A, "", "VMIC" } ,
	{ 0x114B, "", "Canopus Co., Ltd" } ,
	{ 0x114C, "", "Annabooks" } ,
	{ 0x114D, "", "IC Corporation" } ,
	{ 0x114E, "", "Nikon Systems Inc" } ,
	{ 0x114F, "", "Digi International" } ,
	{ 0x1150, "", "Thinking Machines Corp" } ,
	{ 0x1151, "", "JAE Electronics Inc." } ,
	{ 0x1152, "", "Megatek" } ,
	{ 0x1153, "", "Land Win Electronic Corp" } ,
	{ 0x1154, "", "Melco Inc" } ,
	{ 0x1155, "", "Pine Technology Ltd" } ,
	{ 0x1156, "", "Periscope Engineering" } ,
	{ 0x1157, "", "Avsys Corporation" } ,
	{ 0x1158, "", "Voarx R & D Inc" } ,
	{ 0x1159, "", "Mutech Corp" } ,
	{ 0x115A, "", "Harlequin Ltd" } ,
	{ 0x115B, "", "Parallax Graphics" } ,
	{ 0x115C, "", "Photron Ltd." } ,
	{ 0x115D, "", "Xircom" } ,
	{ 0x115E, "", "Peer Protocols Inc" } ,
	{ 0x115F, "", "Maxtor Corporation" } ,
	{ 0x1160, "", "Megasoft Inc" } ,
	{ 0x1161, "", "PFU Limited" } ,
	{ 0x1162, "", "OA Laboratory Co Ltd" } ,
	{ 0x1163, "", "Rendition" } ,
	{ 0x1164, "", "Advanced Peripherals Technologies" } ,
	{ 0x1165, "", "Imagraph Corporation" } ,
	{ 0x1166, "", "Broadcom" } ,
	{ 0x1167, "", "Mutoh Industries Inc" } ,
	{ 0x1168, "", "Thine Electronics Inc" } ,
	{ 0x1169, "", "Centre for Development of Advanced Computing" } ,
	{ 0x116A, "", "Polaris Communications" } ,
	{ 0x116B, "", "Connectware Inc" } ,
	{ 0x116C, "", "Intelligent Resources Integrated Systems" } ,
	{ 0x116D, "", "Martin-Marietta" } ,
	{ 0x116E, "", "Electronics for Imaging" } ,
	{ 0x116F, "", "Workstation Technology" } ,
	{ 0x1170, "", "Inventec Corporation" } ,
	{ 0x1171, "", "Loughborough Sound Images Plc" } ,
	{ 0x1172, "", "Altera Corporation" } ,
	{ 0x1173, "", "Adobe Systems, Inc" } ,
	{ 0x1174, "", "Bridgeport Machines" } ,
	{ 0x1175, "", "Mitron Computer Inc." } ,
	{ 0x1176, "", "SBE Incorporated" } ,
	{ 0x1177, "", "Silicon Engineering" } ,
	{ 0x1178, "", "Alfa, Inc." } ,
	{ 0x1179, "", "Toshiba America Info Systems" } ,
	{ 0x117A, "", "A-Trend Technology" } ,
	{ 0x117B, "", "L G Electronics, Inc." } ,
	{ 0x117C, "", "Atto Technology" } ,
	{ 0x117D, "", "Becton & Dickinson" } ,
	{ 0x117E, "", "T/R Systems" } ,
	{ 0x117F, "", "Integrated Circuit Systems" } ,
	{ 0x1180, "", "Ricoh Co Ltd" } ,
	{ 0x1181, "", "Telmatics International" } ,
	{ 0x1183, "", "Fujikura Ltd" } ,
	{ 0x1184, "", "Forks Inc" } ,
	{ 0x1185, "", "Dataworld International Ltd" } ,
	{ 0x1186, "", "D-Link System Inc" } ,
	{ 0x1187, "", "Advanced Technology Laboratories, Inc." } ,
	{ 0x1188, "", "Shima Seiki Manufacturing Ltd." } ,
	{ 0x1189, "", "Matsushita Electronics Co Ltd" } ,
	{ 0x118A, "", "Hilevel Technology" } ,
	{ 0x118B, "", "Hypertec Pty Limited" } ,
	{ 0x118C, "", "Corollary, Inc" } ,
	{ 0x118D, "", "BitFlow Inc" } ,
	{ 0x118E, "", "Hermstedt GmbH" } ,
	{ 0x118F, "", "Green Logic" } ,
	{ 0x1190, "", "Tripace" } ,
	{ 0x1191, "", "Artop Electronic Corp" } ,
	{ 0x1192, "", "Densan Company Ltd" } ,
	{ 0x1193, "", "Zeitnet Inc." } ,
	{ 0x1194, "", "Toucan Technology" } ,
	{ 0x1195, "", "Ratoc System Inc" } ,
	{ 0x1196, "", "Hytec Electronics Ltd" } ,
	{ 0x1197, "", "Gage Applied Sciences, Inc." } ,
	{ 0x1198, "", "Lambda Systems Inc" } ,
	{ 0x1199, "", "Attachmate Corporation" } ,
	{ 0x119A, "", "Mind Share, Inc." } ,
	{ 0x119B, "", "Omega Micro Inc." } ,
	{ 0x119C, "", "Information Technology Inst." } ,
	{ 0x119D, "", "Bug, Inc. Sapporo Japan" } ,
	{ 0x119E, "", "Fujitsu Microelectronics Ltd." } ,
	{ 0x119F, "", "Bull HN Information Systems" } ,
	{ 0x11A0, "", "Convex Computer Corporation" } ,
	{ 0x11A1, "", "Hamamatsu Photonics K.K." } ,
	{ 0x11A2, "", "Sierra Research and Technology" } ,
	{ 0x11A3, "", "Deuretzbacher GmbH & Co. Eng. KG" } ,
	{ 0x11A4, "", "Barco Graphics NV" } ,
	{ 0x11A5, "", "Microunity Systems Eng. Inc" } ,
	{ 0x11A6, "", "Pure Data Ltd." } ,
	{ 0x11A7, "", "Power Computing Corp." } ,
	{ 0x11A8, "", "Systech Corp." } ,
	{ 0x11A9, "", "InnoSys Inc." } ,
	{ 0x11AA, "", "Actel" } ,
	{ 0x11AB, "", "Marvell Technology Group Ltd." } ,
	{ 0x11AC, "", "Canon Information Systems Research Aust." } ,
	{ 0x11AD, "", "Lite-On Communications Inc" } ,
	{ 0x11AE, "", "Aztech System Ltd" } ,
	{ 0x11AF, "", "Avid Technology Inc." } ,
	{ 0x11B0, "", "V3 Semiconductor Inc." } ,
	{ 0x11B1, "", "Apricot Computers" } ,
	{ 0x11B2, "", "Eastman Kodak" } ,
	{ 0x11B3, "", "Barr Systems Inc." } ,
	{ 0x11B4, "", "Leitch Technology International" } ,
	{ 0x11B5, "", "Radstone Technology Plc" } ,
	{ 0x11B6, "", "United Video Corp" } ,
	{ 0x11B7, "", "Motorola" } ,
	{ 0x11B8, "", "XPoint Technologies, Inc" } ,
	{ 0x11B9, "", "Pathlight Technology Inc." } ,
	{ 0x11BA, "", "Videotron Corp" } ,
	{ 0x11BB, "", "Pyramid Technology" } ,
	{ 0x11BC, "", "Network Peripherals Inc" } ,
	{ 0x11BD, "", "Pinnacle Systems Inc." } ,
	{ 0x11BE, "", "International Microcircuits Inc" } ,
	{ 0x11BF, "", "Astrodesign, Inc." } ,
	{ 0x11C0, "", "Hewlett Packard" } ,
	{ 0x11C1, "", "Agere Systems" } ,
	{ 0x11C2, "", "Sand Microelectronics" } ,
	{ 0x11C3, "", "NEC Corporation" } ,
	{ 0x11C4, "", "Document Technologies, Inc" } ,
	{ 0x11C5, "", "Shiva Corporation" } ,
	{ 0x11C6, "", "Dainippon Screen Mfg. Co. Ltd" } ,
	{ 0x11C7, "", "D.C.M. Data Systems" } ,
	{ 0x11C8, "", "Dolphin Interconnect Solutions AS" } ,
	{ 0x11C9, "", "Magma" } ,
	{ 0x11CA, "", "LSI Systems, Inc" } ,
	{ 0x11CB, "", "Specialix Research Ltd." } ,
	{ 0x11CC, "", "Michels & Kleberhoff Computer GmbH" } ,
	{ 0x11CD, "", "HAL Computer Systems, Inc." } ,
	{ 0x11CE, "", "Netaccess" } ,
	{ 0x11CF, "", "Pioneer Electronic Corporation" } ,
	{ 0x11D0, "", "Lockheed Martin Federal Systems-Manassas" } ,
	{ 0x11D1, "", "Auravision" } ,
	{ 0x11D2, "", "Intercom Inc." } ,
	{ 0x11D3, "", "Trancell Systems Inc" } ,
	{ 0x11D4, "", "Analog Devices" } ,
	{ 0x11D5, "", "Ikon Corporation" } ,
	{ 0x11D6, "", "Tekelec Telecom" } ,
	{ 0x11D7, "", "Trenton Technology, Inc." } ,
	{ 0x11D8, "", "Image Technologies Development" } ,
	{ 0x11D9, "", "TEC Corporation" } ,
	{ 0x11DA, "", "Novell" } ,
	{ 0x11DB, "", "Sega Enterprises Ltd" } ,
	{ 0x11DC, "", "Questra Corporation" } ,
	{ 0x11DD, "", "Crosfield Electronics Limited" } ,
	{ 0x11DE, "", "Zoran Corporation" } ,
	{ 0x11DF, "", "New Wave PDG" } ,
	{ 0x11E0, "", "Cray Communications A/S" } ,
	{ 0x11E1, "", "GEC Plessey Semi Inc." } ,
	{ 0x11E2, "", "Samsung Information Systems America" } ,
	{ 0x11E3, "", "Quicklogic Corporation" } ,
	{ 0x11E4, "", "Second Wave Inc" } ,
	{ 0x11E5, "", "IIX Consulting" } ,
	{ 0x11E6, "", "Mitsui-Zosen System Research" } ,
	{ 0x11E7, "", "Toshiba America, Elec. Company" } ,
	{ 0x11E8, "", "Digital Processing Systems Inc." } ,
	{ 0x11E9, "", "Highwater Designs Ltd." } ,
	{ 0x11EA, "", "Elsag Bailey" } ,
	{ 0x11EB, "", "Formation Inc." } ,
	{ 0x11EC, "", "Coreco Inc" } ,
	{ 0x11ED, "", "Mediamatics" } ,
	{ 0x11EE, "", "Dome Imaging Systems Inc" } ,
	{ 0x11EF, "", "Nicolet Technologies B.V." } ,
	{ 0x11F0, "", "Compu-Shack" } ,
	{ 0x11F1, "", "Symbios Logic Inc" } ,
	{ 0x11F2, "", "Picture Tel Japan K.K." } ,
	{ 0x11F3, "", "Keithley Metrabyte" } ,
	{ 0x11F4, "", "Kinetic Systems Corporation" } ,
	{ 0x11F5, "", "Computing Devices International" } ,
	{ 0x11F6, "", "Compex" } ,
	{ 0x11F7, "", "Scientific Atlanta" } ,
	{ 0x11F8, "", "PMC-Sierra Inc." } ,
	{ 0x11F9, "", "I-Cube Inc" } ,
	{ 0x11FA, "", "Kasan Electronics Company, Ltd." } ,
	{ 0x11FB, "", "Datel Inc" } ,
	{ 0x11FC, "", "Silicon Magic" } ,
	{ 0x11FD, "", "High Street Consultants" } ,
	{ 0x11FE, "", "Comtrol Corporation" } ,
	{ 0x11FF, "", "Scion Corporation" } ,
	{ 0x1200, "", "CSS Corporation" } ,
	{ 0x1201, "", "Vista Controls Corp" } ,
	{ 0x1202, "", "Network General Corp." } ,
	{ 0x1203, "", "Bayer Corporation, Agfa Division" } ,
	{ 0x1204, "", "Lattice Semiconductor Corporation" } ,
	{ 0x1205, "", "Array Corporation" } ,
	{ 0x1206, "", "Amdahl Corporation" } ,
	{ 0x1208, "", "Parsytec GmbH" } ,
	{ 0x1209, "", "SCI Systems Inc" } ,
	{ 0x120A, "", "Synaptel" } ,
	{ 0x120B, "", "Adaptive Solutions" } ,
	{ 0x120C, "", "Technical Corp." } ,
	{ 0x120D, "", "Compression Labs, Inc." } ,
	{ 0x120E, "", "Cyclades Corporation" } ,
	{ 0x120F, "", "Essential Communications" } ,
	{ 0x1210, "", "Hyperparallel Technologies" } ,
	{ 0x1211, "", "Braintech Inc" } ,
	{ 0x1212, "", "Kingston Technology Corp." } ,
	{ 0x1213, "", "Applied Intelligent Systems, Inc." } ,
	{ 0x1214, "", "Performance Technologies, Inc." } ,
	{ 0x1215, "", "Interware Co., Ltd" } ,
	{ 0x1216, "", "Purup Prepress A/S" } ,
	{ 0x1217, "", "O2 Micro, Inc." } ,
	{ 0x1218, "", "Hybricon Corp." } ,
	{ 0x1219, "", "First Virtual Corporation" } ,
	{ 0x121A, "", "3Dfx Interactive, Inc." } ,
	{ 0x121B, "", "Advanced Telecommunications Modules" } ,
	{ 0x121C, "", "Nippon Texaco., Ltd" } ,
	{ 0x121D, "", "Lippert Automationstechnik GmbH" } ,
	{ 0x121E, "", "CSPI" } ,
	{ 0x121F, "", "Arcus Technology, Inc." } ,
	{ 0x1220, "", "Ariel Corporation" } ,
	{ 0x1221, "", "Contec Co., Ltd" } ,
	{ 0x1222, "", "Ancor Communications, Inc." } ,
	{ 0x1223, "", "Artesyn Communication Products" } ,
	{ 0x1224, "", "Interactive Images" } ,
	{ 0x1225, "", "Power I/O, Inc." } ,
	{ 0x1227, "", "Tech-Source" } ,
	{ 0x1228, "", "Norsk Elektro Optikk A/S" } ,
	{ 0x1229, "", "Data Kinesis Inc." } ,
	{ 0x122A, "", "Integrated Telecom" } ,
	{ 0x122B, "", "LG Industrial Systems Co., Ltd" } ,
	{ 0x122C, "", "Sican GmbH" } ,
	{ 0x122D, "", "Aztech System Ltd" } ,
	{ 0x122E, "", "Xyratex" } ,
	{ 0x122F, "", "Andrew Corporation" } ,
	{ 0x1230, "", "Fishcamp Engineering" } ,
	{ 0x1231, "", "Woodward McCoach, Inc." } ,
	{ 0x1232, "", "GPT Limited" } ,
	{ 0x1233, "", "Bus-Tech, Inc." } ,
	{ 0x1234, "", "Technical Corp." } ,
	{ 0x1235, "", "Risq Modular Systems, Inc." } ,
	{ 0x1236, "", "Sigma Designs Corporation" } ,
	{ 0x1237, "", "Alta Technology Corporation" } ,
	{ 0x1238, "", "Adtran" } ,
	{ 0x1239, "", "3DO Company" } ,
	{ 0x123A, "", "Visicom Laboratories, Inc." } ,
	{ 0x123B, "", "Seeq Technology, Inc." } ,
	{ 0x123C, "", "Century Systems, Inc." } ,
	{ 0x123D, "", "Engineering Design Team, Inc." } ,
	{ 0x123E, "", "Simutech, Inc." } ,
	{ 0x123F, "", "C-Cube Microsystems" } ,
	{ 0x1240, "", "Marathon Technologies Corp." } ,
	{ 0x1241, "", "DSC Communications" } ,
	{ 0x1242, "", "JNI Corporation" } ,
	{ 0x1243, "", "Delphax" } ,
	{ 0x1244, "", "AVM Audiovisuelles MKTG & Computer System GmbH" } ,
	{ 0x1245, "", "A.P.D., S.A." } ,
	{ 0x1246, "", "Dipix Technologies, Inc." } ,
	{ 0x1247, "", "Xylon Research, Inc." } ,
	{ 0x1248, "", "Central Data Corporation" } ,
	{ 0x1249, "", "Samsung Electronics Co., Ltd." } ,
	{ 0x124A, "", "AEG Electrocom GmbH" } ,
	{ 0x124B, "", "SBS/Greenspring Modular I/O" } ,
	{ 0x124C, "", "Solitron Technologies, Inc." } ,
	{ 0x124D, "", "Stallion Technologies, Inc." } ,
	{ 0x124E, "", "Cylink" } ,
	{ 0x124F, "", "Infortrend Technology, Inc." } ,
	{ 0x1250, "", "Hitachi Microcomputer System Ltd" } ,
	{ 0x1251, "", "VLSI Solutions Oy" } ,
	{ 0x1253, "", "Guzik Technical Enterprises" } ,
	{ 0x1254, "", "Linear Systems Ltd." } ,
	{ 0x1255, "", "Optibase Ltd" } ,
	{ 0x1256, "", "Perceptive Solutions, Inc." } ,
	{ 0x1257, "", "Vertex Networks, Inc." } ,
	{ 0x1258, "", "Gilbarco, Inc." } ,
	{ 0x1259, "", "Allied Telesyn International" } ,
	{ 0x125A, "", "ABB Power Systems" } ,
	{ 0x125B, "", "Asix Electronics Corporation" } ,
	{ 0x125C, "", "Aurora Technologies, Inc." } ,
	{ 0x125D, "", "ESS Technology" } ,
	{ 0x125E, "", "Specialvideo Engineering SRL" } ,
	{ 0x125F, "", "Concurrent Technologies, Inc." } ,
	{ 0x1260, "", "Intersil Corporation" } ,
	{ 0x1261, "", "Matsushita-Kotobuki Electronics Industries, Ltd." } ,
	{ 0x1262, "", "ES Computer Company, Ltd." } ,
	{ 0x1263, "", "Sonic Solutions" } ,
	{ 0x1264, "", "Aval Nagasaki Corporation" } ,
	{ 0x1265, "", "Casio Computer Co., Ltd." } ,
	{ 0x1266, "", "Microdyne Corporation" } ,
	{ 0x1267, "", "S. A. Telecommunications" } ,
	{ 0x1268, "", "Tektronix" } ,
	{ 0x1269, "", "Thomson-CSF/TTM" } ,
	{ 0x126A, "", "Lexmark International, Inc." } ,
	{ 0x126B, "", "Adax, Inc." } ,
	{ 0x126C, "", "Northern Telecom" } ,
	{ 0x126D, "", "Splash Technology, Inc." } ,
	{ 0x126E, "", "Sumitomo Metal Industries, Ltd." } ,
	{ 0x126F, "", "Silicon Motion, Inc." } ,
	{ 0x1270, "", "Olympus Optical Co., Ltd." } ,
	{ 0x1271, "", "GW Instruments" } ,
	{ 0x1272, "", "Telematics International" } ,
	{ 0x1273, "", "Hughes Network Systems" } ,
	{ 0x1274, "", "Ensoniq" } ,
	{ 0x1275, "", "Network Appliance Corporation" } ,
	{ 0x1276, "", "Switched Network Technologies, Inc." } ,
	{ 0x1277, "", "Comstream" } ,
	{ 0x1278, "", "Transtech Parallel Systems Ltd." } ,
	{ 0x1279, "", "Transmeta Corporation" } ,
	{ 0x127A, "", "Rockwell International" } ,
	{ 0x127B, "", "Pixera Corporation" } ,
	{ 0x127C, "", "Crosspoint Solutions, Inc." } ,
	{ 0x127D, "", "Vela Research" } ,
	{ 0x127E, "", "Winnov, L.P." } ,
	{ 0x127F, "", "Fujifilm" } ,
	{ 0x1280, "", "Photoscript Group Ltd." } ,
	{ 0x1281, "", "Yokogawa Electric Corporation" } ,
	{ 0x1282, "", "Davicom Semiconductor, Inc." } ,
	{ 0x1283, "", "Integrated Technology Express, Inc." } ,
	{ 0x1284, "", "Sahara Networks, Inc." } ,
	{ 0x1285, "", "Platform Technologies, Inc." } ,
	{ 0x1286, "", "Mazet GmbH" } ,
	{ 0x1287, "", "M-Pact, Inc." } ,
	{ 0x1288, "", "Timestep Corporation" } ,
	{ 0x1289, "", "AVC Technology, Inc." } ,
	{ 0x128A, "", "Asante Technologies, Inc." } ,
	{ 0x128B, "", "Transwitch Corporation" } ,
	{ 0x128C, "", "Retix Corporation" } ,
	{ 0x128D, "", "G2 Networks, Inc." } ,
	{ 0x128E, "", "Hoontech Corporation/Samho Multi Tech Ltd." } ,
	{ 0x128F, "", "Tateno Dennou, Inc." } ,
	{ 0x1290, "", "Sord Computer Corporation" } ,
	{ 0x1291, "", "NCS Computer Italia" } ,
	{ 0x1292, "", "Tritech Microelectronics Inc" } ,
	{ 0x1293, "", "Media Reality Technology" } ,
	{ 0x1294, "", "Rhetorex, Inc." } ,
	{ 0x1295, "", "Imagenation Corporation" } ,
	{ 0x1296, "", "Kofax Image Products" } ,
	{ 0x1297, "", "Holco Enterprise Co, Ltd/Shuttle Computer" } ,
	{ 0x1298, "", "Spellcaster Telecommunications Inc." } ,
	{ 0x1299, "", "Knowledge Technology Lab." } ,
	{ 0x129A, "", "VMetro, inc." } ,
	{ 0x129B, "", "Image Access" } ,
	{ 0x129C, "", "Jaycor" } ,
	{ 0x129D, "", "Compcore Multimedia, Inc." } ,
	{ 0x129E, "", "Victor Company of Japan, Ltd." } ,
	{ 0x129F, "", "OEC Medical Systems, Inc." } ,
	{ 0x12A0, "", "Allen-Bradley Company" } ,
	{ 0x12A1, "", "Simpact Associates, Inc." } ,
	{ 0x12A2, "", "Newgen Systems Corporation" } ,
	{ 0x12A3, "", "Lucent Technologies" } ,
	{ 0x12A4, "", "NTT Electronics Technology Company" } ,
	{ 0x12A5, "", "Vision Dynamics Ltd." } ,
	{ 0x12A6, "", "Scalable Networks, Inc." } ,
	{ 0x12A7, "", "AMO GmbH" } ,
	{ 0x12A8, "", "News Datacom" } ,
	{ 0x12A9, "", "Xiotech Corporation" } ,
	{ 0x12AA, "", "SDL Communications, Inc." } ,
	{ 0x12AB, "", "Yuan Yuan Enterprise Co., Ltd." } ,
	{ 0x12AC, "", "Measurex Corporation" } ,
	{ 0x12AD, "", "Multidata GmbH" } ,
	{ 0x12AE, "", "Alteon Networks Inc." } ,
	{ 0x12AF, "", "TDK USA Corp" } ,
	{ 0x12B0, "", "Jorge Scientific Corp" } ,
	{ 0x12B1, "", "GammaLink" } ,
	{ 0x12B2, "", "General Signal Networks" } ,
	{ 0x12B3, "", "Inter-Face Co Ltd" } ,
	{ 0x12B4, "", "FutureTel Inc" } ,
	{ 0x12B5, "", "Granite Systems Inc." } ,
	{ 0x12B6, "", "Natural Microsystems" } ,
	{ 0x12B7, "", "Cognex Modular Vision Systems Div. - Acumen Inc." } ,
	{ 0x12B8, "", "Korg" } ,
	{ 0x12B9, "", "3Com Corp, Modem Division" } ,
	{ 0x12BA, "", "BittWare, Inc." } ,
	{ 0x12BB, "", "Nippon Unisoft Corporation" } ,
	{ 0x12BC, "", "Array Microsystems" } ,
	{ 0x12BD, "", "Computerm Corp." } ,
	{ 0x12BE, "", "Anchor Chips Inc." } ,
	{ 0x12BF, "", "Fujifilm Microdevices" } ,
	{ 0x12C0, "", "Infimed" } ,
	{ 0x12C1, "", "GMM Research Corp" } ,
	{ 0x12C2, "", "Mentec Limited" } ,
	{ 0x12C3, "", "Holtek Microelectronics Inc" } ,
	{ 0x12C4, "", "Connect Tech Inc" } ,
	{ 0x12C5, "", "Picture Elements Incorporated" } ,
	{ 0x12C6, "", "Mitani Corporation" } ,
	{ 0x12C7, "", "Dialogic Corp" } ,
	{ 0x12C8, "", "G Force Co, Ltd" } ,
	{ 0x12C9, "", "Gigi Operations" } ,
	{ 0x12CA, "", "Integrated Computing Engines" } ,
	{ 0x12CB, "", "Antex Electronics Corporation" } ,
	{ 0x12CC, "", "Pluto Technologies International" } ,
	{ 0x12CD, "", "Aims Lab" } ,
	{ 0x12CE, "", "Netspeed Inc." } ,
	{ 0x12CF, "", "Prophet Systems, Inc." } ,
	{ 0x12D0, "", "GDE Systems, Inc." } ,
	{ 0x12D1, "", "PSITech" } ,
	{ 0x12D2, "", "NVidia / SGS Thomson (Joint Venture)" } ,
	{ 0x12D3, "", "Vingmed Sound A/S" } ,
	{ 0x12D4, "", "Ulticom (Formerly DGM&S)" } ,
	{ 0x12D5, "", "Equator Technologies Inc" } ,
	{ 0x12D6, "", "Analogic Corp" } ,
	{ 0x12D7, "", "Biotronic SRL" } ,
	{ 0x12D8, "", "Pericom Semiconductor" } ,
	{ 0x12D9, "", "Aculab PLC" } ,
	{ 0x12DA, "", "True Time Inc." } ,
	{ 0x12DB, "", "Annapolis Micro Systems, Inc" } ,
	{ 0x12DC, "", "Symicron Computer Communication Ltd." } ,
	{ 0x12DD, "", "Management Graphics" } ,
	{ 0x12DE, "", "Rainbow Technologies" } ,
	{ 0x12DF, "", "SBS Technologies Inc" } ,
	{ 0x12E0, "", "Chase Research" } ,
	{ 0x12E1, "", "Nintendo Co, Ltd" } ,
	{ 0x12E2, "", "Datum Inc. Bancomm-Timing Division" } ,
	{ 0x12E3, "", "Imation Corp - Medical Imaging Systems" } ,
	{ 0x12E4, "", "Brooktrout Technology Inc" } ,
	{ 0x12E5, "", "Apex Semiconductor Inc" } ,
	{ 0x12E6, "", "Cirel Systems" } ,
	{ 0x12E7, "", "Sunsgroup Corporation" } ,
	{ 0x12E8, "", "Crisc Corp" } ,
	{ 0x12E9, "", "GE Spacenet" } ,
	{ 0x12EA, "", "Zuken" } ,
	{ 0x12EB, "", "Aureal Semiconductor" } ,
	{ 0x12EC, "", "3A International, Inc." } ,
	{ 0x12ED, "", "Optivision Inc." } ,
	{ 0x12EE, "", "Orange Micro" } ,
	{ 0x12EF, "", "Vienna Systems" } ,
	{ 0x12F0, "", "Pentek" } ,
	{ 0x12F1, "", "Sorenson Vision Inc" } ,
	{ 0x12F2, "", "Gammagraphx, Inc." } ,
	{ 0x12F3, "", "Radstone Technology" } ,
	{ 0x12F4, "", "Megatel" } ,
	{ 0x12F5, "", "Forks" } ,
	{ 0x12F6, "", "Dawson France" } ,
	{ 0x12F7, "", "Cognex" } ,
	{ 0x12F8, "", "Electronic Design GmbH" } ,
	{ 0x12F9, "", "Four Fold Ltd" } ,
	{ 0x12FB, "", "Spectrum Signal Processing" } ,
	{ 0x12FC, "", "Capital Equipment Corp" } ,
	{ 0x12FD, "", "I2S" } ,
	{ 0x12FE, "", "ESD Electronic System Design GmbH" } ,
	{ 0x12FF, "", "Lexicon" } ,
	{ 0x1300, "", "Harman International Industries Inc" } ,
	{ 0x1302, "", "Computer Sciences Corp" } ,
	{ 0x1303, "", "Innovative Integration" } ,
	{ 0x1304, "", "Juniper Networks" } ,
	{ 0x1305, "", "Netphone, Inc" } ,
	{ 0x1306, "", "Duet Technologies" } ,
	{ 0x1307, "", "Measurement Computing" } ,
	{ 0x1308, "", "Jato Technologies Inc." } ,
	{ 0x1309, "", "AB Semiconductor Ltd" } ,
	{ 0x130A, "", "Mitsubishi Electric Microcomputer" } ,
	{ 0x130B, "", "Colorgraphic Communications Corp" } ,
	{ 0x130C, "", "Ambex Technologies, Inc" } ,
	{ 0x130D, "", "Accelerix Inc" } ,
	{ 0x130E, "", "Yamatake-Honeywell Co. Ltd" } ,
	{ 0x130F, "", "Advanet Inc" } ,
	{ 0x1310, "", "Gespac" } ,
	{ 0x1311, "", "Videoserver, Inc" } ,
	{ 0x1312, "", "Acuity Imaging, Inc" } ,
	{ 0x1313, "", "Yaskawa Electric Co." } ,
	{ 0x1316, "", "Teradyne Inc" } ,
	{ 0x1317, "", "Linksys" } ,
	{ 0x1318, "", "Packet Engines Inc." } ,
	{ 0x1319, "", "Fortemedia, Inc" } ,
	{ 0x131A, "", "Finisar Corp." } ,
	{ 0x131C, "", "Nippon Electro-Sensory Devices Corp" } ,
	{ 0x131D, "", "Sysmic, Inc." } ,
	{ 0x131E, "", "Xinex Networks Inc" } ,
	{ 0x131F, "", "Siig Inc" } ,
	{ 0x1320, "", "Crypto AG" } ,
	{ 0x1321, "", "Arcobel Graphics BV" } ,
	{ 0x1322, "", "MTT Co., Ltd" } ,
	{ 0x1323, "", "Dome Inc" } ,
	{ 0x1324, "", "Sphere Communications" } ,
	{ 0x1325, "", "Salix Technologies, Inc" } ,
	{ 0x1326, "", "Seachange international" } ,
	{ 0x1327, "", "Voss scientific" } ,
	{ 0x1328, "", "quadrant international" } ,
	{ 0x1329, "", "Productivity Enhancement" } ,
	{ 0x132A, "", "Microcom Inc." } ,
	{ 0x132B, "", "Broadband Technologies" } ,
	{ 0x132C, "", "Micrel Inc" } ,
	{ 0x132D, "", "Integrated Silicon Solution, Inc." } ,
	{ 0x1330, "", "MMC Networks" } ,
	{ 0x1331, "", "Radisys Corp." } ,
	{ 0x1332, "", "Micro Memory" } ,
	{ 0x1334, "", "Redcreek Communications, Inc" } ,
	{ 0x1335, "", "Videomail, Inc" } ,
	{ 0x1337, "", "Third Planet Publishing" } ,
	{ 0x1338, "", "BT Electronics" } ,
	{ 0x133A, "", "Vtel Corp" } ,
	{ 0x133B, "", "Softcom Microsystems" } ,
	{ 0x133C, "", "Holontech Corp" } ,
	{ 0x133D, "", "SS Technologies" } ,
	{ 0x133E, "", "Virtual Computer Corp" } ,
	{ 0x133F, "", "SCM Microsystems" } ,
	{ 0x1340, "", "Atalla Corp" } ,
	{ 0x1341, "", "Kyoto Microcomputer Co" } ,
	{ 0x1342, "", "Promax Systems Inc" } ,
	{ 0x1343, "", "Phylon Communications Inc" } ,
	{ 0x1344, "", "Crucial Technology" } ,
	{ 0x1345, "", "Arescom Inc" } ,
	{ 0x1347, "", "Odetics" } ,
	{ 0x1349, "", "Sumitomo Electric Industries, Ltd." } ,
	{ 0x134A, "", "DTC Technology Corp." } ,
	{ 0x134B, "", "ARK Research Corp." } ,
	{ 0x134C, "", "Chori Joho System Co. Ltd" } ,
	{ 0x134D, "", "PCTel Inc" } ,
	{ 0x134E, "", "CSTI" } ,
	{ 0x134F, "", "Algo System Co Ltd" } ,
	{ 0x1350, "", "Systec Co. Ltd" } ,
	{ 0x1351, "", "Sonix Inc" } ,
	{ 0x1353, "", "Thales Idatys" } ,
	{ 0x1354, "", "Dwave System Inc" } ,
	{ 0x1355, "", "Kratos Analytical Ltd" } ,
	{ 0x1356, "", "The Logical Co" } ,
	{ 0x1359, "", "Prisa Networks" } ,
	{ 0x135A, "", "Brain Boxes" } ,
	{ 0x135B, "", "Giganet Inc" } ,
	{ 0x135C, "", "Quatech Inc" } ,
	{ 0x135D, "", "ABB Network Partner AB" } ,
	{ 0x135E, "", "Sealevel Systems Inc" } ,
	{ 0x135F, "", "I-Data International A-S" } ,
	{ 0x1360, "", "Meinberg Funkuhren" } ,
	{ 0x1361, "", "Soliton Systems K.K." } ,
	{ 0x1362, "", "Fujifacom Corporation" } ,
	{ 0x1363, "", "Phoenix Technology Ltd" } ,
	{ 0x1364, "", "ATM Communications Inc" } ,
	{ 0x1365, "", "Hypercope GmbH" } ,
	{ 0x1366, "", "Teijin Seiki Co. Ltd" } ,
	{ 0x1367, "", "Hitachi Zosen Corporation" } ,
	{ 0x1368, "", "Skyware Corporation" } ,
	{ 0x1369, "", "Digigram" } ,
	{ 0x136A, "", "High Soft Tech" } ,
	{ 0x136B, "", "Kawasaki Steel Corporation" } ,
	{ 0x136C, "", "Adtek System Science Co Ltd" } ,
	{ 0x136D, "", "Gigalabs Inc" } ,
	{ 0x136F, "", "Applied Magic Inc" } ,
	{ 0x1370, "", "ATL Products" } ,
	{ 0x1371, "", "CNet Technology Inc" } ,
	{ 0x1373, "", "Silicon Vision Inc" } ,
	{ 0x1374, "", "Silicom Ltd" } ,
	{ 0x1375, "", "Argosystems Inc" } ,
	{ 0x1376, "", "LMC" } ,
	{ 0x1377, "", "Electronic Equipment Production & Distribution GmbH" } ,
	{ 0x1378, "", "Telemann Co. Ltd" } ,
	{ 0x1379, "", "Asahi Kasei Microsystems Co Ltd" } ,
	{ 0x137A, "", "Mark of the Unicorn Inc" } ,
	{ 0x137B, "", "PPT Vision" } ,
	{ 0x137C, "", "Iwatsu Electric Co Ltd" } ,
	{ 0x137D, "", "Dynachip Corporation" } ,
	{ 0x137E, "", "Patriot Scientific Corporation" } ,
	{ 0x137F, "", "Japan Satellite Systems Inc" } ,
	{ 0x1380, "", "Sanritz Automation Co Ltd" } ,
	{ 0x1381, "", "Brains Co. Ltd" } ,
	{ 0x1382, "", "Marian - Electronic & Software" } ,
	{ 0x1383, "", "Controlnet Inc" } ,
	{ 0x1384, "", "Reality Simulation Systems Inc" } ,
	{ 0x1385, "", "Netgear" } ,
	{ 0x1386, "", "Video Domain Technologies" } ,
	{ 0x1387, "", "Systran Corp" } ,
	{ 0x1388, "", "Hitachi Information Technology Co Ltd" } ,
	{ 0x1389, "", "Applicom International" } ,
	{ 0x138A, "", "Fusion Micromedia Corp" } ,
	{ 0x138B, "", "Tokimec Inc" } ,
	{ 0x138C, "", "Silicon Reality" } ,
	{ 0x138D, "", "Future Techno Designs pte Ltd" } ,
	{ 0x138E, "", "Basler GmbH" } ,
	{ 0x138F, "", "Patapsco Designs Inc" } ,
	{ 0x1390, "", "Concept Development Inc" } ,
	{ 0x1391, "", "Development Concepts Inc" } ,
	{ 0x1392, "", "Medialight Inc" } ,
	{ 0x1393, "", "Moxa Technologies Co Ltd" } ,
	{ 0x1394, "", "Level One Communications" } ,
	{ 0x1395, "", "Ambicom Inc" } ,
	{ 0x1396, "", "Cipher Systems Inc" } ,
	{ 0x1397, "", "Cologne Chip Designs GmbH" } ,
	{ 0x1398, "", "Clarion co. Ltd" } ,
	{ 0x1399, "", "Rios systems Co Ltd" } ,
	{ 0x139A, "", "Alacritech Inc" } ,
	{ 0x139B, "", "Mediasonic Multimedia Systems Ltd" } ,
	{ 0x139C, "", "Quantum 3d Inc" } ,
	{ 0x139D, "", "EPL limited" } ,
	{ 0x139E, "", "Media4" } ,
	{ 0x139F, "", "Aethra s.r.l." } ,
	{ 0x13A0, "", "Crystal Group Inc" } ,
	{ 0x13A1, "", "Kawasaki Heavy Industries Ltd" } ,
	{ 0x13A2, "", "Ositech Communications Inc" } ,
	{ 0x13A3, "", "Hifn Inc." } ,
	{ 0x13A4, "", "Rascom Inc" } ,
	{ 0x13A5, "", "Audio Digital Imaging Inc" } ,
	{ 0x13A6, "", "Videonics Inc" } ,
	{ 0x13A7, "", "Teles AG" } ,
	{ 0x13A8, "", "Exar Corp." } ,
	{ 0x13A9, "", "Siemens Medical Systems, Ultrasound Group" } ,
	{ 0x13AA, "", "Broadband Networks Inc" } ,
	{ 0x13AB, "", "Arcom Control Systems Ltd" } ,
	{ 0x13AC, "", "Motion Media Technology Ltd" } ,
	{ 0x13AD, "", "Nexus Inc" } ,
	{ 0x13AE, "", "ALD Technology Ltd" } ,
	{ 0x13AF, "", "T.Sqware" } ,
	{ 0x13B0, "", "Maxspeed Corp" } ,
	{ 0x13B1, "", "Tamura corporation" } ,
	{ 0x13B2, "", "Techno Chips Co. Ltd" } ,
	{ 0x13B3, "", "Lanart Corporation" } ,
	{ 0x13B4, "", "Wellbean Co Inc" } ,
	{ 0x13B5, "", "ARM" } ,
	{ 0x13B6, "", "Dlog GmbH" } ,
	{ 0x13B7, "", "Logic Devices Inc" } ,
	{ 0x13B8, "", "Nokia Telecommunications oy" } ,
	{ 0x13B9, "", "Elecom Co Ltd" } ,
	{ 0x13BA, "", "Oxford Instruments" } ,
	{ 0x13BB, "", "Sanyo Technosound Co Ltd" } ,
	{ 0x13BC, "", "Bitran Corporation" } ,
	{ 0x13BD, "", "Sharp corporation" } ,
	{ 0x13BE, "", "Miroku Jyoho Service Co. Ltd" } ,
	{ 0x13BF, "", "Sharewave Inc" } ,
	{ 0x13C0, "", "Microgate Corporation" } ,
	{ 0x13C1, "", "3ware Inc" } ,
	{ 0x13C2, "", "Technotrend Systemtechnik GmbH" } ,
	{ 0x13C3, "", "Janz Computer AG" } ,
	{ 0x13C4, "", "Phase Metrics" } ,
	{ 0x13C5, "", "Alphi Technology Corp" } ,
	{ 0x13C6, "", "Condor Engineering Inc" } ,
	{ 0x13C7, "", "Blue Chip Technology Ltd" } ,
	{ 0x13C8, "", "Apptech Inc" } ,
	{ 0x13C9, "", "Eaton Corporation" } ,
	{ 0x13CA, "", "Iomega Corporation" } ,
	{ 0x13CB, "", "Yano Electric Co Ltd" } ,
	{ 0x13CC, "", "Metheus Corporation" } ,
	{ 0x13CD, "", "Compatible Systems Corporation" } ,
	{ 0x13CE, "", "Cocom A/S" } ,
	{ 0x13CF, "", "Studio Audio & Video Ltd" } ,
	{ 0x13D0, "", "Techsan Electronics Co Ltd" } ,
	{ 0x13D1, "", "Abocom Systems Inc" } ,
	{ 0x13D2, "", "Shark Multimedia Inc" } ,
	{ 0x13D3, "", "IMC Networks" } ,
	{ 0x13D4, "", "Graphics Microsystems Inc" } ,
	{ 0x13D5, "", "Media 100 Inc" } ,
	{ 0x13D6, "", "K.I. Technology Co Ltd" } ,
	{ 0x13D7, "", "Toshiba Engineering Corporation" } ,
	{ 0x13D8, "", "Phobos corporation" } ,
	{ 0x13D9, "", "Apex PC Solutions Inc" } ,
	{ 0x13DA, "", "Intresource Systems pte Ltd" } ,
	{ 0x13DB, "", "Janich & Klass Computertechnik GmbH" } ,
	{ 0x13DC, "", "Netboost Corporation" } ,
	{ 0x13DD, "", "Multimedia Bundle Inc" } ,
	{ 0x13DE, "", "ABB Robotics Products AB" } ,
	{ 0x13DF, "", "E-Tech Inc" } ,
	{ 0x13E0, "", "GVC Corporation" } ,
	{ 0x13E1, "", "Silicom Multimedia Systems Inc" } ,
	{ 0x13E2, "", "Dynamics Research Corporation" } ,
	{ 0x13E3, "", "Nest Inc" } ,
	{ 0x13E4, "", "Calculex Inc" } ,
	{ 0x13E5, "", "Telesoft Design Ltd" } ,
	{ 0x13E6, "", "Argosy research Inc" } ,
	{ 0x13E7, "", "NAC Incorporated" } ,
	{ 0x13E8, "", "Chip Express Corporation" } ,
	{ 0x13E9, "", "Intraserver Technology Inc" } ,
	{ 0x13EA, "", "Dallas Semiconductor" } ,
	{ 0x13EB, "", "Hauppauge Computer Works Inc" } ,
	{ 0x13EC, "", "Zydacron Inc" } ,
	{ 0x13ED, "", "Raytheion E-Systems" } ,
	{ 0x13EE, "", "Hayes Microcomputer Products Inc" } ,
	{ 0x13EF, "", "Coppercom Inc" } ,
	{ 0x13F0, "", "Sundance Technology Inc" } ,
	{ 0x13F1, "", "Oce' - Technologies B.V." } ,
	{ 0x13F2, "", "Ford Microelectronics Inc" } ,
	{ 0x13F3, "", "Mcdata Corporation" } ,
	{ 0x13F4, "", "Troika Networks, Inc." } ,
	{ 0x13F5, "", "Kansai Electric Co. Ltd" } ,
	{ 0x13F6, "", "C-Media Electronics Inc" } ,
	{ 0x13F7, "", "Wildfire Communications" } ,
	{ 0x13F8, "", "Ad Lib Multimedia Inc" } ,
	{ 0x13F9, "", "NTT Advanced Technology Corp." } ,
	{ 0x13FA, "", "Pentland Systems Ltd" } ,
	{ 0x13FB, "", "Aydin Corp" } ,
	{ 0x13FC, "", "Computer Peripherals International" } ,
	{ 0x13FD, "", "Micro Science Inc" } ,
	{ 0x13FE, "", "Advantech Co. Ltd" } ,
	{ 0x13FF, "", "Silicon Spice Inc" } ,
	{ 0x1400, "", "Artx Inc" } ,
	{ 0x1401, "", "CR-Systems A/S" } ,
	{ 0x1402, "", "Meilhaus Electronic GmbH" } ,
	{ 0x1403, "", "Ascor Inc" } ,
	{ 0x1404, "", "Fundamental Software Inc" } ,
	{ 0x1405, "", "Excalibur Systems Inc" } ,
	{ 0x1406, "", "Oce' Printing Systems GmbH" } ,
	{ 0x1407, "", "Lava Computer mfg Inc" } ,
	{ 0x1408, "", "Aloka Co. Ltd" } ,
	{ 0x1409, "", "Timedia Technology Co Ltd" } ,
	{ 0x140A, "", "DSP Research Inc" } ,
	{ 0x140B, "", "Ramix Inc" } ,
	{ 0x140C, "", "Elmic Systems Inc" } ,
	{ 0x140D, "", "Matsushita Electric Works Ltd" } ,
	{ 0x140E, "", "Goepel Electronic GmbH" } ,
	{ 0x140F, "", "Salient Systems Corp" } ,
	{ 0x1410, "", "Midas lab Inc" } ,
	{ 0x1411, "", "Ikos Systems Inc" } ,
	{ 0x1412, "", "VIA Technologies Inc." } ,
	{ 0x1413, "", "Addonics" } ,
	{ 0x1414, "", "Microsoft Corporation" } ,
	{ 0x1415, "", "Oxford Semiconductor Ltd" } ,
	{ 0x1416, "", "Multiwave Innovation pte Ltd" } ,
	{ 0x1417, "", "Convergenet Technologies Inc" } ,
	{ 0x1418, "", "Kyushu electronics systems Inc" } ,
	{ 0x1419, "", "Excel Switching Corp" } ,
	{ 0x141A, "", "Apache Micro Peripherals Inc" } ,
	{ 0x141B, "", "Zoom Telephonics Inc" } ,
	{ 0x141D, "", "Digitan Systems Inc" } ,
	{ 0x141E, "", "Fanuc Ltd" } ,
	{ 0x141F, "", "Visiontech Ltd" } ,
	{ 0x1420, "", "Psion Dacom plc" } ,
	{ 0x1421, "", "Ads Technologies Inc" } ,
	{ 0x1422, "", "Ygrec Systems Co Ltd" } ,
	{ 0x1423, "", "Custom Technology Corp." } ,
	{ 0x1424, "", "Videoserver Connections" } ,
	{ 0x1425, "", "Chelsio Communications Inc" } ,
	{ 0x1426, "", "Storage Technology Corp." } ,
	{ 0x1427, "", "Better On-Line Solutions" } ,
	{ 0x1428, "", "Edec Co Ltd" } ,
	{ 0x1429, "", "Unex Technology Corp." } ,
	{ 0x142A, "", "Kingmax Technology Inc" } ,
	{ 0x142B, "", "Radiolan" } ,
	{ 0x142C, "", "Minton Optic Industry Co Ltd" } ,
	{ 0x142D, "", "Pix stream Inc" } ,
	{ 0x142E, "", "Vitec Multimedia" } ,
	{ 0x142F, "", "Radicom Research Inc" } ,
	{ 0x1430, "", "ITT Aerospace/Communications Division" } ,
	{ 0x1431, "", "Gilat Satellite Networks" } ,
	{ 0x1432, "", "Edimax Computer Co." } ,
	{ 0x1433, "", "Eltec Elektronik GmbH" } ,
	{ 0x1435, "", "RTD Embedded Technologies, Inc." } ,
	{ 0x1436, "", "CIS Technology Inc" } ,
	{ 0x1437, "", "Nissin Inc Co" } ,
	{ 0x1438, "", "Atmel-dream" } ,
	{ 0x1439, "", "Outsource Engineering & Mfg. Inc" } ,
	{ 0x143A, "", "Stargate Solutions Inc" } ,
	{ 0x143B, "", "Canon Research Center, America" } ,
	{ 0x143C, "", "Amlogic Inc" } ,
	{ 0x143D, "", "Tamarack Microelectronics Inc" } ,
	{ 0x143E, "", "Jones Futurex Inc" } ,
	{ 0x143F, "", "Lightwell Co Ltd - Zax Division" } ,
	{ 0x1440, "", "ALGOL Corp." } ,
	{ 0x1441, "", "AGIE Ltd" } ,
	{ 0x1442, "", "Phoenix Contact GmbH & Co." } ,
	{ 0x1443, "", "Unibrain S.A." } ,
	{ 0x1444, "", "TRW" } ,
	{ 0x1445, "", "Logical DO Ltd" } ,
	{ 0x1446, "", "Graphin Co Ltd" } ,
	{ 0x1447, "", "AIM GmBH" } ,
	{ 0x1448, "", "Alesis Studio Electronics" } ,
	{ 0x1449, "", "TUT Systems Inc" } ,
	{ 0x144A, "", "Adlink Technology" } ,
	{ 0x144B, "", "Loronix Information Systems Inc" } ,
	{ 0x144C, "", "Catalina Research Inc" } ,
	{ 0x144D, "", "Samsung Electronics Co Ltd" } ,
	{ 0x144E, "", "OLITEC" } ,
	{ 0x144F, "", "Askey Computer Corp." } ,
	{ 0x1450, "", "Octave Communications Ind." } ,
	{ 0x1451, "", "SP3D Chip Design GmBH" } ,
	{ 0x1453, "", "MYCOM Inc" } ,
	{ 0x1454, "", "Altiga Networks" } ,
	{ 0x1455, "", "Logic Plus Plus Inc" } ,
	{ 0x1456, "", "Advanced Hardware Architectures" } ,
	{ 0x1457, "", "Nuera Communications Inc" } ,
	{ 0x1458, "", "Giga-byte Technology" } ,
	{ 0x1459, "", "DOOIN Electronics" } ,
	{ 0x145A, "", "Escalate Networks Inc" } ,
	{ 0x145B, "", "PRAIM SRL" } ,
	{ 0x145C, "", "Cryptek" } ,
	{ 0x145D, "", "Gallant Computer Inc" } ,
	{ 0x145E, "", "Aashima Technology B.V." } ,
	{ 0x145F, "", "Baldor Electric Company" } ,
	{ 0x1460, "", "DYNARC INC" } ,
	{ 0x1461, "", "Avermedia Technologies Inc" } ,
	{ 0x1462, "", "Micro-Star International Co., Ltd." } ,
	{ 0x1463, "", "Fast Corporation" } ,
	{ 0x1464, "", "Interactive Circuits & Systems Ltd" } ,
	{ 0x1465, "", "GN NETTEST Telecom DIV." } ,
	{ 0x1466, "", "Designpro Inc." } ,
	{ 0x1467, "", "DIGICOM SPA" } ,
	{ 0x1468, "", "AMBIT Microsystem Corp." } ,
	{ 0x1469, "", "Cleveland Motion Controls" } ,
	{ 0x146A, "", "IFR" } ,
	{ 0x146B, "", "Parascan Technologies Ltd" } ,
	{ 0x146C, "", "Ruby Tech Corp." } ,
	{ 0x146D, "", "Tachyon, INC." } ,
	{ 0x146E, "", "Williams Electronics Games, Inc." } ,
	{ 0x146F, "", "Multi Dimensional Consulting Inc" } ,
	{ 0x1470, "", "Bay Networks" } ,
	{ 0x1471, "", "Integrated Telecom Express Inc" } ,
	{ 0x1472, "", "DAIKIN Industries, Ltd" } ,
	{ 0x1473, "", "ZAPEX Technologies Inc" } ,
	{ 0x1474, "", "Doug Carson & Associates" } ,
	{ 0x1475, "", "PICAZO Communications" } ,
	{ 0x1476, "", "MORTARA Instrument Inc" } ,
	{ 0x1477, "", "Net Insight" } ,
	{ 0x1478, "", "DIATREND Corporation" } ,
	{ 0x1479, "", "TORAY Industries Inc" } ,
	{ 0x147A, "", "FORMOSA Industrial Computing" } ,
	{ 0x147B, "", "ABIT Computer Corp." } ,
	{ 0x147C, "", "AWARE, Inc." } ,
	{ 0x147D, "", "Interworks Computer Products" } ,
	{ 0x147E, "", "Matsushita Graphic Communication Systems, Inc." } ,
	{ 0x147F, "", "NIHON UNISYS, Ltd." } ,
	{ 0x1480, "", "SCII Telecom" } ,
	{ 0x1481, "", "BIOPAC Systems Inc" } ,
	{ 0x1482, "", "ISYTEC - Integrierte Systemtechnik GmBH" } ,
	{ 0x1483, "", "LABWAY Corporation" } ,
	{ 0x1484, "", "Logic Corporation" } ,
	{ 0x1485, "", "ERMA - Electronic GmBH" } ,
	{ 0x1486, "", "L3 Communications Telemetry & Instrumentation" } ,
	{ 0x1487, "", "MARQUETTE Medical Systems" } ,
	{ 0x1488, "", "KONTRON Electronik GmBH" } ,
	{ 0x1489, "", "KYE Systems Corporation" } ,
	{ 0x148A, "", "OPTO" } ,
	{ 0x148B, "", "INNOMEDIALOGIC Inc." } ,
	{ 0x148C, "", "C.P. Technology Co. Ltd" } ,
	{ 0x148D, "", "DIGICOM Systems, Inc." } ,
	{ 0x148E, "", "OSI Plus Corporation" } ,
	{ 0x148F, "", "Plant Equipment, Inc." } ,
	{ 0x1490, "", "Stone Microsystems PTY Ltd." } ,
	{ 0x1491, "", "ZEAL Corporation" } ,
	{ 0x1492, "", "Time Logic Corporation" } ,
	{ 0x1493, "", "MAKER Communications" } ,
	{ 0x1494, "", "WINTOP Technology, Inc." } ,
	{ 0x1495, "", "TOKAI Communications Industry Co. Ltd" } ,
	{ 0x1496, "", "JOYTECH Computer Co., Ltd." } ,
	{ 0x1497, "", "SMA Regelsysteme GmBH" } ,
	{ 0x1498, "", "TEWS Datentechnik GmBH" } ,
	{ 0x1499, "", "EMTEC CO., Ltd" } ,
	{ 0x149A, "", "ANDOR Technology Ltd" } ,
	{ 0x149B, "", "SEIKO Instruments Inc" } ,
	{ 0x149C, "", "OVISLINK Corp." } ,
	{ 0x149D, "", "NEWTEK Inc" } ,
	{ 0x149E, "", "Mapletree Networks Inc." } ,
	{ 0x149F, "", "LECTRON Co Ltd" } ,
	{ 0x14A0, "", "SOFTING GmBH" } ,
	{ 0x14A1, "", "Systembase Co Ltd" } ,
	{ 0x14A2, "", "Millennium Engineering Inc" } ,
	{ 0x14A3, "", "Maverick Networks" } ,
	{ 0x14A4, "", "GVC/BCM Advanced Research" } ,
	{ 0x14A5, "", "XIONICS Document Technologies Inc" } ,
	{ 0x14A6, "", "INOVA Computers GmBH & Co KG" } ,
	{ 0x14A7, "", "MYTHOS Systems Inc" } ,
	{ 0x14A8, "", "FEATRON Technologies Corporation" } ,
	{ 0x14A9, "", "HIVERTEC Inc" } ,
	{ 0x14AA, "", "Advanced MOS Technology Inc" } ,
	{ 0x14AB, "", "Mentor Graphics Corp." } ,
	{ 0x14AC, "", "Novaweb Technologies Inc" } ,
	{ 0x14AD, "", "Time Space Radio AB" } ,
	{ 0x14AE, "", "CTI, Inc" } ,
	{ 0x14AF, "", "Guillemot Corporation" } ,
	{ 0x14B0, "", "BST Communication Technology Ltd" } ,
	{ 0x14B1, "", "Nextcom K.K." } ,
	{ 0x14B2, "", "ENNOVATE Networks Inc" } ,
	{ 0x14B3, "", "XPEED Inc" } ,
	{ 0x14B4, "", "PHILIPS Business Electronics B.V." } ,
	{ 0x14B5, "", "Creamware GmBH" } ,
	{ 0x14B6, "", "Quantum Data Corp." } ,
	{ 0x14B7, "", "PROXIM Inc" } ,
	{ 0x14B8, "", "Techsoft Technology Co Ltd" } ,
	{ 0x14B9, "", "AIRONET Wireless Communications" } ,
	{ 0x14BA, "", "INTERNIX Inc." } ,
	{ 0x14BB, "", "SEMTECH Corporation" } ,
	{ 0x14BC, "", "Globespan Semiconductor Inc." } ,
	{ 0x14BD, "", "CARDIO Control N.V." } ,
	{ 0x14BE, "", "L3 Communications" } ,
	{ 0x14BF, "", "SPIDER Communications Inc." } ,
	{ 0x14C0, "", "COMPAL Electronics Inc" } ,
	{ 0x14C1, "", "MYRICOM Inc." } ,
	{ 0x14C2, "", "DTK Computer" } ,
	{ 0x14C3, "", "MEDIATEK Corp." } ,
	{ 0x14C4, "", "IWASAKI Information Systems Co Ltd" } ,
	{ 0x14C5, "", "Automation Products AB" } ,
	{ 0x14C6, "", "Data Race Inc" } ,
	{ 0x14C7, "", "Modular Technology Holdings Ltd" } ,
	{ 0x14C8, "", "Turbocomm Tech. Inc." } ,
	{ 0x14C9, "", "ODIN Telesystems Inc" } ,
	{ 0x14CA, "", "PE Logic Corp." } ,
	{ 0x14CB, "", "Billionton Systems Inc" } ,
	{ 0x14CC, "", "NAKAYO Telecommunications Inc" } ,
	{ 0x14CD, "", "Universal Scientific Ind." } ,
	{ 0x14CE, "", "Whistle Communications" } ,
	{ 0x14CF, "", "TEK Microsystems Inc." } ,
	{ 0x14D0, "", "Ericsson Axe R & D" } ,
	{ 0x14D1, "", "Computer Hi-Tech Co Ltd" } ,
	{ 0x14D2, "", "Titan Electronics Inc" } ,
	{ 0x14D3, "", "CIRTECH (UK) Ltd" } ,
	{ 0x14D4, "", "Panacom Technology Corp" } ,
	{ 0x14D5, "", "Nitsuko Corporation" } ,
	{ 0x14D6, "", "Accusys Inc" } ,
	{ 0x14D7, "", "Hirakawa Hewtech Corp" } ,
	{ 0x14D8, "", "HOPF Elektronik GmBH" } ,
	{ 0x14D9, "", "Alliance Semiconductor Corporation" } ,
	{ 0x14DA, "", "National Aerospace Laboratories" } ,
	{ 0x14DB, "", "AFAVLAB Technology Inc" } ,
	{ 0x14DC, "", "Amplicon Liveline Ltd" } ,
	{ 0x14DD, "", "Boulder Design Labs Inc" } ,
	{ 0x14DE, "", "Applied Integration Corporation" } ,
	{ 0x14DF, "", "ASIC Communications Corp" } ,
	{ 0x14E1, "", "INVERTEX" } ,
	{ 0x14E2, "", "INFOLIBRIA" } ,
	{ 0x14E3, "", "AMTELCO" } ,
	{ 0x14E4, "", "Broadcom Corporation" } ,
	{ 0x14E5, "", "Pixelfusion Ltd" } ,
	{ 0x14E6, "", "SHINING Technology Inc" } ,
	{ 0x14E7, "", "3CX" } ,
	{ 0x14E8, "", "RAYCER Inc" } ,
	{ 0x14E9, "", "GARNETS System CO Ltd" } ,
	{ 0x14EA, "", "Planex Communications, Inc" } ,
	{ 0x14EB, "", "SEIKO EPSON Corp" } ,
	{ 0x14EC, "", "ACQIRIS" } ,
	{ 0x14ED, "", "DATAKINETICS Ltd" } ,
	{ 0x14EE, "", "MASPRO KENKOH Corp" } ,
	{ 0x14EF, "", "CARRY Computer ENG. CO Ltd" } ,
	{ 0x14F0, "", "CANON RESEACH CENTRE FRANCE" } ,
	{ 0x14F1, "", "Conexant" } ,
	{ 0x14F2, "", "MOBILITY Electronics" } ,
	{ 0x14F3, "", "BroadLogic" } ,
	{ 0x14F4, "", "TOKYO Electronic Industry CO Ltd" } ,
	{ 0x14F5, "", "SOPAC Ltd" } ,
	{ 0x14F6, "", "COYOTE Technologies LLC" } ,
	{ 0x14F7, "", "WOLF Technology Inc" } ,
	{ 0x14F8, "", "AUDIOCODES Inc" } ,
	{ 0x14F9, "", "AG COMMUNICATIONS" } ,
	{ 0x14FA, "", "WANDEL & GOCHERMANN" } ,
	{ 0x14FB, "", "TRANSAS MARINE (UK) Ltd" } ,
	{ 0x14FC, "", "Quadrics Ltd" } ,
	{ 0x14FD, "", "JAPAN Computer Industry Inc" } ,
	{ 0x14FE, "", "ARCHTEK TELECOM Corp" } ,
	{ 0x14FF, "", "TWINHEAD INTERNATIONAL Corp" } ,
	{ 0x1500, "", "DELTA Electronics, Inc" } ,
	{ 0x1501, "", "BANKSOFT CANADA Ltd" } ,
	{ 0x1502, "", "MITSUBISHI ELECTRIC LOGISTICS SUPPORT Co Ltd" } ,
	{ 0x1503, "", "KAWASAKI LSI USA Inc" } ,
	{ 0x1504, "", "KAISER Electronics" } ,
	{ 0x1505, "", "ITA INGENIEURBURO FUR TESTAUFGABEN GmbH" } ,
	{ 0x1506, "", "CHAMELEON Systems Inc" } ,
	{ 0x1507, "", "Motorola ?? / HTEC" } ,
	{ 0x1508, "", "HONDA CONNECTORS/MHOTRONICS Inc" } ,
	{ 0x1509, "", "FIRST INTERNATIONAL Computer Inc" } ,
	{ 0x150A, "", "FORVUS RESEARCH Inc" } ,
	{ 0x150B, "", "YAMASHITA Systems Corp" } ,
	{ 0x150C, "", "KYOPAL CO Ltd" } ,
	{ 0x150D, "", "WARPSPPED Inc" } ,
	{ 0x150E, "", "C-PORT Corp" } ,
	{ 0x150F, "", "INTEC GmbH" } ,
	{ 0x1510, "", "BEHAVIOR TECH Computer Corp" } ,
	{ 0x1511, "", "CENTILLIUM Technology Corp" } ,
	{ 0x1512, "", "ROSUN Technologies Inc" } ,
	{ 0x1513, "", "Raychem" } ,
	{ 0x1514, "", "TFL LAN Inc" } ,
	{ 0x1515, "", "Advent design" } ,
	{ 0x1516, "", "MYSON Technology Inc" } ,
	{ 0x1517, "", "ECHOTEK Corp" } ,
	{ 0x1518, "", "PEP MODULAR Computers GmbH" } ,
	{ 0x1519, "", "TELEFON AKTIEBOLAGET LM Ericsson" } ,
	{ 0x151A, "", "Globetek" } ,
	{ 0x151B, "", "COMBOX Ltd" } ,
	{ 0x151C, "", "DIGITAL AUDIO LABS Inc" } ,
	{ 0x151D, "", "Fujitsu Computer Products Of America" } ,
	{ 0x151E, "", "MATRIX Corp" } ,
	{ 0x151F, "", "TOPIC SEMICONDUCTOR Corp" } ,
	{ 0x1520, "", "CHAPLET System Inc" } ,
	{ 0x1521, "", "BELL Corp" } ,
	{ 0x1522, "", "MainPine Ltd" } ,
	{ 0x1523, "", "MUSIC Semiconductors" } ,
	{ 0x1524, "", "ENE Technology Inc" } ,
	{ 0x1525, "", "IMPACT Technologies" } ,
	{ 0x1526, "", "ISS, Inc" } ,
	{ 0x1527, "", "SOLECTRON" } ,
	{ 0x1528, "", "ACKSYS" } ,
	{ 0x1529, "", "AMERICAN MICROSystems Inc" } ,
	{ 0x152A, "", "QUICKTURN DESIGN Systems" } ,
	{ 0x152B, "", "FLYTECH Technology CO Ltd" } ,
	{ 0x152C, "", "MACRAIGOR Systems LLC" } ,
	{ 0x152D, "", "QUANTA Computer Inc" } ,
	{ 0x152E, "", "MELEC Inc" } ,
	{ 0x152F, "", "PHILIPS - CRYPTO" } ,
	{ 0x1530, "", "ACQIS Technology Inc" } ,
	{ 0x1531, "", "CHRYON Corp" } ,
	{ 0x1532, "", "ECHELON Corp" } ,
	{ 0x1533, "", "BALTIMORE" } ,
	{ 0x1534, "", "ROAD Corp" } ,
	{ 0x1535, "", "EVERGREEN Technologies Inc" } ,
	{ 0x1537, "", "DATALEX COMMUNCATIONS" } ,
	{ 0x1538, "", "ARALION Inc" } ,
	{ 0x1539, "", "ATELIER INFORMATIQUES et ELECTRONIQUE ETUDES S.A." } ,
	{ 0x153A, "", "ONO SOKKI" } ,
	{ 0x153B, "", "TERRATEC Electronic GmbH" } ,
	{ 0x153C, "", "ANTAL Electronic" } ,
	{ 0x153D, "", "FILANET Corp" } ,
	{ 0x153E, "", "TECHWELL Inc" } ,
	{ 0x153F, "", "MIPS Technologies, Inc." } ,
	{ 0x1540, "", "PROVIDEO MULTIMEDIA Co Ltd" } ,
	{ 0x1541, "", "MACHONE Communications" } ,
	{ 0x1542, "", "VIVID Technology Inc" } ,
	{ 0x1543, "", "SILICON Laboratories" } ,
	{ 0x1544, "", "DCM DATA Systems" } ,
	{ 0x1545, "", "VISIONTEK" } ,
	{ 0x1546, "", "IOI Technology Corp" } ,
	{ 0x1547, "", "MITUTOYO Corp" } ,
	{ 0x1548, "", "JET PROPULSION Laboratory" } ,
	{ 0x1549, "", "INTERCONNECT Systems Solutions" } ,
	{ 0x154A, "", "MAX Technologies Inc" } ,
	{ 0x154B, "", "COMPUTEX Co Ltd" } ,
	{ 0x154C, "", "VISUAL Technology Inc" } ,
	{ 0x154D, "", "PAN INTERNATIONAL Industrial Corp" } ,
	{ 0x154E, "", "SERVOTEST Ltd" } ,
	{ 0x154F, "", "STRATABEAM Technology" } ,
	{ 0x1550, "", "OPEN NETWORK Co Ltd" } ,
	{ 0x1551, "", "SMART Electronic DEVELOPMENT GmBH" } ,
	{ 0x1552, "", "RACAL AIRTECH Ltd" } ,
	{ 0x1553, "", "CHICONY Electronics Co Ltd" } ,
	{ 0x1554, "", "PROLINK Microsystems Corp" } ,
	{ 0x1555, "", "GESYTEC GmBH" } ,
	{ 0x1556, "", "PLD APPLICATIONS" } ,
	{ 0x1557, "", "MEDIASTAR Co Ltd" } ,
	{ 0x1558, "", "CLEVO/KAPOK Computer" } ,
	{ 0x1559, "", "SI LOGIC Ltd" } ,
	{ 0x155A, "", "INNOMEDIA Inc" } ,
	{ 0x155B, "", "PROTAC INTERNATIONAL Corp" } ,
	{ 0x155C, "", "Cemax-Icon Inc" } ,
	{ 0x155D, "", "Mac System Co Ltd" } ,
	{ 0x155E, "", "LP Elektronik GmbH" } ,
	{ 0x155F, "", "Perle Systems Ltd" } ,
	{ 0x1560, "", "Terayon Communications Systems" } ,
	{ 0x1561, "", "Viewgraphics Inc" } ,
	{ 0x1562, "", "Symbol Technologies" } ,
	{ 0x1563, "", "A-Trend Technology Co Ltd" } ,
	{ 0x1564, "", "Yamakatsu Electronics Industry Co Ltd" } ,
	{ 0x1565, "", "Biostar Microtech Int'l Corp" } ,
	{ 0x1566, "", "Ardent Technologies Inc" } ,
	{ 0x1567, "", "Jungsoft" } ,
	{ 0x1568, "", "DDK Electronics Inc" } ,
	{ 0x1569, "", "Palit Microsystems Inc." } ,
	{ 0x156A, "", "Avtec Systems" } ,
	{ 0x156B, "", "2wire Inc" } ,
	{ 0x156C, "", "Vidac Electronics GmbH" } ,
	{ 0x156D, "", "Alpha-Top Corp" } ,
	{ 0x156E, "", "Alfa Inc" } ,
	{ 0x156F, "", "M-Systems Flash Disk Pioneers Ltd" } ,
	{ 0x1570, "", "Lecroy Corp" } ,
	{ 0x1571, "", "Contemporary Controls" } ,
	{ 0x1572, "", "Otis Elevator Company" } ,
	{ 0x1573, "", "Lattice - Vantis" } ,
	{ 0x1574, "", "Fairchild Semiconductor" } ,
	{ 0x1575, "", "Voltaire Advanced Data Security Ltd" } ,
	{ 0x1576, "", "Viewcast COM" } ,
	{ 0x1578, "", "HITT" } ,
	{ 0x1579, "", "Dual Technology Corp" } ,
	{ 0x157A, "", "Japan Elecronics Ind Inc" } ,
	{ 0x157B, "", "Star Multimedia Corp" } ,
	{ 0x157C, "", "Eurosoft (UK)" } ,
	{ 0x157D, "", "Gemflex Networks" } ,
	{ 0x157E, "", "Transition Networks" } ,
	{ 0x157F, "", "PX Instruments Technology Ltd" } ,
	{ 0x1580, "", "Primex Aerospace Co" } ,
	{ 0x1581, "", "SEH Computertechnik GmbH" } ,
	{ 0x1582, "", "Cytec Corp" } ,
	{ 0x1583, "", "Inet Technologies Inc" } ,
	{ 0x1584, "", "Uniwill Computer Corp" } ,
	{ 0x1585, "", "Logitron" } ,
	{ 0x1586, "", "Lancast Inc" } ,
	{ 0x1587, "", "Konica Corp" } ,
	{ 0x1588, "", "Solidum Systems Corp" } ,
	{ 0x1589, "", "Atlantek Microsystems Pty Ltd" } ,
	{ 0x158A, "", "Digalog Systems Inc" } ,
	{ 0x158B, "", "Allied Data Technologies" } ,
	{ 0x158C, "", "Hitachi Semiconductor & Devices Sales Co Ltd" } ,
	{ 0x158D, "", "Point Multimedia Systems" } ,
	{ 0x158E, "", "Lara Technology Inc" } ,
	{ 0x158F, "", "Ditect Coop" } ,
	{ 0x1590, "", "3pardata Inc" } ,
	{ 0x1591, "", "ARN" } ,
	{ 0x1592, "", "Syba Tech Ltd" } ,
	{ 0x1593, "", "Bops Inc" } ,
	{ 0x1594, "", "Netgame Ltd" } ,
	{ 0x1595, "", "Diva Systems Corp" } ,
	{ 0x1596, "", "Folsom Research Inc" } ,
	{ 0x1597, "", "Memec Design Services" } ,
	{ 0x1598, "", "Granite Microsystems" } ,
	{ 0x1599, "", "Delta Electronics Inc" } ,
	{ 0x159A, "", "General Instrument" } ,
	{ 0x159B, "", "Faraday Technology Corp" } ,
	{ 0x159C, "", "Stratus Computer Systems" } ,
	{ 0x159D, "", "Ningbo Harrison Electronics Co Ltd" } ,
	{ 0x159E, "", "A-Max Technology Co Ltd" } ,
	{ 0x159F, "", "Galea Network Security" } ,
	{ 0x15A0, "", "Compumaster SRL" } ,
	{ 0x15A1, "", "Geocast Network Systems" } ,
	{ 0x15A2, "", "Catalyst Enterprises Inc" } ,
	{ 0x15A3, "", "Italtel" } ,
	{ 0x15A4, "", "X-Net OY" } ,
	{ 0x15A5, "", "Toyota Macs Inc" } ,
	{ 0x15A6, "", "Sunlight Ultrasound Technologies Ltd" } ,
	{ 0x15A7, "", "SSE Telecom Inc" } ,
	{ 0x15A8, "", "Shanghai Communications Technologies Center" } ,
	{ 0x15AA, "", "Moreton Bay" } ,
	{ 0x15AB, "", "Bluesteel Networks Inc" } ,
	{ 0x15AC, "", "North Atlantic Instruments" } ,
	{ 0x15AD, "", "VMware Inc" } ,
	{ 0x15AE, "", "Amersham Pharmacia Biotech" } ,
	{ 0x15B0, "", "Zoltrix International Ltd" } ,
	{ 0x15B1, "", "Source Technology Inc" } ,
	{ 0x15B2, "", "Mosaid Technologies Inc" } ,
	{ 0x15B3, "", "Mellanox Technologies" } ,
	{ 0x15B4, "", "CCI/TRIAD" } ,
	{ 0x15B5, "", "Cimetrics Inc" } ,
	{ 0x15B6, "", "Texas Memory Systems Inc" } ,
	{ 0x15B7, "", "Sandisk Corp" } ,
	{ 0x15B8, "", "ADDI-DATA GmbH" } ,
	{ 0x15B9, "", "Maestro Digital Communications" } ,
	{ 0x15BA, "", "Impacct Technology Corp" } ,
	{ 0x15BB, "", "Portwell Inc" } ,
	{ 0x15BC, "", "Agilent Technologies" } ,
	{ 0x15BD, "", "DFI Inc" } ,
	{ 0x15BE, "", "Sola Electronics" } ,
	{ 0x15BF, "", "High Tech Computer Corp (HTC)" } ,
	{ 0x15C0, "", "BVM Ltd" } ,
	{ 0x15C1, "", "Quantel" } ,
	{ 0x15C2, "", "Newer Technology Inc" } ,
	{ 0x15C3, "", "Taiwan Mycomp Co Ltd" } ,
	{ 0x15C4, "", "EVSX Inc" } ,
	{ 0x15C5, "", "Procomp Informatics Ltd" } ,
	{ 0x15C6, "", "Technical University of Budapest" } ,
	{ 0x15C7, "", "Tateyama System Laboratory Co Ltd" } ,
	{ 0x15C8, "", "Penta Media Co Ltd" } ,
	{ 0x15C9, "", "Serome Technology Inc" } ,
	{ 0x15CA, "", "Bitboys OY" } ,
	{ 0x15CB, "", "AG Electronics Ltd" } ,
	{ 0x15CC, "", "Hotrail Inc" } ,
	{ 0x15CD, "", "Dreamtech Co Ltd" } ,
	{ 0x15CE, "", "Genrad Inc" } ,
	{ 0x15CF, "", "Hilscher GmbH" } ,
	{ 0x15D1, "", "Infineon Technologies AG" } ,
	{ 0x15D2, "", "FIC (First International Computer Inc)" } ,
	{ 0x15D3, "", "NDS Technologies Israel Ltd" } ,
	{ 0x15D4, "", "Iwill Corp" } ,
	{ 0x15D5, "", "Tatung Co" } ,
	{ 0x15D6, "", "Entridia Corp" } ,
	{ 0x15D7, "", "Rockwell-Collins Inc" } ,
	{ 0x15D8, "", "Cybernetics Technology Co Ltd" } ,
	{ 0x15D9, "", "Super Micro Computer Inc" } ,
	{ 0x15DA, "", "Cyberfirm Inc" } ,
	{ 0x15DB, "", "Applied Computing Systems Inc" } ,
	{ 0x15DC, "", "Litronic Inc" } ,
	{ 0x15DD, "", "Sigmatel Inc" } ,
	{ 0x15DE, "", "Malleable Technologies Inc" } ,
	{ 0x15DF, "", "Infinilink Corp" } ,
	{ 0x15E0, "", "Cacheflow Inc" } ,
	{ 0x15E1, "", "Voice Technologies Group Inc" } ,
	{ 0x15E2, "", "Quicknet Technologies Inc" } ,
	{ 0x15E3, "", "Networth Technologies Inc" } ,
	{ 0x15E4, "", "VSN Systemen BV" } ,
	{ 0x15E5, "", "Valley technologies Inc" } ,
	{ 0x15E6, "", "Agere Inc" } ,
	{ 0x15E7, "", "Get Engineering Corp" } ,
	{ 0x15E8, "", "National Datacomm Corp" } ,
	{ 0x15E9, "", "Pacific Digital Corp" } ,
	{ 0x15EA, "", "Tokyo Denshi Sekei K.K." } ,
	{ 0x15EB, "", "Drsearch GmbH" } ,
	{ 0x15EC, "", "Beckhoff GmbH" } ,
	{ 0x15ED, "", "Macrolink Inc" } ,
	{ 0x15EE, "", "In Win Development Inc" } ,
	{ 0x15EF, "", "Intelligent Paradigm Inc" } ,
	{ 0x15F0, "", "B-Tree Systems Inc" } ,
	{ 0x15F1, "", "Times N Systems Inc" } ,
	{ 0x15F2, "", "Diagnostic Instruments Inc" } ,
	{ 0x15F3, "", "Digitmedia Corp" } ,
	{ 0x15F4, "", "Valuesoft" } ,
	{ 0x15F5, "", "Power Micro Research" } ,
	{ 0x15F6, "", "Extreme Packet Device Inc" } ,
	{ 0x15F7, "", "Banctec" } ,
	{ 0x15F8, "", "Koga Electronics Co" } ,
	{ 0x15F9, "", "Zenith Electronics Corp" } ,
	{ 0x15FA, "", "J.P. Axzam Corp" } ,
	{ 0x15FB, "", "Zilog Inc" } ,
	{ 0x15FC, "", "Techsan Electronics Co Ltd" } ,
	{ 0x15FD, "", "N-CUBED.NET" } ,
	{ 0x15FE, "", "Kinpo Electronics Inc" } ,
	{ 0x15FF, "", "Fastpoint Technologies Inc" } ,
	{ 0x1600, "", "Northrop Grumman - Canada Ltd" } ,
	{ 0x1601, "", "Tenta Technology" } ,
	{ 0x1602, "", "Prosys-tec Inc" } ,
	{ 0x1603, "", "Nokia Wireless Communications" } ,
	{ 0x1604, "", "Central System Research Co Ltd" } ,
	{ 0x1605, "", "Pairgain Technologies" } ,
	{ 0x1606, "", "Europop AG" } ,
	{ 0x1607, "", "Lava Semiconductor Manufacturing Inc" } ,
	{ 0x1608, "", "Automated Wagering International" } ,
	{ 0x1609, "", "Scimetric Instruments Inc" } ,
	{ 0x1612, "", "Telesynergy Research Inc." } ,
	{ 0x1619, "", "FarSite Communications Ltd" } ,
	{ 0x161F, "", "Rioworks" } ,
	{ 0x1626, "", "TDK Semiconductor Corp." } ,
	{ 0x1629, "", "Kongsberg Spacetec AS" } ,
	{ 0x1637, "", "Linksys" } ,
	{ 0x1638, "", "Standard Microsystems Corp [SMC]" } ,
	{ 0x163C, "", "Smart Link Ltd." } ,
	{ 0x1657, "", "Brocade Communications Systems, Inc." } ,
	{ 0x165A, "", "Epix Inc" } ,
	{ 0x165D, "", "Hsing Tech. Enterprise Co., Ltd." } ,
	{ 0x165F, "", "Linux Media Labs, LLC" } ,
	{ 0x1661, "", "Worldspace Corp." } ,
	{ 0x1668, "", "Actiontec Electronics Inc" } ,
	{ 0x166D, "", "Broadcom Corporation" } ,
	{ 0x1677, "", "Bernecker + Rainer" } ,
	{ 0x167B, "", "ZyDAS Technology Corp." } ,
	{ 0x1681, "", "Hercules" } ,
	{ 0x1682, "", "XFX Pine Group Inc." } ,
	{ 0x1688, "", "CastleNet Technology Inc." } ,
	{ 0x168C, "", "Atheros Communications, Inc." } ,
	{ 0x1695, "", "EPoX Computer Co., Ltd." } ,
	{ 0x169C, "", "Netcell Corporation" } ,
	{ 0x16A5, "", "Tekram Technology Co.,Ltd." } ,
	{ 0x16AB, "", "Global Sun Technology Inc" } ,
	{ 0x16AE, "", "Safenet Inc" } ,
	{ 0x16AF, "", "SparkLAN Communications, Inc." } ,
	{ 0x16B4, "", "Aspex Semiconductor Ltd" } ,
	{ 0x16B8, "", "Sonnet Technologies, Inc." } ,
	{ 0x16BE, "", "Creatix Polymedia GmbH" } ,
	{ 0x16CA, "", "CENATEK Inc" } ,
	{ 0x16CD, "", "Densitron Technologies" } ,
	{ 0x16CE, "", "Roland Corp." } ,
	{ 0x16DF, "", "PIKA Technologies Inc." } ,
	{ 0x16E3, "", "European Space Agency" } ,
	{ 0x16EC, "", "U.S. Robotics" } ,
	{ 0x16ED, "", "Sycron N. V." } ,
	{ 0x16F3, "", "Jetway Information Co., Ltd." } ,
	{ 0x16F4, "", "Vweb Corp" } ,
	{ 0x16F6, "", "VideoTele.com, Inc." } ,
	{ 0x1702, "", "Internet Machines Corporation (IMC)" } ,
	{ 0x1705, "", "Digital First, Inc." } ,
	{ 0x170B, "", "NetOctave" } ,
	{ 0x170C, "", "YottaYotta Inc." } ,
	{ 0x1725, "", "Vitesse Semiconductor" } ,
	{ 0x172A, "", "Accelerated Encryption" } ,
	{ 0x1734, "", "Fujitsu Siemens Computer GmbH" } ,
	{ 0x1737, "", "Linksys" } ,
	{ 0x173B, "", "Altima (nee Broadcom)" } ,
	{ 0x1743, "", "Peppercon AG" } ,
	{ 0x1749, "", "RLX Technologies" } ,
	{ 0x174B, "", "PC Partner Limited" } ,
	{ 0x174D, "", "WellX Telecom SA" } ,
	{ 0x175C, "", "AudioScience Inc" } ,
	{ 0x175E, "", "Sanera Systems, Inc." } ,
	{ 0x1775, "", "SBS Technologies" } ,
	{ 0x1787, "", "Hightech Information System Ltd." } ,
	{ 0x1796, "", "Research Centre Juelich" } ,
	{ 0x1797, "", "JumpTec h, GMBH" } ,
	{ 0x1799, "", "Belkin" } ,
	{ 0x17A0, "", "Genesys Logic, Inc" } ,
	{ 0x17AA, "", "Lenovo" } ,
	{ 0x17AF, "", "Hightech Information System Ltd." } ,
	{ 0x17B3, "", "Hawking Technologies" } ,
	{ 0x17B4, "", "Indra Networks, Inc." } ,
	{ 0x17C0, "", "Wistron Corp." } ,
	{ 0x17C2, "", "Newisys, Inc." } ,
	{ 0x17CB, "", "Airgo Networks Inc" } ,
	{ 0x17CC, "", "NetChip Technology, Inc" } ,
	{ 0x17CF, "", "Z-Com, Inc." } ,
	{ 0x17D3, "", "Areca Technology Corp." } ,
	{ 0x17D5, "", "Neterion Inc." } ,
	{ 0x17DE, "", "KWorld Computer Co. Ltd." } ,
	{ 0x17EE, "", "Connect Components Ltd" } ,
	{ 0x17F2, "", "Albatron Corp." } ,
	{ 0x17FE, "", "Linksys, A Division of Cisco Systems" } ,
	{ 0x17FF, "", "Benq Corporation" } ,
	{ 0x1813, "", "Ambient Technologies Inc" } ,
	{ 0x1814, "", "RaLink" } ,
	{ 0x1820, "", "InfiniCon Systems Inc." } ,
	{ 0x1822, "", "Twinhan Technology Co. Ltd" } ,
	{ 0x182D, "", "SiteCom Europe BV" } ,
	{ 0x1830, "", "Credence Systems Corporation" } ,
	{ 0x183B, "", "MikroM GmbH" } ,
	{ 0x1849, "", "ASRock Incorporation" } ,
	{ 0x1851, "", "Microtune, Inc." } ,
	{ 0x1852, "", "Anritsu Corp." } ,
	{ 0x1854, "", "LG Electronics, Inc." } ,
	{ 0x185B, "", "Compro Technology, Inc." } ,
	{ 0x185F, "", "Wistron NeWeb Corp." } ,
	{ 0x1864, "", "SilverBack" } ,
	{ 0x1867, "", "Topspin Communications" } ,
	{ 0x187E, "", "ZyXEL Communication Corporation" } ,
	{ 0x1888, "", "Varisys Ltd" } ,
	{ 0x1894, "", "KNC One" } ,
	{ 0x1896, "", "B&B Electronics Manufacturing Company, Inc." } ,
	{ 0x18A1, "", "Astute Networks Inc." } ,
	{ 0x18AC, "", "DViCO Corporation" } ,
	{ 0x18B8, "", "Ammasso" } ,
	{ 0x18BC, "", "Info-Tek Corp." } ,
	{ 0x18C8, "", "Cray Inc" } ,
	{ 0x18C9, "", "ARVOO Engineering BV" } ,
	{ 0x18CA, "", "XGI - Xabre Graphics Inc" } ,
	{ 0x18D2, "", "Sitecom" } ,
	{ 0x18DD, "", "Artimi Inc" } ,
	{ 0x18E6, "", "MPL AG" } ,
	{ 0x18F7, "", "Commtech, Inc." } ,
	{ 0x18FB, "", "Resilience Corporation" } ,
	{ 0x1924, "", "Level 5 Networks Inc." } ,
	{ 0x192E, "", "TransDimension" } ,
	{ 0x1931, "", "Option N.V." } ,
	{ 0x1966, "", "Orad Hi-Tec Systems" } ,
	{ 0x196A, "", "Sensory Networks Inc." } ,
	{ 0x1989, "", "Montilio Inc." } ,
	{ 0x1993, "", "Innominate Security Technologies AG" } ,
	{ 0x19AE, "", "Progeny Systems Corporation" } ,
	{ 0x19D4, "", "Quixant Limited" } ,
	{ 0x1A08, "", "Sierra semiconductor" } ,
	{ 0x1B13, "", "Jaton Corp" } ,
	{ 0x1C1C, "", "Symphony" } ,
	{ 0x1D44, "", "DPT" } ,
	{ 0x1DE1, "", "Tekram Technology Co.,Ltd." } ,
	{ 0x1FC0, "", "Tumsan Oy" } ,
	{ 0x1FC1, "", "PathScale, Inc" } ,
	{ 0x1FCE, "", "Cognio Inc." } ,
	{ 0x2000, "", "Smart Link Ltd." } ,
	{ 0x2001, "", "Temporal Research Ltd" } ,
	{ 0x2003, "", "Smart Link Ltd." } ,
	{ 0x2004, "", "Smart Link Ltd." } ,
	{ 0x21C3, "", "21st Century Computer Corp." } ,
	{ 0x2348, "", "Racore" } ,
	{ 0x2646, "", "Kingston Technologies" } ,
	{ 0x270B, "", "Xantel Corporation" } ,
	{ 0x270F, "", "Chaintech Computer Co. Ltd" } ,
	{ 0x2711, "", "AVID Technology Inc." } ,
	{ 0x2A15, "", "3D Vision(???)" } ,
	{ 0x3000, "", "Hansol Electronics Inc." } ,
	{ 0x3142, "", "Post Impression Systems." } ,
	{ 0x3388, "", "Hint Corp" } ,
	{ 0x3411, "", "Quantum Designs (H.K.) Inc" } ,
	{ 0x3513, "", "ARCOM Control Systems Ltd" } ,
	{ 0x3842, "", "eVga.com. Corp." } ,
	{ 0x38EF, "", "4Links" } ,
	{ 0x3D3D, "", "3DLabs" } ,
	{ 0x4005, "", "Avance Logic Inc." } ,
	{ 0x4033, "", "Addtron Technology Co, Inc." } ,
	{ 0x4143, "", "Digital Equipment Corp" } ,
	{ 0x4144, "", "Alpha Data" } ,
	{ 0x416C, "", "Aladdin Knowledge Systems" } ,
	{ 0x4444, "", "Internext Compression Inc" } ,
	{ 0x4468, "", "Bridgeport machines" } ,
	{ 0x4594, "", "Cogetec Informatique Inc" } ,
	{ 0x45FB, "", "Baldor Electric Company" } ,
	{ 0x4680, "", "Umax Computer Corp" } ,
	{ 0x4843, "", "Hercules Computer Technology Inc" } ,
	{ 0x4916, "", "RedCreek Communications Inc" } ,
	{ 0x4943, "", "Growth Networks" } ,
	{ 0x494F, "", "ACCES I/O Products, Inc." } ,
	{ 0x4978, "", "Axil Computer Inc" } ,
	{ 0x4A14, "", "NetVin" } ,
	{ 0x4B10, "", "Buslogic Inc." } ,
	{ 0x4C48, "", "LUNG HWA Electronics" } ,
	{ 0x4C53, "", "SBS Technologies" } ,
	{ 0x4CA1, "", "Seanix Technology Inc" } ,
	{ 0x4D51, "", "MediaQ Inc." } ,
	{ 0x4D54, "", "Microtechnica Co Ltd" } ,
	{ 0x4DDC, "", "ILC Data Device Corp" } ,
	{ 0x5046, "", "GemTek Technology Corporation" } ,
	{ 0x5053, "", "Voyetra Technologies" } ,
	{ 0x5136, "", "S S Technologies" } ,
	{ 0x5143, "", "Qualcomm Inc" } ,
	{ 0x5145, "", "Ensoniq (Old)" } ,
	{ 0x5168, "", "Animation Technologies Inc." } ,
	{ 0x5301, "", "Alliance Semiconductor Corp." } ,
	{ 0x5333, "", "S3 Inc." } ,
	{ 0x544C, "", "Teralogic Inc" } ,
	{ 0x5455, "", "Technische University Berlin" } ,
	{ 0x5519, "", "Cnet Technologies, Inc." } ,
	{ 0x5544, "", "Dunord Technologies" } ,
	{ 0x5555, "", "Genroco, Inc" } ,
	{ 0x5654, "", "VoiceTronix Pty Ltd" } ,
	{ 0x5700, "", "Netpower" } ,
	{ 0x5851, "", "Exacq Technologies" } ,
	{ 0x6356, "", "UltraStor" } ,
	{ 0x6374, "", "c't Magazin fuer Computertechnik" } ,
	{ 0x6409, "", "Logitec Corp." } ,
	{ 0x6666, "", "Decision Computer International Co." } ,
	{ 0x7063, "", "pcHDTV" } ,
	{ 0x7604, "", "O.N. Electronic Co Ltd." } ,
	{ 0x7BDE, "", "MIDAC Corporation" } ,
	{ 0x7FED, "", "PowerTV" } ,
	{ 0x8008, "", "Quancom Electronic GmbH" } ,
	{ 0x807D, "", "Asustek Computer, Inc." } ,
	{ 0x8086, "", "Intel Corporation" } ,
	{ 0x8401, "", "TRENDware International Inc." } ,
	{ 0x8800, "", "Trigem Computer Inc." } ,
	{ 0x8866, "", "T-Square Design Inc." } ,
	{ 0x8888, "", "Silicon Magic" } ,
	{ 0x8912, "", "TRX" } ,
	{ 0x8C4A, "", "Winbond" } ,
	{ 0x8E0E, "", "Computone Corporation" } ,
	{ 0x8E2E, "", "KTI" } ,
	{ 0x9004, "", "Adaptec" } ,
	{ 0x9005, "", "Adaptec" } ,
	{ 0x907F, "", "Atronics" } ,
	{ 0x919A, "", "Gigapixel Corp" } ,
	{ 0x9412, "", "Holtek" } ,
	{ 0x9699, "", "Omni Media Technology Inc" } ,
	{ 0x9710, "", "NetMos Technology" } ,
	{ 0x9902, "", "Stargen Inc." } ,
	{ 0xA0A0, "", "AOPEN Inc." } ,
	{ 0xA0F1, "", "UNISYS Corporation" } ,
	{ 0xA200, "", "NEC Corporation" } ,
	{ 0xA259, "", "Hewlett Packard" } ,
	{ 0xA25B, "", "Hewlett Packard GmbH PL24-MKT" } ,
	{ 0xA304, "", "Sony" } ,
	{ 0xA727, "", "3Com Corporation" } ,
	{ 0xAA42, "", "Scitex Digital Video" } ,
	{ 0xAC1E, "", "Digital Receiver Technology Inc" } ,
	{ 0xAC3D, "", "Actuality Systems" } ,
	{ 0xAECB, "", "Adrienne Electronics Corporation" } ,
	{ 0xB1B3, "", "Shiva Europe Limited" } ,
	{ 0xBD11, "", "Pinnacle Systems, Inc. (Wrong ID)" } ,
	{ 0xC001, "", "TSI Telsys" } ,
	{ 0xC0A9, "", "Micron/Crucial Technology" } ,
	{ 0xC0DE, "", "Motorola" } ,
	{ 0xC0FE, "", "Motion Engineering, Inc." } ,
	{ 0xCA50, "", "Varian Australia Pty Ltd" } ,
	{ 0xCAFE, "", "Chrysalis-ITS" } ,
	{ 0xCCCC, "", "Catapult Communications" } ,
	{ 0xCDDD, "", "Tyzx, Inc." } ,
	{ 0xD161, "", "Digium, Inc." } ,
	{ 0xD4D4, "", "Dy4 Systems Inc" } ,
	{ 0xD531, "", "I+ME ACTIA GmbH" } ,
	{ 0xD84D, "", "Exsys" } ,
	{ 0xDEAD, "", "Indigita Corporation" } ,
	{ 0xDEAF, "", "Middle Digital Inc." } ,
	{ 0xE000, "", "Winbond" } ,
	{ 0xE159, "", "Tiger Jet Network Inc." } ,
	{ 0xE4BF, "", "EKF Elektronik GmbH" } ,
	{ 0xE55E, "", "Essence Technology, Inc." } ,
	{ 0xEA01, "", "Eagle Technology" } ,
	{ 0xEA60, "", "RME" } ,
	{ 0xEABB, "", "Aashima Technology B.V." } ,
	{ 0xEACE, "", "Endace Measurement Systems, Ltd" } ,
	{ 0xEC80, "", "Belkin Corporation" } ,
	{ 0xECC0, "", "Echo Digital Audio Corporation" } ,
	{ 0xEDD8, "", "ARK Logic Inc" } ,
	{ 0xF1D0, "", "AJA Video" } ,
	{ 0xFA57, "", "Interagon AS" } ,
	{ 0xFEBD, "", "Ultraview Corp." } ,
	{ 0xFEDA, "", "Broadcom Inc" } ,
	{ 0xFEDE, "", "Fedetec Inc." } ,
	{ 0xFFFE, "", "VMWare Inc" } ,
	{ 0xFFFF, "BAD!", "INVALID VENDOR ID" } ,
} ;

/* Use this value for loop control during searching: */
#define	PCI_VENTABLE_LEN	(sizeof(PciVenTable)/sizeof(PCI_VENTABLE))

typedef struct _PCI_DEVTABLE
{
	unsigned short	VenId ;
	unsigned short	DevId ;
	char *	Chip ;
	char *	ChipDesc ;
}  PCI_DEVTABLE, *PPCI_DEVTABLE ;

PCI_DEVTABLE	PciDevTable [] =
{
	{ 0x0070, 0x0003, "", "WinTV PVR-250" } ,
	{ 0x0070, 0x0009, "", "WinTV PVR-150" } ,
	{ 0x0070, 0x0801, "", "WinTV PVR-150" } ,
	{ 0x0070, 0x0807, "", "WinTV PVR-150" } ,
	{ 0x0070, 0x4000, "", "WinTV PVR-350" } ,
	{ 0x0070, 0x4001, "", "WinTV PVR-250 (v1)" } ,
	{ 0x0070, 0x4009, "", "WinTV PVR-250" } ,
	{ 0x0070, 0x4800, "", "WinTV PVR-350" } ,
	{ 0x0070, 0x4801, "", "WinTV PVR-250 MCE" } ,
	{ 0x0070, 0x4803, "", "WinTV PVR-250" } ,
	{ 0x0070, 0x8003, "", "WinTV PVR-150" } ,
	{ 0x0070, 0x8801, "", "WinTV PVR-150" } ,
	{ 0x0070, 0xC801, "", "WinTV PVR-150" } ,
	{ 0x0070, 0xE807, "", "WinTV PVR-500 MCE (1st tuner)" } ,
	{ 0x0070, 0xE817, "", "WinTV PVR-500 MCE (2nd tuner)" } ,
	{ 0x0095, 0x0680, "", "Ultra ATA/133 IDE RAID CONTROLLER CARD" } ,
	{ 0x018A, 0x0106, "", "FPC-0106TX misprogrammed [RTL81xx]" } ,
	{ 0x021B, 0x8139, "", "HNE-300 (RealTek RTL8139c) [iPaq Networking]" } ,
	{ 0x0270, 0x0801, "", "WinTV PVR-150" } ,
	{ 0x0291, 0x8212, "", "DM9102A(DM9102AE, SM9102AF) Ethernet 100/10 MBit(Rev 40)" } ,
	{ 0x02AC, 0x1012, "", "1012 PCMCIA 10/100 Ethernet Card [RTL81xx]" } ,
	{ 0x0357, 0x000A, "", "TTP-Monitoring Card V2.0" } ,
	{ 0x0432, 0x0001, "", "Pluto2 DVB-T Receiver for PCMCIA [EasyWatch MobilSet]" } ,
	{ 0x045E, 0x006E, "", "MN-510 802.11b wireless USB paddle" } ,
	{ 0x045E, 0x00C2, "", "MN-710 wireless USB paddle" } ,
	{ 0x04CF, 0x8818, "", "CS8818 USB2.0-to-ATAPI Bridge Controller with Embedded PHY" } ,
	{ 0x05E3, 0x0701, "", "CBD516" } ,
	{ 0x0675, 0x1700, "", "IS64PH ISDN Adapter" } ,
	{ 0x0675, 0x1702, "", "IS64PH ISDN Adapter" } ,
	{ 0x0675, 0x1703, "", "ISDN Adapter (PCI Bus, DV, W)" } ,
	{ 0x0675, 0x1704, "", "ISDN Adapter (PCI Bus, D, C)" } ,
	{ 0x067B, 0x3507, "", "PL-3507 Hi-Speed USB & IEEE 1394 Combo to IDE Bridge Controller" } ,
	{ 0x09C1, 0x0704, "", "CM 200E Cable Modem" } ,
	{ 0x0B49, 0x064F, "", "Trance Vibrator" } ,
	{ 0x0E11, 0x0001, "", "PCI to EISA Bridge" } ,
	{ 0x0E11, 0x0002, "", "PCI to ISA Bridge" } ,
	{ 0x0E11, 0x0046, "", "Smart Array 64xx" } ,
	{ 0x0E11, 0x0049, "", "NC7132 Gigabit Upgrade Module" } ,
	{ 0x0E11, 0x004A, "", "NC6136 Gigabit Server Adapter" } ,
	{ 0x0E11, 0x005A, "", "Remote Insight II board - Lights-Out" } ,
	{ 0x0E11, 0x007C, "", "NC7770 1000BaseTX" } ,
	{ 0x0E11, 0x007D, "", "NC6770 1000BaseTX" } ,
	{ 0x0E11, 0x0085, "", "NC7780 1000BaseTX" } ,
	{ 0x0E11, 0x00B1, "", "Remote Insight II board - PCI device" } ,
	{ 0x0E11, 0x00BB, "", "NC7760" } ,
	{ 0x0E11, 0x00CA, "", "NC7771" } ,
	{ 0x0E11, 0x00CB, "", "NC7781" } ,
	{ 0x0E11, 0x00CF, "", "NC7772" } ,
	{ 0x0E11, 0x00D0, "", "NC7782" } ,
	{ 0x0E11, 0x00D1, "", "NC7783" } ,
	{ 0x0E11, 0x00E3, "", "NC7761" } ,
	{ 0x0E11, 0x0508, "", "Netelligent 4/16 Token Ring" } ,
	{ 0x0E11, 0x1000, "", "Triflex/Pentium Bridge, Model 1000" } ,
	{ 0x0E11, 0x2000, "", "Triflex/Pentium Bridge, Model 2000" } ,
	{ 0x0E11, 0x3032, "", "QVision 1280/p" } ,
	{ 0x0E11, 0x3033, "", "QVision 1280/p" } ,
	{ 0x0E11, 0x3034, "", "QVision 1280/p" } ,
	{ 0x0E11, 0x4000, "", "4000 [Triflex]" } ,
	{ 0x0E11, 0x4030, "", "SMART-2/P" } ,
	{ 0x0E11, 0x4031, "", "SMART-2SL" } ,
	{ 0x0E11, 0x4032, "", "Smart Array 3200" } ,
	{ 0x0E11, 0x4033, "", "Smart Array 3100ES" } ,
	{ 0x0E11, 0x4034, "", "Smart Array 221" } ,
	{ 0x0E11, 0x4040, "", "Integrated Array" } ,
	{ 0x0E11, 0x4048, "", "Compaq Raid LC2" } ,
	{ 0x0E11, 0x4050, "", "Smart Array 4200" } ,
	{ 0x0E11, 0x4051, "", "Smart Array 4250ES" } ,
	{ 0x0E11, 0x4058, "", "Smart Array 431" } ,
	{ 0x0E11, 0x4070, "", "Smart Array 5300" } ,
	{ 0x0E11, 0x4080, "", "Smart Array 5i" } ,
	{ 0x0E11, 0x4082, "", "Smart Array 532" } ,
	{ 0x0E11, 0x4083, "", "Smart Array 5312" } ,
	{ 0x0E11, 0x4091, "", "Smart Array 6i" } ,
	{ 0x0E11, 0x409A, "", "Smart Array 641" } ,
	{ 0x0E11, 0x409B, "", "Smart Array 642" } ,
	{ 0x0E11, 0x409C, "", "Smart Array 6400" } ,
	{ 0x0E11, 0x409D, "", "Smart Array 6400 EM" } ,
	{ 0x0E11, 0x6010, "", "HotPlug PCI Bridge 6010" } ,
	{ 0x0E11, 0x7020, "", "USB Controller" } ,
	{ 0x0E11, 0xA0EC, "", "Fibre Channel Host Controller" } ,
	{ 0x0E11, 0xA0F0, "", "Advanced System Management Controller" } ,
	{ 0x0E11, 0xA0F3, "", "Triflex PCI to ISA Bridge" } ,
	{ 0x0E11, 0xA0F7, "", "PCI Hotplug Controller" } ,
	{ 0x0E11, 0xA0F8, "", "ZFMicro Chipset USB" } ,
	{ 0x0E11, 0xA0FC, "", "FibreChannel HBA Tachyon" } ,
	{ 0x0E11, 0xAE10, "", "Smart-2/P RAID Controller" } ,
	{ 0x0E11, 0xAE29, "", "MIS-L" } ,
	{ 0x0E11, 0xAE2A, "", "MPC" } ,
	{ 0x0E11, 0xAE2B, "", "MIS-E" } ,
	{ 0x0E11, 0xAE31, "", "System Management Controller" } ,
	{ 0x0E11, 0xAE32, "", "Netelligent 10/100 TX PCI UTP" } ,
	{ 0x0E11, 0xAE33, "", "Triflex Dual EIDE Controller" } ,
	{ 0x0E11, 0xAE34, "", "Netelligent 10 T PCI UTP" } ,
	{ 0x0E11, 0xAE35, "", "Integrated NetFlex-3/P" } ,
	{ 0x0E11, 0xAE40, "", "Netelligent Dual 10/100 TX PCI UTP" } ,
	{ 0x0E11, 0xAE43, "", "Netelligent Integrated 10/100 TX UTP" } ,
	{ 0x0E11, 0xAE69, "", "CETUS-L" } ,
	{ 0x0E11, 0xAE6C, "", "Northstar" } ,
	{ 0x0E11, 0xAE6D, "", "NorthStar CPU to PCI Bridge" } ,
	{ 0x0E11, 0xB011, "", "Netelligent 10/100 TX Embedded UTP" } ,
	{ 0x0E11, 0xB012, "", "Netelligent 10 T/2 PCI UTP/Coax" } ,
	{ 0x0E11, 0xB01E, "", "NC3120 Fast Ethernet NIC" } ,
	{ 0x0E11, 0xB01F, "", "NC3122 Fast Ethernet NIC" } ,
	{ 0x0E11, 0xB02F, "", "NC1120 Ethernet NIC" } ,
	{ 0x0E11, 0xB030, "", "Netelligent 10/100 TX UTP" } ,
	{ 0x0E11, 0xB04A, "", "10/100 TX PCI Intel WOL UTP Controller" } ,
	{ 0x0E11, 0xB060, "", "Smart Array 5300 Controller" } ,
	{ 0x0E11, 0xB0C6, "", "NC3161 Fast Ethernet NIC" } ,
	{ 0x0E11, 0xB0C7, "", "NC3160 Fast Ethernet NIC" } ,
	{ 0x0E11, 0xB0D7, "", "NC3121 Fast Ethernet NIC" } ,
	{ 0x0E11, 0xB0DD, "", "NC3131 Fast Ethernet NIC" } ,
	{ 0x0E11, 0xB0DE, "", "NC3132 Fast Ethernet Module" } ,
	{ 0x0E11, 0xB0DF, "", "NC6132 Gigabit Module" } ,
	{ 0x0E11, 0xB0E0, "", "NC6133 Gigabit Module" } ,
	{ 0x0E11, 0xB0E1, "", "NC3133 Fast Ethernet Module" } ,
	{ 0x0E11, 0xB123, "", "NC6134 Gigabit NIC" } ,
	{ 0x0E11, 0xB134, "", "NC3163 Fast Ethernet NIC" } ,
	{ 0x0E11, 0xB13C, "", "NC3162 Fast Ethernet NIC" } ,
	{ 0x0E11, 0xB144, "", "NC3123 Fast Ethernet NIC" } ,
	{ 0x0E11, 0xB163, "", "NC3134 Fast Ethernet NIC" } ,
	{ 0x0E11, 0xB164, "", "NC3165 Fast Ethernet Upgrade Module" } ,
	{ 0x0E11, 0xB178, "", "Smart Array 5i/532" } ,
	{ 0x0E11, 0xB1A4, "", "NC7131 Gigabit Server Adapter" } ,
	{ 0x0E11, 0xB200, "", "Memory Hot-Plug Controller" } ,
	{ 0x0E11, 0xB203, "", "Integrated Lights Out Controller" } ,
	{ 0x0E11, 0xB204, "", "Integrated Lights Out  Processor" } ,
	{ 0x0E11, 0xF130, "", "NetFlex-3/P ThunderLAN 1.0" } ,
	{ 0x0E11, 0xF150, "", "NetFlex-3/P ThunderLAN 2.3" } ,
	{ 0x1000, 0x0001, "", "53c810" } ,
	{ 0x1000, 0x0002, "", "53c820" } ,
	{ 0x1000, 0x0003, "", "53c825" } ,
	{ 0x1000, 0x0004, "", "53c815" } ,
	{ 0x1000, 0x0005, "", "53c810AP" } ,
	{ 0x1000, 0x0006, "", "53c860" } ,
	{ 0x1000, 0x000A, "", "53c1510" } ,
	{ 0x1000, 0x000B, "", "53C896/897" } ,
	{ 0x1000, 0x000C, "", "53c895" } ,
	{ 0x1000, 0x000D, "", "53c885" } ,
	{ 0x1000, 0x000F, "", "53c875" } ,
	{ 0x1000, 0x0010, "", "53C1510" } ,
	{ 0x1000, 0x0012, "", "53c895a" } ,
	{ 0x1000, 0x0013, "", "53c875a" } ,
	{ 0x1000, 0x0020, "", "53c1010 Ultra3 SCSI Adapter" } ,
	{ 0x1000, 0x0021, "", "53c1010 66MHz  Ultra3 SCSI Adapter" } ,
	{ 0x1000, 0x0030, "", "53c1030 PCI-X Fusion-MPT Dual Ultra320 SCSI" } ,
	{ 0x1000, 0x0031, "", "53c1030ZC PCI-X Fusion-MPT Dual Ultra320 SCSI" } ,
	{ 0x1000, 0x0032, "", "53c1035 PCI-X Fusion-MPT Dual Ultra320 SCSI" } ,
	{ 0x1000, 0x0033, "", "1030ZC_53c1035 PCI-X Fusion-MPT Dual Ultra320 SCSI" } ,
	{ 0x1000, 0x0040, "", "53c1035 PCI-X Fusion-MPT Dual Ultra320 SCSI" } ,
	{ 0x1000, 0x0041, "", "53C1035ZC PCI-X Fusion-MPT Dual Ultra320 SCSI" } ,
	{ 0x1000, 0x0050, "", "SAS1064 PCI-X Fusion-MPT SAS" } ,
	{ 0x1000, 0x0054, "", "SAS1068 PCI-X Fusion-MPT SAS" } ,
	{ 0x1000, 0x0056, "", "SAS1064E PCI-Express Fusion-MPT SAS" } ,
	{ 0x1000, 0x0058, "", "SAS1068E PCI-Express Fusion-MPT SAS" } ,
	{ 0x1000, 0x005A, "", "SAS1066E PCI-Express Fusion-MPT SAS" } ,
	{ 0x1000, 0x005C, "", "SAS1064A PCI-X Fusion-MPT SAS" } ,
	{ 0x1000, 0x005E, "", "SAS1066 PCI-X Fusion-MPT SAS" } ,
	{ 0x1000, 0x0060, "", "SAS1078 PCI-X Fusion-MPT SAS" } ,
	{ 0x1000, 0x008F, "", "53c875J" } ,
	{ 0x1000, 0x0407, "", "MegaRAID" } ,
	{ 0x1000, 0x0408, "", "MegaRAID" } ,
	{ 0x1000, 0x0409, "", "MegaRAID" } ,
	{ 0x1000, 0x0621, "", "FC909 Fibre Channel Adapter" } ,
	{ 0x1000, 0x0622, "", "FC929 Fibre Channel Adapter" } ,
	{ 0x1000, 0x0623, "", "FC929 LAN" } ,
	{ 0x1000, 0x0624, "", "FC919 Fibre Channel Adapter" } ,
	{ 0x1000, 0x0625, "", "FC919 LAN" } ,
	{ 0x1000, 0x0626, "", "FC929X Fibre Channel Adapter" } ,
	{ 0x1000, 0x0627, "", "FC929X LAN" } ,
	{ 0x1000, 0x0628, "", "FC919X Fibre Channel Adapter" } ,
	{ 0x1000, 0x0629, "", "FC919X LAN" } ,
	{ 0x1000, 0x0640, "", "FC949X Fibre Channel Adapter" } ,
	{ 0x1000, 0x0642, "", "FC939X Fibre Channel Adapter" } ,
	{ 0x1000, 0x0646, "", "FC949ES Fibre Channel Adapter" } ,
	{ 0x1000, 0x0701, "", "83C885 NT50 DigitalScape Fast Ethernet" } ,
	{ 0x1000, 0x0702, "", "Yellowfin G-NIC gigabit ethernet" } ,
	{ 0x1000, 0x0804, "", "SA2010" } ,
	{ 0x1000, 0x0805, "", "SA2010ZC" } ,
	{ 0x1000, 0x0806, "", "SA2020" } ,
	{ 0x1000, 0x0807, "", "SA2020ZC" } ,
	{ 0x1000, 0x0901, "", "61C102" } ,
	{ 0x1000, 0x1000, "", "63C815" } ,
	{ 0x1000, 0x1960, "", "MegaRAID" } ,
	{ 0x1001, 0x0010, "", "PCI 1616 Measurement card with 32 digital I/O lines" } ,
	{ 0x1001, 0x0011, "", "OPTO-PCI Opto-Isolated digital I/O board" } ,
	{ 0x1001, 0x0012, "", "PCI-AD/DA Analogue I/O board" } ,
	{ 0x1001, 0x0013, "", "PCI-OPTO-RELAIS Digital I/O board with relay outputs" } ,
	{ 0x1001, 0x0014, "", "PCI-Counter/Timer Counter Timer board" } ,
	{ 0x1001, 0x0015, "", "PCI-DAC416 Analogue output board" } ,
	{ 0x1001, 0x0016, "", "PCI-MFB Analogue I/O board" } ,
	{ 0x1001, 0x0017, "", "PROTO-3 PCI Prototyping board" } ,
	{ 0x1001, 0x9100, "", "INI-9100/9100W SCSI Host" } ,
	{ 0x1002, 0x3150, "", "M24 1P [Radeon Mobility X600]" } ,
	{ 0x1002, 0x3152, "", "M22 [Radeon Mobility X300]" } ,
	{ 0x1002, 0x3154, "", "M24 1T [FireGL M24 GL]" } ,
	{ 0x1002, 0x3E50, "", "RV380 0x3e50 [Radeon X600]" } ,
	{ 0x1002, 0x3E54, "", "RV380 0x3e54 [FireGL V3200]" } ,
	{ 0x1002, 0x3E70, "", "RV380 [Radeon X600] Secondary" } ,
	{ 0x1002, 0x4136, "", "Radeon IGP 320 M" } ,
	{ 0x1002, 0x4137, "", "Radeon IGP330/340/350" } ,
	{ 0x1002, 0x4144, "", "R300 AD [Radeon 9500 Pro]" } ,
	{ 0x1002, 0x4145, "", "R300 AE [Radeon 9700 Pro]" } ,
	{ 0x1002, 0x4146, "", "R300 AF [Radeon 9700 Pro]" } ,
	{ 0x1002, 0x4147, "", "R300 AG [FireGL Z1/X1]" } ,
	{ 0x1002, 0x4148, "", "R350 AH [Radeon 9800]" } ,
	{ 0x1002, 0x4149, "", "R350 AI [Radeon 9800]" } ,
	{ 0x1002, 0x414A, "", "R350 AJ [Radeon 9800]" } ,
	{ 0x1002, 0x414B, "", "R350 AK [Fire GL X2]" } ,
	{ 0x1002, 0x4150, "", "RV350 AP [Radeon 9600]" } ,
	{ 0x1002, 0x4151, "", "RV350 AQ [Radeon 9600]" } ,
	{ 0x1002, 0x4152, "", "RV350 AR [Radeon 9600]" } ,
	{ 0x1002, 0x4153, "", "RV350 AS [Radeon 9550]" } ,
	{ 0x1002, 0x4154, "", "RV350 AT [Fire GL T2]" } ,
	{ 0x1002, 0x4155, "", "RV350 AU [Fire GL T2]" } ,
	{ 0x1002, 0x4156, "", "RV350 AV [Fire GL T2]" } ,
	{ 0x1002, 0x4157, "", "RV350 AW [Fire GL T2]" } ,
	{ 0x1002, 0x4158, "", "68800AX [Mach32]" } ,
	{ 0x1002, 0x4164, "", "R300 AD [Radeon 9500 Pro] (Secondary)" } ,
	{ 0x1002, 0x4165, "", "R300 AE [Radeon 9700 Pro] (Secondary)" } ,
	{ 0x1002, 0x4166, "", "R300 AF [Radeon 9700 Pro] (Secondary)" } ,
	{ 0x1002, 0x4168, "", "Radeon R350 [Radeon 9800] (Secondary)" } ,
	{ 0x1002, 0x4170, "", "RV350 AP [Radeon 9600] (Secondary)" } ,
	{ 0x1002, 0x4171, "", "RV350 AQ [Radeon 9600] (Secondary)" } ,
	{ 0x1002, 0x4172, "", "RV350 AR [Radeon 9600] (Secondary)" } ,
	{ 0x1002, 0x4173, "", "RV350 ?? [Radeon 9550] (Secondary)" } ,
	{ 0x1002, 0x4237, "", "Radeon 7000 IGP" } ,
	{ 0x1002, 0x4242, "", "R200 BB [Radeon All in Wonder 8500DV]" } ,
	{ 0x1002, 0x4243, "", "R200 BC [Radeon All in Wonder 8500]" } ,
	{ 0x1002, 0x4336, "", "Radeon Mobility U1" } ,
	{ 0x1002, 0x4337, "", "Radeon IGP 330M/340M/350M" } ,
	{ 0x1002, 0x4341, "", "IXP150 AC'97 Audio Controller" } ,
	{ 0x1002, 0x4345, "", "EHCI USB Controller" } ,
	{ 0x1002, 0x4347, "", "OHCI USB Controller #1" } ,
	{ 0x1002, 0x4348, "", "OHCI USB Controller #2" } ,
	{ 0x1002, 0x4349, "", "ATI Dual Channel Bus Master PCI IDE Controller" } ,
	{ 0x1002, 0x434D, "", "IXP AC'97 Modem" } ,
	{ 0x1002, 0x4353, "", "ATI SMBus" } ,
	{ 0x1002, 0x4354, "", "215CT [Mach64 CT]" } ,
	{ 0x1002, 0x4358, "", "210888CX [Mach64 CX]" } ,
	{ 0x1002, 0x4363, "", "ATI SMBus" } ,
	{ 0x1002, 0x436E, "", "ATI 436E Serial ATA Controller" } ,
	{ 0x1002, 0x4370, "", "IXP SB400 AC'97 Audio Controller" } ,
	{ 0x1002, 0x4371, "", "IXP SB400 PCI-PCI Bridge" } ,
	{ 0x1002, 0x4372, "", "IXP SB400 SMBus Controller" } ,
	{ 0x1002, 0x4373, "", "IXP SB400 USB2 Host Controller" } ,
	{ 0x1002, 0x4374, "", "IXP SB400 USB Host Controller" } ,
	{ 0x1002, 0x4375, "", "IXP SB400 USB Host Controller" } ,
	{ 0x1002, 0x4376, "", "Standard Dual Channel PCI IDE Controller ATI" } ,
	{ 0x1002, 0x4377, "", "IXP SB400 PCI-ISA Bridge" } ,
	{ 0x1002, 0x4378, "", "ATI SB400 - AC'97 Modem Controller" } ,
	{ 0x1002, 0x4379, "", "ATI 4379 Serial ATA Controller" } ,
	{ 0x1002, 0x437A, "", "ATI 437A Serial ATA Controller" } ,
	{ 0x1002, 0x4437, "", "Radeon Mobility 7000 IGP" } ,
	{ 0x1002, 0x4554, "", "210888ET [Mach64 ET]" } ,
	{ 0x1002, 0x4654, "", "Mach64 VT" } ,
	{ 0x1002, 0x4742, "", "3D Rage Pro AGP 1X/2X" } ,
	{ 0x1002, 0x4744, "", "3D Rage Pro AGP 1X" } ,
	{ 0x1002, 0x4747, "", "3D Rage Pro" } ,
	{ 0x1002, 0x4749, "", "3D Rage Pro" } ,
	{ 0x1002, 0x474C, "", "Rage XC" } ,
	{ 0x1002, 0x474D, "", "Rage XL AGP 2X" } ,
	{ 0x1002, 0x474E, "", "Rage XC AGP" } ,
	{ 0x1002, 0x474F, "", "Rage XL" } ,
	{ 0x1002, 0x4750, "", "3D Rage Pro 215GP" } ,
	{ 0x1002, 0x4751, "", "3D Rage Pro 215GQ" } ,
	{ 0x1002, 0x4752, "", "Rage XL" } ,
	{ 0x1002, 0x4753, "", "Rage XC" } ,
	{ 0x1002, 0x4754, "", "3D Rage I/II 215GT [Mach64 GT]" } ,
	{ 0x1002, 0x4755, "", "3D Rage II+ 215GTB [Mach64 GTB]" } ,
	{ 0x1002, 0x4756, "", "3D Rage IIC 215IIC [Mach64 GT IIC]" } ,
	{ 0x1002, 0x4757, "", "3D Rage IIC AGP" } ,
	{ 0x1002, 0x4758, "", "210888GX [Mach64 GX]" } ,
	{ 0x1002, 0x4759, "", "3D Rage IIC" } ,
	{ 0x1002, 0x475A, "", "3D Rage IIC AGP" } ,
	{ 0x1002, 0x4964, "", "Radeon RV250 Id [Radeon 9000]" } ,
	{ 0x1002, 0x4965, "", "Radeon RV250 Ie [Radeon 9000]" } ,
	{ 0x1002, 0x4966, "", "Radeon RV250 If [Radeon 9000]" } ,
	{ 0x1002, 0x4967, "", "Radeon RV250 Ig [Radeon 9000]" } ,
	{ 0x1002, 0x496E, "", "Radeon RV250 [Radeon 9000] (Secondary)" } ,
	{ 0x1002, 0x4A48, "", "R420 JH [Radeon X800]" } ,
	{ 0x1002, 0x4A49, "", "R420 JI [Radeon X800PRO]" } ,
	{ 0x1002, 0x4A4A, "", "R420 JJ [Radeon X800SE]" } ,
	{ 0x1002, 0x4A4B, "", "R420 JK [Radeon X800]" } ,
	{ 0x1002, 0x4A4C, "", "R420 JL [Radeon X800]" } ,
	{ 0x1002, 0x4A4D, "", "R420 JM [FireGL X3]" } ,
	{ 0x1002, 0x4A4E, "", "M18 JN [Radeon Mobility 9800]" } ,
	{ 0x1002, 0x4A50, "", "R420 JP [Radeon X800XT]" } ,
	{ 0x1002, 0x4A70, "", "R420 [X800XT-PE] (Secondary)" } ,
	{ 0x1002, 0x4B49, "", "R480 [Radeon X850XT]" } ,
	{ 0x1002, 0x4B4C, "", "R481 [Radeon X850XT-PE]" } ,
	{ 0x1002, 0x4B69, "", "R480 [Radeon X850XT secondary]" } ,
	{ 0x1002, 0x4B6B, "", "R480 [Radeon X850Pro] (Secondary)" } ,
	{ 0x1002, 0x4B6C, "", "R481 [Radeon X850XT-PE] Secondary" } ,
	{ 0x1002, 0x4C42, "", "3D Rage LT Pro AGP-133" } ,
	{ 0x1002, 0x4C44, "", "3D Rage LT Pro AGP-66" } ,
	{ 0x1002, 0x4C45, "", "Rage Mobility M3 AGP" } ,
	{ 0x1002, 0x4C46, "", "Rage Mobility M3 AGP 2x" } ,
	{ 0x1002, 0x4C47, "", "3D Rage LT-G 215LG" } ,
	{ 0x1002, 0x4C49, "", "3D Rage LT Pro" } ,
	{ 0x1002, 0x4C4D, "", "Rage Mobility P/M AGP 2x" } ,
	{ 0x1002, 0x4C4E, "", "Rage Mobility L AGP 2x" } ,
	{ 0x1002, 0x4C50, "", "3D Rage LT Pro" } ,
	{ 0x1002, 0x4C51, "", "3D Rage LT Pro" } ,
	{ 0x1002, 0x4C52, "", "Rage Mobility P/M" } ,
	{ 0x1002, 0x4C53, "", "Rage Mobility L" } ,
	{ 0x1002, 0x4C54, "", "264LT [Mach64 LT]" } ,
	{ 0x1002, 0x4C57, "", "Radeon Mobility M7 LW [Radeon Mobility 7500]" } ,
	{ 0x1002, 0x4C58, "", "Radeon RV200 LX [Mobility FireGL 7800 M7]" } ,
	{ 0x1002, 0x4C59, "", "Radeon Mobility M6 LY" } ,
	{ 0x1002, 0x4C5A, "", "Radeon Mobility M6 LZ" } ,
	{ 0x1002, 0x4C64, "", "Radeon R250 Ld [Radeon Mobility 9000 M9]" } ,
	{ 0x1002, 0x4C65, "", "Radeon R250 Le [Radeon Mobility 9000 M9]" } ,
	{ 0x1002, 0x4C66, "", "Radeon R250 Lf [FireGL 9000]" } ,
	{ 0x1002, 0x4C67, "", "Radeon R250 Lg [Radeon Mobility 9000 M9]" } ,
	{ 0x1002, 0x4C6E, "", "Radeon R250 Ln [Radeon Mobility 9000 M9] [Secondary]" } ,
	{ 0x1002, 0x4D46, "", "Rage Mobility M4 AGP" } ,
	{ 0x1002, 0x4D4C, "", "Rage Mobility M4 AGP" } ,
	{ 0x1002, 0x4E44, "", "Radeon R300 ND [Radeon 9700 Pro]" } ,
	{ 0x1002, 0x4E45, "", "Radeon R300 NE [Radeon 9500 Pro]" } ,
	{ 0x1002, 0x4E46, "", "RV350 NF [Radeon 9600]" } ,
	{ 0x1002, 0x4E47, "", "Radeon R300 NG [FireGL X1]" } ,
	{ 0x1002, 0x4E48, "", "Radeon R350 [Radeon 9800 Pro]" } ,
	{ 0x1002, 0x4E49, "", "Radeon R350 [Radeon 9800]" } ,
	{ 0x1002, 0x4E4A, "", "RV350 NJ [Radeon 9800 XT]" } ,
	{ 0x1002, 0x4E4B, "", "R350 NK [Fire GL X2]" } ,
	{ 0x1002, 0x4E50, "", "RV350 [Mobility Radeon 9600 M10]" } ,
	{ 0x1002, 0x4E51, "", "M10 NQ [Radeon Mobility 9600]" } ,
	{ 0x1002, 0x4E52, "", "RV350 [Mobility Radeon 9600 M10]" } ,
	{ 0x1002, 0x4E53, "", "M10 NS [Radeon Mobility 9600]" } ,
	{ 0x1002, 0x4E54, "", "M10 NT [FireGL Mobility T2]" } ,
	{ 0x1002, 0x4E56, "", "M11 NV [FireGL Mobility T2e]" } ,
	{ 0x1002, 0x4E64, "", "Radeon R300 [Radeon 9700 Pro] (Secondary)" } ,
	{ 0x1002, 0x4E65, "", "Radeon R300 [Radeon 9500 Pro] (Secondary)" } ,
	{ 0x1002, 0x4E66, "", "RV350 NF [Radeon 9600] (Secondary)" } ,
	{ 0x1002, 0x4E67, "", "Radeon R300 [FireGL X1] (Secondary)" } ,
	{ 0x1002, 0x4E68, "", "Radeon R350 [Radeon 9800 Pro] (Secondary)" } ,
	{ 0x1002, 0x4E69, "", "Radeon R350 [Radeon 9800] (Secondary)" } ,
	{ 0x1002, 0x4E6A, "", "RV350 NJ [Radeon 9800 XT] (Secondary)" } ,
	{ 0x1002, 0x4E71, "", "M10 NQ [Radeon Mobility 9600] (secondary)" } ,
	{ 0x1002, 0x5041, "", "Rage 128 PA/PRO" } ,
	{ 0x1002, 0x5042, "", "Rage 128 PB/PRO AGP 2x" } ,
	{ 0x1002, 0x5043, "", "Rage 128 PC/PRO AGP 4x" } ,
	{ 0x1002, 0x5044, "", "Rage 128 PD/PRO TMDS" } ,
	{ 0x1002, 0x5045, "", "Rage 128 PE/PRO AGP 2x TMDS" } ,
	{ 0x1002, 0x5046, "", "Rage 128 PF/PRO AGP 4x TMDS" } ,
	{ 0x1002, 0x5047, "", "Rage 128 PG/PRO" } ,
	{ 0x1002, 0x5048, "", "Rage 128 PH/PRO AGP 2x" } ,
	{ 0x1002, 0x5049, "", "Rage 128 PI/PRO AGP 4x" } ,
	{ 0x1002, 0x504A, "", "Rage 128 PJ/PRO TMDS" } ,
	{ 0x1002, 0x504B, "", "Rage 128 PK/PRO AGP 2x TMDS" } ,
	{ 0x1002, 0x504C, "", "Rage 128 PL/PRO AGP 4x TMDS" } ,
	{ 0x1002, 0x504D, "", "Rage 128 PM/PRO" } ,
	{ 0x1002, 0x504E, "", "Rage 128 PN/PRO AGP 2x" } ,
	{ 0x1002, 0x504F, "", "Rage 128 PO/PRO AGP 4x" } ,
	{ 0x1002, 0x5050, "", "Rage 128 PP/PRO TMDS [Xpert 128]" } ,
	{ 0x1002, 0x5051, "", "Rage 128 PQ/PRO AGP 2x TMDS" } ,
	{ 0x1002, 0x5052, "", "Rage 128 PR/PRO AGP 4x TMDS" } ,
	{ 0x1002, 0x5053, "", "Rage 128 PS/PRO" } ,
	{ 0x1002, 0x5054, "", "Rage 128 PT/PRO AGP 2x" } ,
	{ 0x1002, 0x5055, "", "Rage 128 PU/PRO AGP 4x" } ,
	{ 0x1002, 0x5056, "", "Rage 128 PV/PRO TMDS" } ,
	{ 0x1002, 0x5057, "", "Rage 128 PW/PRO AGP 2x TMDS" } ,
	{ 0x1002, 0x5058, "", "Rage 128 PX/PRO AGP 4x TMDS" } ,
	{ 0x1002, 0x5144, "", "Radeon R100 QD [Radeon 7200]" } ,
	{ 0x1002, 0x5145, "", "Radeon R100 QE" } ,
	{ 0x1002, 0x5146, "", "Radeon R100 QF" } ,
	{ 0x1002, 0x5147, "", "Radeon R100 QG" } ,
	{ 0x1002, 0x5148, "", "Radeon R200 QH [Radeon 8500]" } ,
	{ 0x1002, 0x5149, "", "Radeon R200 QI" } ,
	{ 0x1002, 0x514A, "", "Radeon R200 QJ" } ,
	{ 0x1002, 0x514B, "", "Radeon R200 QK" } ,
	{ 0x1002, 0x514C, "", "Radeon R200 QL [Radeon 8500 LE]" } ,
	{ 0x1002, 0x514D, "", "Radeon R200 QM [Radeon 9100]" } ,
	{ 0x1002, 0x514E, "", "Radeon R200 QN [Radeon 8500LE]" } ,
	{ 0x1002, 0x514F, "", "Radeon R200 QO [Radeon 8500LE]" } ,
	{ 0x1002, 0x5154, "", "R200 QT [Radeon 8500]" } ,
	{ 0x1002, 0x5155, "", "R200 QU [Radeon 9100]" } ,
	{ 0x1002, 0x5157, "", "Radeon RV200 QW [Radeon 7500]" } ,
	{ 0x1002, 0x5158, "", "Radeon RV200 QX [Radeon 7500]" } ,
	{ 0x1002, 0x5159, "", "Radeon RV100 QY [Radeon 7000/VE]" } ,
	{ 0x1002, 0x515A, "", "Radeon RV100 QZ [Radeon 7000/VE]" } ,
	{ 0x1002, 0x5168, "", "Radeon R200 Qh" } ,
	{ 0x1002, 0x5169, "", "Radeon R200 Qi" } ,
	{ 0x1002, 0x516A, "", "Radeon R200 Qj" } ,
	{ 0x1002, 0x516B, "", "Radeon R200 Qk" } ,
	{ 0x1002, 0x516C, "", "Radeon R200 Ql" } ,
	{ 0x1002, 0x5245, "", "Rage 128 RE/SG" } ,
	{ 0x1002, 0x5246, "", "Rage 128 RF/SG AGP" } ,
	{ 0x1002, 0x5247, "", "Rage 128 RG" } ,
	{ 0x1002, 0x524B, "", "Rage 128 RK/VR" } ,
	{ 0x1002, 0x524C, "", "Rage 128 RL/VR AGP" } ,
	{ 0x1002, 0x5345, "", "Rage 128 SE/4x" } ,
	{ 0x1002, 0x5346, "", "Rage 128 SF/4x AGP 2x" } ,
	{ 0x1002, 0x5347, "", "Rage 128 SG/4x AGP 4x" } ,
	{ 0x1002, 0x5348, "", "Rage 128 SH" } ,
	{ 0x1002, 0x534B, "", "Rage 128 SK/4x" } ,
	{ 0x1002, 0x534C, "", "Rage 128 SL/4x AGP 2x" } ,
	{ 0x1002, 0x534D, "", "Rage 128 SM/4x AGP 4x" } ,
	{ 0x1002, 0x534E, "", "Rage 128 4x" } ,
	{ 0x1002, 0x5354, "", "Mach 64 VT" } ,
	{ 0x1002, 0x5446, "", "Rage 128 Pro Ultra TF" } ,
	{ 0x1002, 0x544C, "", "Rage 128 Pro Ultra TL" } ,
	{ 0x1002, 0x5452, "", "Rage 128 Pro Ultra TR" } ,
	{ 0x1002, 0x5453, "", "Rage 128 Pro Ultra TS" } ,
	{ 0x1002, 0x5454, "", "Rage 128 Pro Ultra TT" } ,
	{ 0x1002, 0x5455, "", "Rage 128 Pro Ultra TU" } ,
	{ 0x1002, 0x5460, "", "M22 [Radeon Mobility M300]" } ,
	{ 0x1002, 0x5464, "", "M22 [FireGL GL]" } ,
	{ 0x1002, 0x5548, "", "R423 UH [Radeon X800 (PCIE)]" } ,
	{ 0x1002, 0x5549, "", "R423 UI [Radeon X800PRO (PCIE)]" } ,
	{ 0x1002, 0x554A, "", "R423 UJ [Radeon X800LE (PCIE)]" } ,
	{ 0x1002, 0x554B, "", "R423 UK [Radeon X800SE (PCIE)]" } ,
	{ 0x1002, 0x554D, "", "R430 [Radeon X800 XL] (PCIe)" } ,
	{ 0x1002, 0x554F, "", "R430 [Radeon X800 (PCIE)]" } ,
	{ 0x1002, 0x5550, "", "R423 [Fire GL V7100]" } ,
	{ 0x1002, 0x5551, "", "R423 UQ [FireGL V7200 (PCIE)]" } ,
	{ 0x1002, 0x5552, "", "R423 UR [FireGL V5100 (PCIE)]" } ,
	{ 0x1002, 0x5554, "", "R423 UT [FireGL V7100 (PCIE)]" } ,
	{ 0x1002, 0x556B, "", "Radeon R423 UK (PCIE) [X800 SE] (Secondary)" } ,
	{ 0x1002, 0x556D, "", "R430 [Radeon X800 XL] (PCIe) Secondary" } ,
	{ 0x1002, 0x556F, "", "R430 [Radeon X800 (PCIE) Secondary]" } ,
	{ 0x1002, 0x564A, "", "M26 [Mobility FireGL V5000]" } ,
	{ 0x1002, 0x564B, "", "M26 [Mobility FireGL V5000]" } ,
	{ 0x1002, 0x5652, "", "M26 [Radeon Mobility X700]" } ,
	{ 0x1002, 0x5653, "", "Radeon Mobility X700 (PCIE)" } ,
	{ 0x1002, 0x5654, "", "264VT [Mach64 VT]" } ,
	{ 0x1002, 0x5655, "", "264VT3 [Mach64 VT3]" } ,
	{ 0x1002, 0x5656, "", "264VT4 [Mach64 VT4]" } ,
	{ 0x1002, 0x5830, "", "RS300 Host Bridge" } ,
	{ 0x1002, 0x5831, "", "RS300 Host Bridge" } ,
	{ 0x1002, 0x5832, "", "RS300 Host Bridge" } ,
	{ 0x1002, 0x5833, "", "Radeon 9100 IGP Host Bridge" } ,
	{ 0x1002, 0x5834, "", "Radeon 9100 IGP" } ,
	{ 0x1002, 0x5835, "", "RS300M AGP [Radeon Mobility 9100IGP]" } ,
	{ 0x1002, 0x5838, "", "Radeon 9100 IGP AGP Bridge" } ,
	{ 0x1002, 0x5940, "", "RV280 [Radeon 9200 PRO] (Secondary)" } ,
	{ 0x1002, 0x5941, "", "RV280 [Radeon 9200] (Secondary)" } ,
	{ 0x1002, 0x5944, "", "RV280 [Radeon 9200 SE (PCI)]" } ,
	{ 0x1002, 0x5950, "", "RS480 Host Bridge" } ,
	{ 0x1002, 0x5951, "", "ATI Radeon Xpress 200 (RS480/RS482/RX480/RX482) Chipset - Host bridge" } ,
	{ 0x1002, 0x5954, "", "RS480 [Radeon Xpress 200G Series]" } ,
	{ 0x1002, 0x5955, "", "ATI Radeon XPRESS 200M 5955 (PCIE)" } ,
	{ 0x1002, 0x5960, "", "RV280 [Radeon 9200 PRO]" } ,
	{ 0x1002, 0x5961, "", "RV280 [Radeon 9200]" } ,
	{ 0x1002, 0x5962, "", "RV280 [Radeon 9200]" } ,
	{ 0x1002, 0x5964, "", "RV280 [Radeon 9200 SE]" } ,
	{ 0x1002, 0x5969, "", "RN50" } ,
	{ 0x1002, 0x5974, "", "RS482 [Radeon Xpress 200]" } ,
	{ 0x1002, 0x5975, "", "RS482 [Radeon Xpress 200M]" } ,
	{ 0x1002, 0x5A34, "", "RS480 PCI-X Root Port" } ,
	{ 0x1002, 0x5A41, "", "RS400 [Radeon Xpress 200]" } ,
	{ 0x1002, 0x5A42, "", "RS400 [Radeon Xpress 200M]" } ,
	{ 0x1002, 0x5A61, "", "RC410 [Radeon Xpress 200]" } ,
	{ 0x1002, 0x5A62, "", "RC410 [Radeon Xpress 200M]" } ,
	{ 0x1002, 0x5B60, "", "RV370 5B60 [Radeon X300 (PCIE)]" } ,
	{ 0x1002, 0x5B62, "", "RV370 5B62 [Radeon X600 (PCIE)]" } ,
	{ 0x1002, 0x5B63, "", "RV370 [ATI Sapphire X550 Silent]" } ,
	{ 0x1002, 0x5B64, "", "RV370 5B64 [FireGL V3100 (PCIE)]" } ,
	{ 0x1002, 0x5B65, "", "RV370 5B65 [FireGL D1100 (PCIE)]" } ,
	{ 0x1002, 0x5B70, "", "RV370 [Radeon X300SE]" } ,
	{ 0x1002, 0x5B72, "", "Radeon X600(RV380)" } ,
	{ 0x1002, 0x5B73, "", "RV370 secondary [ATI Sapphire X550 Silent]" } ,
	{ 0x1002, 0x5B74, "", "RV370 5B64 [FireGL V3100 (PCIE)] (Secondary)" } ,
	{ 0x1002, 0x5C61, "", "M9+ 5C61 [Radeon Mobility 9200 (AGP)]" } ,
	{ 0x1002, 0x5C63, "", "M9+ 5C63 [Radeon Mobility 9200 (AGP)]" } ,
	{ 0x1002, 0x5D44, "", "RV280 [Radeon 9200 SE] (Secondary)" } ,
	{ 0x1002, 0x5D48, "", "M28 [Radeon Mobility X800XT]" } ,
	{ 0x1002, 0x5D49, "", "M28 [Mobility FireGL V5100]" } ,
	{ 0x1002, 0x5D4A, "", "Mobility Radeon X800" } ,
	{ 0x1002, 0x5D4D, "", "R480 [Radeon X850XT Platinum (PCIE)]" } ,
	{ 0x1002, 0x5D52, "", "R480 [Radeon X850XT (PCIE)] (Primary)" } ,
	{ 0x1002, 0x5D57, "", "R423 5F57 [Radeon X800XT (PCIE)]" } ,
	{ 0x1002, 0x5D6D, "", "R480 [Radeon X850XT Platinum (PCIE)] (Secondary)" } ,
	{ 0x1002, 0x5D72, "", "R480 [Radeon X850XT (PCIE)] (Secondary)" } ,
	{ 0x1002, 0x5D77, "", "R423 5F57 [Radeon X800XT (PCIE)] (Secondary)" } ,
	{ 0x1002, 0x5E48, "", "RV410 [FireGL V5000]" } ,
	{ 0x1002, 0x5E49, "", "RV410 [FireGL V3300]" } ,
	{ 0x1002, 0x5E4A, "", "RV410 [Radeon X700XT]" } ,
	{ 0x1002, 0x5E4B, "", "RV410 [Radeon X700 Pro (PCIE)]" } ,
	{ 0x1002, 0x5E4C, "", "RV410 [Radeon X700SE]" } ,
	{ 0x1002, 0x5E4D, "", "RV410 [Radeon X700 (PCIE)]" } ,
	{ 0x1002, 0x5E4F, "", "RV410 [Radeon X700]" } ,
	{ 0x1002, 0x5E6B, "", "RV410 [Radeon X700 Pro (PCIE)] Secondary" } ,
	{ 0x1002, 0x5E6D, "", "RV410 [Radeon X700 (PCIE)] (Secondary)" } ,
	{ 0x1002, 0x700F, "", "PCI Bridge [IGP 320M]" } ,
	{ 0x1002, 0x7010, "", "PCI Bridge [IGP 340M]" } ,
	{ 0x1002, 0x7105, "", "R520 [FireGL]" } ,
	{ 0x1002, 0x7109, "", "R520 [Radeon X900]" } ,
	{ 0x1002, 0x7833, "", "Radeon 9100 IGP Host Bridge" } ,
	{ 0x1002, 0x7834, "", "Radeon 9100 PRO IGP" } ,
	{ 0x1002, 0x7835, "", "Radeon Mobility 9200 IGP" } ,
	{ 0x1002, 0x7838, "", "Radeon 9100 IGP PCI/AGP Bridge" } ,
	{ 0x1002, 0x7C37, "", "RV350 AQ [Radeon 9600 SE]" } ,
	{ 0x1002, 0xCAB0, "", "AGP Bridge [IGP 320M]" } ,
	{ 0x1002, 0xCAB2, "", "RS200/RS200M AGP Bridge [IGP 340M]" } ,
	{ 0x1002, 0xCAB3, "", "R200 AGP Bridge [Mobility Radeon 7000 IGP]" } ,
	{ 0x1002, 0xCBB2, "", "RS200/RS200M AGP Bridge [IGP 340M]" } ,
	{ 0x1003, 0x0201, "", "US201" } ,
	{ 0x1004, 0x0005, "", "82C592-FC1" } ,
	{ 0x1004, 0x0006, "", "82C593-FC1" } ,
	{ 0x1004, 0x0007, "", "82C594-AFC2" } ,
	{ 0x1004, 0x0008, "", "82C596/7 [Wildcat]" } ,
	{ 0x1004, 0x0009, "", "82C597-AFC2" } ,
	{ 0x1004, 0x000C, "", "82C541 [Lynx]" } ,
	{ 0x1004, 0x000D, "", "82C543 [Lynx]" } ,
	{ 0x1004, 0x0101, "", "82C532" } ,
	{ 0x1004, 0x0102, "", "82C534 [Eagle]" } ,
	{ 0x1004, 0x0103, "", "82C538" } ,
	{ 0x1004, 0x0104, "", "82C535" } ,
	{ 0x1004, 0x0105, "", "82C147" } ,
	{ 0x1004, 0x0200, "", "82C975" } ,
	{ 0x1004, 0x0280, "", "82C925" } ,
	{ 0x1004, 0x0304, "", "QSound ThunderBird PCI Audio" } ,
	{ 0x1004, 0x0305, "", "QSound ThunderBird PCI Audio Gameport" } ,
	{ 0x1004, 0x0306, "", "QSound ThunderBird PCI Audio Support Registers" } ,
	{ 0x1004, 0x0307, "", "Thunderbird" } ,
	{ 0x1004, 0x0308, "", "Thunderbird" } ,
	{ 0x1004, 0x0702, "", "VAS96011 [Golden Gate II]" } ,
	{ 0x1004, 0x0703, "", "Tollgate" } ,
	{ 0x1005, 0x2064, "", "ALG2032/2064" } ,
	{ 0x1005, 0x2128, "", "ALG2364A" } ,
	{ 0x1005, 0x2301, "", "ALG2301" } ,
	{ 0x1005, 0x2302, "", "ALG2302" } ,
	{ 0x1005, 0x2364, "", "ALG2364" } ,
	{ 0x1005, 0x2464, "", "ALG2364A" } ,
	{ 0x1005, 0x2501, "", "ALG2564A/25128A" } ,
	{ 0x100B, 0x0001, "", "DP83810" } ,
	{ 0x100B, 0x0002, "", "87415/87560 IDE" } ,
	{ 0x100B, 0x000E, "", "87560 Legacy I/O" } ,
	{ 0x100B, 0x000F, "", "FireWire Controller" } ,
	{ 0x100B, 0x0011, "", "NS87560 National PCI System I/O" } ,
	{ 0x100B, 0x0012, "", "USB Controller" } ,
	{ 0x100B, 0x0020, "", "DP83815 (MacPhyter) Ethernet Controller" } ,
	{ 0x100B, 0x0021, "", "PC87200 PCI to ISA Bridge" } ,
	{ 0x100B, 0x0022, "", "DP83820 10/100/1000 Ethernet Controller" } ,
	{ 0x100B, 0x0028, "", "Geode GX2 Host Bridge" } ,
	{ 0x100B, 0x002A, "", "CS5535 South Bridge" } ,
	{ 0x100B, 0x002B, "", "CS5535 ISA bridge" } ,
	{ 0x100B, 0x002D, "", "CS5535 IDE" } ,
	{ 0x100B, 0x002E, "", "CS5535 Audio" } ,
	{ 0x100B, 0x002F, "", "CS5535 USB" } ,
	{ 0x100B, 0x0030, "", "Geode GX2 Graphics Processor" } ,
	{ 0x100B, 0x0035, "", "DP83065 [Saturn] 10/100/1000 Ethernet Controller" } ,
	{ 0x100B, 0x0500, "", "SCx200 Bridge" } ,
	{ 0x100B, 0x0501, "", "SCx200 SMI" } ,
	{ 0x100B, 0x0502, "", "SCx200 IDE" } ,
	{ 0x100B, 0x0503, "", "SCx200 Audio" } ,
	{ 0x100B, 0x0504, "", "SCx200 Video" } ,
	{ 0x100B, 0x0505, "", "SCx200 XBus" } ,
	{ 0x100B, 0x0510, "", "SC1100 Bridge" } ,
	{ 0x100B, 0x0511, "", "SC1100 SMI" } ,
	{ 0x100B, 0x0515, "", "SC1100 XBus" } ,
	{ 0x100B, 0xD001, "", "87410 IDE" } ,
	{ 0x100C, 0x3202, "", "ET4000/W32p rev A" } ,
	{ 0x100C, 0x3205, "", "ET4000/W32p rev B" } ,
	{ 0x100C, 0x3206, "", "ET4000/W32p rev C" } ,
	{ 0x100C, 0x3207, "", "ET4000/W32p rev D" } ,
	{ 0x100C, 0x3208, "", "ET6000" } ,
	{ 0x100C, 0x4702, "", "ET6300" } ,
	{ 0x100E, 0x9000, "", "P9000 Viper" } ,
	{ 0x100E, 0x9001, "", "P9000 Viper" } ,
	{ 0x100E, 0x9002, "", "P9000 Viper" } ,
	{ 0x100E, 0x9100, "", "P9100 Viper Pro/SE" } ,
	{ 0x1011, 0x0001, "", "DECchip 21050" } ,
	{ 0x1011, 0x0002, "", "DECchip 21040 [Tulip]" } ,
	{ 0x1011, 0x0004, "", "DECchip 21030 [TGA]" } ,
	{ 0x1011, 0x0007, "", "NVRAM [Zephyr NVRAM]" } ,
	{ 0x1011, 0x0008, "", "KZPSA [KZPSA]" } ,
	{ 0x1011, 0x0009, "", "DECchip 21140 [FasterNet]" } ,
	{ 0x1011, 0x000A, "", "21230 Video Codec" } ,
	{ 0x1011, 0x000D, "", "PBXGB [TGA2]" } ,
	{ 0x1011, 0x000F, "", "DEFPA" } ,
	{ 0x1011, 0x0014, "", "DECchip 21041 [Tulip Pass 3]" } ,
	{ 0x1011, 0x0016, "", "DGLPB [OPPO]" } ,
	{ 0x1011, 0x0017, "", "PV-PCI Graphics Controller (ZLXp-L)" } ,
	{ 0x1011, 0x0019, "", "DECchip 21142/43" } ,
	{ 0x1011, 0x001A, "", "Farallon PN9000SX Gigabit Ethernet" } ,
	{ 0x1011, 0x0021, "", "DECchip 21052" } ,
	{ 0x1011, 0x0022, "", "DECchip 21150" } ,
	{ 0x1011, 0x0023, "", "DECchip 21150" } ,
	{ 0x1011, 0x0024, "", "DECchip 21152" } ,
	{ 0x1011, 0x0025, "", "DECchip 21153" } ,
	{ 0x1011, 0x0026, "", "DECchip 21154" } ,
	{ 0x1011, 0x0034, "", "56k Modem Cardbus" } ,
	{ 0x1011, 0x0045, "", "DECchip 21553" } ,
	{ 0x1011, 0x0046, "", "DECchip 21554" } ,
	{ 0x1011, 0x1065, "", "StrongARM DC21285" } ,
	{ 0x1013, 0x0038, "", "GD 7548" } ,
	{ 0x1013, 0x0040, "", "GD 7555 Flat Panel GUI Accelerator" } ,
	{ 0x1013, 0x004C, "", "GD 7556 Video/Graphics LCD/CRT Ctrlr" } ,
	{ 0x1013, 0x00A0, "", "GD 5430/40 [Alpine]" } ,
	{ 0x1013, 0x00A2, "", "GD 5432 [Alpine]" } ,
	{ 0x1013, 0x00A4, "", "GD 5434-4 [Alpine]" } ,
	{ 0x1013, 0x00A8, "", "GD 5434-8 [Alpine]" } ,
	{ 0x1013, 0x00AC, "", "GD 5436 [Alpine]" } ,
	{ 0x1013, 0x00B0, "", "GD 5440" } ,
	{ 0x1013, 0x00B8, "", "GD 5446" } ,
	{ 0x1013, 0x00BC, "", "GD 5480" } ,
	{ 0x1013, 0x00D0, "", "GD 5462" } ,
	{ 0x1013, 0x00D2, "", "GD 5462 [Laguna I]" } ,
	{ 0x1013, 0x00D4, "", "GD 5464 [Laguna]" } ,
	{ 0x1013, 0x00D5, "", "GD 5464 BD [Laguna]" } ,
	{ 0x1013, 0x00D6, "", "GD 5465 [Laguna]" } ,
	{ 0x1013, 0x00E8, "", "GD 5436U" } ,
	{ 0x1013, 0x1100, "", "CL 6729" } ,
	{ 0x1013, 0x1110, "", "PD 6832 PCMCIA/CardBus Ctrlr" } ,
	{ 0x1013, 0x1112, "", "PD 6834 PCMCIA/CardBus Ctrlr" } ,
	{ 0x1013, 0x1113, "", "PD 6833 PCMCIA/CardBus Ctrlr" } ,
	{ 0x1013, 0x1200, "", "GD 7542 [Nordic]" } ,
	{ 0x1013, 0x1202, "", "GD 7543 [Viking]" } ,
	{ 0x1013, 0x1204, "", "GD 7541 [Nordic Light]" } ,
	{ 0x1013, 0x4000, "", "MD 5620 [CLM Data Fax Voice]" } ,
	{ 0x1013, 0x4400, "", "CD 4400" } ,
	{ 0x1013, 0x6001, "", "CS 4610/11 [CrystalClear SoundFusion Audio Accelerator]" } ,
	{ 0x1013, 0x6003, "", "CS 4614/22/24 [CrystalClear SoundFusion Audio Accelerator]" } ,
	{ 0x1013, 0x6004, "", "CS 4614/22/24 [CrystalClear SoundFusion Audio Accelerator]" } ,
	{ 0x1013, 0x6005, "", "Crystal CS4281 PCI Audio" } ,
	{ 0x1014, 0x0002, "", "PCI to MCA Bridge" } ,
	{ 0x1014, 0x0005, "", "Alta Lite" } ,
	{ 0x1014, 0x0007, "", "Alta MP" } ,
	{ 0x1014, 0x000A, "", "Fire Coral" } ,
	{ 0x1014, 0x0017, "", "CPU to PCI Bridge" } ,
	{ 0x1014, 0x0018, "", "TR Auto LANstreamer" } ,
	{ 0x1014, 0x001B, "", "GXT-150P" } ,
	{ 0x1014, 0x001C, "", "Carrera" } ,
	{ 0x1014, 0x001D, "", "82G2675" } ,
	{ 0x1014, 0x0020, "", "GXT1000 Graphics Adapter" } ,
	{ 0x1014, 0x0022, "", "IBM27-82351" } ,
	{ 0x1014, 0x002D, "", "Python" } ,
	{ 0x1014, 0x002E, "", "SCSI RAID Adapter [ServeRAID]" } ,
	{ 0x1014, 0x0031, "", "2 Port Serial Adapter" } ,
	{ 0x1014, 0x0036, "", "Miami" } ,
	{ 0x1014, 0x0037, "", "82660 CPU to PCI Bridge" } ,
	{ 0x1014, 0x003A, "", "CPU to PCI Bridge" } ,
	{ 0x1014, 0x003C, "", "GXT250P/GXT255P Graphics Adapter" } ,
	{ 0x1014, 0x003E, "", "16/4 Token ring UTP/STP controller" } ,
	{ 0x1014, 0x0045, "", "SSA Adapter" } ,
	{ 0x1014, 0x0046, "", "MPIC interrupt controller" } ,
	{ 0x1014, 0x0047, "", "PCI to PCI Bridge" } ,
	{ 0x1014, 0x0048, "", "PCI to PCI Bridge" } ,
	{ 0x1014, 0x0049, "", "Warhead SCSI Controller" } ,
	{ 0x1014, 0x004E, "", "ATM Controller (14104e00)" } ,
	{ 0x1014, 0x004F, "", "ATM Controller (14104f00)" } ,
	{ 0x1014, 0x0050, "", "ATM Controller (14105000)" } ,
	{ 0x1014, 0x0053, "", "25 MBit ATM Controller" } ,
	{ 0x1014, 0x0054, "", "GXT500P/GXT550P Graphics Adapter" } ,
	{ 0x1014, 0x0057, "", "MPEG PCI Bridge" } ,
	{ 0x1014, 0x005C, "", "i82557B 10/100" } ,
	{ 0x1014, 0x005E, "", "GXT800P Graphics Adapter" } ,
	{ 0x1014, 0x007C, "", "ATM Controller (14107c00)" } ,
	{ 0x1014, 0x007D, "", "3780IDSP [MWave]" } ,
	{ 0x1014, 0x008B, "", "EADS PCI to PCI Bridge" } ,
	{ 0x1014, 0x008E, "", "GXT3000P Graphics Adapter" } ,
	{ 0x1014, 0x0090, "", "GXT 3000P" } ,
	{ 0x1014, 0x0091, "", "SSA Adapter" } ,
	{ 0x1014, 0x0095, "", "20H2999 PCI Docking Bridge" } ,
	{ 0x1014, 0x0096, "", "Chukar chipset SCSI controller" } ,
	{ 0x1014, 0x009F, "", "PCI 4758 Cryptographic Accelerator" } ,
	{ 0x1014, 0x00A5, "", "ATM Controller (1410a500)" } ,
	{ 0x1014, 0x00A6, "", "ATM 155MBPS MM Controller (1410a600)" } ,
	{ 0x1014, 0x00B7, "", "256-bit Graphics Rasterizer [Fire GL1]" } ,
	{ 0x1014, 0x00B8, "", "GXT2000P Graphics Adapter" } ,
	{ 0x1014, 0x00BE, "", "ATM 622MBPS Controller (1410be00)" } ,
	{ 0x1014, 0x00DC, "", "Advanced Systems Management Adapter (ASMA)" } ,
	{ 0x1014, 0x00FC, "", "CPC710 Dual Bridge and Memory Controller (PCI-64)" } ,
	{ 0x1014, 0x0104, "", "Gigabit Ethernet-SX Adapter" } ,
	{ 0x1014, 0x0105, "", "CPC710 Dual Bridge and Memory Controller (PCI-32)" } ,
	{ 0x1014, 0x010F, "", "Remote Supervisor Adapter (RSA)" } ,
	{ 0x1014, 0x0142, "", "Yotta Video Compositor Input" } ,
	{ 0x1014, 0x0144, "", "Yotta Video Compositor Output" } ,
	{ 0x1014, 0x0156, "", "405GP PLB to PCI Bridge" } ,
	{ 0x1014, 0x015E, "", "622Mbps ATM PCI Adapter" } ,
	{ 0x1014, 0x0160, "", "64bit/66MHz PCI ATM 155 MMF" } ,
	{ 0x1014, 0x016E, "", "GXT4000P Graphics Adapter" } ,
	{ 0x1014, 0x0170, "", "GXT6000P Graphics Adapter" } ,
	{ 0x1014, 0x017D, "", "GXT300P Graphics Adapter" } ,
	{ 0x1014, 0x0180, "", "Snipe chipset SCSI controller" } ,
	{ 0x1014, 0x0188, "", "EADS-X PCI-X to PCI-X Bridge" } ,
	{ 0x1014, 0x01A7, "", "PCI-X to PCI-X Bridge" } ,
	{ 0x1014, 0x01BD, "", "ServeRAID Controller" } ,
	{ 0x1014, 0x01C1, "", "64bit/66MHz PCI ATM 155 UTP" } ,
	{ 0x1014, 0x01E6, "", "Cryptographic Accelerator" } ,
	{ 0x1014, 0x01FF, "", "10/100 Mbps Ethernet" } ,
	{ 0x1014, 0x0219, "", "Multiport Serial Adapter" } ,
	{ 0x1014, 0x021B, "", "GXT6500P Graphics Adapter" } ,
	{ 0x1014, 0x021C, "", "GXT4500P Graphics Adapter" } ,
	{ 0x1014, 0x0233, "", "GXT135P Graphics Adapter" } ,
	{ 0x1014, 0x0266, "", "PCI-X Dual Channel SCSI" } ,
	{ 0x1014, 0x0268, "", "Gigabit Ethernet-SX Adapter (PCI-X)" } ,
	{ 0x1014, 0x0269, "", "10/100/1000 Base-TX Ethernet Adapter (PCI-X)" } ,
	{ 0x1014, 0x028C, "", "Citrine chipset SCSI controller" } ,
	{ 0x1014, 0x02A1, "", "Calgary PCI-X Host Bridge" } ,
	{ 0x1014, 0x0302, "", "Winnipeg PCI-X Host Bridge" } ,
	{ 0x1014, 0x0314, "", "ZISC 036 Neural accelerator card" } ,
	{ 0x1014, 0x3022, "", "QLA3022 Network Adapter" } ,
	{ 0x1014, 0x4022, "", "QLA3022 Network Adapter" } ,
	{ 0x1014, 0xFFFF, "", "MPIC-2 interrupt controller" } ,
	{ 0x1017, 0x5343, "", "SPEA 3D Accelerator" } ,
	{ 0x101A, 0x0005, "", "100VG ethernet" } ,
	{ 0x101C, 0x0193, "", "33C193A" } ,
	{ 0x101C, 0x0196, "", "33C196A" } ,
	{ 0x101C, 0x0197, "", "33C197A" } ,
	{ 0x101C, 0x0296, "", "33C296A" } ,
	{ 0x101C, 0x3193, "", "7193" } ,
	{ 0x101C, 0x3197, "", "7197" } ,
	{ 0x101C, 0x3296, "", "33C296A" } ,
	{ 0x101C, 0x4296, "", "34C296" } ,
	{ 0x101C, 0x9710, "", "Pipeline 9710" } ,
	{ 0x101C, 0x9712, "", "Pipeline 9712" } ,
	{ 0x101C, 0xC24A, "", "90C" } ,
	{ 0x101E, 0x0009, "", "MegaRAID 428 Ultra RAID Controller (rev 03)" } ,
	{ 0x101E, 0x1960, "", "MegaRAID" } ,
	{ 0x101E, 0x9010, "", "MegaRAID 428 Ultra RAID Controller" } ,
	{ 0x101E, 0x9030, "", "EIDE Controller" } ,
	{ 0x101E, 0x9031, "", "EIDE Controller" } ,
	{ 0x101E, 0x9032, "", "EIDE & SCSI Controller" } ,
	{ 0x101E, 0x9033, "", "SCSI Controller" } ,
	{ 0x101E, 0x9040, "", "Multimedia card" } ,
	{ 0x101E, 0x9060, "", "MegaRAID 434 Ultra GT RAID Controller" } ,
	{ 0x101E, 0x9063, "", "MegaRAC" } ,
	{ 0x1022, 0x1100, "", "K8 [Athlon64/Opteron] HyperTransport Technology Configuration" } ,
	{ 0x1022, 0x1101, "", "K8 [Athlon64/Opteron] Address Map" } ,
	{ 0x1022, 0x1102, "", "K8 [Athlon64/Opteron] DRAM Controller" } ,
	{ 0x1022, 0x1103, "", "K8 [Athlon64/Opteron] Miscellaneous Control" } ,
	{ 0x1022, 0x2000, "", "79c970 [PCnet32 LANCE]" } ,
	{ 0x1022, 0x2001, "", "79c978 [HomePNA]" } ,
	{ 0x1022, 0x2003, "", "Am 1771 MBW [Alchemy]" } ,
	{ 0x1022, 0x2020, "", "53c974 [PCscsi]" } ,
	{ 0x1022, 0x2040, "", "79c974" } ,
	{ 0x1022, 0x208F, "", "CS5536 GeodeLink PCI South Bridge" } ,
	{ 0x1022, 0x3000, "", "ELanSC520 Microcontroller" } ,
	{ 0x1022, 0x7006, "", "AMD-751 [Irongate] System Controller" } ,
	{ 0x1022, 0x7007, "", "AMD-751 [Irongate] AGP Bridge" } ,
	{ 0x1022, 0x700A, "", "AMD-IGR4 AGP Host to PCI Bridge" } ,
	{ 0x1022, 0x700B, "", "AMD-IGR4 PCI to PCI Bridge" } ,
	{ 0x1022, 0x700C, "", "AMD-760 MP [IGD4-2P] System Controller" } ,
	{ 0x1022, 0x700D, "", "AMD-760 MP [IGD4-2P] AGP Bridge" } ,
	{ 0x1022, 0x700E, "", "AMD-760 [IGD4-1P] System Controller" } ,
	{ 0x1022, 0x700F, "", "AMD-760 [IGD4-1P] AGP Bridge" } ,
	{ 0x1022, 0x7400, "", "AMD-755 [Cobra] ISA" } ,
	{ 0x1022, 0x7401, "", "AMD-755 [Cobra] IDE" } ,
	{ 0x1022, 0x7403, "", "AMD-755 [Cobra] ACPI" } ,
	{ 0x1022, 0x7404, "", "AMD-755 [Cobra] USB" } ,
	{ 0x1022, 0x7408, "", "AMD-756 [Viper] ISA" } ,
	{ 0x1022, 0x7409, "", "AMD-756 [Viper] IDE" } ,
	{ 0x1022, 0x740B, "", "AMD-756 [Viper] ACPI" } ,
	{ 0x1022, 0x740C, "", "AMD-756 [Viper] USB" } ,
	{ 0x1022, 0x7410, "", "AMD-766 [ViperPlus] ISA" } ,
	{ 0x1022, 0x7411, "", "AMD-766 [ViperPlus] IDE" } ,
	{ 0x1022, 0x7413, "", "AMD-766 [ViperPlus] ACPI" } ,
	{ 0x1022, 0x7414, "", "AMD-766 [ViperPlus] USB" } ,
	{ 0x1022, 0x7440, "", "AMD-768 [Opus] ISA" } ,
	{ 0x1022, 0x7441, "", "AMD-768 [Opus] IDE" } ,
	{ 0x1022, 0x7443, "", "AMD-768 [Opus] ACPI" } ,
	{ 0x1022, 0x7445, "", "AMD-768 [Opus] Audio" } ,
	{ 0x1022, 0x7446, "", "AMD-768 [Opus] MC97 Modem (Smart Link HAMR5600 compatible)" } ,
	{ 0x1022, 0x7448, "", "AMD-768 [Opus] PCI" } ,
	{ 0x1022, 0x7449, "", "AMD-768 [Opus] USB" } ,
	{ 0x1022, 0x7450, "", "AMD-8131 PCI-X Bridge" } ,
	{ 0x1022, 0x7451, "", "AMD-8131 PCI-X IOAPIC" } ,
	{ 0x1022, 0x7454, "", "AMD-8151 System Controller" } ,
	{ 0x1022, 0x7455, "", "AMD-8151 AGP Bridge" } ,
	{ 0x1022, 0x7458, "", "AMD-8132 PCI-X Bridge" } ,
	{ 0x1022, 0x7459, "", "AMD-8132 PCI-X IOAPIC" } ,
	{ 0x1022, 0x7460, "", "AMD-8111 PCI" } ,
	{ 0x1022, 0x7461, "", "AMD-8111 USB" } ,
	{ 0x1022, 0x7462, "", "AMD-8111 Ethernet" } ,
	{ 0x1022, 0x7464, "", "AMD-8111 USB" } ,
	{ 0x1022, 0x7468, "", "AMD-8111 LPC" } ,
	{ 0x1022, 0x7469, "", "AMD-8111 IDE" } ,
	{ 0x1022, 0x746A, "", "AMD-8111 SMBus 2.0" } ,
	{ 0x1022, 0x746B, "", "AMD-8111 ACPI" } ,
	{ 0x1022, 0x746D, "", "AMD-8111 AC97 Audio" } ,
	{ 0x1022, 0x746E, "", "AMD-8111 MC97 Modem" } ,
	{ 0x1022, 0x756B, "", "AMD-8111 ACPI" } ,
	{ 0x1023, 0x0194, "", "82C194" } ,
	{ 0x1023, 0x2000, "", "4DWave DX" } ,
	{ 0x1023, 0x2001, "", "4DWave NX" } ,
	{ 0x1023, 0x2100, "", "CyberBlade XP4m32" } ,
	{ 0x1023, 0x2200, "", "XGI Volari XP5" } ,
	{ 0x1023, 0x8400, "", "CyberBlade/i7" } ,
	{ 0x1023, 0x8420, "", "CyberBlade/i7d" } ,
	{ 0x1023, 0x8500, "", "CyberBlade/i1" } ,
	{ 0x1023, 0x8520, "", "CyberBlade i1" } ,
	{ 0x1023, 0x8620, "", "CyberBlade/i1" } ,
	{ 0x1023, 0x8820, "", "CyberBlade XPAi1" } ,
	{ 0x1023, 0x9320, "", "TGUI 9320" } ,
	{ 0x1023, 0x9350, "", "GUI Accelerator" } ,
	{ 0x1023, 0x9360, "", "Flat panel GUI Accelerator" } ,
	{ 0x1023, 0x9382, "", "Cyber 9382 [Reference design]" } ,
	{ 0x1023, 0x9383, "", "Cyber 9383 [Reference design]" } ,
	{ 0x1023, 0x9385, "", "Cyber 9385 [Reference design]" } ,
	{ 0x1023, 0x9386, "", "Cyber 9386" } ,
	{ 0x1023, 0x9388, "", "Cyber 9388" } ,
	{ 0x1023, 0x9397, "", "Cyber 9397" } ,
	{ 0x1023, 0x939A, "", "Cyber 9397DVD" } ,
	{ 0x1023, 0x9420, "", "TGUI 9420" } ,
	{ 0x1023, 0x9430, "", "TGUI 9430" } ,
	{ 0x1023, 0x9440, "", "TGUI 9440" } ,
	{ 0x1023, 0x9460, "", "TGUI 9460" } ,
	{ 0x1023, 0x9470, "", "TGUI 9470" } ,
	{ 0x1023, 0x9520, "", "Cyber 9520" } ,
	{ 0x1023, 0x9525, "", "Cyber 9525" } ,
	{ 0x1023, 0x9540, "", "Cyber 9540" } ,
	{ 0x1023, 0x9660, "", "TGUI 9660/938x/968x" } ,
	{ 0x1023, 0x9680, "", "TGUI 9680" } ,
	{ 0x1023, 0x9682, "", "TGUI 9682" } ,
	{ 0x1023, 0x9683, "", "TGUI 9683" } ,
	{ 0x1023, 0x9685, "", "ProVIDIA 9685" } ,
	{ 0x1023, 0x9750, "", "3DImage 9750" } ,
	{ 0x1023, 0x9753, "", "TGUI 9753" } ,
	{ 0x1023, 0x9754, "", "TGUI 9754" } ,
	{ 0x1023, 0x9759, "", "TGUI 975" } ,
	{ 0x1023, 0x9783, "", "TGUI 9783" } ,
	{ 0x1023, 0x9785, "", "TGUI 9785" } ,
	{ 0x1023, 0x9850, "", "3DImage 9850" } ,
	{ 0x1023, 0x9880, "", "Blade 3D PCI/AGP" } ,
	{ 0x1023, 0x9910, "", "CyberBlade/XP" } ,
	{ 0x1023, 0x9930, "", "CyberBlade/XPm" } ,
	{ 0x1025, 0x1435, "", "M1435" } ,
	{ 0x1025, 0x1445, "", "M1445" } ,
	{ 0x1025, 0x1449, "", "M1449" } ,
	{ 0x1025, 0x1451, "", "M1451" } ,
	{ 0x1025, 0x1461, "", "M1461" } ,
	{ 0x1025, 0x1489, "", "M1489" } ,
	{ 0x1025, 0x1511, "", "M1511" } ,
	{ 0x1025, 0x1512, "", "ALI M1512 Aladdin" } ,
	{ 0x1025, 0x1513, "", "M1513" } ,
	{ 0x1025, 0x1521, "", "ALI M1521 Aladdin III CPU Bridge" } ,
	{ 0x1025, 0x1523, "", "ALI M1523 ISA Bridge" } ,
	{ 0x1025, 0x1531, "", "M1531 Northbridge [Aladdin IV/IV+]" } ,
	{ 0x1025, 0x1533, "", "M1533 PCI-to-ISA Bridge" } ,
	{ 0x1025, 0x1535, "", "M1535 PCI Bridge + Super I/O + FIR" } ,
	{ 0x1025, 0x1541, "", "M1541 Northbridge [Aladdin V]" } ,
	{ 0x1025, 0x1542, "", "M1542 Northbridge [Aladdin V]" } ,
	{ 0x1025, 0x1543, "", "M1543 PCI-to-ISA Bridge + Super I/O + FIR" } ,
	{ 0x1025, 0x1561, "", "M1561 Northbridge [Aladdin 7]" } ,
	{ 0x1025, 0x1621, "", "M1621 Northbridge [Aladdin-Pro II]" } ,
	{ 0x1025, 0x1631, "", "M1631 Northbridge+3D Graphics [Aladdin TNT2]" } ,
	{ 0x1025, 0x1641, "", "M1641 Northbridge [Aladdin-Pro IV]" } ,
	{ 0x1025, 0x1647, "", "M1647 [MaGiK1] PCI North Bridge" } ,
	{ 0x1025, 0x1671, "", "M1671 Northbridge [ALADDiN-P4]" } ,
	{ 0x1025, 0x1672, "", "Northbridge [CyberALADDiN-P4]" } ,
	{ 0x1025, 0x3141, "", "M3141" } ,
	{ 0x1025, 0x3143, "", "M3143" } ,
	{ 0x1025, 0x3145, "", "M3145" } ,
	{ 0x1025, 0x3147, "", "M3147" } ,
	{ 0x1025, 0x3149, "", "M3149" } ,
	{ 0x1025, 0x3151, "", "M3151" } ,
	{ 0x1025, 0x3307, "", "M3307 MPEG-I Video Controller" } ,
	{ 0x1025, 0x3309, "", "M3309 MPEG-II Video w/ Software Audio Decoder" } ,
	{ 0x1025, 0x3321, "", "M3321 MPEG-II Audio/Video Decoder" } ,
	{ 0x1025, 0x5212, "", "M4803" } ,
	{ 0x1025, 0x5215, "", "ALI PCI EIDE Controller" } ,
	{ 0x1025, 0x5217, "", "M5217H" } ,
	{ 0x1025, 0x5219, "", "M5219" } ,
	{ 0x1025, 0x5225, "", "M5225" } ,
	{ 0x1025, 0x5229, "", "M5229" } ,
	{ 0x1025, 0x5235, "", "M5235" } ,
	{ 0x1025, 0x5237, "", "M5237 PCI USB Host Controller" } ,
	{ 0x1025, 0x5240, "", "EIDE Controller" } ,
	{ 0x1025, 0x5241, "", "PCMCIA Bridge" } ,
	{ 0x1025, 0x5242, "", "General Purpose Controller" } ,
	{ 0x1025, 0x5243, "", "PCI to PCI Bridge Controller" } ,
	{ 0x1025, 0x5244, "", "Floppy Disk Controller" } ,
	{ 0x1025, 0x5247, "", "M1541 PCI to PCI Bridge" } ,
	{ 0x1025, 0x5251, "", "M5251 P1394 Controller" } ,
	{ 0x1025, 0x5427, "", "PCI to AGP Bridge" } ,
	{ 0x1025, 0x5451, "", "M5451 PCI AC-Link Controller Audio Device" } ,
	{ 0x1025, 0x5453, "", "M5453 PCI AC-Link Controller Modem Device" } ,
	{ 0x1025, 0x7101, "", "M7101 PCI PMU Power Management Controller" } ,
	{ 0x1028, 0x0001, "", "PowerEdge Expandable RAID Controller 2/Si" } ,
	{ 0x1028, 0x0002, "", "PowerEdge Expandable RAID Controller 3/Di" } ,
	{ 0x1028, 0x0003, "", "PowerEdge Expandable RAID Controller 3/Si" } ,
	{ 0x1028, 0x0006, "", "PowerEdge Expandable RAID Controller 3/Di" } ,
	{ 0x1028, 0x0007, "", "Remote Access Card III" } ,
	{ 0x1028, 0x0008, "", "Remote Access Card III" } ,
	{ 0x1028, 0x0009, "", "Remote Access Card III: BMC/SMIC device not present" } ,
	{ 0x1028, 0x000A, "", "PowerEdge Expandable RAID Controller 3/Di" } ,
	{ 0x1028, 0x000C, "", "Embedded Remote Access or ERA/O" } ,
	{ 0x1028, 0x000D, "", "Embedded Remote Access: BMC/SMIC device" } ,
	{ 0x1028, 0x000E, "", "PowerEdge Expandable RAID controller 4/Di" } ,
	{ 0x1028, 0x000F, "", "PowerEdge Expandable RAID controller 4/Di" } ,
	{ 0x1028, 0x0010, "", "Remote Access Card 4" } ,
	{ 0x1028, 0x0011, "", "Remote Access Card 4 Daughter Card" } ,
	{ 0x1028, 0x0012, "", "Remote Access Card 4 Daughter Card Virtual UART" } ,
	{ 0x1028, 0x0013, "", "PowerEdge Expandable RAID controller 4" } ,
	{ 0x1028, 0x0014, "", "Remote Access Card 4 Daughter Card SMIC interface" } ,
	{ 0x1028, 0x0015, "", "PowerEdge Expandable RAID controller 5" } ,
	{ 0x102A, 0x0000, "", "HYDRA" } ,
	{ 0x102A, 0x0010, "", "ASPEN" } ,
	{ 0x102A, 0x001F, "", "AHA-2940U2/U2W /7890/7891 SCSI Controllers" } ,
	{ 0x102A, 0x00C5, "", "AIC-7899 U160/m SCSI Controller" } ,
	{ 0x102A, 0x00CF, "", "AIC-7899P U160/m" } ,
	{ 0x102B, 0x0010, "", "MGA-I [Impression?]" } ,
	{ 0x102B, 0x0100, "", "MGA 1064SG [Mystique]" } ,
	{ 0x102B, 0x0518, "", "MGA-II [Athena]" } ,
	{ 0x102B, 0x0519, "", "MGA 2064W [Millennium]" } ,
	{ 0x102B, 0x051A, "", "MGA 1064SG [Mystique]" } ,
	{ 0x102B, 0x051B, "", "MGA 2164W [Millennium II]" } ,
	{ 0x102B, 0x051E, "", "MGA 1064SG [Mystique] AGP" } ,
	{ 0x102B, 0x051F, "", "MGA 2164W [Millennium II] AGP" } ,
	{ 0x102B, 0x0520, "", "MGA G200" } ,
	{ 0x102B, 0x0521, "", "MGA G200 AGP" } ,
	{ 0x102B, 0x0525, "", "G400/G450" } ,
	{ 0x102B, 0x0527, "", "MGA Parhelia AGP" } ,
	{ 0x102B, 0x0528, "", "Parhelia 8X" } ,
	{ 0x102B, 0x0D10, "", "MGA Ultima/Impression" } ,
	{ 0x102B, 0x1000, "", "MGA G100 [Productiva]" } ,
	{ 0x102B, 0x1001, "", "MGA G100 [Productiva] AGP" } ,
	{ 0x102B, 0x2007, "", "MGA Mistral" } ,
	{ 0x102B, 0x2527, "", "MGA G550 AGP" } ,
	{ 0x102B, 0x2537, "", "Millenium P650/P750" } ,
	{ 0x102B, 0x2538, "", "Millenium P650 PCIe" } ,
	{ 0x102B, 0x4536, "", "VIA Framegrabber" } ,
	{ 0x102B, 0x6573, "", "Shark 10/100 Multiport SwitchNIC" } ,
	{ 0x102C, 0x00B8, "", "F64310" } ,
	{ 0x102C, 0x00C0, "", "F69000 HiQVideo" } ,
	{ 0x102C, 0x00D0, "", "F65545" } ,
	{ 0x102C, 0x00D8, "", "F65545" } ,
	{ 0x102C, 0x00DC, "", "F65548" } ,
	{ 0x102C, 0x00E0, "", "F65550" } ,
	{ 0x102C, 0x00E4, "", "F65554" } ,
	{ 0x102C, 0x00E5, "", "F65555 HiQVPro" } ,
	{ 0x102C, 0x00F0, "", "F68554" } ,
	{ 0x102C, 0x00F4, "", "F68554 HiQVision" } ,
	{ 0x102C, 0x00F5, "", "F68555" } ,
	{ 0x102C, 0x0C30, "", "F69030" } ,
	{ 0x102D, 0x50DC, "", "3328 Audio" } ,
	{ 0x102F, 0x0009, "", "r4x00" } ,
	{ 0x102F, 0x000A, "", "TX3927 MIPS RISC PCI Controller" } ,
	{ 0x102F, 0x0020, "", "ATM Meteor 155" } ,
	{ 0x102F, 0x0030, "", "TC35815CF PCI 10/100 Mbit Ethernet Controller" } ,
	{ 0x102F, 0x0031, "", "TC35815CF PCI 10/100 Mbit Ethernet Controller with WOL" } ,
	{ 0x102F, 0x0105, "", "TC86C001 [goku-s] IDE" } ,
	{ 0x102F, 0x0106, "", "TC86C001 [goku-s] USB 1.1 Host" } ,
	{ 0x102F, 0x0107, "", "TC86C001 [goku-s] USB Device Controller" } ,
	{ 0x102F, 0x0108, "", "TC86C001 [goku-s] I2C/SIO/GPIO Controller" } ,
	{ 0x102F, 0x0180, "", "TX4927/38 MIPS RISC PCI Controller" } ,
	{ 0x102F, 0x0181, "", "TX4925 MIPS RISC PCI Controller" } ,
	{ 0x102F, 0x0182, "", "TX4937 MIPS RISC PCI Controller" } ,
	{ 0x1031, 0x5601, "", "DC20 ASIC" } ,
	{ 0x1031, 0x5607, "", "Video I/O & motion JPEG compressor" } ,
	{ 0x1031, 0x5631, "", "Media 3D" } ,
	{ 0x1031, 0x6057, "", "MiroVideo DC10/DC30+" } ,
	{ 0x1033, 0x0000, "", "Vr4181A USB Host or Function Control Unit" } ,
	{ 0x1033, 0x0001, "", "PCI to 486-like bus Bridge" } ,
	{ 0x1033, 0x0002, "", "PCI to VL98 Bridge" } ,
	{ 0x1033, 0x0003, "", "ATM Controller" } ,
	{ 0x1033, 0x0004, "", "R4000 PCI Bridge" } ,
	{ 0x1033, 0x0005, "", "PCI to 486-like bus Bridge" } ,
	{ 0x1033, 0x0006, "", "PC-9800 Graphic Accelerator" } ,
	{ 0x1033, 0x0007, "", "PCI to UX-Bus Bridge" } ,
	{ 0x1033, 0x0008, "", "PC-9800 Graphic Accelerator" } ,
	{ 0x1033, 0x0009, "", "PCI to PC9800 Core-Graph Bridge" } ,
	{ 0x1033, 0x0016, "", "PCI to VL Bridge" } ,
	{ 0x1033, 0x001A, "", "[Nile II]" } ,
	{ 0x1033, 0x0021, "", "Vrc4373 [Nile I]" } ,
	{ 0x1033, 0x0029, "", "PowerVR PCX1" } ,
	{ 0x1033, 0x002A, "", "PowerVR 3D" } ,
	{ 0x1033, 0x002C, "", "Star Alpha 2" } ,
	{ 0x1033, 0x002D, "", "PCI to C-bus Bridge" } ,
	{ 0x1033, 0x0035, "", "USB" } ,
	{ 0x1033, 0x003B, "", "PCI to C-bus Bridge" } ,
	{ 0x1033, 0x003E, "", "NAPCCARD Cardbus Controller" } ,
	{ 0x1033, 0x0046, "", "PowerVR PCX2 [midas]" } ,
	{ 0x1033, 0x005A, "", "Vrc5074 [Nile 4]" } ,
	{ 0x1033, 0x0063, "", "Firewarden" } ,
	{ 0x1033, 0x0067, "", "PowerVR Neon 250 Chipset" } ,
	{ 0x1033, 0x0072, "", "uPD72874 IEEE1394 OHCI 1.1 3-port PHY-Link Ctrlr" } ,
	{ 0x1033, 0x0074, "", "56k Voice Modem" } ,
	{ 0x1033, 0x009B, "", "Vrc5476" } ,
	{ 0x1033, 0x00A5, "", "VRC4173" } ,
	{ 0x1033, 0x00A6, "", "VRC5477 AC97" } ,
	{ 0x1033, 0x00CD, "", "IEEE 1394 [OrangeLink] Host Controller" } ,
	{ 0x1033, 0x00CE, "", "IEEE 1394 Host Controller" } ,
	{ 0x1033, 0x00DF, "", "Vr4131" } ,
	{ 0x1033, 0x00E0, "", "USB 2.0" } ,
	{ 0x1033, 0x00E7, "", "IEEE 1394 Host Controller" } ,
	{ 0x1033, 0x00F2, "", "uPD72874 IEEE1394 OHCI 1.1 3-port PHY-Link Ctrlr" } ,
	{ 0x1033, 0x00F3, "", "uPD6113x Multimedia Decoder/Processor [EMMA2]" } ,
	{ 0x1033, 0x010C, "", "VR7701" } ,
	{ 0x1036, 0x0000, "", "TMC-18C30 [36C70]" } ,
	{ 0x1039, 0x0001, "", "Virtual PCI-to-PCI bridge (AGP)" } ,
	{ 0x1039, 0x0002, "", "SG86C202" } ,
	{ 0x1039, 0x0003, "", "SiS AGP Port (virtual PCI-to-PCI bridge)" } ,
	{ 0x1039, 0x0004, "", "PCI-to-PCI bridge" } ,
	{ 0x1039, 0x0006, "", "85C501/2/3" } ,
	{ 0x1039, 0x0008, "", "SiS85C503/5513 (LPC Bridge)" } ,
	{ 0x1039, 0x0009, "", "ACPI" } ,
	{ 0x1039, 0x000A, "", "PCI-to-PCI bridge" } ,
	{ 0x1039, 0x0016, "", "SiS961/2 SMBus Controller" } ,
	{ 0x1039, 0x0018, "", "SiS85C503/5513 (LPC Bridge)" } ,
	{ 0x1039, 0x0180, "", "RAID bus controller 180 SATA/PATA  [SiS]" } ,
	{ 0x1039, 0x0181, "", "SATA" } ,
	{ 0x1039, 0x0182, "", "182 SATA/RAID Controller" } ,
	{ 0x1039, 0x0191, "", "191 Gigabit Ethernet Adapter" } ,
	{ 0x1039, 0x0200, "", "5597/5598/6326 VGA" } ,
	{ 0x1039, 0x0204, "", "82C204" } ,
	{ 0x1039, 0x0205, "", "SG86C205" } ,
	{ 0x1039, 0x0300, "", "300/305 PCI/AGP VGA Display Adapter" } ,
	{ 0x1039, 0x0310, "", "315H PCI/AGP VGA Display Adapter" } ,
	{ 0x1039, 0x0315, "", "315 PCI/AGP VGA Display Adapter" } ,
	{ 0x1039, 0x0325, "", "315PRO PCI/AGP VGA Display Adapter" } ,
	{ 0x1039, 0x0330, "", "330 [Xabre] PCI/AGP VGA Display Adapter" } ,
	{ 0x1039, 0x0406, "", "85C501/2" } ,
	{ 0x1039, 0x0496, "", "85C496" } ,
	{ 0x1039, 0x0530, "", "530 Host" } ,
	{ 0x1039, 0x0540, "", "540 Host" } ,
	{ 0x1039, 0x0550, "", "550 Host" } ,
	{ 0x1039, 0x0597, "", "5513C" } ,
	{ 0x1039, 0x0601, "", "85C601" } ,
	{ 0x1039, 0x0620, "", "620 Host" } ,
	{ 0x1039, 0x0630, "", "630 Host" } ,
	{ 0x1039, 0x0633, "", "633 Host" } ,
	{ 0x1039, 0x0635, "", "635 Host" } ,
	{ 0x1039, 0x0645, "", "SiS645 Host & Memory & AGP Controller" } ,
	{ 0x1039, 0x0646, "", "SiS645DX Host & Memory & AGP Controller" } ,
	{ 0x1039, 0x0648, "", "645xx" } ,
	{ 0x1039, 0x0650, "", "650/M650 Host" } ,
	{ 0x1039, 0x0651, "", "651 Host" } ,
	{ 0x1039, 0x0655, "", "655 Host" } ,
	{ 0x1039, 0x0660, "", "660 Host" } ,
	{ 0x1039, 0x0661, "", "661FX/M661FX/M661MX Host" } ,
	{ 0x1039, 0x0730, "", "730 Host" } ,
	{ 0x1039, 0x0733, "", "733 Host" } ,
	{ 0x1039, 0x0735, "", "735 Host" } ,
	{ 0x1039, 0x0740, "", "740 Host" } ,
	{ 0x1039, 0x0741, "", "741/741GX/M741 Host" } ,
	{ 0x1039, 0x0745, "", "745 Host" } ,
	{ 0x1039, 0x0746, "", "746 Host" } ,
	{ 0x1039, 0x0755, "", "755 Host" } ,
	{ 0x1039, 0x0760, "", "760/M760 Host" } ,
	{ 0x1039, 0x0761, "", "761/M761 Host" } ,
	{ 0x1039, 0x0900, "", "SiS900 PCI Fast Ethernet" } ,
	{ 0x1039, 0x0961, "", "SiS961 [MuTIOL Media IO]" } ,
	{ 0x1039, 0x0962, "", "SiS962 [MuTIOL Media IO]" } ,
	{ 0x1039, 0x0963, "", "SiS963 [MuTIOL Media IO]" } ,
	{ 0x1039, 0x0964, "", "SiS964 [MuTIOL Media IO]" } ,
	{ 0x1039, 0x0965, "", "SiS965 [MuTIOL Media IO]" } ,
	{ 0x1039, 0x3602, "", "83C602" } ,
	{ 0x1039, 0x5107, "", "5107" } ,
	{ 0x1039, 0x5300, "", "SiS540 PCI Display Adapter" } ,
	{ 0x1039, 0x5315, "", "550 PCI/AGP VGA Display Adapter" } ,
	{ 0x1039, 0x5401, "", "486 PCI Chipset" } ,
	{ 0x1039, 0x5511, "", "5511/5512" } ,
	{ 0x1039, 0x5513, "", "5513 [IDE]" } ,
	{ 0x1039, 0x5517, "", "5517" } ,
	{ 0x1039, 0x5571, "", "5571" } ,
	{ 0x1039, 0x5581, "", "5581 Pentium Chipset" } ,
	{ 0x1039, 0x5582, "", "5582" } ,
	{ 0x1039, 0x5591, "", "5591/5592 Host" } ,
	{ 0x1039, 0x5596, "", "5596 Pentium Chipset" } ,
	{ 0x1039, 0x5597, "", "5597 [SiS5582]" } ,
	{ 0x1039, 0x5600, "", "5600 Host" } ,
	{ 0x1039, 0x6204, "", "Video decoder & MPEG interface" } ,
	{ 0x1039, 0x6205, "", "VGA Controller" } ,
	{ 0x1039, 0x6236, "", "6236 3D-AGP" } ,
	{ 0x1039, 0x6300, "", "630/730 PCI/AGP VGA Display Adapter" } ,
	{ 0x1039, 0x6306, "", "530/620 PCI/AGP VGA Display Adapter" } ,
	{ 0x1039, 0x6325, "", "65x/M650/740 PCI/AGP VGA Display Adapter" } ,
	{ 0x1039, 0x6326, "", "86C326 5598/6326" } ,
	{ 0x1039, 0x6330, "", "661/741/760/761 PCI/AGP VGA Display Adapter" } ,
	{ 0x1039, 0x7001, "", "USB 1.0 Controller" } ,
	{ 0x1039, 0x7002, "", "USB 2.0 Controller" } ,
	{ 0x1039, 0x7007, "", "FireWire Controller" } ,
	{ 0x1039, 0x7012, "", "Sound Controller" } ,
	{ 0x1039, 0x7013, "", "AC'97 Modem Controller" } ,
	{ 0x1039, 0x7016, "", "SiS7016 PCI Fast Ethernet Adapter" } ,
	{ 0x1039, 0x7018, "", "SiS PCI Audio Accelerator" } ,
	{ 0x1039, 0x7019, "", "SiS7019 Audio Accelerator" } ,
	{ 0x103C, 0x1005, "", "A4977A Visualize EG" } ,
	{ 0x103C, 0x1006, "", "Visualize FX6" } ,
	{ 0x103C, 0x1008, "", "Visualize FX4" } ,
	{ 0x103C, 0x100A, "", "Visualize FX2" } ,
	{ 0x103C, 0x1028, "", "Tach TL Fibre Channel Host Adapter" } ,
	{ 0x103C, 0x1029, "", "Tach XL2 Fibre Channel Host Adapter" } ,
	{ 0x103C, 0x102A, "", "Tach TS Fibre Channel Host Adapter" } ,
	{ 0x103C, 0x1030, "", "J2585A DeskDirect 10/100VG NIC" } ,
	{ 0x103C, 0x1031, "", "J2585B HP 10/100VG PCI LAN Adapter" } ,
	{ 0x103C, 0x1040, "", "J2973A DeskDirect 10BaseT NIC" } ,
	{ 0x103C, 0x1041, "", "J2585B DeskDirect 10/100 NIC" } ,
	{ 0x103C, 0x1042, "", "J2970A DeskDirect 10BaseT/2 NIC" } ,
	{ 0x103C, 0x1048, "", "Diva Serial [GSP] Multiport UART" } ,
	{ 0x103C, 0x1054, "", "PCI Local Bus Adapter" } ,
	{ 0x103C, 0x1064, "", "79C970 PCnet Ethernet Controller" } ,
	{ 0x103C, 0x108B, "", "Visualize FXe" } ,
	{ 0x103C, 0x10C1, "", "NetServer Smart IRQ Router" } ,
	{ 0x103C, 0x10ED, "", "TopTools Remote Control" } ,
	{ 0x103C, 0x10F0, "", "rio System Bus Adapter" } ,
	{ 0x103C, 0x10F1, "", "rio I/O Controller" } ,
	{ 0x103C, 0x1200, "", "82557B 10/100 NIC" } ,
	{ 0x103C, 0x1219, "", "NetServer PCI Hot-Plug Controller" } ,
	{ 0x103C, 0x121A, "", "NetServer SMIC Controller" } ,
	{ 0x103C, 0x121B, "", "NetServer Legacy COM Port Decoder" } ,
	{ 0x103C, 0x121C, "", "NetServer PCI COM Port Decoder" } ,
	{ 0x103C, 0x1229, "", "zx1 System Bus Adapter" } ,
	{ 0x103C, 0x122A, "", "zx1 I/O Controller" } ,
	{ 0x103C, 0x122E, "", "zx1 Local Bus Adapter" } ,
	{ 0x103C, 0x127C, "", "sx1000 I/O Controller" } ,
	{ 0x103C, 0x1290, "", "Auxiliary Diva Serial Port" } ,
	{ 0x103C, 0x1291, "", "Auxiliary Diva Serial Port" } ,
	{ 0x103C, 0x12B4, "", "zx1 QuickSilver AGP8x Local Bus Adapter" } ,
	{ 0x103C, 0x12FA, "", "BCM4306 802.11b/g Wireless LAN Controller" } ,
	{ 0x103C, 0x2910, "", "E2910A PCIBus Exerciser" } ,
	{ 0x103C, 0x2925, "", "E2925A 32 Bit, 33 MHzPCI Exerciser & Analyzer" } ,
	{ 0x103C, 0x3080, "", "Pavilion ze2028ea" } ,
	{ 0x103C, 0x3220, "", "Hewlett-Packard Smart Array P600" } ,
	{ 0x103C, 0x3230, "", "Hewlett-Packard Smart Array Controller" } ,
	{ 0x1042, 0x1000, "", "PC Tech RZ1000" } ,
	{ 0x1042, 0x1001, "", "PC Tech RZ1001" } ,
	{ 0x1042, 0x3000, "", "Samurai_0" } ,
	{ 0x1042, 0x3010, "", "Samurai_1" } ,
	{ 0x1042, 0x3020, "", "Samurai_IDE" } ,
	{ 0x1043, 0x0675, "", "ISDNLink P-IN100-ST-D" } ,
	{ 0x1043, 0x4015, "", "v7100 SDRAM [GeForce2 MX]" } ,
	{ 0x1043, 0x4021, "", "v7100 Combo Deluxe [GeForce2 MX + TV tuner]" } ,
	{ 0x1043, 0x4057, "", "v8200 GeForce 3" } ,
	{ 0x1043, 0x8043, "", "v8240 PAL 128M [P4T] Motherboard" } ,
	{ 0x1043, 0x807B, "", "v9280/TD [Geforce4 TI4200 8X With TV-Out and DVI]" } ,
	{ 0x1043, 0x80BB, "", "v9180 Magic/T [GeForce4 MX440 AGP 8x 64MB TV-out]" } ,
	{ 0x1043, 0x80C5, "", "nForce3 chipset motherboard [SK8N]" } ,
	{ 0x1043, 0x80DF, "", "v9520 Magic/T" } ,
	{ 0x1044, 0x1012, "", "Domino RAID Engine" } ,
	{ 0x1044, 0xA400, "", "SmartCache/Raid I-IV Controller" } ,
	{ 0x1044, 0xA500, "", "PCI Bridge" } ,
	{ 0x1044, 0xA501, "", "SmartRAID V Controller" } ,
	{ 0x1044, 0xA511, "", "SmartRAID V Controller" } ,
	{ 0x1045, 0xA0F8, "", "82C750 [Vendetta] USB Controller" } ,
	{ 0x1045, 0xC101, "", "92C264" } ,
	{ 0x1045, 0xC178, "", "92C178" } ,
	{ 0x1045, 0xC556, "", "82X556 [Viper]" } ,
	{ 0x1045, 0xC557, "", "82C557 [Viper-M]" } ,
	{ 0x1045, 0xC558, "", "82C558 [Viper-M ISA+IDE]" } ,
	{ 0x1045, 0xC567, "", "82C750 [Vendetta], device 0" } ,
	{ 0x1045, 0xC568, "", "82C750 [Vendetta], device 1" } ,
	{ 0x1045, 0xC569, "", "82C579 [Viper XPress+ Chipset]" } ,
	{ 0x1045, 0xC621, "", "82C621 [Viper-M/N+]" } ,
	{ 0x1045, 0xC700, "", "82C700 [FireStar]" } ,
	{ 0x1045, 0xC701, "", "82C701 [FireStar Plus]" } ,
	{ 0x1045, 0xC814, "", "82C814 [Firebridge 1]" } ,
	{ 0x1045, 0xC822, "", "82C822" } ,
	{ 0x1045, 0xC824, "", "82C824" } ,
	{ 0x1045, 0xC825, "", "82C825 [Firebridge 2]" } ,
	{ 0x1045, 0xC832, "", "82C832" } ,
	{ 0x1045, 0xC861, "", "82C861" } ,
	{ 0x1045, 0xC895, "", "82C895" } ,
	{ 0x1045, 0xC935, "", "EV1935 ECTIVA MachOne PCIAudio" } ,
	{ 0x1045, 0xD568, "", "82C825 [Firebridge 2]" } ,
	{ 0x1045, 0xD721, "", "IDE [FireStar]" } ,
	{ 0x1048, 0x0C60, "", "Gladiac MX" } ,
	{ 0x1048, 0x0D22, "", "Quadro4 900XGL [ELSA GLoria4 900XGL]" } ,
	{ 0x1048, 0x1000, "", "QuickStep 1000" } ,
	{ 0x1048, 0x3000, "", "QuickStep 3000" } ,
	{ 0x1048, 0x8901, "", "Gloria XL" } ,
	{ 0x104A, 0x0008, "", "STG 2000X" } ,
	{ 0x104A, 0x0009, "", "STG 1764X" } ,
	{ 0x104A, 0x0010, "", "STG4000 [3D Prophet Kyro Series]" } ,
	{ 0x104A, 0x0209, "", "STPC Consumer/Industrial North- and Southbridge" } ,
	{ 0x104A, 0x020A, "", "STPC Atlas/ConsumerS/Consumer IIA Northbridge" } ,
	{ 0x104A, 0x0210, "", "STPC Atlas ISA Bridge" } ,
	{ 0x104A, 0x021A, "", "STPC Consumer S Southbridge" } ,
	{ 0x104A, 0x021B, "", "STPC Consumer IIA Southbridge" } ,
	{ 0x104A, 0x0500, "", "ST70137 [Unicorn] ADSL DMT Transceiver" } ,
	{ 0x104A, 0x0564, "", "STPC Client Northbridge" } ,
	{ 0x104A, 0x0981, "", "21x4x DEC-Tulip compatible 10/100 Ethernet" } ,
	{ 0x104A, 0x1746, "", "STG 1764X" } ,
	{ 0x104A, 0x2774, "", "21x4x DEC-Tulip compatible 10/100 Ethernet" } ,
	{ 0x104A, 0x3520, "", "MPEG-II decoder card" } ,
	{ 0x104A, 0x55CC, "", "STPC Client Southbridge" } ,
	{ 0x104B, 0x0140, "", "BT-946C (old) [multimaster  01]" } ,
	{ 0x104B, 0x1040, "", "BT-946C (BA80C30) [MultiMaster 10]" } ,
	{ 0x104B, 0x8130, "", "Flashpoint LT" } ,
	{ 0x104C, 0x0500, "", "100 MBit LAN Controller" } ,
	{ 0x104C, 0x0508, "", "TMS380C2X Compressor Interface" } ,
	{ 0x104C, 0x1000, "", "Eagle i/f AS" } ,
	{ 0x104C, 0x104C, "", "PCI1510 PC card Cardbus Controller" } ,
	{ 0x104C, 0x3D04, "", "TVP4010 [Permedia]" } ,
	{ 0x104C, 0x3D07, "", "TVP4020 [Permedia 2]" } ,
	{ 0x104C, 0x8000, "", "PCILynx/PCILynx2 IEEE 1394 Link Layer Controller" } ,
	{ 0x104C, 0x8009, "", "FireWire Controller" } ,
	{ 0x104C, 0x8017, "", "PCI4410 FireWire Controller" } ,
	{ 0x104C, 0x8019, "", "TSB12LV23 IEEE-1394 Controller" } ,
	{ 0x104C, 0x8020, "", "TSB12LV26 IEEE-1394 Controller (Link)" } ,
	{ 0x104C, 0x8021, "", "TSB43AA22 IEEE-1394 Controller (PHY/Link Integrated)" } ,
	{ 0x104C, 0x8022, "", "TSB43AB22 IEEE-1394a-2000 Controller (PHY/Link)" } ,
	{ 0x104C, 0x8023, "", "TSB43AB22/A IEEE-1394a-2000 Controller (PHY/Link)" } ,
	{ 0x104C, 0x8024, "", "TSB43AB23 IEEE-1394a-2000 Controller (PHY/Link)" } ,
	{ 0x104C, 0x8025, "", "TSB82AA2 IEEE-1394b Link Layer Controller" } ,
	{ 0x104C, 0x8026, "", "TSB43AB21 IEEE-1394a-2000 Controller (PHY/Link)" } ,
	{ 0x104C, 0x8027, "", "PCI4451 IEEE-1394 Controller" } ,
	{ 0x104C, 0x8029, "", "PCI4510 IEEE-1394 Controller" } ,
	{ 0x104C, 0x802B, "", "PCI7410,7510,7610 OHCI-Lynx Controller" } ,
	{ 0x104C, 0x802E, "", "PCI7x20 1394a-2000 OHCI Two-Port PHY/Link-Layer Controller" } ,
	{ 0x104C, 0x8031, "", "PCIxx21/x515 Cardbus Controller" } ,
	{ 0x104C, 0x8032, "", "OHCI Compliant IEEE 1394 Host Controller" } ,
	{ 0x104C, 0x8033, "", "PCIxx21 Integrated FlashMedia Controller" } ,
	{ 0x104C, 0x8034, "", "PCI6411, PCI6421, PCI6611, PCI6621, PCI7411, PCI7421, PCI7611, PCI7621 Secure Digital (SD) Controller" } ,
	{ 0x104C, 0x8035, "", "PCI6411, PCI6421, PCI6611, PCI6621, PCI7411, PCI7421, PCI7611, PCI7621 Smart Card Controller (SMC)" } ,
	{ 0x104C, 0x8036, "", "PCI6515 Cardbus Controller" } ,
	{ 0x104C, 0x8038, "", "PCI6515 SmartCard Controller" } ,
	{ 0x104C, 0x8201, "", "PCI1620 Firmware Loading Function" } ,
	{ 0x104C, 0x8204, "", "PCI7410,7510,7610 PCI Firmware Loading Function" } ,
	{ 0x104C, 0x8400, "", "ACX 100 22Mbps Wireless Interface" } ,
	{ 0x104C, 0x8401, "", "ACX 100 22Mbps Wireless Interface" } ,
	{ 0x104C, 0x9000, "", "Wireless Interface (of unknown type)" } ,
	{ 0x104C, 0x9066, "", "ACX 111 54Mbps Wireless Interface" } ,
	{ 0x104C, 0xA001, "", "TDC1570" } ,
	{ 0x104C, 0xA100, "", "TDC1561" } ,
	{ 0x104C, 0xA102, "", "TNETA1575 HyperSAR Plus w/PCI Host i/f & UTOPIA i/f" } ,
	{ 0x104C, 0xA106, "", "TMS320C6414 TMS320C6415 TMS320C6416" } ,
	{ 0x104C, 0xAC10, "", "PCI1050" } ,
	{ 0x104C, 0xAC11, "", "PCI1053" } ,
	{ 0x104C, 0xAC12, "", "PCI1130" } ,
	{ 0x104C, 0xAC13, "", "PCI1031" } ,
	{ 0x104C, 0xAC15, "", "PCI1131" } ,
	{ 0x104C, 0xAC16, "", "PCI1250" } ,
	{ 0x104C, 0xAC17, "", "PCI1220" } ,
	{ 0x104C, 0xAC18, "", "PCI1260" } ,
	{ 0x104C, 0xAC19, "", "PCI1221" } ,
	{ 0x104C, 0xAC1A, "", "PCI1210" } ,
	{ 0x104C, 0xAC1B, "", "PCI1450" } ,
	{ 0x104C, 0xAC1C, "", "PCI1225" } ,
	{ 0x104C, 0xAC1D, "", "PCI1251A" } ,
	{ 0x104C, 0xAC1E, "", "PCI1211" } ,
	{ 0x104C, 0xAC1F, "", "PCI1251B" } ,
	{ 0x104C, 0xAC20, "", "TI 2030" } ,
	{ 0x104C, 0xAC21, "", "PCI2031" } ,
	{ 0x104C, 0xAC22, "", "PCI2032 PCI Docking Bridge" } ,
	{ 0x104C, 0xAC23, "", "PCI2250 PCI-to-PCI Bridge" } ,
	{ 0x104C, 0xAC28, "", "PCI2050 PCI-to-PCI Bridge" } ,
	{ 0x104C, 0xAC30, "", "PCI1260 PC card Cardbus Controller" } ,
	{ 0x104C, 0xAC40, "", "PCI4450 PC card Cardbus Controller" } ,
	{ 0x104C, 0xAC41, "", "PCI4410 PC card Cardbus Controller" } ,
	{ 0x104C, 0xAC42, "", "PCI4451 PC card Cardbus Controller" } ,
	{ 0x104C, 0xAC44, "", "PCI4510 PC card Cardbus Controller" } ,
	{ 0x104C, 0xAC46, "", "PCI4520 PC card Cardbus Controller" } ,
	{ 0x104C, 0xAC47, "", "PCI7510 PC card Cardbus Controller" } ,
	{ 0x104C, 0xAC4A, "", "PCI7510,7610 PC card Cardbus Controller" } ,
	{ 0x104C, 0xAC50, "", "PCI1410 PC card Cardbus Controller" } ,
	{ 0x104C, 0xAC51, "", "PCI1420" } ,
	{ 0x104C, 0xAC52, "", "PCI1451 PC card Cardbus Controller" } ,
	{ 0x104C, 0xAC53, "", "PCI1421 PC card Cardbus Controller" } ,
	{ 0x104C, 0xAC54, "", "PCI1620 PC Card Controller" } ,
	{ 0x104C, 0xAC55, "", "PCI1520 PC card Cardbus Controller" } ,
	{ 0x104C, 0xAC56, "", "PCI1510 PC card Cardbus Controller" } ,
	{ 0x104C, 0xAC60, "", "PCI2040 PCI to DSP Bridge Controller" } ,
	{ 0x104C, 0xAC8D, "", "PCI 7620" } ,
	{ 0x104C, 0xAC8E, "", "PCI7420 CardBus Controller" } ,
	{ 0x104C, 0xAC8F, "", "PCI7420/PCI7620 Dual Socket CardBus and Smart Card Cont. w/ 1394a-2000 OHCI Two-Port  PHY/Link-Layer Cont. and SD/MS-Pro Sockets" } ,
	{ 0x104C, 0xFE00, "", "FireWire Host Controller" } ,
	{ 0x104C, 0xFE03, "", "12C01A FireWire Host Controller" } ,
	{ 0x104D, 0x8004, "", "DTL-H2500 [Playstation development board]" } ,
	{ 0x104D, 0x8009, "", "CXD1947Q i.LINK Controller" } ,
	{ 0x104D, 0x8039, "", "CXD3222 i.LINK Controller" } ,
	{ 0x104D, 0x8056, "", "Rockwell HCF 56K modem" } ,
	{ 0x104D, 0x808A, "", "Memory Stick Controller" } ,
	{ 0x104E, 0x0017, "", "OTI-64017" } ,
	{ 0x104E, 0x0107, "", "OTI-107 [Spitfire]" } ,
	{ 0x104E, 0x0109, "", "Video Adapter" } ,
	{ 0x104E, 0x0111, "", "OTI-64111 [Spitfire]" } ,
	{ 0x104E, 0x0217, "", "OTI-64217" } ,
	{ 0x104E, 0x0317, "", "OTI-64317" } ,
	{ 0x1050, 0x0000, "", "NE2000" } ,
	{ 0x1050, 0x0001, "", "W83769F" } ,
	{ 0x1050, 0x0105, "", "W82C105" } ,
	{ 0x1050, 0x0840, "", "W89C840" } ,
	{ 0x1050, 0x0940, "", "W89C940" } ,
	{ 0x1050, 0x5A5A, "", "W89C940F" } ,
	{ 0x1050, 0x6692, "", "W6692" } ,
	{ 0x1050, 0x9921, "", "W99200F MPEG-1 Video Encoder" } ,
	{ 0x1050, 0x9922, "", "W99200F/W9922PF MPEG-1/2 Video Encoder" } ,
	{ 0x1050, 0x9970, "", "W9970CF" } ,
	{ 0x1055, 0x9130, "", "SLC90E66 [Victory66] IDE" } ,
	{ 0x1055, 0x9460, "", "SLC90E66 [Victory66] ISA" } ,
	{ 0x1055, 0x9462, "", "SLC90E66 [Victory66] USB" } ,
	{ 0x1055, 0x9463, "", "SLC90E66 [Victory66] ACPI" } ,
	{ 0x1057, 0x0001, "", "MPC105 [Eagle]" } ,
	{ 0x1057, 0x0002, "", "MPC106 [Grackle]" } ,
	{ 0x1057, 0x0003, "", "MPC8240 [Kahlua]" } ,
	{ 0x1057, 0x0004, "", "MPC107" } ,
	{ 0x1057, 0x0006, "", "MPC8245 [Unity]" } ,
	{ 0x1057, 0x0008, "", "MPC8540" } ,
	{ 0x1057, 0x0009, "", "MPC8560" } ,
	{ 0x1057, 0x0100, "", "MC145575 [HFC-PCI]" } ,
	{ 0x1057, 0x0431, "", "KTI829c 100VG" } ,
	{ 0x1057, 0x1801, "", "DSP56301 Digital Signal Processor" } ,
	{ 0x1057, 0x18C0, "", "MPC8265A/8266/8272" } ,
	{ 0x1057, 0x18C1, "", "MPC8271/MPC8272" } ,
	{ 0x1057, 0x3410, "", "DSP56361 Digital Signal Processor" } ,
	{ 0x1057, 0x4801, "", "Raven" } ,
	{ 0x1057, 0x4802, "", "Falcon" } ,
	{ 0x1057, 0x4803, "", "Hawk" } ,
	{ 0x1057, 0x4806, "", "CPX8216" } ,
	{ 0x1057, 0x4D68, "", "20268" } ,
	{ 0x1057, 0x5600, "", "SM56 PCI Modem" } ,
	{ 0x1057, 0x5803, "", "MPC5200" } ,
	{ 0x1057, 0x5806, "", "MCF54 Coldfire" } ,
	{ 0x1057, 0x5808, "", "MPC8220" } ,
	{ 0x1057, 0x6400, "", "MPC190 Security Processor (S1 family, encryption)" } ,
	{ 0x1057, 0x6405, "", "MPC184 Security Processor (S1 family)" } ,
	{ 0x105A, 0x0D30, "", "PDC20265 (FastTrak100 Lite/Ultra100)" } ,
	{ 0x105A, 0x0D38, "", "20263" } ,
	{ 0x105A, 0x1275, "", "20275" } ,
	{ 0x105A, 0x3318, "", "PDC20318 (SATA150 TX4)" } ,
	{ 0x105A, 0x3319, "", "PDC20319 (FastTrak S150 TX4)" } ,
	{ 0x105A, 0x3371, "", "PDC20371 (FastTrak S150 TX2plus)" } ,
	{ 0x105A, 0x3373, "", "PDC20378 (FastTrak 378/SATA 378)" } ,
	{ 0x105A, 0x3375, "", "PDC20375 (SATA150 TX2plus)" } ,
	{ 0x105A, 0x3376, "", "PDC20376 (FastTrak 376)" } ,
	{ 0x105A, 0x3515, "", "PDC40719" } ,
	{ 0x105A, 0x3519, "", "PDC40519 (FastTrak TX4200)" } ,
	{ 0x105A, 0x3571, "", "PDC20571 (FastTrak TX2200)" } ,
	{ 0x105A, 0x3574, "", "PDC20579 SATAII 150 IDE Controller" } ,
	{ 0x105A, 0x3577, "", "PDC40779 (SATA 300 779)" } ,
	{ 0x105A, 0x3D17, "", "PDC20718 (SATA 300 TX4)" } ,
	{ 0x105A, 0x3D18, "", "PDC20518/PDC40518 (SATAII 150 TX4)" } ,
	{ 0x105A, 0x3D73, "", "PDC40775 (SATA 300 TX2plus)" } ,
	{ 0x105A, 0x3D75, "", "PDC20575 (SATAII150 TX2plus)" } ,
	{ 0x105A, 0x4D30, "", "PDC20267 (FastTrak100/Ultra100)" } ,
	{ 0x105A, 0x4D33, "", "20246" } ,
	{ 0x105A, 0x4D38, "", "PDC20262 (FastTrak66/Ultra66)" } ,
	{ 0x105A, 0x4D68, "", "PDC20268 (Ultra100 TX2)" } ,
	{ 0x105A, 0x4D69, "", "20269" } ,
	{ 0x105A, 0x5275, "", "PDC20276 (MBFastTrak133 Lite)" } ,
	{ 0x105A, 0x5300, "", "DC5300" } ,
	{ 0x105A, 0x6268, "", "PDC20270 (FastTrak100 LP/TX2/TX4)" } ,
	{ 0x105A, 0x6269, "", "PDC20271 (FastTrak TX2000)" } ,
	{ 0x105A, 0x6621, "", "PDC20621 (FastTrak S150 SX4/FastTrak SX4000 lite)" } ,
	{ 0x105A, 0x6622, "", "PDC20621 [SATA150 SX4] 4 Channel IDE RAID Controller" } ,
	{ 0x105A, 0x6624, "", "PDC20621 [FastTrak SX4100]" } ,
	{ 0x105A, 0x6626, "", "PDC20618 (Ultra 618)" } ,
	{ 0x105A, 0x6629, "", "PDC20619 (FastTrak TX4000)" } ,
	{ 0x105A, 0x7275, "", "PDC20277 (SBFastTrak133 Lite)" } ,
	{ 0x105A, 0x8002, "", "SATAII150 SX8" } ,
	{ 0x105D, 0x2309, "", "Imagine 128" } ,
	{ 0x105D, 0x2339, "", "Imagine 128-II" } ,
	{ 0x105D, 0x493D, "", "Imagine 128 T2R [Ticket to Ride]" } ,
	{ 0x105D, 0x5348, "", "Revolution 4" } ,
	{ 0x1060, 0x0001, "", "UM82C881" } ,
	{ 0x1060, 0x0002, "", "UM82C886" } ,
	{ 0x1060, 0x0101, "", "UM8673F" } ,
	{ 0x1060, 0x0881, "", "UM8881" } ,
	{ 0x1060, 0x0886, "", "UM8886F" } ,
	{ 0x1060, 0x0891, "", "UM8891A" } ,
	{ 0x1060, 0x1001, "", "UM886A" } ,
	{ 0x1060, 0x673A, "", "UM8886BF" } ,
	{ 0x1060, 0x673B, "", "EIDE Master/DMA" } ,
	{ 0x1060, 0x8710, "", "UM8710" } ,
	{ 0x1060, 0x886A, "", "UM8886A" } ,
	{ 0x1060, 0x8881, "", "UM8881F" } ,
	{ 0x1060, 0x8886, "", "UM8886F" } ,
	{ 0x1060, 0x888A, "", "UM8886A" } ,
	{ 0x1060, 0x8891, "", "UM8891A" } ,
	{ 0x1060, 0x9017, "", "UM9017F" } ,
	{ 0x1060, 0x9018, "", "UM9018" } ,
	{ 0x1060, 0x9026, "", "UM9026" } ,
	{ 0x1060, 0xE881, "", "UM8881N" } ,
	{ 0x1060, 0xE886, "", "UM8886N" } ,
	{ 0x1060, 0xE88A, "", "UM8886N" } ,
	{ 0x1060, 0xE891, "", "UM8891N" } ,
	{ 0x1061, 0x0001, "", "AGX016" } ,
	{ 0x1061, 0x0002, "", "IIT3204/3501" } ,
	{ 0x1066, 0x0000, "", "PT80C826" } ,
	{ 0x1066, 0x0001, "", "PT86C521 [Vesuvius v1] Host Bridge" } ,
	{ 0x1066, 0x0002, "", "PT86C523 [Vesuvius v3] PCI-ISA Bridge Master" } ,
	{ 0x1066, 0x0003, "", "PT86C524 [Nile] PCI-to-PCI Bridge" } ,
	{ 0x1066, 0x0004, "", "PT86C525 [Nile-II] PCI-to-PCI Bridge" } ,
	{ 0x1066, 0x0005, "", "National PC87550 System Controller" } ,
	{ 0x1066, 0x8002, "", "PT86C523 [Vesuvius v3] PCI-ISA Bridge Slave" } ,
	{ 0x1067, 0x0301, "", "AccelGraphics AccelECLIPSE" } ,
	{ 0x1067, 0x0304, "", "AccelGALAXY A2100 [OEM Evans & Sutherland]" } ,
	{ 0x1067, 0x0308, "", "Tornado 3000 [OEM Evans & Sutherland]" } ,
	{ 0x1067, 0x1002, "", "VG500 [VolumePro Volume Rendering Accelerator]" } ,
	{ 0x1069, 0x0001, "", "DAC960P" } ,
	{ 0x1069, 0x0002, "", "DAC960PD" } ,
	{ 0x1069, 0x0010, "", "DAC960PG" } ,
	{ 0x1069, 0x0020, "", "DAC960LA" } ,
	{ 0x1069, 0x0050, "", "AcceleRAID 352/170/160 support Device" } ,
	{ 0x1069, 0xB166, "", "AcceleRAID 600/500/400/Sapphire support Device" } ,
	{ 0x1069, 0xBA55, "", "eXtremeRAID 1100 support Device" } ,
	{ 0x1069, 0xBA56, "", "eXtremeRAID 2000/3000 support Device" } ,
	{ 0x1069, 0xBA57, "", "eXtremeRAID 4000/5000 support Device" } ,
	{ 0x106B, 0x0001, "", "Bandit PowerPC host bridge" } ,
	{ 0x106B, 0x0002, "", "Grand Central I/O" } ,
	{ 0x106B, 0x0003, "", "Control Video" } ,
	{ 0x106B, 0x0004, "", "PlanB Video-In" } ,
	{ 0x106B, 0x0007, "", "O'Hare I/O" } ,
	{ 0x106B, 0x000C, "", "DOS on Mac" } ,
	{ 0x106B, 0x000E, "", "Hydra Mac I/O" } ,
	{ 0x106B, 0x0010, "", "Heathrow Mac I/O" } ,
	{ 0x106B, 0x0017, "", "Paddington Mac I/O" } ,
	{ 0x106B, 0x0018, "", "UniNorth FireWire" } ,
	{ 0x106B, 0x0019, "", "KeyLargo USB" } ,
	{ 0x106B, 0x001E, "", "UniNorth Internal PCI" } ,
	{ 0x106B, 0x001F, "", "UniNorth PCI" } ,
	{ 0x106B, 0x0020, "", "UniNorth AGP" } ,
	{ 0x106B, 0x0021, "", "UniNorth GMAC (Sun GEM)" } ,
	{ 0x106B, 0x0022, "", "KeyLargo Mac I/O" } ,
	{ 0x106B, 0x0024, "", "UniNorth/Pangea GMAC (Sun GEM)" } ,
	{ 0x106B, 0x0025, "", "KeyLargo/Pangea Mac I/O" } ,
	{ 0x106B, 0x0026, "", "KeyLargo/Pangea USB" } ,
	{ 0x106B, 0x0027, "", "UniNorth/Pangea AGP" } ,
	{ 0x106B, 0x0028, "", "UniNorth/Pangea PCI" } ,
	{ 0x106B, 0x0029, "", "UniNorth/Pangea Internal PCI" } ,
	{ 0x106B, 0x002D, "", "UniNorth 1.5 AGP" } ,
	{ 0x106B, 0x002E, "", "UniNorth 1.5 PCI" } ,
	{ 0x106B, 0x002F, "", "UniNorth 1.5 Internal PCI" } ,
	{ 0x106B, 0x0030, "", "UniNorth/Pangea FireWire" } ,
	{ 0x106B, 0x0031, "", "UniNorth 2 FireWire" } ,
	{ 0x106B, 0x0032, "", "UniNorth 2 GMAC (Sun GEM)" } ,
	{ 0x106B, 0x0033, "", "UniNorth 2 ATA/100" } ,
	{ 0x106B, 0x0034, "", "UniNorth 2 AGP" } ,
	{ 0x106B, 0x0035, "", "UniNorth 2 PCI" } ,
	{ 0x106B, 0x0036, "", "UniNorth 2 Internal PCI" } ,
	{ 0x106B, 0x003B, "", "UniNorth/Intrepid ATA/100" } ,
	{ 0x106B, 0x003E, "", "KeyLargo/Intrepid Mac I/O" } ,
	{ 0x106B, 0x003F, "", "KeyLargo/Intrepid USB" } ,
	{ 0x106B, 0x0040, "", "K2 KeyLargo USB" } ,
	{ 0x106B, 0x0041, "", "K2 KeyLargo Mac/IO" } ,
	{ 0x106B, 0x0042, "", "K2 FireWire" } ,
	{ 0x106B, 0x0043, "", "K2 ATA/100" } ,
	{ 0x106B, 0x0045, "", "K2 HT-PCI Bridge" } ,
	{ 0x106B, 0x0046, "", "K2 HT-PCI Bridge" } ,
	{ 0x106B, 0x0047, "", "K2 HT-PCI Bridge" } ,
	{ 0x106B, 0x0048, "", "K2 HT-PCI Bridge" } ,
	{ 0x106B, 0x0049, "", "K2 HT-PCI Bridge" } ,
	{ 0x106B, 0x004B, "", "U3 AGP" } ,
	{ 0x106B, 0x004C, "", "K2 GMAC (Sun GEM)" } ,
	{ 0x106B, 0x004F, "", "Shasta Mac I/O" } ,
	{ 0x106B, 0x0050, "", "Shasta IDE" } ,
	{ 0x106B, 0x0051, "", "Shasta (Sun GEM)" } ,
	{ 0x106B, 0x0052, "", "Shasta Firewire" } ,
	{ 0x106B, 0x0053, "", "Shasta PCI Bridge" } ,
	{ 0x106B, 0x0054, "", "Shasta PCI Bridge" } ,
	{ 0x106B, 0x0055, "", "Shasta PCI Bridge" } ,
	{ 0x106B, 0x0058, "", "U3L AGP Bridge" } ,
	{ 0x106B, 0x0059, "", "U3H AGP Bridge" } ,
	{ 0x106B, 0x0066, "", "Intrepid2 AGP Bridge" } ,
	{ 0x106B, 0x0067, "", "Intrepid2 PCI Bridge" } ,
	{ 0x106B, 0x0068, "", "Intrepid2 PCI Bridge" } ,
	{ 0x106B, 0x1645, "", "Tigon3 Gigabit Ethernet NIC (BCM5701)" } ,
	{ 0x106C, 0x8801, "", "Dual Pentium ISA/PCI Motherboard" } ,
	{ 0x106C, 0x8802, "", "PowerPC ISA/PCI Motherboard" } ,
	{ 0x106C, 0x8803, "", "Dual Window Graphics Accelerator" } ,
	{ 0x106C, 0x8804, "", "LAN Controller" } ,
	{ 0x106C, 0x8805, "", "100-BaseT LAN" } ,
	{ 0x1071, 0x8160, "", "Mitac 8060B Mobile Platform" } ,
	{ 0x1073, 0x0001, "", "3D GUI Accelerator" } ,
	{ 0x1073, 0x0002, "", "YGV615 [RPA3 3D-Graphics Controller]" } ,
	{ 0x1073, 0x0003, "", "YMF-740" } ,
	{ 0x1073, 0x0004, "", "YMF-724" } ,
	{ 0x1073, 0x0005, "", "DS1 Audio" } ,
	{ 0x1073, 0x0006, "", "DS1 Audio" } ,
	{ 0x1073, 0x0008, "", "DS1 Audio" } ,
	{ 0x1073, 0x000A, "", "DS1L Audio" } ,
	{ 0x1073, 0x000C, "", "YMF-740C [DS-1L Audio Controller]" } ,
	{ 0x1073, 0x000D, "", "YMF-724F [DS-1 Audio Controller]" } ,
	{ 0x1073, 0x0010, "", "YMF-744B [DS-1S Audio Controller]" } ,
	{ 0x1073, 0x0012, "", "YMF-754 [DS-1E Audio Controller]" } ,
	{ 0x1073, 0x0020, "", "DS-1 Audio" } ,
	{ 0x1073, 0x2000, "", "DS2416 Digital Mixing Card" } ,
	{ 0x1074, 0x4E78, "", "82c500/1" } ,
	{ 0x1077, 0x1016, "", "ISP10160 Single Channel Ultra3 SCSI Processor" } ,
	{ 0x1077, 0x1020, "", "ISP1020 Fast-wide SCSI" } ,
	{ 0x1077, 0x1022, "", "ISP1022 Fast-wide SCSI" } ,
	{ 0x1077, 0x1080, "", "ISP1080 SCSI Host Adapter" } ,
	{ 0x1077, 0x1216, "", "ISP12160 Dual Channel Ultra3 SCSI Processor" } ,
	{ 0x1077, 0x1240, "", "ISP1240 SCSI Host Adapter" } ,
	{ 0x1077, 0x1280, "", "ISP1280 SCSI Host Adapter" } ,
	{ 0x1077, 0x2020, "", "ISP2020A Fast!SCSI Basic Adapter" } ,
	{ 0x1077, 0x2100, "", "QLA2100 64-bit Fibre Channel Adapter" } ,
	{ 0x1077, 0x2200, "", "QLA2200 64-bit Fibre Channel Adapter" } ,
	{ 0x1077, 0x2300, "", "QLA2300 64-bit Fibre Channel Adapter" } ,
	{ 0x1077, 0x2312, "", "QLA2312 Fibre Channel Adapter" } ,
	{ 0x1077, 0x3022, "", "QLA3022 Network Adapter" } ,
	{ 0x1077, 0x4022, "", "QLA4022 iSCSI TOE Adapter" } ,
	{ 0x1078, 0x0000, "", "5510 [Grappa]" } ,
	{ 0x1078, 0x0001, "", "PCI Master" } ,
	{ 0x1078, 0x0002, "", "5520 [Cognac]" } ,
	{ 0x1078, 0x0100, "", "5530 Legacy [Kahlua]" } ,
	{ 0x1078, 0x0101, "", "5530 SMI [Kahlua]" } ,
	{ 0x1078, 0x0102, "", "5530 IDE [Kahlua]" } ,
	{ 0x1078, 0x0103, "", "5530 Audio [Kahlua]" } ,
	{ 0x1078, 0x0104, "", "5530 Video [Kahlua]" } ,
	{ 0x1078, 0x0400, "", "ZFMicro PCI Bridge" } ,
	{ 0x1078, 0x0401, "", "ZFMicro Chipset SMI" } ,
	{ 0x1078, 0x0402, "", "ZFMicro Chipset IDE" } ,
	{ 0x1078, 0x0403, "", "ZFMicro Expansion Bus" } ,
	{ 0x107D, 0x0000, "", "P86C850" } ,
	{ 0x107D, 0x2134, "", "WinFast 3D S320 II" } ,
	{ 0x107D, 0x2971, "", "[GeForce FX 5900] WinFast A350 TDH MyViVo" } ,
	{ 0x107E, 0x0001, "", "5515 ATM Adapter [Flipper]" } ,
	{ 0x107E, 0x0002, "", "100 VG AnyLan Controller" } ,
	{ 0x107E, 0x0004, "", "5526 Fibre Channel Host Adapter" } ,
	{ 0x107E, 0x0005, "", "x526 Fibre Channel Host Adapter" } ,
	{ 0x107E, 0x0008, "", "5525/5575 ATM Adapter (155 Mbit) [Atlantic]" } ,
	{ 0x107E, 0x9003, "", "5535-4P-BRI-ST" } ,
	{ 0x107E, 0x9007, "", "5535-4P-BRI-U" } ,
	{ 0x107E, 0x9008, "", "5535-1P-SR" } ,
	{ 0x107E, 0x900C, "", "5535-1P-SR-ST" } ,
	{ 0x107E, 0x900E, "", "5535-1P-SR-U" } ,
	{ 0x107E, 0x9011, "", "5535-1P-PRI" } ,
	{ 0x107E, 0x9013, "", "5535-2P-PRI" } ,
	{ 0x107E, 0x9023, "", "5536-4P-BRI-ST" } ,
	{ 0x107E, 0x9027, "", "5536-4P-BRI-U" } ,
	{ 0x107E, 0x9031, "", "5536-1P-PRI" } ,
	{ 0x107E, 0x9033, "", "5536-2P-PRI" } ,
	{ 0x107F, 0x0802, "", "SL82C105" } ,
	{ 0x1080, 0x0600, "", "82C599" } ,
	{ 0x1080, 0xC691, "", "Cypress CY82C691" } ,
	{ 0x1080, 0xC693, "", "82c693" } ,
	{ 0x1081, 0x0D47, "", "Radius PCI to NuBUS Bridge" } ,
	{ 0x1083, 0x0001, "", "FR710" } ,
	{ 0x108A, 0x0001, "", "VME Bridge Model 617" } ,
	{ 0x108A, 0x0010, "", "VME Bridge Model 618" } ,
	{ 0x108A, 0x0040, "", "dataBLIZZARD" } ,
	{ 0x108A, 0x3000, "", "VME Bridge Model 2706" } ,
	{ 0x108D, 0x0001, "", "Token-Ring 16/4 PCI Adapter (3136/3137)" } ,
	{ 0x108D, 0x0002, "", "16/4 Token Ring" } ,
	{ 0x108D, 0x0004, "", "RapidFire 3139 Token-Ring 16/4 PCI Adapter" } ,
	{ 0x108D, 0x0005, "", "GoCard 3250 Token-Ring 16/4 CardBus PC Card" } ,
	{ 0x108D, 0x0006, "", "OC-3530 RapidFire Token-Ring 100" } ,
	{ 0x108D, 0x0007, "", "RapidFire 3141 Token-Ring 16/4 PCI Fiber Adapter" } ,
	{ 0x108D, 0x0008, "", "RapidFire 3540 HSTR 100/16/4 PCI Adapter" } ,
	{ 0x108D, 0x0011, "", "OC-2315" } ,
	{ 0x108D, 0x0012, "", "OC-2325" } ,
	{ 0x108D, 0x0013, "", "OC-2183/2185" } ,
	{ 0x108D, 0x0014, "", "OC-2326" } ,
	{ 0x108D, 0x0019, "", "OC-2327/2250 10/100 Ethernet Adapter" } ,
	{ 0x108D, 0x0021, "", "OC-6151/6152 [RapidFire ATM 155]" } ,
	{ 0x108D, 0x0022, "", "ATM Adapter" } ,
	{ 0x108E, 0x0001, "", "EBUS" } ,
	{ 0x108E, 0x1000, "", "EBUS" } ,
	{ 0x108E, 0x1001, "", "Happy Meal" } ,
	{ 0x108E, 0x1100, "", "RIO EBUS" } ,
	{ 0x108E, 0x1101, "", "RIO GEM" } ,
	{ 0x108E, 0x1102, "", "RIO 1394" } ,
	{ 0x108E, 0x1103, "", "RIO USB" } ,
	{ 0x108E, 0x1648, "", "[bge] Gigabit Ethernet" } ,
	{ 0x108E, 0x2BAD, "", "GEM" } ,
	{ 0x108E, 0x5000, "", "Simba Advanced PCI Bridge" } ,
	{ 0x108E, 0x5043, "", "SunPCI Co-processor" } ,
	{ 0x108E, 0x8000, "", "Psycho PCI Bus Module" } ,
	{ 0x108E, 0x8001, "", "Schizo PCI Bus Module" } ,
	{ 0x108E, 0x8002, "", "Schizo+ PCI Bus Module" } ,
	{ 0x108E, 0xA000, "", "Ultra IIi" } ,
	{ 0x108E, 0xA001, "", "Ultra IIe" } ,
	{ 0x108E, 0xA801, "", "Tomatillo PCI Bus Module" } ,
	{ 0x108E, 0xABBA, "", "Cassini 10/100/1000" } ,
	{ 0x1091, 0x0020, "", "3D graphics processor" } ,
	{ 0x1091, 0x0021, "", "3D graphics processor w/Texturing" } ,
	{ 0x1091, 0x0040, "", "3D graphics frame buffer" } ,
	{ 0x1091, 0x0041, "", "3D graphics frame buffer" } ,
	{ 0x1091, 0x0060, "", "Proprietary bus bridge" } ,
	{ 0x1091, 0x00E4, "", "Powerstorm 4D50T" } ,
	{ 0x1091, 0x0720, "", "Motion JPEG codec" } ,
	{ 0x1091, 0x07A0, "", "Sun Expert3D-Lite Graphics Accelerator" } ,
	{ 0x1091, 0x1091, "", "Sun Expert3D Graphics Accelerator" } ,
	{ 0x1092, 0x00A0, "", "Speedstar Pro SE" } ,
	{ 0x1092, 0x00A8, "", "Speedstar 64" } ,
	{ 0x1092, 0x0550, "", "Viper V550" } ,
	{ 0x1092, 0x08D4, "", "Supra 2260 Modem" } ,
	{ 0x1092, 0x094C, "", "SupraExpress 56i Pro" } ,
	{ 0x1092, 0x1092, "", "Viper V330" } ,
	{ 0x1092, 0x6120, "", "Maximum DVD" } ,
	{ 0x1092, 0x8810, "", "Stealth SE" } ,
	{ 0x1092, 0x8811, "", "Stealth 64/SE" } ,
	{ 0x1092, 0x8880, "", "Stealth" } ,
	{ 0x1092, 0x8881, "", "Stealth" } ,
	{ 0x1092, 0x88B0, "", "Stealth 64" } ,
	{ 0x1092, 0x88B1, "", "Stealth 64" } ,
	{ 0x1092, 0x88C0, "", "Stealth 64" } ,
	{ 0x1092, 0x88C1, "", "Stealth 64" } ,
	{ 0x1092, 0x88D0, "", "Stealth 64" } ,
	{ 0x1092, 0x88D1, "", "Stealth 64" } ,
	{ 0x1092, 0x88F0, "", "Stealth 64" } ,
	{ 0x1092, 0x88F1, "", "Stealth 64" } ,
	{ 0x1092, 0x9999, "", "DMD-I0928-1 Monster sound sound chip" } ,
	{ 0x1093, 0x0160, "", "PCI-DIO-96" } ,
	{ 0x1093, 0x0162, "", "PCI-MIO-16XE-50" } ,
	{ 0x1093, 0x1170, "", "PCI-MIO-16XE-10" } ,
	{ 0x1093, 0x1180, "", "PCI-MIO-16E-1" } ,
	{ 0x1093, 0x1190, "", "PCI-MIO-16E-4" } ,
	{ 0x1093, 0x1310, "", "PCI-6602" } ,
	{ 0x1093, 0x1330, "", "PCI-6031E" } ,
	{ 0x1093, 0x1350, "", "PCI-6071E" } ,
	{ 0x1093, 0x14E0, "", "PCI-6110" } ,
	{ 0x1093, 0x14F0, "", "PCI-6111" } ,
	{ 0x1093, 0x17D0, "", "PCI-6503" } ,
	{ 0x1093, 0x1870, "", "PCI-6713" } ,
	{ 0x1093, 0x1880, "", "PCI-6711" } ,
	{ 0x1093, 0x18B0, "", "PCI-6052E" } ,
	{ 0x1093, 0x2410, "", "PCI-6733" } ,
	{ 0x1093, 0x2890, "", "PCI-6036E" } ,
	{ 0x1093, 0x2A60, "", "PCI-6023E" } ,
	{ 0x1093, 0x2A70, "", "PCI-6024E" } ,
	{ 0x1093, 0x2A80, "", "PCI-6025E" } ,
	{ 0x1093, 0x2C80, "", "PCI-6035E" } ,
	{ 0x1093, 0x2CA0, "", "PCI-6034E" } ,
	{ 0x1093, 0x70B8, "", "PCI-6251 [M Series - High Speed Multifunction DAQ]" } ,
	{ 0x1093, 0xB001, "", "IMAQ-PCI-1408" } ,
	{ 0x1093, 0xB011, "", "IMAQ-PXI-1408" } ,
	{ 0x1093, 0xB021, "", "IMAQ-PCI-1424" } ,
	{ 0x1093, 0xB031, "", "IMAQ-PCI-1413" } ,
	{ 0x1093, 0xB041, "", "IMAQ-PCI-1407" } ,
	{ 0x1093, 0xB051, "", "IMAQ-PXI-1407" } ,
	{ 0x1093, 0xB061, "", "IMAQ-PCI-1411" } ,
	{ 0x1093, 0xB071, "", "IMAQ-PCI-1422" } ,
	{ 0x1093, 0xB081, "", "IMAQ-PXI-1422" } ,
	{ 0x1093, 0xB091, "", "IMAQ-PXI-1411" } ,
	{ 0x1093, 0xC801, "", "PCI-GPIB" } ,
	{ 0x1093, 0xC831, "", "PCI-GPIB bridge" } ,
	{ 0x1095, 0x0240, "", "Adaptec AAR-1210SA SATA HostRAID Controller" } ,
	{ 0x1095, 0x0640, "", "PCI0640" } ,
	{ 0x1095, 0x0643, "", "PCI0643" } ,
	{ 0x1095, 0x0646, "", "PCI0646" } ,
	{ 0x1095, 0x0647, "", "PCI0647" } ,
	{ 0x1095, 0x0648, "", "PCI0648" } ,
	{ 0x1095, 0x0649, "", "SiI 0649 Ultra ATA/100 PCI to ATA Host Controller" } ,
	{ 0x1095, 0x0650, "", "PBC0650A" } ,
	{ 0x1095, 0x0670, "", "USB0670" } ,
	{ 0x1095, 0x0673, "", "USB0673" } ,
	{ 0x1095, 0x0680, "", "PCI0680 Ultra ATA-133 Host Controller" } ,
	{ 0x1095, 0x3112, "", "SiI 3112 [SATALink/SATARaid] Serial ATA Controller" } ,
	{ 0x1095, 0x3114, "", "SiI 3114 [SATALink/SATARaid] Serial ATA Controller" } ,
	{ 0x1095, 0x3124, "", "SiI 3124 PCI-X Serial ATA Controller" } ,
	{ 0x1095, 0x3132, "", "SiI 3132 Serial ATA Raid II Controller" } ,
	{ 0x1095, 0x3512, "", "SiI 3512 [SATALink/SATARaid] Serial ATA Controller" } ,
	{ 0x1098, 0x0001, "", "QD-8500" } ,
	{ 0x1098, 0x0002, "", "QD-8580" } ,
	{ 0x109E, 0x032E, "", "Bt878 Video Capture" } ,
	{ 0x109E, 0x0350, "", "Bt848 Video Capture" } ,
	{ 0x109E, 0x0351, "", "Bt849A Video capture" } ,
	{ 0x109E, 0x0369, "", "Bt878 Video Capture" } ,
	{ 0x109E, 0x036C, "", "Bt879(??) Video Capture" } ,
	{ 0x109E, 0x036E, "", "Bt878 Video Capture" } ,
	{ 0x109E, 0x036F, "", "Bt879 Video Capture" } ,
	{ 0x109E, 0x0370, "", "Bt880 Video Capture" } ,
	{ 0x109E, 0x0878, "", "Bt878 Audio Capture" } ,
	{ 0x109E, 0x0879, "", "Bt879 Audio Capture" } ,
	{ 0x109E, 0x0880, "", "Bt880 Audio Capture" } ,
	{ 0x109E, 0x2115, "", "BtV 2115 Mediastream controller" } ,
	{ 0x109E, 0x2125, "", "BtV 2125 Mediastream controller" } ,
	{ 0x109E, 0x2164, "", "BtV 2164" } ,
	{ 0x109E, 0x2165, "", "BtV 2165" } ,
	{ 0x109E, 0x8230, "", "Bt8230 ATM Segment/Reassembly Ctrlr (SRC)" } ,
	{ 0x109E, 0x8472, "", "Bt8472" } ,
	{ 0x109E, 0x8474, "", "Bt8474" } ,
	{ 0x10A5, 0x3052, "", "SmartPCI562 56K Modem" } ,
	{ 0x10A5, 0x5449, "", "SmartPCI561 modem" } ,
	{ 0x10A8, 0x0000, "", "STB Horizon 64" } ,
	{ 0x10A9, 0x0001, "", "Crosstalk to PCI Bridge" } ,
	{ 0x10A9, 0x0002, "", "Linc I/O controller" } ,
	{ 0x10A9, 0x0003, "", "IOC3 I/O controller" } ,
	{ 0x10A9, 0x0004, "", "O2 MACE" } ,
	{ 0x10A9, 0x0005, "", "RAD Audio" } ,
	{ 0x10A9, 0x0006, "", "HPCEX" } ,
	{ 0x10A9, 0x0007, "", "RPCEX" } ,
	{ 0x10A9, 0x0008, "", "DiVO VIP" } ,
	{ 0x10A9, 0x0009, "", "AceNIC Gigabit Ethernet" } ,
	{ 0x10A9, 0x0010, "", "AMP Video I/O" } ,
	{ 0x10A9, 0x0011, "", "GRIP" } ,
	{ 0x10A9, 0x0012, "", "SGH PSHAC GSN" } ,
	{ 0x10A9, 0x1001, "", "Magic Carpet" } ,
	{ 0x10A9, 0x1002, "", "Lithium" } ,
	{ 0x10A9, 0x1003, "", "Dual JPEG 1" } ,
	{ 0x10A9, 0x1004, "", "Dual JPEG 2" } ,
	{ 0x10A9, 0x1005, "", "Dual JPEG 3" } ,
	{ 0x10A9, 0x1006, "", "Dual JPEG 4" } ,
	{ 0x10A9, 0x1007, "", "Dual JPEG 5" } ,
	{ 0x10A9, 0x1008, "", "Cesium" } ,
	{ 0x10A9, 0x100A, "", "IOC4 I/O controller" } ,
	{ 0x10A9, 0x2001, "", "Fibre Channel" } ,
	{ 0x10A9, 0x2002, "", "ASDE" } ,
	{ 0x10A9, 0x4001, "", "TIO-CE PCI Express Bridge" } ,
	{ 0x10A9, 0x4002, "", "TIO-CE PCI Express Port" } ,
	{ 0x10A9, 0x8001, "", "O2 1394" } ,
	{ 0x10A9, 0x8002, "", "G-net NT" } ,
	{ 0x10A9, 0x8010, "", "Broadcom e-net [SGI IO9/IO10 BaseIO]" } ,
	{ 0x10A9, 0x8018, "", "Broadcom e-net [SGI A330 Server BaseIO]" } ,
	{ 0x10AA, 0x0000, "", "ACCM 2188" } ,
	{ 0x10AD, 0x0001, "", "W83769F" } ,
	{ 0x10AD, 0x0003, "", "SL82C103" } ,
	{ 0x10AD, 0x0005, "", "SL82C105" } ,
	{ 0x10AD, 0x0103, "", "SL82c103" } ,
	{ 0x10AD, 0x0105, "", "SL82c105" } ,
	{ 0x10AD, 0x0565, "", "W83C553" } ,
	{ 0x10B3, 0x3106, "", "DB87144" } ,
	{ 0x10B3, 0xB106, "", "DB87144" } ,
	{ 0x10B4, 0x1B1D, "", "Velocity 128 3D" } ,
	{ 0x10B5, 0x0001, "", "i960 PCI bus interface" } ,
	{ 0x10B5, 0x1076, "", "VScom 800 8 port serial adaptor" } ,
	{ 0x10B5, 0x1077, "", "VScom 400 4 port serial adaptor" } ,
	{ 0x10B5, 0x1078, "", "VScom 210 2 port serial and 1 port parallel adaptor" } ,
	{ 0x10B5, 0x1103, "", "VScom 200 2 port serial adaptor" } ,
	{ 0x10B5, 0x1146, "", "VScom 010 1 port parallel adaptor" } ,
	{ 0x10B5, 0x1147, "", "VScom 020 2 port parallel adaptor" } ,
	{ 0x10B5, 0x2724, "", "Thales PCSM Security Card" } ,
	{ 0x10B5, 0x6540, "", "PCI6540/6466 PCI-PCI bridge (transparent mode)" } ,
	{ 0x10B5, 0x6541, "", "PCI6540/6466 PCI-PCI bridge (non-transparent mode, primary side)" } ,
	{ 0x10B5, 0x6542, "", "PCI6540/6466 PCI-PCI bridge (non-transparent mode, secondary side)" } ,
	{ 0x10B5, 0x8516, "", "PEX 8516  Versatile PCI Express Switch" } ,
	{ 0x10B5, 0x8532, "", "PEX 8532  Versatile PCI Express Switch" } ,
	{ 0x10B5, 0x9030, "", "PCI <-> IOBus Bridge Hot Swap" } ,
	{ 0x10B5, 0x9036, "", "9036" } ,
	{ 0x10B5, 0x9050, "", "PCI <-> IOBus Bridge" } ,
	{ 0x10B5, 0x9054, "", "PCI <-> IOBus Bridge" } ,
	{ 0x10B5, 0x9056, "", "Francois" } ,
	{ 0x10B5, 0x9060, "", "9060" } ,
	{ 0x10B5, 0x906D, "", "9060SD" } ,
	{ 0x10B5, 0x906E, "", "9060ES" } ,
	{ 0x10B5, 0x9080, "", "9080" } ,
	{ 0x10B5, 0xBB04, "", "B&B 3PCIOSD1A Isolated PCI Serial" } ,
	{ 0x10B6, 0x0001, "", "Smart 16/4 PCI Ringnode" } ,
	{ 0x10B6, 0x0002, "", "Smart 16/4 PCI Ringnode Mk2" } ,
	{ 0x10B6, 0x0003, "", "Smart 16/4 PCI Ringnode Mk3" } ,
	{ 0x10B6, 0x0004, "", "Smart 16/4 PCI Ringnode Mk1" } ,
	{ 0x10B6, 0x0006, "", "16/4 Cardbus Adapter" } ,
	{ 0x10B6, 0x0007, "", "Presto PCI Adapter" } ,
	{ 0x10B6, 0x0009, "", "Smart 100/16/4 PCI-HS Ringnode" } ,
	{ 0x10B6, 0x000A, "", "Smart 100/16/4 PCI Ringnode" } ,
	{ 0x10B6, 0x000B, "", "16/4 CardBus Adapter Mk2" } ,
	{ 0x10B6, 0x000C, "", "RapidFire 3140V2 16/4 TR Adapter" } ,
	{ 0x10B6, 0x1000, "", "Collage 25/155 ATM Client Adapter" } ,
	{ 0x10B6, 0x1001, "", "Collage 155 ATM Server Adapter" } ,
	{ 0x10B7, 0x0001, "", "3c985 1000BaseSX (SX/TX)" } ,
	{ 0x10B7, 0x0013, "", "AR5212 802.11abg NIC (3CRDAG675)" } ,
	{ 0x10B7, 0x0910, "", "3C910-A01" } ,
	{ 0x10B7, 0x1006, "", "MINI PCI type 3B Data Fax Modem" } ,
	{ 0x10B7, 0x1007, "", "Mini PCI 56k Winmodem" } ,
	{ 0x10B7, 0x1201, "", "3c982-TXM 10/100baseTX Dual Port A [Hydra]" } ,
	{ 0x10B7, 0x1202, "", "3c982-TXM 10/100baseTX Dual Port B [Hydra]" } ,
	{ 0x10B7, 0x1700, "", "3c940 10/100/1000Base-T [Marvell]" } ,
	{ 0x10B7, 0x3390, "", "3c339 TokenLink Velocity" } ,
	{ 0x10B7, 0x3590, "", "3c359 TokenLink Velocity XL" } ,
	{ 0x10B7, 0x4500, "", "3c450 HomePNA [Tornado]" } ,
	{ 0x10B7, 0x5055, "", "3c555 Laptop Hurricane" } ,
	{ 0x10B7, 0x5057, "", "3c575 Megahertz 10/100 LAN CardBus [Boomerang]" } ,
	{ 0x10B7, 0x5157, "", "3cCFE575BT Megahertz 10/100 LAN CardBus [Cyclone]" } ,
	{ 0x10B7, 0x5257, "", "3cCFE575CT CardBus [Cyclone]" } ,
	{ 0x10B7, 0x5900, "", "3c590 10BaseT [Vortex]" } ,
	{ 0x10B7, 0x5920, "", "3c592 EISA 10mbps Demon/Vortex" } ,
	{ 0x10B7, 0x5950, "", "3c595 100BaseTX [Vortex]" } ,
	{ 0x10B7, 0x5951, "", "3c595 100BaseT4 [Vortex]" } ,
	{ 0x10B7, 0x5952, "", "3c595 100Base-MII [Vortex]" } ,
	{ 0x10B7, 0x5970, "", "3c597 EISA Fast Demon/Vortex" } ,
	{ 0x10B7, 0x5B57, "", "3c595 Megahertz 10/100 LAN CardBus [Boomerang]" } ,
	{ 0x10B7, 0x6000, "", "3CRSHPW796 [OfficeConnect Wireless CardBus]" } ,
	{ 0x10B7, 0x6001, "", "3com 3CRWE154G72 [Office Connect Wireless LAN Adapter]" } ,
	{ 0x10B7, 0x6055, "", "3c556 Hurricane CardBus [Cyclone]" } ,
	{ 0x10B7, 0x6056, "", "3c556B CardBus [Tornado]" } ,
	{ 0x10B7, 0x6560, "", "3cCFE656 CardBus [Cyclone]" } ,
	{ 0x10B7, 0x6561, "", "3cCFEM656 10/100 LAN+56K Modem CardBus" } ,
	{ 0x10B7, 0x6562, "", "3cCFEM656B 10/100 LAN+Winmodem CardBus [Cyclone]" } ,
	{ 0x10B7, 0x6563, "", "3cCFEM656B 10/100 LAN+56K Modem CardBus" } ,
	{ 0x10B7, 0x6564, "", "3cXFEM656C 10/100 LAN+Winmodem CardBus [Tornado]" } ,
	{ 0x10B7, 0x7646, "", "3cSOHO100-TX Hurricane" } ,
	{ 0x10B7, 0x7770, "", "3CRWE777 PCI(PLX) Wireless Adaptor [Airconnect]" } ,
	{ 0x10B7, 0x7940, "", "3c803 FDDILink UTP Controller" } ,
	{ 0x10B7, 0x7980, "", "3c804 FDDILink SAS Controller" } ,
	{ 0x10B7, 0x7990, "", "3c805 FDDILink DAS Controller" } ,
	{ 0x10B7, 0x80EB, "", "3c940B 10/100/1000Base-T" } ,
	{ 0x10B7, 0x8811, "", "Token ring" } ,
	{ 0x10B7, 0x9000, "", "3c900 10BaseT [Boomerang]" } ,
	{ 0x10B7, 0x9001, "", "3c900 10Mbps Combo [Boomerang]" } ,
	{ 0x10B7, 0x9004, "", "3c900B-TPO Etherlink XL [Cyclone]" } ,
	{ 0x10B7, 0x9005, "", "3c900B-Combo Etherlink XL [Cyclone]" } ,
	{ 0x10B7, 0x9006, "", "3c900B-TPC Etherlink XL [Cyclone]" } ,
	{ 0x10B7, 0x900A, "", "3c900B-FL 10base-FL [Cyclone]" } ,
	{ 0x10B7, 0x9050, "", "3c905 100BaseTX [Boomerang]" } ,
	{ 0x10B7, 0x9051, "", "3c905 100BaseT4 [Boomerang]" } ,
	{ 0x10B7, 0x9055, "", "3c905B 100BaseTX [Cyclone]" } ,
	{ 0x10B7, 0x9056, "", "3c905B-T4 Fast EtherLink XL [Cyclone]" } ,
	{ 0x10B7, 0x9058, "", "3c905B Deluxe Etherlink 10/100/BNC [Cyclone]" } ,
	{ 0x10B7, 0x905A, "", "3c905B-FX Fast Etherlink XL FX 100baseFx [Cyclone]" } ,
	{ 0x10B7, 0x9200, "", "3c905C-TX/TX-M [Tornado]" } ,
	{ 0x10B7, 0x9201, "", "3C920B-EMB Integrated Fast Ethernet Controller [Tornado]" } ,
	{ 0x10B7, 0x9202, "", "3Com 3C920B-EMB-WNM Integrated Fast Ethernet Controller" } ,
	{ 0x10B7, 0x9210, "", "3C920B-EMB-WNM Integrated Fast Ethernet Controller" } ,
	{ 0x10B7, 0x9300, "", "3CSOHO100B-TX 910-A01 [tulip]" } ,
	{ 0x10B7, 0x9800, "", "3c980-TX Fast Etherlink XL Server Adapter [Cyclone]" } ,
	{ 0x10B7, 0x9805, "", "3c980-C 10/100baseTX NIC [Python-T]" } ,
	{ 0x10B7, 0x9900, "", "3C990-TX [Typhoon]" } ,
	{ 0x10B7, 0x9902, "", "3CR990-TX-95 [Typhoon 56-bit]" } ,
	{ 0x10B7, 0x9903, "", "3CR990-TX-97 [Typhoon 168-bit]" } ,
	{ 0x10B7, 0x9904, "", "3C990B-TX-M/3C990BSVR [Typhoon2]" } ,
	{ 0x10B7, 0x9905, "", "3CR990-FX-95/97/95 [Typhon Fiber]" } ,
	{ 0x10B7, 0x9908, "", "3CR990SVR95 [Typhoon Server 56-bit]" } ,
	{ 0x10B7, 0x9909, "", "3CR990SVR97 [Typhoon Server 168-bit]" } ,
	{ 0x10B7, 0x990A, "", "3C990SVR [Typhoon Server]" } ,
	{ 0x10B7, 0x990B, "", "3C990SVR [Typhoon Server]" } ,
	{ 0x10B8, 0x0005, "", "83c170 EPIC/100 Fast Ethernet Adapter" } ,
	{ 0x10B8, 0x0006, "", "83c175 EPIC/100 Fast Ethernet Adapter" } ,
	{ 0x10B8, 0x1000, "", "FDC 37c665" } ,
	{ 0x10B8, 0x1001, "", "FDC 37C922" } ,
	{ 0x10B8, 0x2802, "", "SMC2802W [EZ Connect g]" } ,
	{ 0x10B8, 0xA011, "", "83C170QF" } ,
	{ 0x10B8, 0xB106, "", "SMC34C90" } ,
	{ 0x10B9, 0x0101, "", "CMI8338/C3DX PCI Audio Device" } ,
	{ 0x10B9, 0x0111, "", "C-Media CMI8738/C3DX Audio Device (OEM)" } ,
	{ 0x10B9, 0x0780, "", "Multi-IO Card" } ,
	{ 0x10B9, 0x0782, "", "Multi-IO Card" } ,
	{ 0x10B9, 0x1435, "", "M1435" } ,
	{ 0x10B9, 0x1445, "", "M1445" } ,
	{ 0x10B9, 0x1449, "", "M1449" } ,
	{ 0x10B9, 0x1451, "", "M1451" } ,
	{ 0x10B9, 0x1461, "", "M1461" } ,
	{ 0x10B9, 0x1489, "", "M1489" } ,
	{ 0x10B9, 0x1511, "", "M1511 [Aladdin]" } ,
	{ 0x10B9, 0x1512, "", "M1512 [Aladdin]" } ,
	{ 0x10B9, 0x1513, "", "M1513 [Aladdin]" } ,
	{ 0x10B9, 0x1521, "", "M1521 [Aladdin III]" } ,
	{ 0x10B9, 0x1523, "", "M1523" } ,
	{ 0x10B9, 0x1531, "", "M1531 [Aladdin IV]" } ,
	{ 0x10B9, 0x1533, "", "M1533 PCI to ISA Bridge [Aladdin IV]" } ,
	{ 0x10B9, 0x1541, "", "M1541" } ,
	{ 0x10B9, 0x1543, "", "M1543" } ,
	{ 0x10B9, 0x1563, "", "M1563 HyperTransport South Bridge" } ,
	{ 0x10B9, 0x1573, "", "PCI to LPC Controller" } ,
	{ 0x10B9, 0x1621, "", "M1621" } ,
	{ 0x10B9, 0x1631, "", "ALI M1631 PCI North Bridge Aladdin Pro III" } ,
	{ 0x10B9, 0x1632, "", "M1632M Northbridge+Trident" } ,
	{ 0x10B9, 0x1641, "", "ALI M1641 PCI North Bridge Aladdin Pro IV" } ,
	{ 0x10B9, 0x1644, "", "M1644/M1644T Northbridge+Trident" } ,
	{ 0x10B9, 0x1646, "", "M1646 Northbridge+Trident" } ,
	{ 0x10B9, 0x1647, "", "M1647 Northbridge [MAGiK 1 / MobileMAGiK 1]" } ,
	{ 0x10B9, 0x1651, "", "M1651/M1651T Northbridge [Aladdin-Pro 5/5M,Aladdin-Pro 5T/5TM]" } ,
	{ 0x10B9, 0x1671, "", "M1671 Super P4 Northbridge [AGP4X,PCI and SDR/DDR]" } ,
	{ 0x10B9, 0x1672, "", "M1672 Northbridge [CyberALADDiN-P4]" } ,
	{ 0x10B9, 0x1681, "", "M1681 P4 Northbridge [AGP8X,HyperTransport and SDR/DDR]" } ,
	{ 0x10B9, 0x1687, "", "M1687 K8 Northbridge [AGP8X and HyperTransport]" } ,
	{ 0x10B9, 0x1689, "", "M1689 K8 Northbridge [Super K8 Single Chip]" } ,
	{ 0x10B9, 0x1695, "", "M1695 K8 Northbridge [PCI Express and HyperTransport]" } ,
	{ 0x10B9, 0x3141, "", "M3141" } ,
	{ 0x10B9, 0x3143, "", "M3143" } ,
	{ 0x10B9, 0x3145, "", "M3145" } ,
	{ 0x10B9, 0x3147, "", "M3147" } ,
	{ 0x10B9, 0x3149, "", "M3149" } ,
	{ 0x10B9, 0x3151, "", "M3151" } ,
	{ 0x10B9, 0x3307, "", "M3307" } ,
	{ 0x10B9, 0x3309, "", "M3309" } ,
	{ 0x10B9, 0x3323, "", "M3325 Video/Audio Decoder" } ,
	{ 0x10B9, 0x5212, "", "M4803" } ,
	{ 0x10B9, 0x5215, "", "MS4803" } ,
	{ 0x10B9, 0x5217, "", "M5217H" } ,
	{ 0x10B9, 0x5219, "", "M5219" } ,
	{ 0x10B9, 0x5225, "", "M5225" } ,
	{ 0x10B9, 0x5228, "", "M5228 ALi ATA/RAID Controller" } ,
	{ 0x10B9, 0x5229, "", "M5229 IDE" } ,
	{ 0x10B9, 0x5235, "", "M5225" } ,
	{ 0x10B9, 0x5237, "", "USB 1.1 Controller" } ,
	{ 0x10B9, 0x5239, "", "USB 2.0 Controller" } ,
	{ 0x10B9, 0x5243, "", "M1541 PCI to AGP Controller" } ,
	{ 0x10B9, 0x5246, "", "AGP8X Controller" } ,
	{ 0x10B9, 0x5247, "", "PCI to AGP Controller" } ,
	{ 0x10B9, 0x5249, "", "M5249 HTT to PCI Bridge" } ,
	{ 0x10B9, 0x5251, "", "M5251 P1394 OHCI 1.0 Controller" } ,
	{ 0x10B9, 0x5253, "", "M5253 P1394 OHCI 1.1 Controller" } ,
	{ 0x10B9, 0x5261, "", "M5261 Ethernet Controller" } ,
	{ 0x10B9, 0x5263, "", "M5263 Ethernet Controller" } ,
	{ 0x10B9, 0x5281, "", "ALi M5281 Serial ATA / RAID Host Controller" } ,
	{ 0x10B9, 0x5287, "", "ULi 5287 SATA" } ,
	{ 0x10B9, 0x5288, "", "ULi M5288 SATA" } ,
	{ 0x10B9, 0x5289, "", "ULi 5289 SATA" } ,
	{ 0x10B9, 0x5450, "", "Lucent Technologies Soft Modem AMR" } ,
	{ 0x10B9, 0x5451, "", "M5451 PCI AC-Link Controller Audio Device" } ,
	{ 0x10B9, 0x5453, "", "M5453 PCI AC-Link Controller Modem Device" } ,
	{ 0x10B9, 0x5455, "", "M5455 PCI AC-Link Controller Audio Device" } ,
	{ 0x10B9, 0x5457, "", "M5457 AC'97 Modem Controller" } ,
	{ 0x10B9, 0x5459, "", "SmartLink SmartPCI561 56K Modem" } ,
	{ 0x10B9, 0x545A, "", "SmartLink SmartPCI563 56K Modem" } ,
	{ 0x10B9, 0x5461, "", "High Definition Audio/AC'97 Host Controller" } ,
	{ 0x10B9, 0x5471, "", "M5471 Memory Stick Controller" } ,
	{ 0x10B9, 0x5473, "", "M5473 SD-MMC Controller" } ,
	{ 0x10B9, 0x7101, "", "M7101 Power Management Controller [PMU]" } ,
	{ 0x10BA, 0x0301, "", "AccelGraphics AccelECLIPSE" } ,
	{ 0x10BA, 0x0304, "", "AccelGALAXY A2100 [OEM Evans & Sutherland]" } ,
	{ 0x10BA, 0x0308, "", "Tornado 3000 [OEM Evans & Sutherland]" } ,
	{ 0x10BA, 0x1002, "", "VG500 [VolumePro Volume Rendering Accelerator]" } ,
	{ 0x10BD, 0x0E34, "", "NE-34" } ,
	{ 0x10C3, 0x1100, "", "Smartether100 SC1100 LAN Adapter (i82557B)" } ,
	{ 0x10C8, 0x0001, "", "NM2070 [MagicGraph 128]" } ,
	{ 0x10C8, 0x0002, "", "NM2090 [MagicGraph 128V]" } ,
	{ 0x10C8, 0x0003, "", "NM2093 [MagicGraph 128ZV]" } ,
	{ 0x10C8, 0x0004, "", "NM2160 [MagicGraph 128XD]" } ,
	{ 0x10C8, 0x0005, "", "NM2200 [MagicGraph 256AV]" } ,
	{ 0x10C8, 0x0006, "", "NM2360 [MagicMedia 256ZX]" } ,
	{ 0x10C8, 0x0016, "", "NM2380 [MagicMedia 256XL+]" } ,
	{ 0x10C8, 0x0025, "", "NM2230 [MagicGraph 256AV+]" } ,
	{ 0x10C8, 0x0083, "", "NM2093 [MagicGraph 128ZV+]" } ,
	{ 0x10C8, 0x8005, "", "NM2200 [MagicMedia 256AV Audio]" } ,
	{ 0x10C8, 0x8006, "", "NM2360 [MagicMedia 256ZX Audio]" } ,
	{ 0x10C8, 0x8016, "", "NM2380 [MagicMedia 256XL+ Audio]" } ,
	{ 0x10CC, 0x0660, "", "Articia S Host Bridge" } ,
	{ 0x10CC, 0x0661, "", "Articia S PCI Bridge" } ,
	{ 0x10CD, 0x1100, "", "ASC1100" } ,
	{ 0x10CD, 0x1200, "", "ASC1200 [(abp940) Fast SCSI-II]" } ,
	{ 0x10CD, 0x1300, "", "ABP940-U / ABP960-U" } ,
	{ 0x10CD, 0x2300, "", "ABP940-UW" } ,
	{ 0x10CD, 0x2500, "", "ABP940-U2W" } ,
	{ 0x10CF, 0x2001, "", "mb86605" } ,
	{ 0x10D9, 0x0431, "", "MX98715" } ,
	{ 0x10D9, 0x0512, "", "MX98713" } ,
	{ 0x10D9, 0x0531, "", "MX987x5" } ,
	{ 0x10D9, 0x8625, "", "MX86250" } ,
	{ 0x10D9, 0x8626, "", "Macronix MX86251 + 3Dfx Voodoo Rush" } ,
	{ 0x10D9, 0x8888, "", "MX86200" } ,
	{ 0x10DA, 0x0508, "", "TC4048 Token Ring 4/16" } ,
	{ 0x10DA, 0x3390, "", "Tl3c3x9" } ,
	{ 0x10DC, 0x0001, "", "STAR/RD24 SCI-PCI (PMC)" } ,
	{ 0x10DC, 0x0002, "", "TAR/RD24 SCI-PCI (PMC)" } ,
	{ 0x10DC, 0x0021, "", "HIPPI destination" } ,
	{ 0x10DC, 0x0022, "", "HIPPI source" } ,
	{ 0x10DC, 0x10DC, "", "ATT2C15-3 FPGA" } ,
	{ 0x10DE, 0x0008, "", "NV1 [EDGE 3D]" } ,
	{ 0x10DE, 0x0009, "", "NV1 [EDGE 3D]" } ,
	{ 0x10DE, 0x0010, "", "NV2 [Mutara V08]" } ,
	{ 0x10DE, 0x0020, "", "NV4 [RIVA TNT]" } ,
	{ 0x10DE, 0x0028, "", "NV5 [RIVA TNT2/TNT2 Pro]" } ,
	{ 0x10DE, 0x0029, "", "NV5 [RIVA TNT2 Ultra]" } ,
	{ 0x10DE, 0x002A, "", "NV5 [Riva TnT2]" } ,
	{ 0x10DE, 0x002B, "", "NV5 [Riva TnT2]" } ,
	{ 0x10DE, 0x002C, "", "NV6 [Vanta/Vanta LT]" } ,
	{ 0x10DE, 0x002D, "", "NV5M64 [RIVA TNT2 Model 64/Model 64 Pro]" } ,
	{ 0x10DE, 0x002E, "", "NV6 [Vanta]" } ,
	{ 0x10DE, 0x002F, "", "NV6 [Vanta]" } ,
	{ 0x10DE, 0x0034, "", "MCP04 SMBus" } ,
	{ 0x10DE, 0x0035, "", "MCP04 IDE" } ,
	{ 0x10DE, 0x0036, "", "MCP04 Serial ATA Controller" } ,
	{ 0x10DE, 0x0037, "", "MCP04 Ethernet Controller" } ,
	{ 0x10DE, 0x0038, "", "MCP04 Ethernet Controller" } ,
	{ 0x10DE, 0x003A, "", "MCP04 AC'97 Audio Controller" } ,
	{ 0x10DE, 0x003B, "", "MCP04 USB Controller" } ,
	{ 0x10DE, 0x003C, "", "MCP04 USB Controller" } ,
	{ 0x10DE, 0x003D, "", "MCP04 PCI Bridge" } ,
	{ 0x10DE, 0x003E, "", "MCP04 Serial ATA Controller" } ,
	{ 0x10DE, 0x0040, "", "nv40 [GeForce 6800 Ultra]" } ,
	{ 0x10DE, 0x0041, "", "NV40 [GeForce 6800]" } ,
	{ 0x10DE, 0x0042, "", "NV40.2 [GeForce 6800 LE]" } ,
	{ 0x10DE, 0x0043, "", "NV40.3" } ,
	{ 0x10DE, 0x0045, "", "NV40 [GeForce 6800 GT]" } ,
	{ 0x10DE, 0x0049, "", "NV40GL" } ,
	{ 0x10DE, 0x004E, "", "NV40GL [Quadro FX 4000]" } ,
	{ 0x10DE, 0x0050, "", "CK804 ISA Bridge" } ,
	{ 0x10DE, 0x0051, "", "CK804 ISA Bridge" } ,
	{ 0x10DE, 0x0052, "", "CK804 SMBus" } ,
	{ 0x10DE, 0x0053, "", "CK804 IDE" } ,
	{ 0x10DE, 0x0054, "", "CK804 Serial ATA Controller" } ,
	{ 0x10DE, 0x0055, "", "CK804 Serial ATA Controller" } ,
	{ 0x10DE, 0x0056, "", "CK804 Ethernet Controller" } ,
	{ 0x10DE, 0x0057, "", "CK804 Ethernet Controller" } ,
	{ 0x10DE, 0x0058, "", "CK804 AC'97 Modem" } ,
	{ 0x10DE, 0x0059, "", "CK804 AC'97 Audio Controller" } ,
	{ 0x10DE, 0x005A, "", "CK804 USB Controller" } ,
	{ 0x10DE, 0x005B, "", "CK804 USB Controller" } ,
	{ 0x10DE, 0x005C, "", "CK804 PCI Bridge" } ,
	{ 0x10DE, 0x005D, "", "CK804 PCIE Bridge" } ,
	{ 0x10DE, 0x005E, "", "CK804 Memory Controller" } ,
	{ 0x10DE, 0x005F, "", "CK804 Memory Controller" } ,
	{ 0x10DE, 0x0060, "", "nForce2 ISA Bridge" } ,
	{ 0x10DE, 0x0064, "", "nForce2 SMBus (MCP)" } ,
	{ 0x10DE, 0x0065, "", "nForce2 IDE" } ,
	{ 0x10DE, 0x0066, "", "nForce2 Ethernet Controller" } ,
	{ 0x10DE, 0x0067, "", "nForce2 USB Controller" } ,
	{ 0x10DE, 0x0068, "", "nForce2 USB Controller" } ,
	{ 0x10DE, 0x006A, "", "nForce2 AC97 Audio Controler (MCP)" } ,
	{ 0x10DE, 0x006B, "", "nForce Audio Processing Unit" } ,
	{ 0x10DE, 0x006C, "", "nForce2 External PCI Bridge" } ,
	{ 0x10DE, 0x006D, "", "nForce2 PCI Bridge" } ,
	{ 0x10DE, 0x006E, "", "nForce2 FireWire (IEEE 1394) Controller" } ,
	{ 0x10DE, 0x0080, "", "MCP2A ISA bridge" } ,
	{ 0x10DE, 0x0084, "", "MCP2A SMBus" } ,
	{ 0x10DE, 0x0085, "", "MCP2A IDE" } ,
	{ 0x10DE, 0x0086, "", "MCP2A Ethernet Controller" } ,
	{ 0x10DE, 0x0087, "", "MCP2A USB Controller" } ,
	{ 0x10DE, 0x0088, "", "MCP2A USB Controller" } ,
	{ 0x10DE, 0x008A, "", "MCP2S AC'97 Audio Controller" } ,
	{ 0x10DE, 0x008B, "", "MCP2A PCI Bridge" } ,
	{ 0x10DE, 0x008C, "", "MCP2A Ethernet Controller" } ,
	{ 0x10DE, 0x008E, "", "nForce2 Serial ATA Controller" } ,
	{ 0x10DE, 0x0091, "", "GeForce 7800 GTX" } ,
	{ 0x10DE, 0x00A0, "", "NV5 [Aladdin TNT2]" } ,
	{ 0x10DE, 0x00C0, "", "NV41.0" } ,
	{ 0x10DE, 0x00C1, "", "NV41.1 [GeForce 6800]" } ,
	{ 0x10DE, 0x00C2, "", "NV41.2 [GeForce 6800 LE]" } ,
	{ 0x10DE, 0x00C8, "", "NV41.8 [GeForce Go 6800]" } ,
	{ 0x10DE, 0x00C9, "", "NV41.9 [GeForce Go 6800 Ultra]" } ,
	{ 0x10DE, 0x00CC, "", "NV41 [Quadro FX Go1400]" } ,
	{ 0x10DE, 0x00CD, "", "NV41 [Quadro FX 3450/4000 SDI]" } ,
	{ 0x10DE, 0x00CE, "", "NV41GL [Quadro FX 1400]" } ,
	{ 0x10DE, 0x00D0, "", "nForce3 LPC Bridge" } ,
	{ 0x10DE, 0x00D1, "", "nForce3 Host Bridge" } ,
	{ 0x10DE, 0x00D2, "", "nForce3 AGP Bridge" } ,
	{ 0x10DE, 0x00D3, "", "CK804 Memory Controller" } ,
	{ 0x10DE, 0x00D4, "", "nForce3 SMBus" } ,
	{ 0x10DE, 0x00D5, "", "nForce3 IDE" } ,
	{ 0x10DE, 0x00D6, "", "nForce3 Ethernet" } ,
	{ 0x10DE, 0x00D7, "", "nForce3 USB 1.1" } ,
	{ 0x10DE, 0x00D8, "", "nForce3 USB 2.0" } ,
	{ 0x10DE, 0x00DA, "", "nForce3 Audio" } ,
	{ 0x10DE, 0x00DD, "", "nForce3 PCI Bridge" } ,
	{ 0x10DE, 0x00DF, "", "CK8S Ethernet Controller" } ,
	{ 0x10DE, 0x00E0, "", "nForce3 250Gb LPC Bridge" } ,
	{ 0x10DE, 0x00E1, "", "nForce3 250Gb Host Bridge" } ,
	{ 0x10DE, 0x00E2, "", "nForce3 250Gb AGP Host to PCI Bridge" } ,
	{ 0x10DE, 0x00E3, "", "CK8S Serial ATA Controller (v2.5)" } ,
	{ 0x10DE, 0x00E4, "", "nForce 250Gb PCI System Management" } ,
	{ 0x10DE, 0x00E5, "", "CK8S Parallel ATA Controller (v2.5)" } ,
	{ 0x10DE, 0x00E6, "", "CK8S Ethernet Controller" } ,
	{ 0x10DE, 0x00E7, "", "CK8S USB Controller" } ,
	{ 0x10DE, 0x00E8, "", "nForce3 EHCI USB 2.0 Controller" } ,
	{ 0x10DE, 0x00EA, "", "nForce3 250Gb AC'97 Audio Controller" } ,
	{ 0x10DE, 0x00ED, "", "nForce3 250Gb PCI-to-PCI Bridge" } ,
	{ 0x10DE, 0x00EE, "", "CK8S Serial ATA Controller (v2.5)" } ,
	{ 0x10DE, 0x00F0, "", "NV40 [GeForce 6800/GeForce 6800 Ultra]" } ,
	{ 0x10DE, 0x00F1, "", "NV43 [GeForce 6600/GeForce 6600 GT]" } ,
	{ 0x10DE, 0x00F2, "", "NV43 [GeForce 6600/GeForce 6600 GT]" } ,
	{ 0x10DE, 0x00F3, "", "NV43 [GeForce 6200]" } ,
	{ 0x10DE, 0x00F8, "", "NV45GL [Quadro FX 3400/4400]" } ,
	{ 0x10DE, 0x00F9, "", "NV40 [GeForce 6800 Ultra/GeForce 6800 GT]" } ,
	{ 0x10DE, 0x00FA, "", "NV36 [GeForce PCX 5750]" } ,
	{ 0x10DE, 0x00FB, "", "NV35 [GeForce PCX 5900]" } ,
	{ 0x10DE, 0x00FC, "", "NV37GL [Quadro FX 330/GeForce PCX 5300]" } ,
	{ 0x10DE, 0x00FD, "", "NV37GL [Quadro FX 330]" } ,
	{ 0x10DE, 0x00FE, "", "NV38GL [Quadro FX 1300]" } ,
	{ 0x10DE, 0x00FF, "", "NV18 [GeForce PCX 4300]" } ,
	{ 0x10DE, 0x0100, "", "NV10 [GeForce 256 SDR]" } ,
	{ 0x10DE, 0x0101, "", "NV10DDR [GeForce 256 DDR]" } ,
	{ 0x10DE, 0x0103, "", "NV10GL [Quadro]" } ,
	{ 0x10DE, 0x0110, "", "NV11 [GeForce2 MX/MX 400]" } ,
	{ 0x10DE, 0x0111, "", "NV11DDR [GeForce2 MX 100 DDR/200 DDR]" } ,
	{ 0x10DE, 0x0112, "", "NV11 [GeForce2 Go]" } ,
	{ 0x10DE, 0x0113, "", "NV11GL [Quadro2 MXR/EX/Go]" } ,
	{ 0x10DE, 0x0140, "", "NV43 [GeForce 6600 GT]" } ,
	{ 0x10DE, 0x0141, "", "NV43 [GeForce 6600]" } ,
	{ 0x10DE, 0x0144, "", "NV43 [GeForce Go 6600]" } ,
	{ 0x10DE, 0x0145, "", "NV43 [GeForce 6610 XL]" } ,
	{ 0x10DE, 0x0146, "", "NV43 [Geforce Go 6600TE/6200TE]" } ,
	{ 0x10DE, 0x0148, "", "NV43 [GeForce Go 6600]" } ,
	{ 0x10DE, 0x014E, "", "NV43GL [Quadro FX 540]" } ,
	{ 0x10DE, 0x014F, "", "NV43 [GeForce 6200]" } ,
	{ 0x10DE, 0x0150, "", "NV15 [GeForce2 GTS/Pro]" } ,
	{ 0x10DE, 0x0151, "", "NV15DDR [GeForce2 Ti]" } ,
	{ 0x10DE, 0x0152, "", "NV15BR [GeForce2 Ultra, Bladerunner]" } ,
	{ 0x10DE, 0x0153, "", "NV15GL [Quadro2 Pro]" } ,
	{ 0x10DE, 0x0161, "", "GeForce 6200 TurboCache(TM)" } ,
	{ 0x10DE, 0x0164, "", "NV44 [GeForce Go 6200]" } ,
	{ 0x10DE, 0x0165, "", "NV44 [Quadro NVS 285]" } ,
	{ 0x10DE, 0x0167, "", "GeForce Go 6200 TurboCache" } ,
	{ 0x10DE, 0x0170, "", "NV17 [GeForce4 MX 460]" } ,
	{ 0x10DE, 0x0171, "", "NV17 [GeForce4 MX 440]" } ,
	{ 0x10DE, 0x0172, "", "NV17 [GeForce4 MX 420]" } ,
	{ 0x10DE, 0x0173, "", "NV17 [GeForce4 MX 440-SE]" } ,
	{ 0x10DE, 0x0174, "", "NV17 [GeForce4 440 Go]" } ,
	{ 0x10DE, 0x0175, "", "NV17 [GeForce4 420 Go]" } ,
	{ 0x10DE, 0x0176, "", "NV17 [GeForce4 420 Go 32M]" } ,
	{ 0x10DE, 0x0177, "", "NV17 [GeForce4 460 Go]" } ,
	{ 0x10DE, 0x0178, "", "NV17GL [Quadro4 550 XGL]" } ,
	{ 0x10DE, 0x0179, "", "NV17 [GeForce4 420 Go 32M]" } ,
	{ 0x10DE, 0x017A, "", "NV17GL [Quadro4 200/400 NVS]" } ,
	{ 0x10DE, 0x017B, "", "NV17GL [Quadro4 550 XGL]" } ,
	{ 0x10DE, 0x017C, "", "NV17GL [Quadro4 500 GoGL]" } ,
	{ 0x10DE, 0x017D, "", "NV17 [GeForce4 410 Go 16M]" } ,
	{ 0x10DE, 0x0181, "", "NV18 [GeForce4 MX 440 AGP 8x]" } ,
	{ 0x10DE, 0x0182, "", "NV18 [GeForce4 MX 440SE AGP 8x]" } ,
	{ 0x10DE, 0x0183, "", "NV18 [GeForce4 MX 420 AGP 8x]" } ,
	{ 0x10DE, 0x0185, "", "NV18 [GeForce4 MX 4000 AGP 8x]" } ,
	{ 0x10DE, 0x0186, "", "NV18M [GeForce4 448 Go]" } ,
	{ 0x10DE, 0x0187, "", "NV18M [GeForce4 488 Go]" } ,
	{ 0x10DE, 0x0188, "", "NV18GL [Quadro4 580 XGL]" } ,
	{ 0x10DE, 0x018A, "", "NV18GL [Quadro4 NVS AGP 8x]" } ,
	{ 0x10DE, 0x018B, "", "NV18GL [Quadro4 380 XGL]" } ,
	{ 0x10DE, 0x018D, "", "NV18M [GeForce4 448 Go]" } ,
	{ 0x10DE, 0x01A0, "", "NVCrush11 [GeForce2 MX Integrated Graphics]" } ,
	{ 0x10DE, 0x01A4, "", "nForce CPU bridge" } ,
	{ 0x10DE, 0x01AB, "", "nForce 420 Memory Controller (DDR)" } ,
	{ 0x10DE, 0x01AC, "", "nForce 220/420 Memory Controller" } ,
	{ 0x10DE, 0x01AD, "", "nForce 220/420 Memory Controller" } ,
	{ 0x10DE, 0x01B0, "", "nForce Audio" } ,
	{ 0x10DE, 0x01B1, "", "nForce Audio" } ,
	{ 0x10DE, 0x01B2, "", "nForce ISA Bridge" } ,
	{ 0x10DE, 0x01B4, "", "nForce PCI System Management" } ,
	{ 0x10DE, 0x01B7, "", "nForce AGP to PCI Bridge" } ,
	{ 0x10DE, 0x01B8, "", "nForce PCI-to-PCI bridge" } ,
	{ 0x10DE, 0x01BC, "", "nForce IDE" } ,
	{ 0x10DE, 0x01C1, "", "nForce AC'97 Modem Controller" } ,
	{ 0x10DE, 0x01C2, "", "nForce USB Controller" } ,
	{ 0x10DE, 0x01C3, "", "nForce Ethernet Controller" } ,
	{ 0x10DE, 0x01E0, "", "nForce2 AGP (different version?)" } ,
	{ 0x10DE, 0x01E8, "", "nForce2 AGP" } ,
	{ 0x10DE, 0x01EA, "", "nForce2 Memory Controller 0" } ,
	{ 0x10DE, 0x01EB, "", "nForce2 Memory Controller 1" } ,
	{ 0x10DE, 0x01EC, "", "nForce2 Memory Controller 2" } ,
	{ 0x10DE, 0x01ED, "", "nForce2 Memory Controller 3" } ,
	{ 0x10DE, 0x01EE, "", "nForce2 Memory Controller 4" } ,
	{ 0x10DE, 0x01EF, "", "nForce2 Memory Controller 5" } ,
	{ 0x10DE, 0x01F0, "", "NV18 [GeForce4 MX - nForce GPU]" } ,
	{ 0x10DE, 0x0200, "", "NV20 [GeForce3]" } ,
	{ 0x10DE, 0x0201, "", "NV20 [GeForce3 Ti 200]" } ,
	{ 0x10DE, 0x0202, "", "NV20 [GeForce3 Ti 500]" } ,
	{ 0x10DE, 0x0203, "", "NV20DCC [Quadro DCC]" } ,
	{ 0x10DE, 0x0221, "", "GeForce 6200" } ,
	{ 0x10DE, 0x0240, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x0241, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x0242, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x0243, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x0244, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x0245, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x0246, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x0247, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x0248, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x0249, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x024A, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x024B, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x024C, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x024D, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x024E, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x024F, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x0250, "", "NV25 [GeForce4 Ti 4600]" } ,
	{ 0x10DE, 0x0251, "", "NV25 [GeForce4 Ti 4400]" } ,
	{ 0x10DE, 0x0252, "", "NV25 [GeForce4 Ti]" } ,
	{ 0x10DE, 0x0253, "", "NV25 [GeForce4 Ti 4200]" } ,
	{ 0x10DE, 0x0258, "", "NV25GL [Quadro4 900 XGL]" } ,
	{ 0x10DE, 0x0259, "", "NV25GL [Quadro4 750 XGL]" } ,
	{ 0x10DE, 0x025B, "", "NV25GL [Quadro4 700 XGL]" } ,
	{ 0x10DE, 0x0260, "", "MCP51 LPC Bridge" } ,
	{ 0x10DE, 0x0261, "", "MCP51 LPC Bridge" } ,
	{ 0x10DE, 0x0262, "", "MCP51 LPC Bridge" } ,
	{ 0x10DE, 0x0263, "", "MCP51 LPC Bridge" } ,
	{ 0x10DE, 0x0264, "", "MCP51 SMBus" } ,
	{ 0x10DE, 0x0265, "", "MCP51 IDE" } ,
	{ 0x10DE, 0x0266, "", "MCP51 Serial ATA Controller" } ,
	{ 0x10DE, 0x0267, "", "MCP51 Serial ATA Controller" } ,
	{ 0x10DE, 0x0268, "", "MCP51 Ethernet Controller" } ,
	{ 0x10DE, 0x0269, "", "MCP51 Ethernet Controller" } ,
	{ 0x10DE, 0x026A, "", "MCP51 MCI" } ,
	{ 0x10DE, 0x026B, "", "MCP51 AC97 Audio Controller" } ,
	{ 0x10DE, 0x026C, "", "MCP51 High Definition Audio" } ,
	{ 0x10DE, 0x026D, "", "MCP51 USB Controller" } ,
	{ 0x10DE, 0x026E, "", "MCP51 USB Controller" } ,
	{ 0x10DE, 0x026F, "", "MCP51 PCI Bridge" } ,
	{ 0x10DE, 0x0270, "", "MCP51 Host Bridge" } ,
	{ 0x10DE, 0x0271, "", "MCP51 PMU" } ,
	{ 0x10DE, 0x0272, "", "MCP51 Memory Controller 0" } ,
	{ 0x10DE, 0x027E, "", "C51 Memory Controller 2" } ,
	{ 0x10DE, 0x027F, "", "C51 Memory Controller 3" } ,
	{ 0x10DE, 0x0280, "", "NV28 [GeForce4 Ti 4800]" } ,
	{ 0x10DE, 0x0281, "", "NV28 [GeForce4 Ti 4200 AGP 8x]" } ,
	{ 0x10DE, 0x0282, "", "NV28 [GeForce4 Ti 4800 SE]" } ,
	{ 0x10DE, 0x0286, "", "NV28 [GeForce4 Ti 4200 Go AGP 8x]" } ,
	{ 0x10DE, 0x0288, "", "NV28GL [Quadro4 980 XGL]" } ,
	{ 0x10DE, 0x0289, "", "NV28GL [Quadro4 780 XGL]" } ,
	{ 0x10DE, 0x028C, "", "NV28GLM [Quadro4 700 GoGL]" } ,
	{ 0x10DE, 0x02A0, "", "NV2A [XGPU]" } ,
	{ 0x10DE, 0x02F0, "", "C51 Host Bridge" } ,
	{ 0x10DE, 0x02F1, "", "C51 Host Bridge" } ,
	{ 0x10DE, 0x02F2, "", "C51 Host Bridge" } ,
	{ 0x10DE, 0x02F3, "", "C51 Host Bridge" } ,
	{ 0x10DE, 0x02F4, "", "C51 Host Bridge" } ,
	{ 0x10DE, 0x02F5, "", "C51 Host Bridge" } ,
	{ 0x10DE, 0x02F6, "", "C51 Host Bridge" } ,
	{ 0x10DE, 0x02F7, "", "C51 Host Bridge" } ,
	{ 0x10DE, 0x02F8, "", "C51 Memory Controller 5" } ,
	{ 0x10DE, 0x02F9, "", "C51 Memory Controller 4" } ,
	{ 0x10DE, 0x02FA, "", "C51 Memory Controller 0" } ,
	{ 0x10DE, 0x02FB, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x02FC, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x02FD, "", "C51 PCI Express Bridge" } ,
	{ 0x10DE, 0x02FE, "", "C51 Memory Controller 1" } ,
	{ 0x10DE, 0x02FF, "", "C51 Host Bridge" } ,
	{ 0x10DE, 0x0300, "", "NV30 [GeForce FX]" } ,
	{ 0x10DE, 0x0301, "", "NV30 [GeForce FX 5800 Ultra]" } ,
	{ 0x10DE, 0x0302, "", "NV30 [GeForce FX 5800]" } ,
	{ 0x10DE, 0x0308, "", "NV30GL [Quadro FX 2000]" } ,
	{ 0x10DE, 0x0309, "", "NV30GL [Quadro FX 1000]" } ,
	{ 0x10DE, 0x0311, "", "NV31 [GeForce FX 5600 Ultra]" } ,
	{ 0x10DE, 0x0312, "", "NV31 [GeForce FX 5600]" } ,
	{ 0x10DE, 0x0313, "", "NV31" } ,
	{ 0x10DE, 0x0314, "", "NV31 [GeForce FX 5600XT]" } ,
	{ 0x10DE, 0x0316, "", "NV31M" } ,
	{ 0x10DE, 0x0317, "", "NV31M Pro" } ,
	{ 0x10DE, 0x031A, "", "NV31M [GeForce FX Go5600]" } ,
	{ 0x10DE, 0x031B, "", "NV31M [GeForce FX Go5650]" } ,
	{ 0x10DE, 0x031C, "", "NVIDIA Quadro FX Go700" } ,
	{ 0x10DE, 0x031D, "", "NV31GLM" } ,
	{ 0x10DE, 0x031E, "", "NV31GLM Pro" } ,
	{ 0x10DE, 0x031F, "", "NV31GLM Pro" } ,
	{ 0x10DE, 0x0320, "", "NV34 [GeForce FX 5200]" } ,
	{ 0x10DE, 0x0321, "", "NV34 [GeForce FX 5200 Ultra]" } ,
	{ 0x10DE, 0x0322, "", "NV34 [GeForce FX 5200]" } ,
	{ 0x10DE, 0x0323, "", "NV34 [GeForce FX 5200LE]" } ,
	{ 0x10DE, 0x0324, "", "NV34M [GeForce FX Go5200]" } ,
	{ 0x10DE, 0x0325, "", "NV34M [GeForce FX Go5250]" } ,
	{ 0x10DE, 0x0326, "", "NV34 [GeForce FX 5500]" } ,
	{ 0x10DE, 0x0327, "", "NV34 [GeForce FX 5100]" } ,
	{ 0x10DE, 0x0328, "", "NV34M [GeForce FX Go5200 32M/64M]" } ,
	{ 0x10DE, 0x0329, "", "NV34M [GeForce FX Go5200]" } ,
	{ 0x10DE, 0x032A, "", "NV34GL [Quadro NVS 280 PCI]" } ,
	{ 0x10DE, 0x032B, "", "NV34GL [Quadro FX 500/600 PCI]" } ,
	{ 0x10DE, 0x032C, "", "NV34GLM [GeForce FX Go 5300]" } ,
	{ 0x10DE, 0x032D, "", "NV34 [GeForce FX Go5100]" } ,
	{ 0x10DE, 0x032F, "", "NV34GL" } ,
	{ 0x10DE, 0x0330, "", "NV35 [GeForce FX 5900 Ultra]" } ,
	{ 0x10DE, 0x0331, "", "NV35 [GeForce FX 5900]" } ,
	{ 0x10DE, 0x0332, "", "NV35 [GeForce FX 5900XT]" } ,
	{ 0x10DE, 0x0333, "", "NV38 [GeForce FX 5950 Ultra]" } ,
	{ 0x10DE, 0x0334, "", "NV35 [GeForce FX 5900ZT]" } ,
	{ 0x10DE, 0x0338, "", "NV35GL [Quadro FX 3000]" } ,
	{ 0x10DE, 0x033F, "", "NV35GL [Quadro FX 700]" } ,
	{ 0x10DE, 0x0341, "", "NV36.1 [GeForce FX 5700 Ultra]" } ,
	{ 0x10DE, 0x0342, "", "NV36.2 [GeForce FX 5700]" } ,
	{ 0x10DE, 0x0343, "", "NV36 [GeForce FX 5700LE]" } ,
	{ 0x10DE, 0x0344, "", "NV36.4 [GeForce FX 5700VE]" } ,
	{ 0x10DE, 0x0345, "", "NV36.5" } ,
	{ 0x10DE, 0x0347, "", "NV36 [GeForce FX Go5700]" } ,
	{ 0x10DE, 0x0348, "", "NV36 [GeForce FX Go5700]" } ,
	{ 0x10DE, 0x0349, "", "NV36M Pro" } ,
	{ 0x10DE, 0x034B, "", "NV36MAP" } ,
	{ 0x10DE, 0x034C, "", "NV36 [Quadro FX Go1000]" } ,
	{ 0x10DE, 0x034E, "", "NV36GL [Quadro FX 1100]" } ,
	{ 0x10DE, 0x034F, "", "NV36GL" } ,
	{ 0x10DE, 0x0360, "", "MCP55 LPC Bridge" } ,
	{ 0x10DE, 0x0361, "", "MCP55 LPC Bridge" } ,
	{ 0x10DE, 0x0362, "", "MCP55 LPC Bridge" } ,
	{ 0x10DE, 0x0363, "", "MCP55 LPC Bridge" } ,
	{ 0x10DE, 0x0364, "", "MCP55 LPC Bridge" } ,
	{ 0x10DE, 0x0365, "", "MCP55 LPC Bridge" } ,
	{ 0x10DE, 0x0366, "", "MCP55 LPC Bridge" } ,
	{ 0x10DE, 0x0367, "", "MCP55 LPC Bridge" } ,
	{ 0x10DE, 0x0368, "", "MCP55 SMBus" } ,
	{ 0x10DE, 0x0369, "", "MCP55 Memory Controller" } ,
	{ 0x10DE, 0x036A, "", "MCP55 Memory Controller" } ,
	{ 0x10DE, 0x036C, "", "MCP55 USB Controller" } ,
	{ 0x10DE, 0x036D, "", "MCP55 USB Controller" } ,
	{ 0x10DE, 0x036E, "", "MCP55 IDE" } ,
	{ 0x10DE, 0x0371, "", "MCP55 High Definition Audio" } ,
	{ 0x10DE, 0x0372, "", "MCP55 Ethernet" } ,
	{ 0x10DE, 0x0373, "", "MCP55 Ethernet" } ,
	{ 0x10DE, 0x037A, "", "MCP55 Memory Controller" } ,
	{ 0x10DE, 0x037E, "", "MCP55 SATA Controller" } ,
	{ 0x10DE, 0x037F, "", "MCP55 SATA Controller" } ,
	{ 0x10DF, 0x1AE5, "", "LP6000 Fibre Channel Host Adapter" } ,
	{ 0x10DF, 0x1AE6, "", "LP 8000 Fibre Channel Host Adapter Alternate ID (JX1:2-3, JX2:1-2)" } ,
	{ 0x10DF, 0x1AE7, "", "LP 8000 Fibre Channel Host Adapter Alternate ID (JX1:2-3, JX2:2-3)" } ,
	{ 0x10DF, 0xF005, "", "LP1150e Fibre Channel Host Adapter" } ,
	{ 0x10DF, 0xF085, "", "LP850 Fibre Channel Host Adapter" } ,
	{ 0x10DF, 0xF095, "", "LP952 Fibre Channel Host Adapter" } ,
	{ 0x10DF, 0xF098, "", "LP982 Fibre Channel Host Adapter" } ,
	{ 0x10DF, 0xF0A5, "", "LP1050 Fibre Channel Host Adapter" } ,
	{ 0x10DF, 0xF0D5, "", "LP1150 Fibre Channel Host Adapter" } ,
	{ 0x10DF, 0xF100, "", "LP11000e Fibre Channel Host Adapter" } ,
	{ 0x10DF, 0xF700, "", "LP7000 Fibre Channel Host Adapter" } ,
	{ 0x10DF, 0xF701, "", "LP7000 Fibre Channel Host Adapter Alternate ID (JX1:2-3, JX2:1-2)" } ,
	{ 0x10DF, 0xF800, "", "LP8000 Fibre Channel Host Adapter" } ,
	{ 0x10DF, 0xF801, "", "LP8000 Fibre Channel Host Adapter Alternate ID (JX1:2-3, JX2:1-2)" } ,
	{ 0x10DF, 0xF900, "", "LP9000 Fibre Channel Host Adapter" } ,
	{ 0x10DF, 0xF901, "", "LP9000 Fibre Channel Host Adapter Alternate ID (JX1:2-3, JX2:1-2)" } ,
	{ 0x10DF, 0xF980, "", "LP9802 Fibre Channel Host Adapter" } ,
	{ 0x10DF, 0xF981, "", "LP9802 Fibre Channel Host Adapter Alternate ID" } ,
	{ 0x10DF, 0xF982, "", "LP9802 Fibre Channel Host Adapter Alternate ID" } ,
	{ 0x10DF, 0xFA00, "", "LP10000 Fibre Channel Host Adapter" } ,
	{ 0x10DF, 0xFA01, "", "LP101 Fibre Channel Host Adapter" } ,
	{ 0x10DF, 0xFD00, "", "LP11000 Fibre Channel Host Adapter" } ,
	{ 0x10E0, 0x5026, "", "IMS5026/27/28" } ,
	{ 0x10E0, 0x5027, "", "IMS5027" } ,
	{ 0x10E0, 0x5028, "", "IMS5028" } ,
	{ 0x10E0, 0x8849, "", "IMS8849" } ,
	{ 0x10E0, 0x8853, "", "IMS8853" } ,
	{ 0x10E0, 0x9128, "", "IMS9128 [Twin turbo 128]" } ,
	{ 0x10E1, 0x0391, "", "TRM-S1040" } ,
	{ 0x10E1, 0x690C, "", "DC-690c" } ,
	{ 0x10E1, 0xDC29, "", "DC-290" } ,
	{ 0x10E3, 0x0000, "", "CA91C042 [Universe]" } ,
	{ 0x10E3, 0x0860, "", "CA91C860 [QSpan]" } ,
	{ 0x10E3, 0x0862, "", "CA91C862A [QSpan-II]" } ,
	{ 0x10E3, 0x8260, "", "CA91L8200B [Dual PCI PowerSpan II]" } ,
	{ 0x10E3, 0x8261, "", "CA91L8260B [Single PCI PowerSpan II]" } ,
	{ 0x10E8, 0x1072, "", "INES GPIB-PCI (AMCC5920 based)" } ,
	{ 0x10E8, 0x2011, "", "Q-Motion Video Capture/Edit board" } ,
	{ 0x10E8, 0x4750, "", "S5930 [Matchmaker]" } ,
	{ 0x10E8, 0x5920, "", "S5920" } ,
	{ 0x10E8, 0x8043, "", "LANai4.x [Myrinet LANai interface chip]" } ,
	{ 0x10E8, 0x8062, "", "S5933_PARASTATION" } ,
	{ 0x10E8, 0x807D, "", "S5933 [Matchmaker]" } ,
	{ 0x10E8, 0x8088, "", "Kongsberg Spacetec Format Synchronizer" } ,
	{ 0x10E8, 0x8089, "", "Kongsberg Spacetec Serial Output Board" } ,
	{ 0x10E8, 0x809C, "", "S5933_HEPC3" } ,
	{ 0x10E8, 0x80D7, "", "PCI-9112" } ,
	{ 0x10E8, 0x80D9, "", "PCI-9118" } ,
	{ 0x10E8, 0x80DA, "", "PCI-9812" } ,
	{ 0x10E8, 0x811A, "", "PCI-IEEE1355-DS-DE Interface" } ,
	{ 0x10E8, 0x814C, "", "Fastcom ESCC-PCI (Commtech, Inc.)" } ,
	{ 0x10E8, 0x8170, "", "S5933 [Matchmaker] (Chipset Development Tool)" } ,
	{ 0x10E8, 0x81E6, "", "Multimedia video controller" } ,
	{ 0x10E8, 0x8291, "", "Fastcom 232/8-PCI (Commtech, Inc.)" } ,
	{ 0x10E8, 0x82C4, "", "Fastcom 422/4-PCI (Commtech, Inc.)" } ,
	{ 0x10E8, 0x82C5, "", "Fastcom 422/2-PCI (Commtech, Inc.)" } ,
	{ 0x10E8, 0x82C6, "", "Fastcom IG422/1-PCI (Commtech, Inc.)" } ,
	{ 0x10E8, 0x82C7, "", "Fastcom IG232/2-PCI (Commtech, Inc.)" } ,
	{ 0x10E8, 0x82CA, "", "Fastcom 232/4-PCI (Commtech, Inc.)" } ,
	{ 0x10E8, 0x82DB, "", "AJA HDNTV HD SDI Framestore" } ,
	{ 0x10E8, 0x82E2, "", "Fastcom DIO24H-PCI (Commtech, Inc.)" } ,
	{ 0x10E8, 0x8851, "", "S5933 on Innes Corp FM Radio Capture card" } ,
	{ 0x10EA, 0x1680, "", "IGA-1680" } ,
	{ 0x10EA, 0x1682, "", "IGA-1682" } ,
	{ 0x10EA, 0x1683, "", "IGA-1683" } ,
	{ 0x10EA, 0x2000, "", "CyberPro 2000" } ,
	{ 0x10EA, 0x2010, "", "CyberPro 2000A" } ,
	{ 0x10EA, 0x5000, "", "CyberPro 5000" } ,
	{ 0x10EA, 0x5050, "", "CyberPro 5050" } ,
	{ 0x10EA, 0x5202, "", "CyberPro 5202" } ,
	{ 0x10EA, 0x5252, "", "CyberPro5252" } ,
	{ 0x10EB, 0x0101, "", "3GA" } ,
	{ 0x10EB, 0x8111, "", "Twist3 Frame Grabber" } ,
	{ 0x10EC, 0x8029, "", "RTL-8029(AS)" } ,
	{ 0x10EC, 0x8129, "", "RTL-8129" } ,
	{ 0x10EC, 0x8138, "", "RT8139 (B/C) Cardbus Fast Ethernet Adapter" } ,
	{ 0x10EC, 0x8139, "", "RTL-8139/8139C/8139C+" } ,
	{ 0x10EC, 0x8169, "", "RTL-8169 Gigabit Ethernet" } ,
	{ 0x10EC, 0x8180, "", "RTL8180L 802.11b MAC" } ,
	{ 0x10EC, 0x8197, "", "SmartLAN56 56K Modem" } ,
	{ 0x10ED, 0x7310, "", "V7310" } ,
	{ 0x10EE, 0x0314, "", "Wildcard TE405P/TE410P (1st Gen)" } ,
	{ 0x10EE, 0x3FC0, "", "RME Digi96" } ,
	{ 0x10EE, 0x3FC1, "", "RME Digi96/8" } ,
	{ 0x10EE, 0x3FC2, "", "RME Digi96/8 Pro" } ,
	{ 0x10EE, 0x3FC3, "", "RME Digi96/8 Pad" } ,
	{ 0x10EE, 0x3FC4, "", "RME Digi9652 (Hammerfall)" } ,
	{ 0x10EE, 0x3FC5, "", "RME Hammerfall DSP" } ,
	{ 0x10EE, 0x3FC6, "", "RME Hammerfall DSP MADI" } ,
	{ 0x10EE, 0x8381, "", "Ellips Santos Frame Grabber" } ,
	{ 0x10EF, 0x8154, "", "M815x Token Ring Adapter" } ,
	{ 0x10F5, 0xA001, "", "NDR4000 [NR4600 Bridge]" } ,
	{ 0x10FA, 0x000C, "", "TARGA 1000" } ,
	{ 0x10FB, 0x186F, "", "TH 6255" } ,
	{ 0x10FC, 0x0003, "", "Cardbus IDE Controller" } ,
	{ 0x10FC, 0x0005, "", "Cardbus SCSI CBSC II" } ,
	{ 0x1101, 0x1060, "", "INI-A100U2W" } ,
	{ 0x1101, 0x9100, "", "INI-9100/9100W" } ,
	{ 0x1101, 0x9400, "", "INI-940" } ,
	{ 0x1101, 0x9401, "", "INI-950" } ,
	{ 0x1101, 0x9500, "", "360P" } ,
	{ 0x1101, 0x9502, "", "Initio INI-9100UW Ultra Wide SCSI Controller INIC-950P chip" } ,
	{ 0x1102, 0x0002, "", "SB Live! EMU10k1" } ,
	{ 0x1102, 0x0004, "", "SB Audigy" } ,
	{ 0x1102, 0x0006, "", "[SB Live! Value] EMU10k1X" } ,
	{ 0x1102, 0x0007, "", "SB Audigy LS" } ,
	{ 0x1102, 0x0008, "", "SB0400 Audigy2 Value" } ,
	{ 0x1102, 0x4001, "", "SB Audigy FireWire Port" } ,
	{ 0x1102, 0x7002, "", "SB Live! MIDI/Game Port" } ,
	{ 0x1102, 0x7003, "", "SB Audigy MIDI/Game port" } ,
	{ 0x1102, 0x7004, "", "[SB Live! Value] Input device controller" } ,
	{ 0x1102, 0x7005, "", "SB Audigy LS MIDI/Game port" } ,
	{ 0x1102, 0x8064, "", "SB0100 [SBLive! 5.1 OEM]" } ,
	{ 0x1102, 0x8938, "", "Ectiva EV1938" } ,
	{ 0x1103, 0x0003, "", "HPT343" } ,
	{ 0x1103, 0x0004, "", "HPT366/368/370/370A/372/372N" } ,
	{ 0x1103, 0x0005, "", "HPT372A/372N" } ,
	{ 0x1103, 0x0006, "", "HPT302" } ,
	{ 0x1103, 0x0007, "", "HPT371/371N" } ,
	{ 0x1103, 0x0008, "", "HPT374" } ,
	{ 0x1103, 0x0009, "", "HPT372N" } ,
	{ 0x1105, 0x1105, "", "REALmagic Xcard MPEG 1/2/3/4 DVD Decoder" } ,
	{ 0x1105, 0x8300, "", "REALmagic Hollywood Plus DVD Decoder" } ,
	{ 0x1105, 0x8400, "", "EM840x REALmagic DVD/MPEG-2 Audio/Video Decoder" } ,
	{ 0x1105, 0x8401, "", "EM8401 REALmagic DVD/MPEG-2 A/V Decoder" } ,
	{ 0x1105, 0x8470, "", "EM8470 REALmagic DVD/MPEG-4 A/V Decoder" } ,
	{ 0x1105, 0x8471, "", "EM8471 REALmagic DVD/MPEG-4 A/V Decoder" } ,
	{ 0x1105, 0x8475, "", "EM8475 REALmagic DVD/MPEG-4 A/V Decoder" } ,
	{ 0x1105, 0x8476, "", "EM8476 REALmagic DVD/MPEG-4 A/V Decoder" } ,
	{ 0x1105, 0x8485, "", "EM8485 REALmagic DVD/MPEG-4 A/V Decoder" } ,
	{ 0x1105, 0x8486, "", "EM8486 REALmagic DVD/MPEG-4 A/V Decoder" } ,
	{ 0x1106, 0x0102, "", "Embedded VIA Ethernet Controller" } ,
	{ 0x1106, 0x0130, "", "VT6305 1394.A Controller" } ,
	{ 0x1106, 0x0204, "", "K8M800 Host Bridge" } ,
	{ 0x1106, 0x0238, "", "K8T890 Host Bridge" } ,
	{ 0x1106, 0x0259, "", "CN400/PM880 Host Bridge" } ,
	{ 0x1106, 0x0269, "", "KT880 Host Bridge" } ,
	{ 0x1106, 0x0282, "", "K8T800Pro Host Bridge" } ,
	{ 0x1106, 0x0290, "", "K8M890 Host Bridge" } ,
	{ 0x1106, 0x0296, "", "P4M800 Host Bridge" } ,
	{ 0x1106, 0x0305, "", "VT8363/8365 [KT133/KM133]" } ,
	{ 0x1106, 0x0308, "", "PT894 Host Bridge" } ,
	{ 0x1106, 0x0314, "", "P4M800CE Host Bridge" } ,
	{ 0x1106, 0x0391, "", "VT8371 [KX133]" } ,
	{ 0x1106, 0x0501, "", "VT8501 [Apollo MVP4]" } ,
	{ 0x1106, 0x0505, "", "VT82C505" } ,
	{ 0x1106, 0x0561, "", "VT82C576MV" } ,
	{ 0x1106, 0x0571, "", "VT82C586A/B/VT82C686/A/B/VT823x/A/C PIPC Bus Master IDE" } ,
	{ 0x1106, 0x0576, "", "VT82C576 3V [Apollo Master]" } ,
	{ 0x1106, 0x0585, "", "VT82C585VP [Apollo VP1/VPX]" } ,
	{ 0x1106, 0x0586, "", "VT82C586/A/B PCI-to-ISA [Apollo VP]" } ,
	{ 0x1106, 0x0591, "", "VT8237A SATA 2-Port Controller" } ,
	{ 0x1106, 0x0595, "", "VT82C595 [Apollo VP2]" } ,
	{ 0x1106, 0x0596, "", "VT82C596 ISA [Mobile South]" } ,
	{ 0x1106, 0x0597, "", "VT82C597 [Apollo VP3]" } ,
	{ 0x1106, 0x0598, "", "VT82C598 [Apollo MVP3]" } ,
	{ 0x1106, 0x0601, "", "VT8601 [Apollo ProMedia]" } ,
	{ 0x1106, 0x0605, "", "VT8605 [ProSavage PM133]" } ,
	{ 0x1106, 0x0680, "", "VT82C680 [Apollo P6]" } ,
	{ 0x1106, 0x0686, "", "VT82C686 [Apollo Super South]" } ,
	{ 0x1106, 0x0691, "", "VT82C693A/694x [Apollo PRO133x]" } ,
	{ 0x1106, 0x0693, "", "VT82C693 [Apollo Pro Plus]" } ,
	{ 0x1106, 0x0698, "", "VT82C693A [Apollo Pro133 AGP]" } ,
	{ 0x1106, 0x0926, "", "VT82C926 [Amazon]" } ,
	{ 0x1106, 0x1000, "", "VT82C570MV" } ,
	{ 0x1106, 0x1106, "", "VT82C570MV" } ,
	{ 0x1106, 0x1204, "", "K8M800 Host Bridge" } ,
	{ 0x1106, 0x1208, "", "PT890 Host Bridge" } ,
	{ 0x1106, 0x1238, "", "K8T890 Host Bridge" } ,
	{ 0x1106, 0x1258, "", "PT880 Host Bridge" } ,
	{ 0x1106, 0x1259, "", "CN400/PM880 Host Bridge" } ,
	{ 0x1106, 0x1269, "", "KT880 Host Bridge" } ,
	{ 0x1106, 0x1282, "", "K8T800Pro Host Bridge" } ,
	{ 0x1106, 0x1290, "", "K8M890 Host Bridge" } ,
	{ 0x1106, 0x1296, "", "P4M800 Host Bridge" } ,
	{ 0x1106, 0x1308, "", "PT894 Host Bridge" } ,
	{ 0x1106, 0x1314, "", "P4M800CE Host Bridge" } ,
	{ 0x1106, 0x1571, "", "VT82C576M/VT82C586" } ,
	{ 0x1106, 0x1595, "", "VT82C595/97 [Apollo VP2/97]" } ,
	{ 0x1106, 0x2204, "", "K8M800 Host Bridge" } ,
	{ 0x1106, 0x2208, "", "PT890 Host Bridge" } ,
	{ 0x1106, 0x2238, "", "K8T890 Host Bridge" } ,
	{ 0x1106, 0x2258, "", "PT880 Host Bridge" } ,
	{ 0x1106, 0x2259, "", "CN400/PM880 Host Bridge" } ,
	{ 0x1106, 0x2269, "", "KT880 Host Bridge" } ,
	{ 0x1106, 0x2282, "", "K8T800Pro Host Bridge" } ,
	{ 0x1106, 0x2290, "", "K8M890 Host Bridge" } ,
	{ 0x1106, 0x2296, "", "P4M800 Host Bridge" } ,
	{ 0x1106, 0x2308, "", "PT894 Host Bridge" } ,
	{ 0x1106, 0x2314, "", "P4M800CE Host Bridge" } ,
	{ 0x1106, 0x287A, "", "VT8251 PCI to PCI Bridge" } ,
	{ 0x1106, 0x287B, "", "VT8251 PCI to PCIE Bridge" } ,
	{ 0x1106, 0x287C, "", "VT8251 PCIE Root Port" } ,
	{ 0x1106, 0x287D, "", "VT8251 PCIE Root Port" } ,
	{ 0x1106, 0x287E, "", "VT8251 Ultra VLINK Controller" } ,
	{ 0x1106, 0x3022, "", "CLE266" } ,
	{ 0x1106, 0x3038, "", "VT82xxxxx UHCI USB 1.1 Controller" } ,
	{ 0x1106, 0x3040, "", "VT82C586B ACPI" } ,
	{ 0x1106, 0x3043, "", "VT86C100A [Rhine]" } ,
	{ 0x1106, 0x3044, "", "IEEE 1394 Host Controller" } ,
	{ 0x1106, 0x3050, "", "VT82C596 Power Management" } ,
	{ 0x1106, 0x3051, "", "VT82C596 Power Management" } ,
	{ 0x1106, 0x3053, "", "VT6105M [Rhine-III]" } ,
	{ 0x1106, 0x3057, "", "VT82C686 [Apollo Super ACPI]" } ,
	{ 0x1106, 0x3058, "", "VT82C686 AC97 Audio Controller" } ,
	{ 0x1106, 0x3059, "", "VT8233/A/8235/8237 AC97 Audio Controller" } ,
	{ 0x1106, 0x3065, "", "VT6102 [Rhine-II]" } ,
	{ 0x1106, 0x3068, "", "AC'97 Modem Controller" } ,
	{ 0x1106, 0x3074, "", "VT8233 PCI to ISA Bridge" } ,
	{ 0x1106, 0x3091, "", "VT8633 [Apollo Pro266]" } ,
	{ 0x1106, 0x3099, "", "VT8366/A/7 [Apollo KT266/A/333]" } ,
	{ 0x1106, 0x3101, "", "VT8653 Host Bridge" } ,
	{ 0x1106, 0x3102, "", "VT8662 Host Bridge" } ,
	{ 0x1106, 0x3103, "", "VT8615 Host Bridge" } ,
	{ 0x1106, 0x3104, "", "USB 2.0" } ,
	{ 0x1106, 0x3106, "", "VT6105 [Rhine-III]" } ,
	{ 0x1106, 0x3108, "", "S3 Unichrome Pro VGA Adapter" } ,
	{ 0x1106, 0x3109, "", "VT8233C PCI to ISA Bridge" } ,
	{ 0x1106, 0x3112, "", "VT8361 [KLE133] Host Bridge" } ,
	{ 0x1106, 0x3113, "", "VPX/VPX2 PCI to PCI Bridge Controller" } ,
	{ 0x1106, 0x3116, "", "VT8375 [KM266/KL266] Host Bridge" } ,
	{ 0x1106, 0x3118, "", "S3 Unichrome Pro VGA Adapter" } ,
	{ 0x1106, 0x3119, "", "VT6120/VT6121/VT6122 Gigabit Ethernet Adapter" } ,
	{ 0x1106, 0x3122, "", "VT8623 [Apollo CLE266] integrated CastleRock graphics" } ,
	{ 0x1106, 0x3123, "", "VT8623 [Apollo CLE266]" } ,
	{ 0x1106, 0x3128, "", "VT8753 [P4X266 AGP]" } ,
	{ 0x1106, 0x3133, "", "VT3133 Host Bridge" } ,
	{ 0x1106, 0x3147, "", "VT8233A ISA Bridge" } ,
	{ 0x1106, 0x3148, "", "P4M266 Host Bridge" } ,
	{ 0x1106, 0x3149, "", "VIA VT6420 SATA RAID Controller" } ,
	{ 0x1106, 0x3156, "", "P/KN266 Host Bridge" } ,
	{ 0x1106, 0x3164, "", "VT6410 ATA133 RAID controller" } ,
	{ 0x1106, 0x3168, "", "VT8374 P4X400 Host Controller/AGP Bridge" } ,
	{ 0x1106, 0x3177, "", "VT8235 ISA Bridge" } ,
	{ 0x1106, 0x3178, "", "ProSavageDDR P4N333 Host Bridge" } ,
	{ 0x1106, 0x3188, "", "VT8385 [K8T800 AGP] Host Bridge" } ,
	{ 0x1106, 0x3189, "", "VT8377 [KT400/KT600 AGP] Host Bridge" } ,
	{ 0x1106, 0x3204, "", "K8M800 Host Bridge" } ,
	{ 0x1106, 0x3205, "", "VT8378 [KM400/A] Chipset Host Bridge" } ,
	{ 0x1106, 0x3208, "", "PT890 Host Bridge" } ,
	{ 0x1106, 0x3213, "", "VPX/VPX2 PCI to PCI Bridge Controller" } ,
	{ 0x1106, 0x3218, "", "K8T800M Host Bridge" } ,
	{ 0x1106, 0x3227, "", "VT8237 ISA bridge [KT600/K8T800/K8T890 South]" } ,
	{ 0x1106, 0x3238, "", "K8T890 Host Bridge" } ,
	{ 0x1106, 0x3249, "", "VT6421 IDE RAID Controller" } ,
	{ 0x1106, 0x3258, "", "PT880 Host Bridge" } ,
	{ 0x1106, 0x3259, "", "CN400/PM880 Host Bridge" } ,
	{ 0x1106, 0x3269, "", "KT880 Host Bridge" } ,
	{ 0x1106, 0x3282, "", "K8T800Pro Host Bridge" } ,
	{ 0x1106, 0x3288, "", "VIA High Definition Audio Controller" } ,
	{ 0x1106, 0x3290, "", "K8M890 Host Bridge" } ,
	{ 0x1106, 0x3296, "", "P4M800 Host Bridge" } ,
	{ 0x1106, 0x3337, "", "VT8237A PCI to ISA Bridge" } ,
	{ 0x1106, 0x3349, "", "VT8251 AHCI/SATA 4-Port Controller" } ,
	{ 0x1106, 0x337A, "", "VT8237A PCI to PCI Bridge" } ,
	{ 0x1106, 0x337B, "", "VT8237A PCI to PCIE Bridge" } ,
	{ 0x1106, 0x4149, "", "VIA VT6420 (ATA133) Controller" } ,
	{ 0x1106, 0x4204, "", "K8M800 Host Bridge" } ,
	{ 0x1106, 0x4208, "", "PT890 Host Bridge" } ,
	{ 0x1106, 0x4238, "", "K8T890 Host Bridge" } ,
	{ 0x1106, 0x4258, "", "PT880 Host Bridge" } ,
	{ 0x1106, 0x4259, "", "CN400/PM880 Host Bridge" } ,
	{ 0x1106, 0x4269, "", "KT880 Host Bridge" } ,
	{ 0x1106, 0x4282, "", "K8T800Pro Host Bridge" } ,
	{ 0x1106, 0x4290, "", "K8M890 Host Bridge" } ,
	{ 0x1106, 0x4296, "", "P4M800 Host Bridge" } ,
	{ 0x1106, 0x4308, "", "PT894 Host Bridge" } ,
	{ 0x1106, 0x4314, "", "P4M800CE Host Bridge" } ,
	{ 0x1106, 0x5030, "", "VT82C596 ACPI [Apollo PRO]" } ,
	{ 0x1106, 0x5208, "", "PT890 I/O APIC Interrupt Controller" } ,
	{ 0x1106, 0x5238, "", "K8T890 I/O APIC Interrupt Controller" } ,
	{ 0x1106, 0x5290, "", "K8M890 I/O APIC Interrupt Controller" } ,
	{ 0x1106, 0x5308, "", "PT894 I/O APIC Interrupt Controller" } ,
	{ 0x1106, 0x6100, "", "VT85C100A [Rhine II]" } ,
	{ 0x1106, 0x7204, "", "K8M800 Host Bridge" } ,
	{ 0x1106, 0x7205, "", "VT8378 [S3 UniChrome] Integrated Video" } ,
	{ 0x1106, 0x7208, "", "PT890 Host Bridge" } ,
	{ 0x1106, 0x7238, "", "K8T890 Host Bridge" } ,
	{ 0x1106, 0x7258, "", "PT880 Host Bridge" } ,
	{ 0x1106, 0x7259, "", "CN400/PM880 Host Bridge" } ,
	{ 0x1106, 0x7269, "", "KT880 Host Bridge" } ,
	{ 0x1106, 0x7282, "", "K8T800Pro Host Bridge" } ,
	{ 0x1106, 0x7290, "", "K8M890 Host Bridge" } ,
	{ 0x1106, 0x7296, "", "P4M800 Host Bridge" } ,
	{ 0x1106, 0x7308, "", "PT894 Host Bridge" } ,
	{ 0x1106, 0x7314, "", "P4M800CE Host Bridge" } ,
	{ 0x1106, 0x8231, "", "VT8231 [PCI-to-ISA Bridge]" } ,
	{ 0x1106, 0x8235, "", "VT8235 ACPI" } ,
	{ 0x1106, 0x8305, "", "VT8363/8365 [KT133/KM133 AGP]" } ,
	{ 0x1106, 0x8391, "", "VT8371 [KX133 AGP]" } ,
	{ 0x1106, 0x8501, "", "VT8501 [Apollo MVP4 AGP]" } ,
	{ 0x1106, 0x8596, "", "VT82C596 [Apollo PRO AGP]" } ,
	{ 0x1106, 0x8597, "", "VT82C597 [Apollo VP3 AGP]" } ,
	{ 0x1106, 0x8598, "", "VT82C598/694x [Apollo MVP3/Pro133x AGP]" } ,
	{ 0x1106, 0x8601, "", "VT8601 [Apollo ProMedia AGP]" } ,
	{ 0x1106, 0x8605, "", "VT8605 [PM133 AGP]" } ,
	{ 0x1106, 0x8691, "", "VT82C691 [Apollo Pro]" } ,
	{ 0x1106, 0x8693, "", "VT82C693 [Apollo Pro Plus] PCI Bridge" } ,
	{ 0x1106, 0xA208, "", "PT890 PCI to PCI Bridge Controller" } ,
	{ 0x1106, 0xA238, "", "K8T890 PCI to PCI Bridge Controller" } ,
	{ 0x1106, 0xB091, "", "VT8633 [Apollo Pro266 AGP]" } ,
	{ 0x1106, 0xB099, "", "VT8366/A/7 [Apollo KT266/A/333 AGP]" } ,
	{ 0x1106, 0xB101, "", "VT8653 AGP Bridge" } ,
	{ 0x1106, 0xB102, "", "VT8362 AGP Bridge" } ,
	{ 0x1106, 0xB103, "", "VT8615 AGP Bridge" } ,
	{ 0x1106, 0xB112, "", "VT8361 [KLE133] AGP Bridge" } ,
	{ 0x1106, 0xB113, "", "VPX/VPX2 I/O APIC Interrupt Controller" } ,
	{ 0x1106, 0xB115, "", "VT8363/8365 [KT133/KM133] PCI Bridge" } ,
	{ 0x1106, 0xB168, "", "VT8235 PCI Bridge" } ,
	{ 0x1106, 0xB188, "", "VT8237 PCI bridge [K8T800/K8T890 South]" } ,
	{ 0x1106, 0xB198, "", "VT8237 PCI Bridge" } ,
	{ 0x1106, 0xB213, "", "VPX/VPX2 I/O APIC Interrupt Controller" } ,
	{ 0x1106, 0xC208, "", "PT890 PCI to PCI Bridge Controller" } ,
	{ 0x1106, 0xC238, "", "K8T890 PCI to PCI Bridge Controller" } ,
	{ 0x1106, 0xD104, "", "VT8237 Integrated Fast Ethernet Controller" } ,
	{ 0x1106, 0xD208, "", "PT890 PCI to PCI Bridge Controller" } ,
	{ 0x1106, 0xD213, "", "VPX/VPX2 PCI to PCI Bridge Controller" } ,
	{ 0x1106, 0xD238, "", "K8T890 PCI to PCI Bridge Controller" } ,
	{ 0x1106, 0xE208, "", "PT890 PCI to PCI Bridge Controller" } ,
	{ 0x1106, 0xE238, "", "K8T890 PCI to PCI Bridge Controller" } ,
	{ 0x1106, 0xF208, "", "PT890 PCI to PCI Bridge Controller" } ,
	{ 0x1106, 0xF238, "", "K8T890 PCI to PCI Bridge Controller" } ,
	{ 0x1107, 0x0576, "", "VIA VT82C570MV [Apollo] (Wrong vendor ID!)" } ,
	{ 0x1108, 0x0100, "", "p1690plus_AA" } ,
	{ 0x1108, 0x0101, "", "p1690plus_AB" } ,
	{ 0x1108, 0x0105, "", "P1690Plus" } ,
	{ 0x1108, 0x0108, "", "P1690Plus" } ,
	{ 0x1108, 0x0138, "", "P1690Plus" } ,
	{ 0x1108, 0x0139, "", "P1690Plus" } ,
	{ 0x1108, 0x013C, "", "P1690Plus" } ,
	{ 0x1108, 0x013D, "", "P1690Plus" } ,
	{ 0x1109, 0x1400, "", "EM110TX [EX110TX]" } ,
	{ 0x110A, 0x0002, "", "Pirahna 2-port" } ,
	{ 0x110A, 0x0005, "", "Tulip controller, power management, switch extender" } ,
	{ 0x110A, 0x0006, "", "FSC PINC (I/O-APIC)" } ,
	{ 0x110A, 0x0015, "", "FSC Multiprocessor Interrupt Controller" } ,
	{ 0x110A, 0x001D, "", "FSC Copernicus Management Controller" } ,
	{ 0x110A, 0x007B, "", "FSC Remote Service Controller, mailbox device" } ,
	{ 0x110A, 0x007C, "", "FSC Remote Service Controller, shared memory device" } ,
	{ 0x110A, 0x007D, "", "FSC Remote Service Controller, SMIC device" } ,
	{ 0x110A, 0x2101, "", "HST SAPHIR V Primary PCI (ISDN/PMx)" } ,
	{ 0x110A, 0x2102, "", "DSCC4 PEB/PEF 20534 DMA Supported Serial Communication Controller with 4 Channels" } ,
	{ 0x110A, 0x2104, "", "Eicon Diva 2.02 compatible passive ISDN card" } ,
	{ 0x110A, 0x3142, "", "SIMATIC NET CP 5613A1 (Profibus Adapter)" } ,
	{ 0x110A, 0x4021, "", "SIMATIC NET CP 5512 (Profibus and MPI Cardbus Adapter)" } ,
	{ 0x110A, 0x4029, "", "SIMATIC NET CP 5613A2 (Profibus Adapter)" } ,
	{ 0x110A, 0x4942, "", "FPGA I-Bus Tracer for MBD" } ,
	{ 0x110A, 0x6120, "", "SZB6120" } ,
	{ 0x110B, 0x0001, "", "Mpact Media Processor" } ,
	{ 0x110B, 0x0004, "", "Mpact 2" } ,
	{ 0x1110, 0x6037, "", "Firepower Powerized SMP I/O ASIC" } ,
	{ 0x1110, 0x6073, "", "Firepower Powerized SMP I/O ASIC" } ,
	{ 0x1112, 0x2200, "", "FDDI Adapter" } ,
	{ 0x1112, 0x2300, "", "Fast Ethernet Adapter" } ,
	{ 0x1112, 0x2340, "", "4 Port Fast Ethernet Adapter" } ,
	{ 0x1112, 0x2400, "", "ATM Adapter" } ,
	{ 0x1113, 0x1211, "", "SMC2-1211TX" } ,
	{ 0x1113, 0x1216, "", "EN-1216 Ethernet Adapter" } ,
	{ 0x1113, 0x1217, "", "EN-1217 Ethernet Adapter" } ,
	{ 0x1113, 0x5105, "", "10Mbps Network card" } ,
	{ 0x1113, 0x9211, "", "EN-1207D Fast Ethernet Adapter" } ,
	{ 0x1113, 0x9511, "", "21x4x DEC-Tulip compatible Fast Ethernet" } ,
	{ 0x1113, 0xD301, "", "CPWNA100 (Philips wireless PCMCIA)" } ,
	{ 0x1113, 0xEC02, "", "SMC 1244TX v3" } ,
	{ 0x1114, 0x0506, "", "at76c506 802.11b Wireless Network Adaptor" } ,
	{ 0x1116, 0x0022, "", "DT3001" } ,
	{ 0x1116, 0x0023, "", "DT3002" } ,
	{ 0x1116, 0x0024, "", "DT3003" } ,
	{ 0x1116, 0x0025, "", "DT3004" } ,
	{ 0x1116, 0x0026, "", "DT3005" } ,
	{ 0x1116, 0x0027, "", "DT3001-PGL" } ,
	{ 0x1116, 0x0028, "", "DT3003-PGL" } ,
	{ 0x1117, 0x9500, "", "Max-1C SVGA card" } ,
	{ 0x1117, 0x9501, "", "Max-1C image processing" } ,
	{ 0x1119, 0x0000, "", "GDT 6000/6020/6050" } ,
	{ 0x1119, 0x0001, "", "GDT 6000B/6010" } ,
	{ 0x1119, 0x0002, "", "GDT 6110/6510" } ,
	{ 0x1119, 0x0003, "", "GDT 6120/6520" } ,
	{ 0x1119, 0x0004, "", "GDT 6530" } ,
	{ 0x1119, 0x0005, "", "GDT 6550" } ,
	{ 0x1119, 0x0006, "", "GDT 6117/6517" } ,
	{ 0x1119, 0x0007, "", "GDT 6127/6527" } ,
	{ 0x1119, 0x0008, "", "GDT 6537" } ,
	{ 0x1119, 0x0009, "", "GDT 6557/6557-ECC" } ,
	{ 0x1119, 0x000A, "", "GDT 6115/6515" } ,
	{ 0x1119, 0x000B, "", "GDT 6125/6525" } ,
	{ 0x1119, 0x000C, "", "GDT 6535" } ,
	{ 0x1119, 0x000D, "", "GDT 6555" } ,
	{ 0x1119, 0x0010, "", "GDT 6115/6515" } ,
	{ 0x1119, 0x0011, "", "GDT 6125/6525" } ,
	{ 0x1119, 0x0012, "", "GDT 6535" } ,
	{ 0x1119, 0x0013, "", "GDT 6555/6555-ECC" } ,
	{ 0x1119, 0x0100, "", "GDT 6117RP/6517RP" } ,
	{ 0x1119, 0x0101, "", "GDT 6127RP/6527RP" } ,
	{ 0x1119, 0x0102, "", "GDT 6537RP" } ,
	{ 0x1119, 0x0103, "", "GDT 6557RP" } ,
	{ 0x1119, 0x0104, "", "GDT 6111RP/6511RP" } ,
	{ 0x1119, 0x0105, "", "GDT 6121RP/6521RP" } ,
	{ 0x1119, 0x0110, "", "GDT 6117RD/6517RD" } ,
	{ 0x1119, 0x0111, "", "GDT 6127RD/6527RD" } ,
	{ 0x1119, 0x0112, "", "GDT 6537RD" } ,
	{ 0x1119, 0x0113, "", "GDT 6557RD" } ,
	{ 0x1119, 0x0114, "", "GDT 6111RD/6511RD" } ,
	{ 0x1119, 0x0115, "", "GDT 6121RD/6521RD" } ,
	{ 0x1119, 0x0118, "", "GDT 6118RD/6518RD/6618RD" } ,
	{ 0x1119, 0x0119, "", "GDT 6128RD/6528RD/6628RD" } ,
	{ 0x1119, 0x011A, "", "GDT 6538RD/6638RD" } ,
	{ 0x1119, 0x011B, "", "GDT 6558RD/6658RD" } ,
	{ 0x1119, 0x0120, "", "GDT 6117RP2/6517RP2" } ,
	{ 0x1119, 0x0121, "", "GDT 6127RP2/6527RP2" } ,
	{ 0x1119, 0x0122, "", "GDT 6537RP2" } ,
	{ 0x1119, 0x0123, "", "GDT 6557RP2" } ,
	{ 0x1119, 0x0124, "", "GDT 6111RP2/6511RP2" } ,
	{ 0x1119, 0x0125, "", "GDT 6121RP2/6521RP2" } ,
	{ 0x1119, 0x0136, "", "GDT 6113RS/6513RS" } ,
	{ 0x1119, 0x0137, "", "GDT 6123RS/6523RS" } ,
	{ 0x1119, 0x0138, "", "GDT 6118RS/6518RS/6618RS" } ,
	{ 0x1119, 0x0139, "", "GDT 6128RS/6528RS/6628RS" } ,
	{ 0x1119, 0x013A, "", "GDT 6538RS/6638RS" } ,
	{ 0x1119, 0x013B, "", "GDT 6558RS/6658RS" } ,
	{ 0x1119, 0x013C, "", "GDT 6533RS/6633RS" } ,
	{ 0x1119, 0x013D, "", "GDT 6543RS/6643RS" } ,
	{ 0x1119, 0x013E, "", "GDT 6553RS/6653RS" } ,
	{ 0x1119, 0x013F, "", "GDT 6563RS/6663RS" } ,
	{ 0x1119, 0x0166, "", "GDT 7113RN/7513RN/7613RN" } ,
	{ 0x1119, 0x0167, "", "GDT 7123RN/7523RN/7623RN" } ,
	{ 0x1119, 0x0168, "", "GDT 7118RN/7518RN/7518RN" } ,
	{ 0x1119, 0x0169, "", "GDT 7128RN/7528RN/7628RN" } ,
	{ 0x1119, 0x016A, "", "GDT 7538RN/7638RN" } ,
	{ 0x1119, 0x016B, "", "GDT 7558RN/7658RN" } ,
	{ 0x1119, 0x016C, "", "GDT 7533RN/7633RN" } ,
	{ 0x1119, 0x016D, "", "GDT 7543RN/7643RN" } ,
	{ 0x1119, 0x016E, "", "GDT 7553RN/7653RN" } ,
	{ 0x1119, 0x016F, "", "GDT 7563RN/7663RN" } ,
	{ 0x1119, 0x01D6, "", "GDT 4x13RZ" } ,
	{ 0x1119, 0x01D7, "", "GDT 4x23RZ" } ,
	{ 0x1119, 0x01F6, "", "GDT 8x13RZ" } ,
	{ 0x1119, 0x01F7, "", "GDT 8x23RZ" } ,
	{ 0x1119, 0x01FC, "", "GDT 8x33RZ" } ,
	{ 0x1119, 0x01FD, "", "GDT 8x43RZ" } ,
	{ 0x1119, 0x01FE, "", "GDT 8x53RZ" } ,
	{ 0x1119, 0x01FF, "", "GDT 8x63RZ" } ,
	{ 0x1119, 0x0210, "", "GDT 6519RD/6619RD" } ,
	{ 0x1119, 0x0211, "", "GDT 6529RD/6629RD" } ,
	{ 0x1119, 0x0260, "", "GDT 7519RN/7619RN" } ,
	{ 0x1119, 0x0261, "", "GDT 7529RN/7629RN" } ,
	{ 0x1119, 0x02FF, "", "GDT MAXRP" } ,
	{ 0x1119, 0x0300, "", "GDT NEWRX" } ,
	{ 0x111A, 0x0000, "", "155P-MF1 (FPGA)" } ,
	{ 0x111A, 0x0002, "", "155P-MF1 (ASIC)" } ,
	{ 0x111A, 0x0003, "", "ENI-25P ATM" } ,
	{ 0x111A, 0x0005, "", "SpeedStream (LANAI)" } ,
	{ 0x111A, 0x0007, "", "SpeedStream ADSL" } ,
	{ 0x111A, 0x1203, "", "SpeedStream 1023 Wireless PCI Adapter" } ,
	{ 0x111C, 0x0001, "", "Powerbis Bridge" } ,
	{ 0x111D, 0x0001, "", "IDT77201/77211 155Mbps ATM SAR Controller [NICStAR]" } ,
	{ 0x111D, 0x0003, "", "IDT77222/77252 155Mbps ATM MICRO ABR SAR Controller" } ,
	{ 0x111D, 0x0004, "", "IDT77V252 155Mbps ATM MICRO ABR SAR Controller" } ,
	{ 0x111D, 0x0005, "", "IDT77V222 155Mbps ATM MICRO ABR SAR Controller" } ,
	{ 0x111F, 0x4A47, "", "Precision MX Video engine interface" } ,
	{ 0x111F, 0x5243, "", "Frame capture bus interface" } ,
	{ 0x1127, 0x0200, "", "ForeRunner PCA-200 ATM" } ,
	{ 0x1127, 0x0210, "", "PCA-200PC" } ,
	{ 0x1127, 0x0250, "", "ATM" } ,
	{ 0x1127, 0x0300, "", "ForeRunner PCA-200EPC ATM" } ,
	{ 0x1127, 0x0310, "", "ATM" } ,
	{ 0x1127, 0x0400, "", "ForeRunnerHE ATM Adapter" } ,
	{ 0x112F, 0x0000, "", "MVC IC-PCI" } ,
	{ 0x112F, 0x0001, "", "MVC IM-PCI Video frame grabber/processor" } ,
	{ 0x1131, 0x1561, "", "USB 1.1 Host Controller" } ,
	{ 0x1131, 0x1562, "", "USB 2.0 Host Controller" } ,
	{ 0x1131, 0x3400, "", "SmartPCI56(UCB1500) 56K Modem" } ,
	{ 0x1131, 0x5400, "", "TriMedia TM1000/1100" } ,
	{ 0x1131, 0x5402, "", "TriMedia TM-1300" } ,
	{ 0x1131, 0x7130, "", "SAA7130 Video Broadcast Decoder" } ,
	{ 0x1131, 0x7133, "", "SAA7133 Video Broadcast Decoder" } ,
	{ 0x1131, 0x7134, "", "SAA7134 Video Broadcast Decoder" } ,
	{ 0x1131, 0x7135, "", "SAA7135 Video Broadcast Decoder" } ,
	{ 0x1131, 0x7145, "", "SAA7145" } ,
	{ 0x1131, 0x7146, "", "SAA7146" } ,
	{ 0x1131, 0x9730, "", "SAA9730 Integrated Multimedia and Peripheral Controller" } ,
	{ 0x1133, 0x7901, "", "EiconCard S90" } ,
	{ 0x1133, 0x7902, "", "EiconCard S90" } ,
	{ 0x1133, 0x7911, "", "EiconCard S91" } ,
	{ 0x1133, 0x7912, "", "EiconCard S91" } ,
	{ 0x1133, 0x7941, "", "EiconCard S94" } ,
	{ 0x1133, 0x7942, "", "EiconCard S94" } ,
	{ 0x1133, 0x7943, "", "EiconCard S94" } ,
	{ 0x1133, 0x7944, "", "EiconCard S94" } ,
	{ 0x1133, 0xB921, "", "EiconCard P92" } ,
	{ 0x1133, 0xB922, "", "EiconCard P92" } ,
	{ 0x1133, 0xB923, "", "EiconCard P92" } ,
	{ 0x1133, 0xE001, "", "Diva Pro 2.0 S/T" } ,
	{ 0x1133, 0xE002, "", "Diva 2.0 S/T PCI" } ,
	{ 0x1133, 0xE003, "", "Diva Pro 2.0 U" } ,
	{ 0x1133, 0xE004, "", "Diva 2.0 U PCI" } ,
	{ 0x1133, 0xE005, "", "Diva 2.01 S/T PCI" } ,
	{ 0x1133, 0xE006, "", "Diva CT S/T PCI" } ,
	{ 0x1133, 0xE007, "", "Diva CT U PCI" } ,
	{ 0x1133, 0xE008, "", "Diva CT Lite S/T PCI" } ,
	{ 0x1133, 0xE009, "", "Diva CT Lite U PCI" } ,
	{ 0x1133, 0xE00A, "", "Diva ISDN+V.90 PCI" } ,
	{ 0x1133, 0xE00B, "", "Diva 2.02 PCI S/T" } ,
	{ 0x1133, 0xE00C, "", "Diva 2.02 PCI U" } ,
	{ 0x1133, 0xE00D, "", "Diva ISDN Pro 3.0 PCI" } ,
	{ 0x1133, 0xE00E, "", "Diva ISDN+CT S/T PCI Rev 2" } ,
	{ 0x1133, 0xE010, "", "Diva Server BRI-2M PCI" } ,
	{ 0x1133, 0xE011, "", "Diva Server BRI S/T Rev 2" } ,
	{ 0x1133, 0xE012, "", "Diva Server 4BRI-8M PCI" } ,
	{ 0x1133, 0xE013, "", "Diva Server 4BRI Rev 2" } ,
	{ 0x1133, 0xE014, "", "Diva Server PRI-30M PCI" } ,
	{ 0x1133, 0xE015, "", "DIVA Server PRI Rev 2" } ,
	{ 0x1133, 0xE016, "", "Diva Server Voice 4BRI PCI" } ,
	{ 0x1133, 0xE017, "", "Diva Server Voice 4BRI Rev 2" } ,
	{ 0x1133, 0xE018, "", "Diva Server BRI-2M 2.0 PCI" } ,
	{ 0x1133, 0xE019, "", "Diva Server Voice PRI Rev 2" } ,
	{ 0x1133, 0xE01A, "", "Diva Server 2FX" } ,
	{ 0x1133, 0xE01B, "", "Diva Server Voice BRI-2M 2.0 PCI" } ,
	{ 0x1133, 0xE01C, "", "Diva Server PRI Rev 3" } ,
	{ 0x1133, 0xE01E, "", "Diva Server 2PRI" } ,
	{ 0x1133, 0xE020, "", "Diva Server 4PRI" } ,
	{ 0x1133, 0xE024, "", "Diva Server Analog-4P" } ,
	{ 0x1133, 0xE028, "", "Diva Server Analog-8P" } ,
	{ 0x1133, 0xE02A, "", "Diva Server IPM-300" } ,
	{ 0x1133, 0xE02C, "", "Diva Server IPM-600" } ,
	{ 0x1134, 0x0001, "", "Raceway Bridge" } ,
	{ 0x1134, 0x0002, "", "Dual PCI to RapidIO Bridge" } ,
	{ 0x1135, 0x0001, "", "Printer controller" } ,
	{ 0x1138, 0x8905, "", "8905 [STD 32 Bridge]" } ,
	{ 0x1139, 0x0001, "", "VGA Compatable 3D Graphics" } ,
	{ 0x113C, 0x0000, "", "PCI-9060 i960 Bridge" } ,
	{ 0x113C, 0x0001, "", "PCI-SDK [PCI i960 Evaluation Platform]" } ,
	{ 0x113C, 0x0911, "", "PCI-911 [i960Jx-based Intelligent I/O Controller]" } ,
	{ 0x113C, 0x0912, "", "PCI-912 [i960CF-based Intelligent I/O Controller]" } ,
	{ 0x113C, 0x0913, "", "PCI-913" } ,
	{ 0x113C, 0x0914, "", "PCI-914 [I/O Controller w/ secondary PCI bus]" } ,
	{ 0x113F, 0x0808, "", "SST-64P Adapter" } ,
	{ 0x113F, 0x1010, "", "SST-128P Adapter" } ,
	{ 0x113F, 0x80C0, "", "SST-16P DB Adapter" } ,
	{ 0x113F, 0x80C4, "", "SST-16P RJ Adapter" } ,
	{ 0x113F, 0x80C8, "", "SST-16P Adapter" } ,
	{ 0x113F, 0x8888, "", "SST-4P Adapter" } ,
	{ 0x113F, 0x9090, "", "SST-8P Adapter" } ,
	{ 0x1142, 0x3210, "", "AP6410" } ,
	{ 0x1142, 0x6422, "", "ProVideo 6422" } ,
	{ 0x1142, 0x6424, "", "ProVideo 6424" } ,
	{ 0x1142, 0x6425, "", "ProMotion AT25" } ,
	{ 0x1142, 0x643D, "", "ProMotion AT3D" } ,
	{ 0x1144, 0x0001, "", "Noservo controller" } ,
	{ 0x1145, 0x8007, "", "NinjaSCSI-32 Workbit" } ,
	{ 0x1145, 0xF007, "", "NinjaSCSI-32 KME" } ,
	{ 0x1145, 0xF010, "", "NinjaSCSI-32 Workbit" } ,
	{ 0x1145, 0xF012, "", "NinjaSCSI-32 Logitec" } ,
	{ 0x1145, 0xF013, "", "NinjaSCSI-32 Logitec" } ,
	{ 0x1145, 0xF015, "", "NinjaSCSI-32 Melco" } ,
	{ 0x1145, 0xF020, "", "NinjaSCSI-32 Sony PCGA-DVD51" } ,
	{ 0x1148, 0x4000, "", "FDDI Adapter" } ,
	{ 0x1148, 0x4200, "", "Token Ring adapter" } ,
	{ 0x1148, 0x4300, "", "SK-98xx Gigabit Ethernet Server Adapter" } ,
	{ 0x1148, 0x4320, "", "SK-98xx V2.0 Gigabit Ethernet Adapter" } ,
	{ 0x1148, 0x4400, "", "SK-9Dxx Gigabit Ethernet Adapter" } ,
	{ 0x1148, 0x4500, "", "SK-9Mxx Gigabit Ethernet Adapter" } ,
	{ 0x1148, 0x9000, "", "SK-9Sxx Gigabit Ethernet Server Adapter PCI-X" } ,
	{ 0x1148, 0x9843, "", "[Fujitsu] Gigabit Ethernet" } ,
	{ 0x1148, 0x9E00, "", "SK-9Exx 10/100/1000Base-T Adapter" } ,
	{ 0x114A, 0x5579, "", "VMIPCI-5579 (Reflective Memory Card)" } ,
	{ 0x114A, 0x5587, "", "VMIPCI-5587 (Reflective Memory Card)" } ,
	{ 0x114A, 0x6504, "", "VMIC PCI 7755 FPGA" } ,
	{ 0x114A, 0x7587, "", "VMIVME-7587" } ,
	{ 0x114F, 0x0002, "", "AccelePort EPC" } ,
	{ 0x114F, 0x0003, "", "RightSwitch SE-6" } ,
	{ 0x114F, 0x0004, "", "AccelePort Xem" } ,
	{ 0x114F, 0x0005, "", "AccelePort Xr" } ,
	{ 0x114F, 0x0006, "", "AccelePort Xr,C/X" } ,
	{ 0x114F, 0x0009, "", "AccelePort Xr/J" } ,
	{ 0x114F, 0x000A, "", "AccelePort EPC/J" } ,
	{ 0x114F, 0x000C, "", "DataFirePRIme T1 (1-port)" } ,
	{ 0x114F, 0x000D, "", "SyncPort 2-Port (x.25/FR)" } ,
	{ 0x114F, 0x0011, "", "AccelePort 8r EIA-232 (IBM)" } ,
	{ 0x114F, 0x0012, "", "AccelePort 8r EIA-422" } ,
	{ 0x114F, 0x0013, "", "AccelePort Xr" } ,
	{ 0x114F, 0x0014, "", "AccelePort 8r EIA-422" } ,
	{ 0x114F, 0x0015, "", "AccelePort Xem" } ,
	{ 0x114F, 0x0016, "", "AccelePort EPC/X" } ,
	{ 0x114F, 0x0017, "", "AccelePort C/X" } ,
	{ 0x114F, 0x001A, "", "DataFirePRIme E1 (1-port)" } ,
	{ 0x114F, 0x001B, "", "AccelePort C/X (IBM)" } ,
	{ 0x114F, 0x001D, "", "DataFire RAS T1/E1/PRI" } ,
	{ 0x114F, 0x0023, "", "AccelePort RAS" } ,
	{ 0x114F, 0x0024, "", "DataFire RAS B4 ST/U" } ,
	{ 0x114F, 0x0026, "", "AccelePort 4r 920" } ,
	{ 0x114F, 0x0027, "", "AccelePort Xr 920" } ,
	{ 0x114F, 0x0028, "", "ClassicBoard 4" } ,
	{ 0x114F, 0x0029, "", "ClassicBoard 8" } ,
	{ 0x114F, 0x0034, "", "AccelePort 2r 920" } ,
	{ 0x114F, 0x0035, "", "DataFire DSP T1/E1/PRI cPCI" } ,
	{ 0x114F, 0x0040, "", "AccelePort Xp" } ,
	{ 0x114F, 0x0042, "", "AccelePort 2p" } ,
	{ 0x114F, 0x0043, "", "AccelePort 4p" } ,
	{ 0x114F, 0x0044, "", "AccelePort 8p" } ,
	{ 0x114F, 0x0045, "", "AccelePort 16p" } ,
	{ 0x114F, 0x004E, "", "AccelePort 32p" } ,
	{ 0x114F, 0x0070, "", "Datafire Micro V IOM2 (Europe)" } ,
	{ 0x114F, 0x0071, "", "Datafire Micro V (Europe)" } ,
	{ 0x114F, 0x0072, "", "Datafire Micro V IOM2 (North America)" } ,
	{ 0x114F, 0x0073, "", "Datafire Micro V (North America)" } ,
	{ 0x114F, 0x00B0, "", "Digi Neo 4" } ,
	{ 0x114F, 0x00B1, "", "Digi Neo 8" } ,
	{ 0x114F, 0x00C8, "", "Digi Neo 2 DB9" } ,
	{ 0x114F, 0x00C9, "", "Digi Neo 2 DB9 PRI" } ,
	{ 0x114F, 0x00CA, "", "Digi Neo 2 RJ45" } ,
	{ 0x114F, 0x00CB, "", "Digi Neo 2 RJ45 PRI" } ,
	{ 0x114F, 0x00D0, "", "ClassicBoard 4 422" } ,
	{ 0x114F, 0x00D1, "", "ClassicBoard 8 422" } ,
	{ 0x114F, 0x6001, "", "Avanstar" } ,
	{ 0x1158, 0x3011, "", "Tokenet/vg 1001/10m anylan" } ,
	{ 0x1158, 0x9050, "", "Lanfleet/Truevalue" } ,
	{ 0x1158, 0x9051, "", "Lanfleet/Truevalue" } ,
	{ 0x1159, 0x0001, "", "MV-1000" } ,
	{ 0x115D, 0x0003, "", "Cardbus Ethernet 10/100" } ,
	{ 0x115D, 0x0005, "", "Cardbus Ethernet 10/100" } ,
	{ 0x115D, 0x0007, "", "Cardbus Ethernet 10/100" } ,
	{ 0x115D, 0x000B, "", "Cardbus Ethernet 10/100" } ,
	{ 0x115D, 0x000C, "", "Mini-PCI V.90 56k Modem" } ,
	{ 0x115D, 0x000F, "", "Cardbus Ethernet 10/100" } ,
	{ 0x115D, 0x00D4, "", "Mini-PCI K56Flex Modem" } ,
	{ 0x115D, 0x0101, "", "Cardbus 56k modem" } ,
	{ 0x115D, 0x0103, "", "Cardbus Ethernet + 56k Modem" } ,
	{ 0x1163, 0x0001, "", "Verite 1000" } ,
	{ 0x1163, 0x2000, "", "Verite V2000/V2100/V2200" } ,
	{ 0x1165, 0x0001, "", "Motion TPEG Recorder/Player with audio" } ,
	{ 0x1166, 0x0000, "", "CMIC-LE" } ,
	{ 0x1166, 0x0005, "", "CNB20-LE Host Bridge" } ,
	{ 0x1166, 0x0006, "", "CNB20HE Host Bridge" } ,
	{ 0x1166, 0x0007, "", "CNB20-LE Host Bridge" } ,
	{ 0x1166, 0x0008, "", "CNB20HE Host Bridge" } ,
	{ 0x1166, 0x0009, "", "CNB20LE Host Bridge" } ,
	{ 0x1166, 0x0010, "", "CIOB30" } ,
	{ 0x1166, 0x0011, "", "CMIC-HE" } ,
	{ 0x1166, 0x0012, "", "CMIC-WS Host Bridge (GC-LE chipset)" } ,
	{ 0x1166, 0x0013, "", "CNB20-HE Host Bridge" } ,
	{ 0x1166, 0x0014, "", "CMIC-LE Host Bridge (GC-LE chipset)" } ,
	{ 0x1166, 0x0015, "", "CMIC-GC Host Bridge" } ,
	{ 0x1166, 0x0016, "", "CMIC-GC Host Bridge" } ,
	{ 0x1166, 0x0017, "", "GCNB-LE Host Bridge" } ,
	{ 0x1166, 0x0036, "", "HT1000 PCI/PCI-X bridge" } ,
	{ 0x1166, 0x0101, "", "CIOB-X2 PCI-X I/O Bridge" } ,
	{ 0x1166, 0x0104, "", "HT1000 PCI/PCI-X bridge" } ,
	{ 0x1166, 0x0110, "", "CIOB-E I/O Bridge with Gigabit Ethernet" } ,
	{ 0x1166, 0x0130, "", "HT1000 PCI-X bridge" } ,
	{ 0x1166, 0x0132, "", "HT1000 PCI-Express bridge" } ,
	{ 0x1166, 0x0200, "", "OSB4 South Bridge" } ,
	{ 0x1166, 0x0201, "", "CSB5 South Bridge" } ,
	{ 0x1166, 0x0203, "", "CSB6 South Bridge" } ,
	{ 0x1166, 0x0205, "", "HT1000 Legacy South Bridge" } ,
	{ 0x1166, 0x0211, "", "OSB4 IDE Controller" } ,
	{ 0x1166, 0x0212, "", "CSB5 IDE Controller" } ,
	{ 0x1166, 0x0213, "", "CSB6 RAID/IDE Controller" } ,
	{ 0x1166, 0x0214, "", "HT1000 Legacy IDE controller" } ,
	{ 0x1166, 0x0217, "", "CSB6 IDE Controller" } ,
	{ 0x1166, 0x0220, "", "OSB4/CSB5 OHCI USB Controller" } ,
	{ 0x1166, 0x0221, "", "CSB6 OHCI USB Controller" } ,
	{ 0x1166, 0x0223, "", "HT1000 USB Controller" } ,
	{ 0x1166, 0x0225, "", "CSB5 LPC bridge" } ,
	{ 0x1166, 0x0227, "", "GCLE-2 Host Bridge" } ,
	{ 0x1166, 0x0230, "", "CSB5 LPC bridge" } ,
	{ 0x1166, 0x0234, "", "HT1000 LPC Bridge" } ,
	{ 0x1166, 0x0240, "", "K2 SATA" } ,
	{ 0x1166, 0x0241, "", "RAIDCore RC4000" } ,
	{ 0x1166, 0x0242, "", "RAIDCore BC4000" } ,
	{ 0x1166, 0x024A, "", "BCM5785 (HT1000) SATA Native SATA Mode" } ,
	{ 0x116A, 0x6100, "", "Bus/Tag Channel" } ,
	{ 0x116A, 0x6800, "", "Escon Channel" } ,
	{ 0x116A, 0x7100, "", "Bus/Tag Channel" } ,
	{ 0x116A, 0x7800, "", "Escon Channel" } ,
	{ 0x1178, 0xAFA1, "", "Fast Ethernet Adapter" } ,
	{ 0x1179, 0x0102, "", "Extended IDE Controller" } ,
	{ 0x1179, 0x0103, "", "EX-IDE Type-B" } ,
	{ 0x1179, 0x0404, "", "DVD Decoder card" } ,
	{ 0x1179, 0x0406, "", "Tecra Video Capture device" } ,
	{ 0x1179, 0x0407, "", "DVD Decoder card (Version 2)" } ,
	{ 0x1179, 0x0601, "", "CPU to PCI bridge" } ,
	{ 0x1179, 0x0603, "", "ToPIC95 PCI to CardBus Bridge for Notebooks" } ,
	{ 0x1179, 0x060A, "", "ToPIC95" } ,
	{ 0x1179, 0x060F, "", "ToPIC97" } ,
	{ 0x1179, 0x0617, "", "ToPIC100 PCI to Cardbus Bridge with ZV Support" } ,
	{ 0x1179, 0x0618, "", "CPU to PCI and PCI to ISA bridge" } ,
	{ 0x1179, 0x0701, "", "FIR Port" } ,
	{ 0x1179, 0x0804, "", "TC6371AF SmartMedia Controller" } ,
	{ 0x1179, 0x0805, "", "SD TypA Controller" } ,
	{ 0x1179, 0x0D01, "", "FIR Port Type-DO" } ,
	{ 0x117C, 0x0030, "", "Ultra320 SCSI Host Adapter" } ,
	{ 0x1180, 0x0465, "", "RL5c465" } ,
	{ 0x1180, 0x0466, "", "RL5c466" } ,
	{ 0x1180, 0x0475, "", "RL5c475" } ,
	{ 0x1180, 0x0476, "", "RL5c476 II" } ,
	{ 0x1180, 0x0477, "", "RL5c477" } ,
	{ 0x1180, 0x0478, "", "RL5c478" } ,
	{ 0x1180, 0x0522, "", "R5C522 IEEE 1394 Controller" } ,
	{ 0x1180, 0x0551, "", "R5C551 IEEE 1394 Controller" } ,
	{ 0x1180, 0x0552, "", "R5C552 IEEE 1394 Controller" } ,
	{ 0x1180, 0x0575, "", "R5C575 SD Bus Host Adapter" } ,
	{ 0x1180, 0x0576, "", "R5C576 SD Bus Host Adapter" } ,
	{ 0x1180, 0x0592, "", "R5C592 Memory Stick Bus Host Adapter" } ,
	{ 0x1180, 0x0822, "", "R5C822 SD/SDIO/MMC/MS/MSPro Host Adapter" } ,
	{ 0x1180, 0x0852, "", "xD-Picture Card Controller" } ,
	{ 0x1186, 0x0100, "", "DC21041" } ,
	{ 0x1186, 0x1002, "", "DL10050 Sundance Ethernet" } ,
	{ 0x1186, 0x1025, "", "AirPlus Xtreme G DWL-G650 Adapter" } ,
	{ 0x1186, 0x1026, "", "AirXpert DWL-AG650 Wireless Cardbus Adapter" } ,
	{ 0x1186, 0x1043, "", "AirXpert DWL-AG650 Wireless Cardbus Adapter" } ,
	{ 0x1186, 0x1300, "", "RTL8139 Ethernet" } ,
	{ 0x1186, 0x1340, "", "DFE-690TXD CardBus PC Card" } ,
	{ 0x1186, 0x1541, "", "DFE-680TXD CardBus PC Card" } ,
	{ 0x1186, 0x1561, "", "DRP-32TXD Cardbus PC Card" } ,
	{ 0x1186, 0x2027, "", "AirPlus Xtreme G DWL-G520 Adapter" } ,
	{ 0x1186, 0x3203, "", "AirPlus Xtreme G DWL-G520 Adapter" } ,
	{ 0x1186, 0x3300, "", "DWL-510 2.4GHz Wireless PCI Adapter" } ,
	{ 0x1186, 0x3A03, "", "AirPro DWL-A650 Wireless Cardbus Adapter(rev.B)" } ,
	{ 0x1186, 0x3A04, "", "AirPro DWL-AB650 Multimode Wireless Cardbus Adapter" } ,
	{ 0x1186, 0x3A05, "", "AirPro DWL-AB520 Multimode Wireless PCI Adapter" } ,
	{ 0x1186, 0x3A07, "", "AirXpert DWL-AG650 Wireless Cardbus Adapter" } ,
	{ 0x1186, 0x3A08, "", "AirXpert DWL-AG520 Wireless PCI Adapter" } ,
	{ 0x1186, 0x3A10, "", "AirXpert DWL-AG650 Wireless Cardbus Adapter(rev.B)" } ,
	{ 0x1186, 0x3A11, "", "AirXpert DWL-AG520 Wireless PCI Adapter(rev.B)" } ,
	{ 0x1186, 0x3A12, "", "AirPlus DWL-G650 Wireless Cardbus Adapter(rev.C)" } ,
	{ 0x1186, 0x3A13, "", "AirPlus DWL-G520 Wireless PCI Adapter(rev.B)" } ,
	{ 0x1186, 0x3A14, "", "AirPremier DWL-AG530 Wireless PCI Adapter" } ,
	{ 0x1186, 0x3A63, "", "AirXpert DWL-AG660 Wireless Cardbus Adapter" } ,
	{ 0x1186, 0x4000, "", "DL2000-based Gigabit Ethernet" } ,
	{ 0x1186, 0x4300, "", "DGE-528T Gigabit Ethernet Adapter" } ,
	{ 0x1186, 0x4C00, "", "Gigabit Ethernet Adapter" } ,
	{ 0x1186, 0x8400, "", "D-Link DWL-650+ CardBus PC Card" } ,
	{ 0x118C, 0x0014, "", "PCIB [C-bus II to PCI bus host bridge chip]" } ,
	{ 0x118C, 0x1117, "", "Intel 8-way XEON Profusion Chipset [Cache Coherency Filter]" } ,
	{ 0x118D, 0x0001, "", "Raptor-PCI framegrabber" } ,
	{ 0x118D, 0x0012, "", "Model 12 Road Runner Frame Grabber" } ,
	{ 0x118D, 0x0014, "", "Model 14 Road Runner Frame Grabber" } ,
	{ 0x118D, 0x0024, "", "Model 24 Road Runner Frame Grabber" } ,
	{ 0x118D, 0x0044, "", "Model 44 Road Runner Frame Grabber" } ,
	{ 0x118D, 0x0112, "", "Model 12 Road Runner Frame Grabber" } ,
	{ 0x118D, 0x0114, "", "Model 14 Road Runner Frame Grabber" } ,
	{ 0x118D, 0x0124, "", "Model 24 Road Runner Frame Grabber" } ,
	{ 0x118D, 0x0144, "", "Model 44 Road Runner Frame Grabber" } ,
	{ 0x118D, 0x0212, "", "Model 12 Road Runner Frame Grabber" } ,
	{ 0x118D, 0x0214, "", "Model 14 Road Runner Frame Grabber" } ,
	{ 0x118D, 0x0224, "", "Model 24 Road Runner Frame Grabber" } ,
	{ 0x118D, 0x0244, "", "Model 44 Road Runner Frame Grabber" } ,
	{ 0x118D, 0x0312, "", "Model 12 Road Runner Frame Grabber" } ,
	{ 0x118D, 0x0314, "", "Model 14 Road Runner Frame Grabber" } ,
	{ 0x118D, 0x0324, "", "Model 24 Road Runner Frame Grabber" } ,
	{ 0x118D, 0x0344, "", "Model 44 Road Runner Frame Grabber" } ,
	{ 0x1190, 0xC731, "", "TP-910/920/940 PCI Ultra(Wide) SCSI Adapter" } ,
	{ 0x1191, 0x0003, "", "SCSI Cache Host Adapter" } ,
	{ 0x1191, 0x0004, "", "ATP8400" } ,
	{ 0x1191, 0x0005, "", "ATP850UF" } ,
	{ 0x1191, 0x0006, "", "ATP860 NO-BIOS" } ,
	{ 0x1191, 0x0007, "", "ATP860" } ,
	{ 0x1191, 0x0008, "", "ATP865 NO-ROM" } ,
	{ 0x1191, 0x0009, "", "ATP865" } ,
	{ 0x1191, 0x8002, "", "AEC6710 SCSI-2 Host Adapter" } ,
	{ 0x1191, 0x8010, "", "AEC6712UW SCSI" } ,
	{ 0x1191, 0x8020, "", "AEC6712U SCSI" } ,
	{ 0x1191, 0x8030, "", "AEC6712S SCSI" } ,
	{ 0x1191, 0x8040, "", "AEC6712D SCSI" } ,
	{ 0x1191, 0x8050, "", "AEC6712SUW SCSI" } ,
	{ 0x1191, 0x8060, "", "AEC6712 SCSI" } ,
	{ 0x1191, 0x8080, "", "AEC67160 SCSI" } ,
	{ 0x1191, 0x8081, "", "AEC67160S SCSI" } ,
	{ 0x1191, 0x808A, "", "AEC67162 2-ch. LVD SCSI" } ,
	{ 0x1193, 0x0001, "", "1221" } ,
	{ 0x1193, 0x0002, "", "1225" } ,
	{ 0x1197, 0x010C, "", "CompuScope 82G 8bit 2GS/s Analog Input Card" } ,
	{ 0x119B, 0x1221, "", "82C092G" } ,
	{ 0x119E, 0x0001, "", "FireStream 155" } ,
	{ 0x119E, 0x0003, "", "FireStream 50" } ,
	{ 0x11A9, 0x4240, "", "AMCC S933Q Intelligent Serial Card" } ,
	{ 0x11AB, 0x0146, "", "GT-64010/64010A System Controller" } ,
	{ 0x11AB, 0x138F, "", "W8300 802.11 Adapter (rev 07)" } ,
	{ 0x11AB, 0x1FA6, "", "Marvell W8300 802.11 Adapter" } ,
	{ 0x11AB, 0x1FA7, "", "88W8310 and 88W8000G [Libertas] 802.11g client chipset" } ,
	{ 0x11AB, 0x1FAA, "", "88w8335 [Libertas] 802.11b/g Wireless" } ,
	{ 0x11AB, 0x4320, "", "88E8001 Gigabit Ethernet Controller" } ,
	{ 0x11AB, 0x4350, "", "88E8035 Fast Ethernet Controller" } ,
	{ 0x11AB, 0x4351, "", "88E8036 Fast Ethernet Controller" } ,
	{ 0x11AB, 0x4360, "", "88E8052 Gigabit Ethernet Controller" } ,
	{ 0x11AB, 0x4361, "", "88E8050 Gigabit Ethernet Controller" } ,
	{ 0x11AB, 0x4362, "", "88E8053 Gigabit Ethernet Controller" } ,
	{ 0x11AB, 0x4611, "", "GT-64115 System Controller" } ,
	{ 0x11AB, 0x4620, "", "GT-64120/64120A/64121A System Controller" } ,
	{ 0x11AB, 0x4801, "", "GT-48001" } ,
	{ 0x11AB, 0x5005, "", "Belkin F5D5005 Gigabit Desktop Network PCI Card" } ,
	{ 0x11AB, 0x5040, "", "MV88SX5040 4-port SATA I PCI-X Controller" } ,
	{ 0x11AB, 0x5041, "", "MV88SX5041 4-port SATA I PCI-X Controller" } ,
	{ 0x11AB, 0x5080, "", "MV88SX5080 8-port SATA I PCI-X Controller" } ,
	{ 0x11AB, 0x5081, "", "MV88SX5081 8-port SATA I PCI-X Controller" } ,
	{ 0x11AB, 0x6041, "", "MV88SX6041 4-port SATA II PCI-X Controller" } ,
	{ 0x11AB, 0x6081, "", "MV88SX6081 8-port SATA II PCI-X Controller" } ,
	{ 0x11AB, 0x6460, "", "MV64360/64361/64362 System Controller" } ,
	{ 0x11AB, 0x6480, "", "MV64460/64461/64462 System Controller" } ,
	{ 0x11AB, 0xF003, "", "GT-64010 Primary Image Piranha Image Generator" } ,
	{ 0x11AD, 0x0002, "", "LNE100TX" } ,
	{ 0x11AD, 0xC115, "", "LNE100TX [Linksys EtherFast 10/100]" } ,
	{ 0x11AF, 0x0001, "", "Cinema" } ,
	{ 0x11AF, 0xEE40, "", "Digidesign Audiomedia III" } ,
	{ 0x11B0, 0x0002, "", "V300PSC" } ,
	{ 0x11B0, 0x0292, "", "V292PBC [Am29030/40 Bridge]" } ,
	{ 0x11B0, 0x0960, "", "V96xPBC" } ,
	{ 0x11B0, 0xC960, "", "V96DPC" } ,
	{ 0x11B8, 0x0001, "", "Quad PeerMaster" } ,
	{ 0x11B9, 0xC0ED, "", "SSA Controller" } ,
	{ 0x11BC, 0x0001, "", "NP-PCI" } ,
	{ 0x11C1, 0x0440, "", "56k WinModem" } ,
	{ 0x11C1, 0x0441, "", "56k WinModem" } ,
	{ 0x11C1, 0x0442, "", "56k WinModem" } ,
	{ 0x11C1, 0x0443, "", "LT WinModem" } ,
	{ 0x11C1, 0x0444, "", "LT WinModem" } ,
	{ 0x11C1, 0x0445, "", "LT WinModem" } ,
	{ 0x11C1, 0x0446, "", "LT WinModem" } ,
	{ 0x11C1, 0x0447, "", "LT WinModem" } ,
	{ 0x11C1, 0x0448, "", "WinModem 56k" } ,
	{ 0x11C1, 0x0449, "", "WinModem 56k" } ,
	{ 0x11C1, 0x044A, "", "F-1156IV WinModem (V90, 56KFlex)" } ,
	{ 0x11C1, 0x044B, "", "LT WinModem" } ,
	{ 0x11C1, 0x044C, "", "LT WinModem" } ,
	{ 0x11C1, 0x044D, "", "LT WinModem" } ,
	{ 0x11C1, 0x044E, "", "LT WinModem" } ,
	{ 0x11C1, 0x044F, "", "V90 WildWire Modem" } ,
	{ 0x11C1, 0x0450, "", "LT WinModem" } ,
	{ 0x11C1, 0x0451, "", "LT WinModem" } ,
	{ 0x11C1, 0x0452, "", "LT WinModem" } ,
	{ 0x11C1, 0x0453, "", "LT WinModem" } ,
	{ 0x11C1, 0x0454, "", "LT WinModem" } ,
	{ 0x11C1, 0x0455, "", "LT WinModem" } ,
	{ 0x11C1, 0x0456, "", "LT WinModem" } ,
	{ 0x11C1, 0x0457, "", "LT WinModem" } ,
	{ 0x11C1, 0x0458, "", "LT WinModem" } ,
	{ 0x11C1, 0x0459, "", "LT WinModem" } ,
	{ 0x11C1, 0x045A, "", "LT WinModem" } ,
	{ 0x11C1, 0x045C, "", "LT WinModem" } ,
	{ 0x11C1, 0x0461, "", "V90 WildWire Modem" } ,
	{ 0x11C1, 0x0462, "", "V90 WildWire Modem" } ,
	{ 0x11C1, 0x0480, "", "Venus Modem (V90, 56KFlex)" } ,
	{ 0x11C1, 0x048C, "", "V.92 56K WinModem" } ,
	{ 0x11C1, 0x048F, "", "V.92 56k WinModem" } ,
	{ 0x11C1, 0x5801, "", "USB" } ,
	{ 0x11C1, 0x5802, "", "USS-312 USB Controller" } ,
	{ 0x11C1, 0x5803, "", "USS-344S USB Controller" } ,
	{ 0x11C1, 0x5811, "", "FW323" } ,
	{ 0x11C1, 0x8110, "", "T8110 H.100/H.110 TDM switch" } ,
	{ 0x11C1, 0xAB10, "", "WL60010 Wireless LAN MAC" } ,
	{ 0x11C1, 0xAB11, "", "WL60040 Multimode Wireles LAN MAC" } ,
	{ 0x11C1, 0xAB20, "", "ORiNOCO PCI Adapter" } ,
	{ 0x11C1, 0xAB21, "", "Agere Wireless PCI Adapter" } ,
	{ 0x11C1, 0xAB30, "", "Hermes2 Mini-PCI WaveLAN a/b/g" } ,
	{ 0x11C8, 0x0658, "", "PSB32 SCI-Adapter D31x" } ,
	{ 0x11C8, 0xD665, "", "PSB64 SCI-Adapter D32x" } ,
	{ 0x11C8, 0xD667, "", "PSB66 SCI-Adapter D33x" } ,
	{ 0x11C9, 0x0010, "", "16-line serial port w/- DMA" } ,
	{ 0x11C9, 0x0011, "", "4-line serial port w/- DMA" } ,
	{ 0x11CB, 0x2000, "", "PCI_9050" } ,
	{ 0x11CB, 0x4000, "", "SUPI_1" } ,
	{ 0x11CB, 0x8000, "", "T225" } ,
	{ 0x11D1, 0x01F7, "", "VxP524" } ,
	{ 0x11D4, 0x1535, "", "Blackfin BF535 processor" } ,
	{ 0x11D4, 0x1805, "", "SM56 PCI modem" } ,
	{ 0x11D4, 0x1889, "", "AD1889 sound chip" } ,
	{ 0x11D4, 0x5340, "", "AD1881 sound chip" } ,
	{ 0x11D5, 0x0115, "", "10115" } ,
	{ 0x11D5, 0x0117, "", "10117" } ,
	{ 0x11DE, 0x6057, "", "ZR36057PQC Video cutting chipset" } ,
	{ 0x11DE, 0x6120, "", "ZR36120" } ,
	{ 0x11E3, 0x5030, "", "PC Watchdog" } ,
	{ 0x11F0, 0x4231, "", "FDDI" } ,
	{ 0x11F0, 0x4232, "", "FASTline UTP Quattro" } ,
	{ 0x11F0, 0x4233, "", "FASTline FO" } ,
	{ 0x11F0, 0x4234, "", "FASTline UTP" } ,
	{ 0x11F0, 0x4235, "", "FASTline-II UTP" } ,
	{ 0x11F0, 0x4236, "", "FASTline-II FO" } ,
	{ 0x11F0, 0x4731, "", "GIGAline" } ,
	{ 0x11F4, 0x2915, "", "CAMAC controller" } ,
	{ 0x11F6, 0x0112, "", "ENet100VG4" } ,
	{ 0x11F6, 0x0113, "", "FreedomLine 100" } ,
	{ 0x11F6, 0x1401, "", "ReadyLink 2000" } ,
	{ 0x11F6, 0x2011, "", "RL100-ATX 10/100" } ,
	{ 0x11F6, 0x2201, "", "ReadyLink 100TX (Winbond W89C840)" } ,
	{ 0x11F6, 0x9881, "", "RL100TX Fast Ethernet" } ,
	{ 0x11F8, 0x7375, "", "PM7375 [LASAR-155 ATM SAR]" } ,
	{ 0x11FE, 0x0001, "", "RocketPort 32 port w/external I/F" } ,
	{ 0x11FE, 0x0002, "", "RocketPort 8 port w/external I/F" } ,
	{ 0x11FE, 0x0003, "", "RocketPort 16 port w/external I/F" } ,
	{ 0x11FE, 0x0004, "", "RocketPort 4 port w/quad cable" } ,
	{ 0x11FE, 0x0005, "", "RocketPort 8 port w/octa cable" } ,
	{ 0x11FE, 0x0006, "", "RocketPort 8 port w/RJ11 connectors" } ,
	{ 0x11FE, 0x0007, "", "RocketPort 4 port w/RJ11 connectors" } ,
	{ 0x11FE, 0x0008, "", "RocketPort 8 port w/ DB78 SNI (Siemens) connector" } ,
	{ 0x11FE, 0x0009, "", "RocketPort 16 port w/ DB78 SNI (Siemens) connector" } ,
	{ 0x11FE, 0x000A, "", "RocketPort Plus 4 port" } ,
	{ 0x11FE, 0x000B, "", "RocketPort Plus 8 port" } ,
	{ 0x11FE, 0x000C, "", "RocketModem 6 port" } ,
	{ 0x11FE, 0x000D, "", "RocketModem 4-port" } ,
	{ 0x11FE, 0x000E, "", "RocketPort Plus 2 port RS232" } ,
	{ 0x11FE, 0x000F, "", "RocketPort Plus 2 port RS422" } ,
	{ 0x11FE, 0x0801, "", "RocketPort UPCI 32 port w/external I/F" } ,
	{ 0x11FE, 0x0802, "", "RocketPort UPCI 8 port w/external I/F" } ,
	{ 0x11FE, 0x0803, "", "RocketPort UPCI 16 port w/external I/F" } ,
	{ 0x11FE, 0x0805, "", "RocketPort UPCI 8 port w/octa cable" } ,
	{ 0x11FE, 0x080C, "", "RocketModem III 8 port" } ,
	{ 0x11FE, 0x080D, "", "RocketModem III 4 port" } ,
	{ 0x11FE, 0x0812, "", "RocketPort UPCI Plus 8 port RS422" } ,
	{ 0x11FE, 0x0903, "", "RocketPort Compact PCI 16 port w/external I/F" } ,
	{ 0x11FE, 0x8015, "", "RocketPort 4-port UART 16954" } ,
	{ 0x11FF, 0x0003, "", "AG-5" } ,
	{ 0x1202, 0x4300, "", "Gigabit Ethernet Adapter" } ,
	{ 0x1208, 0x4853, "", "HS-Link Device" } ,
	{ 0x120E, 0x0100, "", "Cyclom-Y below first megabyte" } ,
	{ 0x120E, 0x0101, "", "Cyclom-Y above first megabyte" } ,
	{ 0x120E, 0x0102, "", "Cyclom-4Y below first megabyte" } ,
	{ 0x120E, 0x0103, "", "Cyclom-4Y above first megabyte" } ,
	{ 0x120E, 0x0104, "", "Cyclom-8Y below first megabyte" } ,
	{ 0x120E, 0x0105, "", "Cyclom-8Y above first megabyte" } ,
	{ 0x120E, 0x0200, "", "Cyclades-Z below first megabyte" } ,
	{ 0x120E, 0x0201, "", "Cyclades-Z above first megabyte" } ,
	{ 0x120E, 0x0300, "", "PC300/RSV or /X21 (2 ports)" } ,
	{ 0x120E, 0x0301, "", "PC300/RSV or /X21 (1 port)" } ,
	{ 0x120E, 0x0310, "", "PC300/TE (2 ports)" } ,
	{ 0x120E, 0x0311, "", "PC300/TE (1 port)" } ,
	{ 0x120E, 0x0320, "", "PC300/TE-M (2 ports)" } ,
	{ 0x120E, 0x0321, "", "PC300/TE-M (1 port)" } ,
	{ 0x120E, 0x0400, "", "PC400" } ,
	{ 0x120F, 0x0001, "", "Roadrunner serial HIPPI" } ,
	{ 0x1217, 0x6729, "", "OZ6729" } ,
	{ 0x1217, 0x673A, "", "OZ6730" } ,
	{ 0x1217, 0x6832, "", "OZ6832/6833 CardBus Controller" } ,
	{ 0x1217, 0x6836, "", "OZ6836/6860 CardBus Controller" } ,
	{ 0x1217, 0x6872, "", "OZ6812 CardBus Controller" } ,
	{ 0x1217, 0x6925, "", "OZ6922 CardBus Controller" } ,
	{ 0x1217, 0x6933, "", "OZ6933/711E1 CardBus/SmartCardBus Controller" } ,
	{ 0x1217, 0x6972, "", "OZ601/6912/711E0 CardBus/SmartCardBus Controller" } ,
	{ 0x1217, 0x7110, "", "OZ711Mx 4-in-1 MemoryCardBus Accelerator" } ,
	{ 0x1217, 0x7112, "", "OZ711EC1/M1 SmartCardBus/MemoryCardBus Controller" } ,
	{ 0x1217, 0x7113, "", "OZ711EC1 SmartCardBus Controller" } ,
	{ 0x1217, 0x7114, "", "OZ711M1/MC1 4-in-1 MemoryCardBus Controller" } ,
	{ 0x1217, 0x7134, "", "OZ711MP1/MS1 MemoryCardBus Controller" } ,
	{ 0x1217, 0x71E2, "", "OZ711E2 SmartCardBus Controller" } ,
	{ 0x1217, 0x7212, "", "OZ711M2 4-in-1 MemoryCardBus Controller" } ,
	{ 0x1217, 0x7213, "", "OZ6933E CardBus Controller" } ,
	{ 0x1217, 0x7223, "", "OZ711M3/MC3 4-in-1 MemoryCardBus Controller" } ,
	{ 0x1217, 0x7233, "", "OZ711MP3/MS3 4-in-1 MemoryCardBus Controller" } ,
	{ 0x121A, 0x0001, "", "Voodoo" } ,
	{ 0x121A, 0x0002, "", "Voodoo 2" } ,
	{ 0x121A, 0x0003, "", "Voodoo Banshee" } ,
	{ 0x121A, 0x0004, "", "Voodoo Banshee [Velocity 100]" } ,
	{ 0x121A, 0x0005, "", "Voodoo 3" } ,
	{ 0x121A, 0x0009, "", "Voodoo 4 / Voodoo 5" } ,
	{ 0x121A, 0x0057, "", "Voodoo 3/3000 [Avenger]" } ,
	{ 0x1220, 0x1220, "", "AMCC 5933 TMS320C80 DSP/Imaging board" } ,
	{ 0x1223, 0x0003, "", "PM/Link" } ,
	{ 0x1223, 0x0004, "", "PM/T1" } ,
	{ 0x1223, 0x0005, "", "PM/E1" } ,
	{ 0x1223, 0x0008, "", "PM/SLS" } ,
	{ 0x1223, 0x0009, "", "BajaSpan Resource Target" } ,
	{ 0x1223, 0x000A, "", "BajaSpan Section 0" } ,
	{ 0x1223, 0x000B, "", "BajaSpan Section 1" } ,
	{ 0x1223, 0x000C, "", "BajaSpan Section 2" } ,
	{ 0x1223, 0x000D, "", "BajaSpan Section 3" } ,
	{ 0x1223, 0x000E, "", "PM/PPC" } ,
	{ 0x1227, 0x0006, "", "Raptor GFX 8P" } ,
	{ 0x122D, 0x1206, "", "368DSP" } ,
	{ 0x122D, 0x1400, "", "Trident PCI288-Q3DII (NX)" } ,
	{ 0x122D, 0x50DC, "", "3328 Audio" } ,
	{ 0x122D, 0x80DA, "", "3328 Audio" } ,
	{ 0x1236, 0x0000, "", "RealMagic64/GX" } ,
	{ 0x1236, 0x6401, "", "REALmagic 64/GX (SD 6425)" } ,
	{ 0x123D, 0x0000, "", "EasyConnect 8/32" } ,
	{ 0x123D, 0x0002, "", "EasyConnect 8/64" } ,
	{ 0x123D, 0x0003, "", "EasyIO" } ,
	{ 0x123F, 0x00E4, "", "MPEG" } ,
	{ 0x123F, 0x8120, "", "E4?" } ,
	{ 0x123F, 0x8888, "", "Cinemaster C 3.0 DVD Decoder" } ,
	{ 0x1242, 0x1560, "", "JNIC-1560 PCI-X Fibre Channel Controller" } ,
	{ 0x1242, 0x4643, "", "FCI-1063 Fibre Channel Adapter" } ,
	{ 0x1242, 0x6562, "", "FCX2-6562 Dual Channel PCI-X Fibre Channel Adapter" } ,
	{ 0x1242, 0x656A, "", "FCX-6562 PCI-X Fibre Channel Adapter" } ,
	{ 0x1244, 0x0700, "", "B1 ISDN" } ,
	{ 0x1244, 0x0800, "", "C4 ISDN" } ,
	{ 0x1244, 0x0A00, "", "A1 ISDN [Fritz]" } ,
	{ 0x1244, 0x0E00, "", "Fritz!PCI v2.0 ISDN" } ,
	{ 0x1244, 0x1100, "", "C2 ISDN" } ,
	{ 0x1244, 0x1200, "", "T1 ISDN" } ,
	{ 0x1244, 0x2700, "", "Fritz!Card DSL SL" } ,
	{ 0x1244, 0x2900, "", "Fritz!Card DSL v2.0" } ,
	{ 0x124B, 0x0040, "", "PCI-40A or cPCI-200 Quad IndustryPack carrier" } ,
	{ 0x124D, 0x0000, "", "EasyConnection 8/32" } ,
	{ 0x124D, 0x0002, "", "EasyConnection 8/64" } ,
	{ 0x124D, 0x0003, "", "EasyIO" } ,
	{ 0x124D, 0x0004, "", "EasyConnection/RA" } ,
	{ 0x124F, 0x0041, "", "IFT-2000 Series RAID Controller" } ,
	{ 0x1255, 0x1110, "", "MPEG Forge" } ,
	{ 0x1255, 0x1210, "", "MPEG Fusion" } ,
	{ 0x1255, 0x2110, "", "VideoPlex" } ,
	{ 0x1255, 0x2120, "", "VideoPlex CC" } ,
	{ 0x1255, 0x2130, "", "VideoQuest" } ,
	{ 0x1256, 0x4201, "", "PCI-2220I" } ,
	{ 0x1256, 0x4401, "", "PCI-2240I" } ,
	{ 0x1256, 0x5201, "", "PCI-2000" } ,
	{ 0x1259, 0x2560, "", "AT-2560 Fast Ethernet Adapter (i82557B)" } ,
	{ 0x1259, 0xA117, "", "RTL81xx Fast Ethernet" } ,
	{ 0x1259, 0xA120, "", "21x4x DEC-Tulip compatible 10/100 Ethernet" } ,
	{ 0x125B, 0x1400, "", "ALFA GFC2204 Fast Ethernet" } ,
	{ 0x125C, 0x0101, "", "Saturn 4520P" } ,
	{ 0x125C, 0x0640, "", "Aries 16000P" } ,
	{ 0x125D, 0x0000, "", "ES336H Fax Modem (Early Model)" } ,
	{ 0x125D, 0x1948, "", "Solo?" } ,
	{ 0x125D, 0x1968, "", "ES1968 Maestro 2" } ,
	{ 0x125D, 0x1969, "", "ES1969 Solo-1 Audiodrive" } ,
	{ 0x125D, 0x1978, "", "ES1978 Maestro 2E" } ,
	{ 0x125D, 0x1988, "", "ES1988 Allegro-1" } ,
	{ 0x125D, 0x1989, "", "ESS Modem" } ,
	{ 0x125D, 0x1998, "", "ES1983S Maestro-3i PCI Audio Accelerator" } ,
	{ 0x125D, 0x1999, "", "ES1983S Maestro-3i PCI Modem Accelerator" } ,
	{ 0x125D, 0x199A, "", "ES1983S Maestro-3i PCI Audio Accelerator" } ,
	{ 0x125D, 0x199B, "", "ES1983S Maestro-3i PCI Modem Accelerator" } ,
	{ 0x125D, 0x2808, "", "ES336H Fax Modem (Later Model)" } ,
	{ 0x125D, 0x2838, "", "ES2838/2839 SuperLink Modem" } ,
	{ 0x125D, 0x2898, "", "ES2898 Modem" } ,
	{ 0x1260, 0x3872, "", "Prism 2.5 Wavelan chipset" } ,
	{ 0x1260, 0x3873, "", "Prism 2.5 Wavelan chipset" } ,
	{ 0x1260, 0x3886, "", "ISL3886 [Prism Javelin/Prism Xbow]" } ,
	{ 0x1260, 0x3890, "", "Intersil ISL3890 [Prism GT/Prism Duette]" } ,
	{ 0x1260, 0x8130, "", "HMP8130 NTSC/PAL Video Decoder" } ,
	{ 0x1260, 0x8131, "", "HMP8131 NTSC/PAL Video Decoder" } ,
	{ 0x1260, 0xFFFF, "", "ISL3886IK" } ,
	{ 0x1266, 0x0001, "", "NE10/100 Adapter (i82557B)" } ,
	{ 0x1266, 0x1910, "", "NE2000Plus (RT8029) Ethernet Adapter" } ,
	{ 0x1267, 0x5352, "", "PCR2101" } ,
	{ 0x1267, 0x5A4B, "", "Telsat Turbo" } ,
	{ 0x126C, 0x1211, "", "10/100BaseTX [RTL81xx]" } ,
	{ 0x126C, 0x126C, "", "802.11b Wireless Ethernet Adapter" } ,
	{ 0x126F, 0x0501, "", "SM501 VoyagerGX" } ,
	{ 0x126F, 0x0710, "", "SM710 LynxEM" } ,
	{ 0x126F, 0x0712, "", "SM712 LynxEM+" } ,
	{ 0x126F, 0x0720, "", "SM720 Lynx3DM" } ,
	{ 0x126F, 0x0730, "", "SM731 Cougar3DR" } ,
	{ 0x126F, 0x0810, "", "SM810 LynxE" } ,
	{ 0x126F, 0x0811, "", "SM811 LynxE" } ,
	{ 0x126F, 0x0820, "", "SM820 Lynx3D" } ,
	{ 0x126F, 0x0910, "", "SM910" } ,
	{ 0x1273, 0x0002, "", "DirecPC" } ,
	{ 0x1274, 0x1171, "", "ES1373 [AudioPCI] (also Creative Labs CT5803)" } ,
	{ 0x1274, 0x1371, "", "ES1371 [AudioPCI-97]" } ,
	{ 0x1274, 0x5000, "", "ES1370 [AudioPCI]" } ,
	{ 0x1274, 0x5880, "", "5880 AudioPCI" } ,
	{ 0x1278, 0x0701, "", "TPE3/TM3 PowerPC Node" } ,
	{ 0x1278, 0x0710, "", "TPE5 PowerPC PCI board" } ,
	{ 0x1279, 0x0060, "", "TM8000 Northbridge" } ,
	{ 0x1279, 0x0061, "", "TM8000 AGP bridge" } ,
	{ 0x1279, 0x0295, "", "Northbridge" } ,
	{ 0x1279, 0x0395, "", "LongRun Northbridge" } ,
	{ 0x1279, 0x0396, "", "SDRAM controller" } ,
	{ 0x1279, 0x0397, "", "BIOS scratchpad" } ,
	{ 0x127A, 0x1002, "", "HCF 56k Data/Fax Modem" } ,
	{ 0x127A, 0x1003, "", "HCF 56k Data/Fax Modem" } ,
	{ 0x127A, 0x1004, "", "HCF 56k Data/Fax/Voice Modem" } ,
	{ 0x127A, 0x1005, "", "HCF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" } ,
	{ 0x127A, 0x1022, "", "HCF 56k Modem" } ,
	{ 0x127A, 0x1023, "", "HCF 56k Data/Fax Modem" } ,
	{ 0x127A, 0x1024, "", "HCF 56k Data/Fax/Voice Modem" } ,
	{ 0x127A, 0x1025, "", "HCF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" } ,
	{ 0x127A, 0x1026, "", "HCF 56k PCI Speakerphone Modem" } ,
	{ 0x127A, 0x1032, "", "HCF 56k Modem" } ,
	{ 0x127A, 0x1033, "", "HCF 56k Modem" } ,
	{ 0x127A, 0x1034, "", "HCF 56k Modem" } ,
	{ 0x127A, 0x1035, "", "HCF 56k PCI Speakerphone Modem" } ,
	{ 0x127A, 0x1036, "", "HCF 56k Modem" } ,
	{ 0x127A, 0x1085, "", "HCF 56k Volcano PCI Modem" } ,
	{ 0x127A, 0x2005, "", "HCF 56k Data/Fax Modem" } ,
	{ 0x127A, 0x2013, "", "HSF 56k Data/Fax Modem" } ,
	{ 0x127A, 0x2014, "", "HSF 56k Data/Fax/Voice Modem" } ,
	{ 0x127A, 0x2015, "", "HSF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" } ,
	{ 0x127A, 0x2016, "", "HSF 56k Data/Fax/Voice/Spkp Modem" } ,
	{ 0x127A, 0x4311, "", "Riptide HSF 56k PCI Modem" } ,
	{ 0x127A, 0x4320, "", "Riptide PCI Audio Controller" } ,
	{ 0x127A, 0x4321, "", "Riptide HCF 56k PCI Modem" } ,
	{ 0x127A, 0x4322, "", "Riptide PCI Game Controller" } ,
	{ 0x127A, 0x8234, "", "RapidFire 616X ATM155 Adapter" } ,
	{ 0x1282, 0x9009, "", "Ethernet 100/10 MBit" } ,
	{ 0x1282, 0x9100, "", "21x4x DEC-Tulip compatible 10/100 Ethernet" } ,
	{ 0x1282, 0x9102, "", "21x4x DEC-Tulip compatible 10/100 Ethernet" } ,
	{ 0x1282, 0x9132, "", "Ethernet 100/10 MBit" } ,
	{ 0x1283, 0x673A, "", "IT8330G" } ,
	{ 0x1283, 0x8211, "", "ITE 8211F Single Channel UDMA 133 (ASUS 8211 (ITE IT8212 ATA RAID Controller))" } ,
	{ 0x1283, 0x8212, "", "IT/ITE8212 Dual channel ATA RAID controller (PCI version seems to be IT8212, embedded seems to be ITE8212)" } ,
	{ 0x1283, 0x8330, "", "IT8330G" } ,
	{ 0x1283, 0x8872, "", "IT8874F PCI Dual Serial Port Controller" } ,
	{ 0x1283, 0x8888, "", "IT8888F PCI to ISA Bridge with SMB" } ,
	{ 0x1283, 0x8889, "", "IT8889F PCI to ISA Bridge" } ,
	{ 0x1283, 0xE886, "", "IT8330G" } ,
	{ 0x1285, 0x0100, "", "AGOGO sound chip (aka ESS Maestro 1)" } ,
	{ 0x1287, 0x001E, "", "LS220D DVD Decoder" } ,
	{ 0x1287, 0x001F, "", "LS220C DVD Decoder" } ,
	{ 0x128D, 0x0021, "", "ATM155 Adapter" } ,
	{ 0x128E, 0x0008, "", "ST128 WSS/SB" } ,
	{ 0x128E, 0x0009, "", "ST128 SAM9407" } ,
	{ 0x128E, 0x000A, "", "ST128 Game Port" } ,
	{ 0x128E, 0x000B, "", "ST128 MPU Port" } ,
	{ 0x128E, 0x000C, "", "ST128 Ctrl Port" } ,
	{ 0x129A, 0x0615, "", "PBT-615 PCI-X Bus Analyzer" } ,
	{ 0x12A3, 0x8105, "", "T8105 H100 Digital Switch" } ,
	{ 0x12AB, 0x0002, "", "AU8830 [Vortex2] Based Sound Card With A3D Support" } ,
	{ 0x12AB, 0x3000, "", "MPG-200C PCI DVD Decoder Card" } ,
	{ 0x12AE, 0x0001, "", "AceNIC Gigabit Ethernet" } ,
	{ 0x12AE, 0x0002, "", "AceNIC Gigabit Ethernet (Copper)" } ,
	{ 0x12AE, 0x00FA, "", "Farallon PN9100-T Gigabit Ethernet" } ,
	{ 0x12B9, 0x1006, "", "WinModem" } ,
	{ 0x12B9, 0x1007, "", "USR 56k Internal WinModem" } ,
	{ 0x12B9, 0x1008, "", "56K FaxModem Model 5610" } ,
	{ 0x12BE, 0x3041, "", "AN3041Q CO-MEM" } ,
	{ 0x12BE, 0x3042, "", "AN3042Q CO-MEM Lite" } ,
	{ 0x12C3, 0x0058, "", "PCI NE2K Ethernet" } ,
	{ 0x12C3, 0x5598, "", "PCI NE2K Ethernet" } ,
	{ 0x12C4, 0x0001, "", "Blue HEAT/PCI 8 (RS232/CL/RJ11)" } ,
	{ 0x12C4, 0x0002, "", "Blue HEAT/PCI 4 (RS232)" } ,
	{ 0x12C4, 0x0003, "", "Blue HEAT/PCI 2 (RS232)" } ,
	{ 0x12C4, 0x0004, "", "Blue HEAT/PCI 8 (UNIV, RS485)" } ,
	{ 0x12C4, 0x0005, "", "Blue HEAT/PCI 4+4/6+2 (UNIV, RS232/485)" } ,
	{ 0x12C4, 0x0006, "", "Blue HEAT/PCI 4 (OPTO, RS485)" } ,
	{ 0x12C4, 0x0007, "", "Blue HEAT/PCI 2+2 (RS232/485)" } ,
	{ 0x12C4, 0x0008, "", "Blue HEAT/PCI 2 (OPTO, Tx, RS485)" } ,
	{ 0x12C4, 0x0009, "", "Blue HEAT/PCI 2+6 (RS232/485)" } ,
	{ 0x12C4, 0x000A, "", "Blue HEAT/PCI 8 (Tx, RS485)" } ,
	{ 0x12C4, 0x000B, "", "Blue HEAT/PCI 4 (Tx, RS485)" } ,
	{ 0x12C4, 0x000C, "", "Blue HEAT/PCI 2 (20 MHz, RS485)" } ,
	{ 0x12C4, 0x000D, "", "Blue HEAT/PCI 2 PTM" } ,
	{ 0x12C4, 0x0100, "", "NT960/PCI" } ,
	{ 0x12C4, 0x0201, "", "cPCI Titan - 2 Port" } ,
	{ 0x12C4, 0x0202, "", "cPCI Titan - 4 Port" } ,
	{ 0x12C4, 0x0300, "", "CTI PCI UART 2 (RS232)" } ,
	{ 0x12C4, 0x0301, "", "CTI PCI UART 4 (RS232)" } ,
	{ 0x12C4, 0x0302, "", "CTI PCI UART 8 (RS232)" } ,
	{ 0x12C4, 0x0310, "", "CTI PCI UART 1+1 (RS232/485)" } ,
	{ 0x12C4, 0x0311, "", "CTI PCI UART 2+2 (RS232/485)" } ,
	{ 0x12C4, 0x0312, "", "CTI PCI UART 4+4 (RS232/485)" } ,
	{ 0x12C4, 0x0320, "", "CTI PCI UART 2" } ,
	{ 0x12C4, 0x0321, "", "CTI PCI UART 4" } ,
	{ 0x12C4, 0x0322, "", "CTI PCI UART 8" } ,
	{ 0x12C4, 0x0330, "", "CTI PCI UART 2 (RS485)" } ,
	{ 0x12C4, 0x0331, "", "CTI PCI UART 4 (RS485)" } ,
	{ 0x12C4, 0x0332, "", "CTI PCI UART 8 (RS485)" } ,
	{ 0x12C5, 0x007E, "", "Imaging/Scanning Subsystem Engine" } ,
	{ 0x12C5, 0x007F, "", "Imaging/Scanning Subsystem Engine" } ,
	{ 0x12C5, 0x0081, "", "PCIVST [Grayscale Thresholding Engine]" } ,
	{ 0x12C5, 0x0085, "", "Video Simulator/Sender" } ,
	{ 0x12C5, 0x0086, "", "THR2 Multi-scale Thresholder" } ,
	{ 0x12D2, 0x0008, "", "NV1" } ,
	{ 0x12D2, 0x0009, "", "DAC64" } ,
	{ 0x12D2, 0x0018, "", "Riva128" } ,
	{ 0x12D2, 0x0019, "", "Riva128ZX" } ,
	{ 0x12D2, 0x0020, "", "TNT" } ,
	{ 0x12D2, 0x0028, "", "TNT2" } ,
	{ 0x12D2, 0x0029, "", "UTNT2" } ,
	{ 0x12D2, 0x002C, "", "VTNT2" } ,
	{ 0x12D2, 0x00A0, "", "ITNT2" } ,
	{ 0x12D4, 0x0200, "", "T1 Card" } ,
	{ 0x12D5, 0x0003, "", "BSP16" } ,
	{ 0x12D5, 0x1000, "", "BSP15" } ,
	{ 0x12D8, 0x8150, "", "PCI to PCI Bridge" } ,
	{ 0x12D9, 0x0002, "", "PCI Prosody" } ,
	{ 0x12D9, 0x0004, "", "cPCI Prosody" } ,
	{ 0x12D9, 0x0005, "", "Aculab E1/T1 PCI card" } ,
	{ 0x12DE, 0x0200, "", "CryptoSwift CS200" } ,
	{ 0x12E0, 0x0010, "", "ST16C654 Quad UART" } ,
	{ 0x12E0, 0x0020, "", "ST16C654 Quad UART" } ,
	{ 0x12E0, 0x0030, "", "ST16C654 Quad UART" } ,
	{ 0x12EB, 0x0001, "", "Vortex 1" } ,
	{ 0x12EB, 0x0002, "", "Vortex 2" } ,
	{ 0x12EB, 0x0003, "", "AU8810 Vortex Digital Audio Processor" } ,
	{ 0x12EB, 0x8803, "", "Vortex 56k Software Modem" } ,
	{ 0x12F8, 0x0002, "", "VideoMaker" } ,
	{ 0x12FB, 0x0001, "", "PMC-MAI" } ,
	{ 0x12FB, 0x00F5, "", "F5 Dakar" } ,
	{ 0x12FB, 0x02AD, "", "PMC-2MAI" } ,
	{ 0x12FB, 0x2ADC, "", "ePMC-2ADC" } ,
	{ 0x12FB, 0x3100, "", "PRO-3100" } ,
	{ 0x12FB, 0x3500, "", "PRO-3500" } ,
	{ 0x12FB, 0x4D4F, "", "Modena" } ,
	{ 0x12FB, 0x8120, "", "ePMC-8120" } ,
	{ 0x12FB, 0xDA62, "", "Daytona C6201 PCI (Hurricane)" } ,
	{ 0x12FB, 0xDB62, "", "Ingliston XBIF" } ,
	{ 0x12FB, 0xDC62, "", "Ingliston PLX9054" } ,
	{ 0x12FB, 0xDD62, "", "Ingliston JTAG/ISP" } ,
	{ 0x12FB, 0xEDDC, "", "ePMC-MSDDC" } ,
	{ 0x12FB, 0xFA01, "", "ePMC-FPGA" } ,
	{ 0x1307, 0x0001, "", "PCI-DAS1602/16" } ,
	{ 0x1307, 0x000B, "", "PCI-DIO48H" } ,
	{ 0x1307, 0x000C, "", "PCI-PDISO8" } ,
	{ 0x1307, 0x000D, "", "PCI-PDISO16" } ,
	{ 0x1307, 0x000F, "", "PCI-DAS1200" } ,
	{ 0x1307, 0x0010, "", "PCI-DAS1602/12" } ,
	{ 0x1307, 0x0014, "", "PCI-DIO24H" } ,
	{ 0x1307, 0x0015, "", "PCI-DIO24H/CTR3" } ,
	{ 0x1307, 0x0016, "", "PCI-DIO48H/CTR15" } ,
	{ 0x1307, 0x0017, "", "PCI-DIO96H" } ,
	{ 0x1307, 0x0018, "", "PCI-CTR05" } ,
	{ 0x1307, 0x0019, "", "PCI-DAS1200/JR" } ,
	{ 0x1307, 0x001A, "", "PCI-DAS1001" } ,
	{ 0x1307, 0x001B, "", "PCI-DAS1002" } ,
	{ 0x1307, 0x001C, "", "PCI-DAS1602JR/16" } ,
	{ 0x1307, 0x001D, "", "PCI-DAS6402/16" } ,
	{ 0x1307, 0x001E, "", "PCI-DAS6402/12" } ,
	{ 0x1307, 0x001F, "", "PCI-DAS16/M1" } ,
	{ 0x1307, 0x0020, "", "PCI-DDA02/12" } ,
	{ 0x1307, 0x0021, "", "PCI-DDA04/12" } ,
	{ 0x1307, 0x0022, "", "PCI-DDA08/12" } ,
	{ 0x1307, 0x0023, "", "PCI-DDA02/16" } ,
	{ 0x1307, 0x0024, "", "PCI-DDA04/16" } ,
	{ 0x1307, 0x0025, "", "PCI-DDA08/16" } ,
	{ 0x1307, 0x0026, "", "PCI-DAC04/12-HS" } ,
	{ 0x1307, 0x0027, "", "PCI-DAC04/16-HS" } ,
	{ 0x1307, 0x0028, "", "PCI-DIO24" } ,
	{ 0x1307, 0x0029, "", "PCI-DAS08" } ,
	{ 0x1307, 0x002C, "", "PCI-INT32" } ,
	{ 0x1307, 0x0033, "", "PCI-DUAL-AC5" } ,
	{ 0x1307, 0x0034, "", "PCI-DAS-TC" } ,
	{ 0x1307, 0x0035, "", "PCI-DAS64/M1/16" } ,
	{ 0x1307, 0x0036, "", "PCI-DAS64/M2/16" } ,
	{ 0x1307, 0x0037, "", "PCI-DAS64/M3/16" } ,
	{ 0x1307, 0x004C, "", "PCI-DAS1000" } ,
	{ 0x1307, 0x004D, "", "PCI-QUAD04" } ,
	{ 0x1307, 0x0052, "", "PCI-DAS4020/12" } ,
	{ 0x1307, 0x0054, "", "PCI-DIO96" } ,
	{ 0x1307, 0x005E, "", "PCI-DAS6025" } ,
	{ 0x1308, 0x0001, "", "NetCelerator Adapter" } ,
	{ 0x1317, 0x0981, "", "21x4x DEC-Tulip compatible 10/100 Ethernet" } ,
	{ 0x1317, 0x0985, "", "NC100 Network Everywhere Fast Ethernet 10/100" } ,
	{ 0x1317, 0x1985, "", "21x4x DEC-Tulip compatible 10/100 Ethernet" } ,
	{ 0x1317, 0x2850, "", "HSP MicroModem 56" } ,
	{ 0x1317, 0x8201, "", "ADMtek ADM8211 802.11b Wireless Interface" } ,
	{ 0x1317, 0x8211, "", "ADMtek ADM8211 802.11b Wireless Interface" } ,
	{ 0x1317, 0x9511, "", "21x4x DEC-Tulip compatible 10/100 Ethernet" } ,
	{ 0x1318, 0x0911, "", "GNIC-II PCI Gigabit Ethernet [Hamachi]" } ,
	{ 0x1319, 0x0801, "", "Xwave QS3000A [FM801]" } ,
	{ 0x1319, 0x0802, "", "Xwave QS3000A [FM801 game port]" } ,
	{ 0x1319, 0x1000, "", "FM801 PCI Audio" } ,
	{ 0x1319, 0x1001, "", "FM801 PCI Joystick" } ,
	{ 0x131F, 0x1000, "", "CyberSerial (1-port) 16550" } ,
	{ 0x131F, 0x1001, "", "CyberSerial (1-port) 16650" } ,
	{ 0x131F, 0x1002, "", "CyberSerial (1-port) 16850" } ,
	{ 0x131F, 0x1010, "", "Duet 1S(16550)+1P" } ,
	{ 0x131F, 0x1011, "", "Duet 1S(16650)+1P" } ,
	{ 0x131F, 0x1012, "", "Duet 1S(16850)+1P" } ,
	{ 0x131F, 0x1020, "", "CyberParallel (1-port)" } ,
	{ 0x131F, 0x1021, "", "CyberParallel (2-port)" } ,
	{ 0x131F, 0x1030, "", "CyberSerial (2-port) 16550" } ,
	{ 0x131F, 0x1031, "", "CyberSerial (2-port) 16650" } ,
	{ 0x131F, 0x1032, "", "CyberSerial (2-port) 16850" } ,
	{ 0x131F, 0x1034, "", "Trio 2S(16550)+1P" } ,
	{ 0x131F, 0x1035, "", "Trio 2S(16650)+1P" } ,
	{ 0x131F, 0x1036, "", "Trio 2S(16850)+1P" } ,
	{ 0x131F, 0x1050, "", "CyberSerial (4-port) 16550" } ,
	{ 0x131F, 0x1051, "", "CyberSerial (4-port) 16650" } ,
	{ 0x131F, 0x1052, "", "CyberSerial (4-port) 16850" } ,
	{ 0x131F, 0x2000, "", "CyberSerial (1-port) 16550" } ,
	{ 0x131F, 0x2001, "", "CyberSerial (1-port) 16650" } ,
	{ 0x131F, 0x2002, "", "CyberSerial (1-port) 16850" } ,
	{ 0x131F, 0x2010, "", "Duet 1S(16550)+1P" } ,
	{ 0x131F, 0x2011, "", "Duet 1S(16650)+1P" } ,
	{ 0x131F, 0x2012, "", "Duet 1S(16850)+1P" } ,
	{ 0x131F, 0x2020, "", "CyberParallel (1-port)" } ,
	{ 0x131F, 0x2021, "", "CyberParallel (2-port)" } ,
	{ 0x131F, 0x2030, "", "CyberSerial (2-port) 16550" } ,
	{ 0x131F, 0x2031, "", "CyberSerial (2-port) 16650" } ,
	{ 0x131F, 0x2032, "", "CyberSerial (2-port) 16850" } ,
	{ 0x131F, 0x2040, "", "Trio 1S(16550)+2P" } ,
	{ 0x131F, 0x2041, "", "Trio 1S(16650)+2P" } ,
	{ 0x131F, 0x2042, "", "Trio 1S(16850)+2P" } ,
	{ 0x131F, 0x2050, "", "CyberSerial (4-port) 16550" } ,
	{ 0x131F, 0x2051, "", "CyberSerial (4-port) 16650" } ,
	{ 0x131F, 0x2052, "", "CyberSerial (4-port) 16850" } ,
	{ 0x131F, 0x2060, "", "Trio 2S(16550)+1P" } ,
	{ 0x131F, 0x2061, "", "Trio 2S(16650)+1P" } ,
	{ 0x131F, 0x2062, "", "Trio 2S(16850)+1P" } ,
	{ 0x131F, 0x2081, "", "CyberSerial (8-port) ST16654" } ,
	{ 0x1331, 0x0030, "", "ENP-2611" } ,
	{ 0x1331, 0x8200, "", "82600 Host Bridge" } ,
	{ 0x1331, 0x8201, "", "82600 IDE" } ,
	{ 0x1331, 0x8202, "", "82600 USB" } ,
	{ 0x1331, 0x8210, "", "82600 PCI Bridge" } ,
	{ 0x1332, 0x5415, "", "MM-5415CN PCI Memory Module with Battery Backup" } ,
	{ 0x1332, 0x5425, "", "MM-5425CN PCI 64/66 Memory Module with Battery Backup" } ,
	{ 0x1332, 0x6140, "", "MM-6140D" } ,
	{ 0x134A, 0x0001, "", "Domex 536" } ,
	{ 0x134A, 0x0002, "", "Domex DMX3194UP SCSI Adapter" } ,
	{ 0x134D, 0x2189, "", "HSP56 MicroModem" } ,
	{ 0x134D, 0x2486, "", "2304WT V.92 MDC Modem" } ,
	{ 0x134D, 0x7890, "", "HSP MicroModem 56" } ,
	{ 0x134D, 0x7891, "", "HSP MicroModem 56" } ,
	{ 0x134D, 0x7892, "", "HSP MicroModem 56" } ,
	{ 0x134D, 0x7893, "", "HSP MicroModem 56" } ,
	{ 0x134D, 0x7894, "", "HSP MicroModem 56" } ,
	{ 0x134D, 0x7895, "", "HSP MicroModem 56" } ,
	{ 0x134D, 0x7896, "", "HSP MicroModem 56" } ,
	{ 0x134D, 0x7897, "", "HSP MicroModem 56" } ,
	{ 0x1353, 0x0002, "", "Proserver" } ,
	{ 0x1353, 0x0003, "", "PCI-FUT" } ,
	{ 0x1353, 0x0004, "", "PCI-S0" } ,
	{ 0x1353, 0x0005, "", "PCI-FUT-S0" } ,
	{ 0x135C, 0x0010, "", "QSC-100" } ,
	{ 0x135C, 0x0020, "", "DSC-100" } ,
	{ 0x135C, 0x0030, "", "DSC-200/300" } ,
	{ 0x135C, 0x0040, "", "QSC-200/300" } ,
	{ 0x135C, 0x0050, "", "ESC-100D" } ,
	{ 0x135C, 0x0060, "", "ESC-100M" } ,
	{ 0x135C, 0x00F0, "", "MPAC-100 Syncronous Serial Card (Zilog 85230)" } ,
	{ 0x135C, 0x0170, "", "QSCLP-100" } ,
	{ 0x135C, 0x0180, "", "DSCLP-100" } ,
	{ 0x135C, 0x0190, "", "SSCLP-100" } ,
	{ 0x135C, 0x01A0, "", "QSCLP-200/300" } ,
	{ 0x135C, 0x01B0, "", "DSCLP-200/300" } ,
	{ 0x135C, 0x01C0, "", "SSCLP-200/300" } ,
	{ 0x135E, 0x5101, "", "Route 56.PCI - Multi-Protocol Serial Interface (Zilog Z16C32)" } ,
	{ 0x135E, 0x7101, "", "Single Port RS-232/422/485/530" } ,
	{ 0x135E, 0x7201, "", "Dual Port RS-232/422/485 Interface" } ,
	{ 0x135E, 0x7202, "", "Dual Port RS-232 Interface" } ,
	{ 0x135E, 0x7401, "", "Four Port RS-232 Interface" } ,
	{ 0x135E, 0x7402, "", "Four Port RS-422/485 Interface" } ,
	{ 0x135E, 0x7801, "", "Eight Port RS-232 Interface" } ,
	{ 0x135E, 0x8001, "", "8001 Digital I/O Adapter" } ,
	{ 0x1360, 0x0101, "", "PCI32 DCF77 Radio Clock" } ,
	{ 0x1360, 0x0102, "", "PCI509 DCF77 Radio Clock" } ,
	{ 0x1360, 0x0103, "", "PCI510 DCF77 Radio Clock" } ,
	{ 0x1360, 0x0201, "", "GPS167PCI GPS Receiver" } ,
	{ 0x1360, 0x0202, "", "GPS168PCI GPS Receiver" } ,
	{ 0x1360, 0x0203, "", "GPS169PCI GPS Receiver" } ,
	{ 0x1360, 0x0301, "", "TCR510PCI IRIG Timecode Reader" } ,
	{ 0x1360, 0x0302, "", "TCR167PCI IRIG Timecode Reader" } ,
	{ 0x136B, 0xFF01, "", "KL5A72002 Motion JPEG" } ,
	{ 0x1371, 0x434E, "", "GigaCard Network Adapter" } ,
	{ 0x137A, 0x0001, "", "PCI-324 Audiowire Interface" } ,
	{ 0x1382, 0x0001, "", "ARC88 audio recording card" } ,
	{ 0x1382, 0x2008, "", "Prodif 96 Pro sound system" } ,
	{ 0x1382, 0x2088, "", "Marc 8 Midi sound system" } ,
	{ 0x1382, 0x20C8, "", "Marc A sound system" } ,
	{ 0x1382, 0x4008, "", "Marc 2 sound system" } ,
	{ 0x1382, 0x4010, "", "Marc 2 Pro sound system" } ,
	{ 0x1382, 0x4048, "", "Marc 4 MIDI sound system" } ,
	{ 0x1382, 0x4088, "", "Marc 4 Digi sound system" } ,
	{ 0x1382, 0x4248, "", "Marc X sound system" } ,
	{ 0x1385, 0x0013, "", "WG311T" } ,
	{ 0x1385, 0x311A, "", "GA511 Gigabit Ethernet" } ,
	{ 0x1385, 0x4100, "", "802.11b Wireless Adapter (MA301)" } ,
	{ 0x1385, 0x4105, "", "MA311 802.11b wireless adapter" } ,
	{ 0x1385, 0x4400, "", "WAG511 802.11a/b/g Dual Band Wireless PC Card" } ,
	{ 0x1385, 0x4600, "", "WAG511 802.11a/b/g Dual Band Wireless PC Card" } ,
	{ 0x1385, 0x4601, "", "WAG511 802.11a/b/g Dual Band Wireless PC Card" } ,
	{ 0x1385, 0x4610, "", "WAG511 802.11a/b/g Dual Band Wireless PC Card" } ,
	{ 0x1385, 0x4A00, "", "WAG311 802.11a/g Wireless PCI Adapter" } ,
	{ 0x1385, 0x4C00, "", "WG311v2 54 Mbps Wireless PCI Adapter" } ,
	{ 0x1385, 0x620A, "", "GA620 Gigabit Ethernet" } ,
	{ 0x1385, 0x622A, "", "GA622" } ,
	{ 0x1385, 0x630A, "", "GA630 Gigabit Ethernet" } ,
	{ 0x1385, 0xF004, "", "FA310TX" } ,
	{ 0x1389, 0x0001, "", "PCI1500PFB [Intelligent fieldbus adaptor]" } ,
	{ 0x1393, 0x1040, "", "Smartio C104H/PCI" } ,
	{ 0x1393, 0x1141, "", "Industrio CP-114" } ,
	{ 0x1393, 0x1680, "", "Smartio C168H/PCI" } ,
	{ 0x1393, 0x2040, "", "Intellio CP-204J" } ,
	{ 0x1393, 0x2180, "", "Intellio C218 Turbo PCI" } ,
	{ 0x1393, 0x3200, "", "Intellio C320 Turbo PCI" } ,
	{ 0x1394, 0x0001, "", "LXT1001 Gigabit Ethernet" } ,
	{ 0x1397, 0x16B8, "", "ISDN network Controller [HFC-8S]" } ,
	{ 0x1397, 0x2BD0, "", "ISDN network controller [HFC-PCI]" } ,
	{ 0x139A, 0x0001, "", "Quad Port 10/100 Server Accelerator" } ,
	{ 0x139A, 0x0003, "", "Single Port 10/100 Server Accelerator" } ,
	{ 0x139A, 0x0005, "", "Single Port Gigabit Server Accelerator" } ,
	{ 0x13A3, 0x0005, "", "7751 Security Processor" } ,
	{ 0x13A3, 0x0006, "", "6500 Public Key Processor" } ,
	{ 0x13A3, 0x0007, "", "7811 Security Processor" } ,
	{ 0x13A3, 0x0012, "", "7951 Security Processor" } ,
	{ 0x13A3, 0x0014, "", "78XX Security Processor" } ,
	{ 0x13A3, 0x0016, "", "8065 Security Processor" } ,
	{ 0x13A3, 0x0017, "", "8165 Security Processor" } ,
	{ 0x13A3, 0x0018, "", "8154 Security Processor" } ,
	{ 0x13A3, 0x001D, "", "7956 Security Processor" } ,
	{ 0x13A3, 0x0020, "", "7955 Security Processor" } ,
	{ 0x13A3, 0x0026, "", "8155 Security Processor" } ,
	{ 0x13A8, 0x0152, "", "XR17C/D152 Dual PCI UART" } ,
	{ 0x13A8, 0x0154, "", "XR17C154 Quad UART" } ,
	{ 0x13A8, 0x0158, "", "XR17C158 Octal UART" } ,
	{ 0x13C0, 0x0010, "", "SyncLink Adapter v1" } ,
	{ 0x13C0, 0x0020, "", "SyncLink SCC Adapter" } ,
	{ 0x13C0, 0x0030, "", "SyncLink Multiport Adapter" } ,
	{ 0x13C0, 0x0210, "", "SyncLink Adapter v2" } ,
	{ 0x13C1, 0x1000, "", "5xxx/6xxx-series PATA-RAID" } ,
	{ 0x13C1, 0x1001, "", "7xxx/8xxx-series PATA/SATA-RAID" } ,
	{ 0x13C1, 0x1002, "", "9xxx-series SATA-RAID" } ,
	{ 0x13C6, 0x0520, "", "CEI-520 A429 Card" } ,
	{ 0x13C6, 0x0620, "", "CEI-620 A429 Card" } ,
	{ 0x13C6, 0x0820, "", "CEI-820 A429 Card" } ,
	{ 0x13D0, 0x2103, "", "B2C2 FlexCopII DVB chip / Technisat SkyStar2 DVB card" } ,
	{ 0x13D0, 0x2200, "", "B2C2 FlexCopIII DVB chip / Technisat SkyStar2 DVB card" } ,
	{ 0x13D1, 0xAB02, "", "ADMtek Centaur-C rev 17 [D-Link DFE-680TX] CardBus Fast Ethernet Adapter" } ,
	{ 0x13D1, 0xAB03, "", "21x4x DEC-Tulip compatible 10/100 Ethernet" } ,
	{ 0x13D1, 0xAB06, "", "RTL8139 [FE2000VX] CardBus Fast Ethernet Attached Port Adapter" } ,
	{ 0x13D1, 0xAB08, "", "21x4x DEC-Tulip compatible 10/100 Ethernet" } ,
	{ 0x13DF, 0x0001, "", "PCI56RVP Modem" } ,
	{ 0x13F0, 0x0201, "", "ST201 Sundance Ethernet" } ,
	{ 0x13F0, 0x1023, "", "IC Plus IP1000 Family Gigabit Ethernet" } ,
	{ 0x13F4, 0x1401, "", "Zentai Fibre Channel Adapter" } ,
	{ 0x13F6, 0x0011, "", "CMI8738" } ,
	{ 0x13F6, 0x0100, "", "CM8338A" } ,
	{ 0x13F6, 0x0101, "", "CM8338B" } ,
	{ 0x13F6, 0x0111, "", "CM8738" } ,
	{ 0x13F6, 0x0211, "", "CM8738" } ,
	{ 0x13FE, 0x1240, "", "PCI-1240 4-channel stepper motor controller card" } ,
	{ 0x13FE, 0x1600, "", "PCI-1612 4-port RS-232/422/485 PCI communication card" } ,
	{ 0x13FE, 0x1733, "", "PCI-1733 32-channel isolated digital input card" } ,
	{ 0x13FE, 0x1752, "", "PCI-1752" } ,
	{ 0x13FE, 0x1754, "", "PCI-1754" } ,
	{ 0x13FE, 0x1756, "", "PCI-1756" } ,
	{ 0x1400, 0x1401, "", "9432 TX" } ,
	{ 0x1407, 0x0100, "", "Lava Dual Serial" } ,
	{ 0x1407, 0x0101, "", "Lava Quatro A" } ,
	{ 0x1407, 0x0102, "", "Lava Quatro B" } ,
	{ 0x1407, 0x0110, "", "Lava DSerial-PCI Port A" } ,
	{ 0x1407, 0x0111, "", "Lava DSerial-PCI Port B" } ,
	{ 0x1407, 0x0120, "", "Quattro-PCI A" } ,
	{ 0x1407, 0x0121, "", "Quattro-PCI B" } ,
	{ 0x1407, 0x0180, "", "Lava Octo A" } ,
	{ 0x1407, 0x0181, "", "Lava Octo B" } ,
	{ 0x1407, 0x0200, "", "Lava Port Plus" } ,
	{ 0x1407, 0x0201, "", "Lava Quad A" } ,
	{ 0x1407, 0x0202, "", "Lava Quad B" } ,
	{ 0x1407, 0x0220, "", "Lava Quattro PCI Ports A/B" } ,
	{ 0x1407, 0x0221, "", "Lava Quattro PCI Ports C/D" } ,
	{ 0x1407, 0x0500, "", "Lava Single Serial" } ,
	{ 0x1407, 0x0600, "", "Lava Port 650" } ,
	{ 0x1407, 0x8000, "", "Lava Parallel" } ,
	{ 0x1407, 0x8001, "", "Dual parallel port controller A" } ,
	{ 0x1407, 0x8002, "", "Lava Dual Parallel port A" } ,
	{ 0x1407, 0x8003, "", "Lava Dual Parallel port B" } ,
	{ 0x1407, 0x8800, "", "BOCA Research IOPPAR" } ,
	{ 0x1409, 0x7168, "", "PCI2S550 (Dual 16550 UART)" } ,
	{ 0x1412, 0x1712, "", "ICE1712 [Envy24] PCI Multi-Channel I/O Controller" } ,
	{ 0x1412, 0x1724, "", "VT1720/24 [Envy24PT/HT] PCI Multi-Channel Audio Controller" } ,
	{ 0x1415, 0x8403, "", "VScom 011H-EP1 1 port parallel adaptor" } ,
	{ 0x1415, 0x9501, "", "OX16PCI954 (Quad 16950 UART) function 0" } ,
	{ 0x1415, 0x950A, "", "EXSYS EX-41092 Dual 16950 Serial adapter" } ,
	{ 0x1415, 0x950B, "", "OXCB950 Cardbus 16950 UART" } ,
	{ 0x1415, 0x9510, "", "OX16PCI954 (Quad 16950 UART) function 1 (Disabled)" } ,
	{ 0x1415, 0x9511, "", "OX16PCI954 (Quad 16950 UART) function 1" } ,
	{ 0x1415, 0x9521, "", "OX16PCI952 (Dual 16950 UART)" } ,
	{ 0x1415, 0x9523, "", "OX16PCI952 Integrated Parallel Port" } ,
	{ 0x1420, 0x8002, "", "Gold Card NetGlobal 56k+10/100Mb CardBus (Ethernet part)" } ,
	{ 0x1420, 0x8003, "", "Gold Card NetGlobal 56k+10/100Mb CardBus (Modem part)" } ,
	{ 0x142E, 0x4020, "", "VM2-2 [Video Maker 2] MPEG1/2 Encoder" } ,
	{ 0x1432, 0x9130, "", "RTL81xx Fast Ethernet" } ,
	{ 0x144A, 0x7296, "", "PCI-7296" } ,
	{ 0x144A, 0x7432, "", "PCI-7432" } ,
	{ 0x144A, 0x7433, "", "PCI-7433" } ,
	{ 0x144A, 0x7434, "", "PCI-7434" } ,
	{ 0x144A, 0x7841, "", "PCI-7841" } ,
	{ 0x144A, 0x8133, "", "PCI-8133" } ,
	{ 0x144A, 0x8164, "", "PCI-8164" } ,
	{ 0x144A, 0x8554, "", "PCI-8554" } ,
	{ 0x144A, 0x9111, "", "PCI-9111" } ,
	{ 0x144A, 0x9113, "", "PCI-9113" } ,
	{ 0x144A, 0x9114, "", "PCI-9114" } ,
	{ 0x1458, 0x0C11, "", "K8NS Pro Mainboard" } ,
	{ 0x145F, 0x0001, "", "NextMove PCI" } ,
	{ 0x1462, 0x6819, "", "Broadcom Corporation BCM4306 802.11b/g Wireless LAN Controller [MSI CB54G]" } ,
	{ 0x1462, 0x6825, "", "PCI Card wireless 11g [PC54G]" } ,
	{ 0x1462, 0x8725, "", "NVIDIA NV25 [GeForce4 Ti 4600] VGA Adapter" } ,
	{ 0x1462, 0x9000, "", "NVIDIA NV28 [GeForce4 Ti 4800] VGA Adapter" } ,
	{ 0x1462, 0x9110, "", "GeFORCE FX5200" } ,
	{ 0x1462, 0x9119, "", "NVIDIA NV31 [GeForce FX 5600XT] VGA Adapter" } ,
	{ 0x1462, 0x9591, "", "nVidia Corporation NV36 [GeForce FX 5700LE]" } ,
	{ 0x146C, 0x1430, "", "FE-1430TX Fast Ethernet PCI Adapter" } ,
	{ 0x148D, 0x1003, "", "HCF 56k Data/Fax Modem" } ,
	{ 0x1497, 0x1497, "", "SMA Technologie AG" } ,
	{ 0x1498, 0x30C8, "", "TPCI200" } ,
	{ 0x149D, 0x0001, "", "Video Toaster for PC" } ,
	{ 0x14AF, 0x7102, "", "3D Prophet II MX" } ,
	{ 0x14B3, 0x0000, "", "DSL NIC" } ,
	{ 0x14B5, 0x0200, "", "Scope" } ,
	{ 0x14B5, 0x0300, "", "Pulsar" } ,
	{ 0x14B5, 0x0400, "", "PulsarSRB" } ,
	{ 0x14B5, 0x0600, "", "Pulsar2" } ,
	{ 0x14B5, 0x0800, "", "DSP-Board" } ,
	{ 0x14B5, 0x0900, "", "DSP-Board" } ,
	{ 0x14B5, 0x0A00, "", "DSP-Board" } ,
	{ 0x14B5, 0x0B00, "", "DSP-Board" } ,
	{ 0x14B7, 0x0001, "", "Symphony 4110" } ,
	{ 0x14B9, 0x0001, "", "PC4800" } ,
	{ 0x14B9, 0x0340, "", "PC4800" } ,
	{ 0x14B9, 0x0350, "", "PC4800" } ,
	{ 0x14B9, 0x4500, "", "PC4500" } ,
	{ 0x14B9, 0x4800, "", "Cisco Aironet 340 802.11b Wireless LAN Adapter/Aironet PC4800" } ,
	{ 0x14B9, 0xA504, "", "Cisco Aironet Wireless 802.11b" } ,
	{ 0x14B9, 0xA505, "", "Cisco Aironet CB20a 802.11a Wireless LAN Adapter" } ,
	{ 0x14B9, 0xA506, "", "Cisco Aironet Mini PCI b/g" } ,
	{ 0x14C1, 0x8043, "", "Myrinet 2000 Scalable Cluster Interconnect" } ,
	{ 0x14D2, 0x8001, "", "VScom 010L 1 port parallel adaptor" } ,
	{ 0x14D2, 0x8002, "", "VScom 020L 2 port parallel adaptor" } ,
	{ 0x14D2, 0x8010, "", "VScom 100L 1 port serial adaptor" } ,
	{ 0x14D2, 0x8011, "", "VScom 110L 1 port serial and 1 port parallel adaptor" } ,
	{ 0x14D2, 0x8020, "", "VScom 200L 1 port serial adaptor" } ,
	{ 0x14D2, 0x8021, "", "VScom 210L 2 port serial and 1 port parallel adaptor" } ,
	{ 0x14D2, 0x8040, "", "VScom 400L 4 port serial adaptor" } ,
	{ 0x14D2, 0x8080, "", "VScom 800L 8 port serial adaptor" } ,
	{ 0x14D2, 0xA000, "", "VScom 010H 1 port parallel adaptor" } ,
	{ 0x14D2, 0xA001, "", "VScom 100H 1 port serial adaptor" } ,
	{ 0x14D2, 0xA003, "", "VScom 400H 4 port serial adaptor" } ,
	{ 0x14D2, 0xA004, "", "VScom 400HF1 4 port serial adaptor" } ,
	{ 0x14D2, 0xA005, "", "VScom 200H 2 port serial adaptor" } ,
	{ 0x14D2, 0xE001, "", "VScom 010HV2 1 port parallel adaptor" } ,
	{ 0x14D2, 0xE010, "", "VScom 100HV2 1 port serial adaptor" } ,
	{ 0x14D2, 0xE020, "", "VScom 200HV2 2 port serial adaptor" } ,
	{ 0x14D9, 0x0010, "", "AP1011/SP1011 HyperTransport-PCI Bridge [Sturgeon]" } ,
	{ 0x14D9, 0x9000, "", "AS90L10204/10208 HyperTransport to PCI-X Bridge" } ,
	{ 0x14DB, 0x2120, "", "TK9902" } ,
	{ 0x14DC, 0x0000, "", "PCI230" } ,
	{ 0x14DC, 0x0001, "", "PCI242" } ,
	{ 0x14DC, 0x0002, "", "PCI244" } ,
	{ 0x14DC, 0x0003, "", "PCI247" } ,
	{ 0x14DC, 0x0004, "", "PCI248" } ,
	{ 0x14DC, 0x0005, "", "PCI249" } ,
	{ 0x14DC, 0x0006, "", "PCI260" } ,
	{ 0x14DC, 0x0007, "", "PCI224" } ,
	{ 0x14DC, 0x0008, "", "PCI234" } ,
	{ 0x14DC, 0x0009, "", "PCI236" } ,
	{ 0x14DC, 0x000A, "", "PCI272" } ,
	{ 0x14DC, 0x000B, "", "PCI215" } ,
	{ 0x14E4, 0x0800, "", "Sentry5 Chipcommon I/O Controller" } ,
	{ 0x14E4, 0x0804, "", "Sentry5 PCI Bridge" } ,
	{ 0x14E4, 0x0805, "", "Sentry5 MIPS32 CPU" } ,
	{ 0x14E4, 0x0806, "", "Sentry5 Ethernet Controller" } ,
	{ 0x14E4, 0x080B, "", "Sentry5 Crypto Accelerator" } ,
	{ 0x14E4, 0x080F, "", "Sentry5 DDR/SDR RAM Controller" } ,
	{ 0x14E4, 0x0811, "", "Sentry5 External Interface Core" } ,
	{ 0x14E4, 0x0816, "", "BCM3302 Sentry5 MIPS32 CPU" } ,
	{ 0x14E4, 0x1600, "", "NetXtreme BCM5752 Gigabit Ethernet PCI Express" } ,
	{ 0x14E4, 0x1601, "", "NetXtreme BCM5752M Gigabit Ethernet PCI Express" } ,
	{ 0x14E4, 0x1644, "", "NetXtreme BCM5700 Gigabit Ethernet" } ,
	{ 0x14E4, 0x1645, "", "NetXtreme BCM5701 Gigabit Ethernet" } ,
	{ 0x14E4, 0x1646, "", "NetXtreme BCM5702 Gigabit Ethernet" } ,
	{ 0x14E4, 0x1647, "", "NetXtreme BCM5703 Gigabit Ethernet" } ,
	{ 0x14E4, 0x1648, "", "NetXtreme BCM5704 Gigabit Ethernet" } ,
	{ 0x14E4, 0x164A, "", "NetXtreme II BCM5706 Gigabit Ethernet" } ,
	{ 0x14E4, 0x164D, "", "NetXtreme BCM5702FE Gigabit Ethernet" } ,
	{ 0x14E4, 0x1653, "", "NetXtreme BCM5705 Gigabit Ethernet" } ,
	{ 0x14E4, 0x1654, "", "NetXtreme BCM5705_2 Gigabit Ethernet" } ,
	{ 0x14E4, 0x1659, "", "NetXtreme BCM5721 Gigabit Ethernet PCI Express" } ,
	{ 0x14E4, 0x165D, "", "NetXtreme BCM5705M Gigabit Ethernet" } ,
	{ 0x14E4, 0x165E, "", "NetXtreme BCM5705M_2 Gigabit Ethernet" } ,
	{ 0x14E4, 0x166A, "", "NetXtreme BCM5780 Gigabit Ethernet" } ,
	{ 0x14E4, 0x166B, "", "NetXtreme BCM5780S Gigabit Ethernet" } ,
	{ 0x14E4, 0x166E, "", "570x 10/100 Integrated Controller" } ,
	{ 0x14E4, 0x1677, "", "NetXtreme BCM5751 Gigabit Ethernet PCI Express" } ,
	{ 0x14E4, 0x167D, "", "NetXtreme BCM5751M Gigabit Ethernet PCI Express" } ,
	{ 0x14E4, 0x167E, "", "NetXtreme BCM5751F Fast Ethernet PCI Express" } ,
	{ 0x14E4, 0x1696, "", "NetXtreme BCM5782 Gigabit Ethernet" } ,
	{ 0x14E4, 0x169C, "", "NetXtreme BCM5788 Gigabit Ethernet" } ,
	{ 0x14E4, 0x169D, "", "NetLink BCM5789 Gigabit Ethernet PCI Express" } ,
	{ 0x14E4, 0x16A6, "", "NetXtreme BCM5702X Gigabit Ethernet" } ,
	{ 0x14E4, 0x16A7, "", "NetXtreme BCM5703X Gigabit Ethernet" } ,
	{ 0x14E4, 0x16A8, "", "NetXtreme BCM5704S Gigabit Ethernet" } ,
	{ 0x14E4, 0x16AA, "", "NetXtreme II BCM5706S Gigabit Ethernet" } ,
	{ 0x14E4, 0x16C6, "", "NetXtreme BCM5702A3 Gigabit Ethernet" } ,
	{ 0x14E4, 0x16C7, "", "NetXtreme BCM5703 Gigabit Ethernet" } ,
	{ 0x14E4, 0x16DD, "", "NetLink BCM5781 Gigabit Ethernet PCI Express" } ,
	{ 0x14E4, 0x16F7, "", "NetXtreme BCM5753 Gigabit Ethernet PCI Express" } ,
	{ 0x14E4, 0x16FD, "", "NetXtreme BCM5753M Gigabit Ethernet PCI Express" } ,
	{ 0x14E4, 0x16FE, "", "NetXtreme BCM5753F Fast Ethernet PCI Express" } ,
	{ 0x14E4, 0x170C, "", "BCM4401-B0 100Base-TX" } ,
	{ 0x14E4, 0x170D, "", "NetXtreme BCM5901 100Base-TX" } ,
	{ 0x14E4, 0x170E, "", "NetXtreme BCM5901 100Base-TX" } ,
	{ 0x14E4, 0x3352, "", "BCM3352" } ,
	{ 0x14E4, 0x3360, "", "BCM3360" } ,
	{ 0x14E4, 0x4210, "", "BCM4210 iLine10 HomePNA 2.0" } ,
	{ 0x14E4, 0x4211, "", "BCM4211 iLine10 HomePNA 2.0 + V.90 56k modem" } ,
	{ 0x14E4, 0x4212, "", "BCM4212 v.90 56k modem" } ,
	{ 0x14E4, 0x4301, "", "BCM4303 802.11b Wireless LAN Controller" } ,
	{ 0x14E4, 0x4305, "", "BCM4307 V.90 56k Modem" } ,
	{ 0x14E4, 0x4306, "", "BCM4307 Ethernet Controller" } ,
	{ 0x14E4, 0x4307, "", "BCM4307 802.11b Wireless LAN Controller" } ,
	{ 0x14E4, 0x4310, "", "BCM4310 Chipcommon I/OController" } ,
	{ 0x14E4, 0x4312, "", "BCM4310 UART" } ,
	{ 0x14E4, 0x4313, "", "BCM4310 Ethernet Controller" } ,
	{ 0x14E4, 0x4315, "", "BCM4310 USB Controller" } ,
	{ 0x14E4, 0x4318, "", "BCM4318 [AirForce One 54g] 802.11g Wireless LAN Controller" } ,
	{ 0x14E4, 0x4320, "", "BCM4306 802.11b/g Wireless LAN Controller" } ,
	{ 0x14E4, 0x4321, "", "BCM4306 802.11a Wireless LAN Controller" } ,
	{ 0x14E4, 0x4322, "", "BCM4306 UART" } ,
	{ 0x14E4, 0x4324, "", "BCM4309 802.11a/b/g" } ,
	{ 0x14E4, 0x4325, "", "BCM43xG 802.11b/g" } ,
	{ 0x14E4, 0x4326, "", "BCM4307 Chipcommon I/O Controller?" } ,
	{ 0x14E4, 0x4401, "", "BCM4401 100Base-T" } ,
	{ 0x14E4, 0x4402, "", "BCM4402 Integrated 10/100BaseT" } ,
	{ 0x14E4, 0x4403, "", "BCM4402 V.90 56k Modem" } ,
	{ 0x14E4, 0x4410, "", "BCM4413 iLine32 HomePNA 2.0" } ,
	{ 0x14E4, 0x4411, "", "BCM4413 V.90 56k modem" } ,
	{ 0x14E4, 0x4412, "", "BCM4412 10/100BaseT" } ,
	{ 0x14E4, 0x4430, "", "BCM44xx CardBus iLine32 HomePNA 2.0" } ,
	{ 0x14E4, 0x4432, "", "BCM4432 CardBus 10/100BaseT" } ,
	{ 0x14E4, 0x4610, "", "BCM4610 Sentry5 PCI to SB Bridge" } ,
	{ 0x14E4, 0x4611, "", "BCM4610 Sentry5 iLine32 HomePNA 1.0" } ,
	{ 0x14E4, 0x4612, "", "BCM4610 Sentry5 V.90 56k Modem" } ,
	{ 0x14E4, 0x4613, "", "BCM4610 Sentry5 Ethernet Controller" } ,
	{ 0x14E4, 0x4614, "", "BCM4610 Sentry5 External Interface" } ,
	{ 0x14E4, 0x4615, "", "BCM4610 Sentry5 USB Controller" } ,
	{ 0x14E4, 0x4704, "", "BCM4704 PCI to SB Bridge" } ,
	{ 0x14E4, 0x4705, "", "BCM4704 Sentry5 802.11b Wireless LAN Controller" } ,
	{ 0x14E4, 0x4706, "", "BCM4704 Sentry5 Ethernet Controller" } ,
	{ 0x14E4, 0x4707, "", "BCM4704 Sentry5 USB Controller" } ,
	{ 0x14E4, 0x4708, "", "BCM4704 Crypto Accelerator" } ,
	{ 0x14E4, 0x4710, "", "BCM4710 Sentry5 PCI to SB Bridge" } ,
	{ 0x14E4, 0x4711, "", "BCM47xx Sentry5 iLine32 HomePNA 2.0" } ,
	{ 0x14E4, 0x4712, "", "BCM47xx V.92 56k modem" } ,
	{ 0x14E4, 0x4713, "", "Sentry5 Ethernet Controller" } ,
	{ 0x14E4, 0x4714, "", "BCM47xx Sentry5 External Interface" } ,
	{ 0x14E4, 0x4715, "", "Sentry5 USB Controller" } ,
	{ 0x14E4, 0x4716, "", "BCM47xx Sentry5 USB Host Controller" } ,
	{ 0x14E4, 0x4717, "", "BCM47xx Sentry5 USB Device Controller" } ,
	{ 0x14E4, 0x4718, "", "Sentry5 Crypto Accelerator" } ,
	{ 0x14E4, 0x4720, "", "BCM4712 MIPS CPU" } ,
	{ 0x14E4, 0x5365, "", "BCM5365P Sentry5 Host Bridge" } ,
	{ 0x14E4, 0x5600, "", "BCM5600 StrataSwitch 24+2 Ethernet Switch Controller" } ,
	{ 0x14E4, 0x5605, "", "BCM5605 StrataSwitch 24+2 Ethernet Switch Controller" } ,
	{ 0x14E4, 0x5615, "", "BCM5615 StrataSwitch 24+2 Ethernet Switch Controller" } ,
	{ 0x14E4, 0x5625, "", "BCM5625 StrataSwitch 24+2 Ethernet Switch Controller" } ,
	{ 0x14E4, 0x5645, "", "BCM5645 StrataSwitch 24+2 Ethernet Switch Controller" } ,
	{ 0x14E4, 0x5670, "", "BCM5670 8-Port 10GE Ethernet Switch Fabric" } ,
	{ 0x14E4, 0x5680, "", "BCM5680 G-Switch 8 Port Gigabit Ethernet Switch Controller" } ,
	{ 0x14E4, 0x5690, "", "BCM5690 12-port Multi-Layer Gigabit Ethernet Switch" } ,
	{ 0x14E4, 0x5691, "", "BCM5691 GE/10GE 8+2 Gigabit Ethernet Switch Controller" } ,
	{ 0x14E4, 0x5692, "", "BCM5692 12-port Multi-Layer Gigabit Ethernet Switch" } ,
	{ 0x14E4, 0x5820, "", "BCM5820 Crypto Accelerator" } ,
	{ 0x14E4, 0x5821, "", "BCM5821 Crypto Accelerator" } ,
	{ 0x14E4, 0x5822, "", "BCM5822 Crypto Accelerator" } ,
	{ 0x14E4, 0x5823, "", "BCM5823 Crypto Accelerator" } ,
	{ 0x14E4, 0x5824, "", "BCM5824 Crypto Accelerator" } ,
	{ 0x14E4, 0x5840, "", "BCM5840 Crypto Accelerator" } ,
	{ 0x14E4, 0x5841, "", "BCM5841 Crypto Accelerator" } ,
	{ 0x14E4, 0x5850, "", "BCM5850 Crypto Accelerator" } ,
	{ 0x14EA, 0xAB06, "", "FNW-3603-TX CardBus Fast Ethernet" } ,
	{ 0x14EA, 0xAB07, "", "RTL81xx RealTek Ethernet" } ,
	{ 0x14EA, 0xAB08, "", "FNW-3602-TX CardBus Fast Ethernet" } ,
	{ 0x14F1, 0x1002, "", "HCF 56k Modem" } ,
	{ 0x14F1, 0x1003, "", "HCF 56k Modem" } ,
	{ 0x14F1, 0x1004, "", "HCF 56k Modem" } ,
	{ 0x14F1, 0x1005, "", "HCF 56k Modem" } ,
	{ 0x14F1, 0x1006, "", "HCF 56k Modem" } ,
	{ 0x14F1, 0x1022, "", "HCF 56k Modem" } ,
	{ 0x14F1, 0x1023, "", "HCF 56k Modem" } ,
	{ 0x14F1, 0x1024, "", "HCF 56k Modem" } ,
	{ 0x14F1, 0x1025, "", "HCF 56k Modem" } ,
	{ 0x14F1, 0x1026, "", "HCF 56k Modem" } ,
	{ 0x14F1, 0x1032, "", "HCF 56k Modem" } ,
	{ 0x14F1, 0x1033, "", "HCF 56k Data/Fax Modem" } ,
	{ 0x14F1, 0x1034, "", "HCF 56k Data/Fax/Voice Modem" } ,
	{ 0x14F1, 0x1035, "", "HCF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" } ,
	{ 0x14F1, 0x1036, "", "HCF 56k Data/Fax/Voice/Spkp Modem" } ,
	{ 0x14F1, 0x1052, "", "HCF 56k Data/Fax Modem (Worldwide)" } ,
	{ 0x14F1, 0x1053, "", "HCF 56k Data/Fax Modem (Worldwide)" } ,
	{ 0x14F1, 0x1054, "", "HCF 56k Data/Fax/Voice Modem (Worldwide)" } ,
	{ 0x14F1, 0x1055, "", "HCF 56k Data/Fax/Voice/Spkp (w/Handset) Modem (Worldwide)" } ,
	{ 0x14F1, 0x1056, "", "HCF 56k Data/Fax/Voice/Spkp Modem (Worldwide)" } ,
	{ 0x14F1, 0x1057, "", "HCF 56k Data/Fax/Voice/Spkp Modem (Worldwide)" } ,
	{ 0x14F1, 0x1059, "", "HCF 56k Data/Fax/Voice Modem (Worldwide)" } ,
	{ 0x14F1, 0x1063, "", "HCF 56k Data/Fax Modem" } ,
	{ 0x14F1, 0x1064, "", "HCF 56k Data/Fax/Voice Modem" } ,
	{ 0x14F1, 0x1065, "", "HCF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" } ,
	{ 0x14F1, 0x1066, "", "HCF 56k Data/Fax/Voice/Spkp Modem" } ,
	{ 0x14F1, 0x1085, "", "HCF V90 56k Data/Fax/Voice/Spkp PCI Modem" } ,
	{ 0x14F1, 0x1433, "", "HCF 56k Data/Fax Modem" } ,
	{ 0x14F1, 0x1434, "", "HCF 56k Data/Fax/Voice Modem" } ,
	{ 0x14F1, 0x1435, "", "HCF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" } ,
	{ 0x14F1, 0x1436, "", "HCF 56k Data/Fax Modem" } ,
	{ 0x14F1, 0x1453, "", "HCF 56k Data/Fax Modem" } ,
	{ 0x14F1, 0x1454, "", "HCF 56k Data/Fax/Voice Modem" } ,
	{ 0x14F1, 0x1455, "", "HCF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" } ,
	{ 0x14F1, 0x1456, "", "HCF 56k Data/Fax/Voice/Spkp Modem" } ,
	{ 0x14F1, 0x1610, "", "ADSL AccessRunner PCI Arbitration Device" } ,
	{ 0x14F1, 0x1611, "", "AccessRunner PCI ADSL Interface Device" } ,
	{ 0x14F1, 0x1620, "", "AccessRunner V2 PCI ADSL Arbitration Device" } ,
	{ 0x14F1, 0x1621, "", "AccessRunner V2 PCI ADSL Interface Device" } ,
	{ 0x14F1, 0x1622, "", "AccessRunner V2 PCI ADSL Yukon WAN Adapter" } ,
	{ 0x14F1, 0x1803, "", "HCF 56k Modem" } ,
	{ 0x14F1, 0x1811, "", "Conextant MiniPCI Network Adapter" } ,
	{ 0x14F1, 0x1815, "", "HCF 56k Modem" } ,
	{ 0x14F1, 0x2003, "", "HSF 56k Data/Fax Modem" } ,
	{ 0x14F1, 0x2004, "", "HSF 56k Data/Fax/Voice Modem" } ,
	{ 0x14F1, 0x2005, "", "HSF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" } ,
	{ 0x14F1, 0x2006, "", "HSF 56k Data/Fax/Voice/Spkp Modem" } ,
	{ 0x14F1, 0x2013, "", "HSF 56k Data/Fax Modem" } ,
	{ 0x14F1, 0x2014, "", "HSF 56k Data/Fax/Voice Modem" } ,
	{ 0x14F1, 0x2015, "", "HSF 56k Data/Fax/Voice/Spkp (w/Handset) Modem" } ,
	{ 0x14F1, 0x2016, "", "HSF 56k Data/Fax/Voice/Spkp Modem" } ,
	{ 0x14F1, 0x2043, "", "HSF 56k Data/Fax Modem (WorldW SmartDAA)" } ,
	{ 0x14F1, 0x2044, "", "HSF 56k Data/Fax/Voice Modem (WorldW SmartDAA)" } ,
	{ 0x14F1, 0x2045, "", "HSF 56k Data/Fax/Voice/Spkp (w/Handset) Modem (WorldW SmartDAA)" } ,
	{ 0x14F1, 0x2046, "", "HSF 56k Data/Fax/Voice/Spkp Modem (WorldW SmartDAA)" } ,
	{ 0x14F1, 0x2063, "", "HSF 56k Data/Fax Modem (SmartDAA)" } ,
	{ 0x14F1, 0x2064, "", "HSF 56k Data/Fax/Voice Modem (SmartDAA)" } ,
	{ 0x14F1, 0x2065, "", "HSF 56k Data/Fax/Voice/Spkp (w/Handset) Modem (SmartDAA)" } ,
	{ 0x14F1, 0x2066, "", "HSF 56k Data/Fax/Voice/Spkp Modem (SmartDAA)" } ,
	{ 0x14F1, 0x2093, "", "HSF 56k Modem" } ,
	{ 0x14F1, 0x2143, "", "HSF 56k Data/Fax/Cell Modem (Mob WorldW SmartDAA)" } ,
	{ 0x14F1, 0x2144, "", "HSF 56k Data/Fax/Voice/Cell Modem (Mob WorldW SmartDAA)" } ,
	{ 0x14F1, 0x2145, "", "HSF 56k Data/Fax/Voice/Spkp (w/HS)/Cell Modem (Mob WorldW SmartDAA)" } ,
	{ 0x14F1, 0x2146, "", "HSF 56k Data/Fax/Voice/Spkp/Cell Modem (Mob WorldW SmartDAA)" } ,
	{ 0x14F1, 0x2163, "", "HSF 56k Data/Fax/Cell Modem (Mob SmartDAA)" } ,
	{ 0x14F1, 0x2164, "", "HSF 56k Data/Fax/Voice/Cell Modem (Mob SmartDAA)" } ,
	{ 0x14F1, 0x2165, "", "HSF 56k Data/Fax/Voice/Spkp (w/HS)/Cell Modem (Mob SmartDAA)" } ,
	{ 0x14F1, 0x2166, "", "HSF 56k Data/Fax/Voice/Spkp/Cell Modem (Mob SmartDAA)" } ,
	{ 0x14F1, 0x2343, "", "HSF 56k Data/Fax CardBus Modem (Mob WorldW SmartDAA)" } ,
	{ 0x14F1, 0x2344, "", "HSF 56k Data/Fax/Voice CardBus Modem (Mob WorldW SmartDAA)" } ,
	{ 0x14F1, 0x2345, "", "HSF 56k Data/Fax/Voice/Spkp (w/HS) CardBus Modem (Mob WorldW SmartDAA)" } ,
	{ 0x14F1, 0x2346, "", "HSF 56k Data/Fax/Voice/Spkp CardBus Modem (Mob WorldW SmartDAA)" } ,
	{ 0x14F1, 0x2363, "", "HSF 56k Data/Fax CardBus Modem (Mob SmartDAA)" } ,
	{ 0x14F1, 0x2364, "", "HSF 56k Data/Fax/Voice CardBus Modem (Mob SmartDAA)" } ,
	{ 0x14F1, 0x2365, "", "HSF 56k Data/Fax/Voice/Spkp (w/HS) CardBus Modem (Mob SmartDAA)" } ,
	{ 0x14F1, 0x2366, "", "HSF 56k Data/Fax/Voice/Spkp CardBus Modem (Mob SmartDAA)" } ,
	{ 0x14F1, 0x2443, "", "HSF 56k Data/Fax Modem (Mob WorldW SmartDAA)" } ,
	{ 0x14F1, 0x2444, "", "HSF 56k Data/Fax/Voice Modem (Mob WorldW SmartDAA)" } ,
	{ 0x14F1, 0x2445, "", "HSF 56k Data/Fax/Voice/Spkp (w/HS) Modem (Mob WorldW SmartDAA)" } ,
	{ 0x14F1, 0x2446, "", "HSF 56k Data/Fax/Voice/Spkp Modem (Mob WorldW SmartDAA)" } ,
	{ 0x14F1, 0x2463, "", "HSF 56k Data/Fax Modem (Mob SmartDAA)" } ,
	{ 0x14F1, 0x2464, "", "HSF 56k Data/Fax/Voice Modem (Mob SmartDAA)" } ,
	{ 0x14F1, 0x2465, "", "HSF 56k Data/Fax/Voice/Spkp (w/HS) Modem (Mob SmartDAA)" } ,
	{ 0x14F1, 0x2466, "", "HSF 56k Data/Fax/Voice/Spkp Modem (Mob SmartDAA)" } ,
	{ 0x14F1, 0x2F00, "", "HSF 56k HSFi Modem" } ,
	{ 0x14F1, 0x2F02, "", "HSF 56k HSFi Data/Fax" } ,
	{ 0x14F1, 0x2F11, "", "HSF 56k HSFi Modem" } ,
	{ 0x14F1, 0x2F20, "", "HSF 56k Data/Fax Modem" } ,
	{ 0x14F1, 0x8234, "", "RS8234 ATM SAR Controller [ServiceSAR Plus]" } ,
	{ 0x14F1, 0x8800, "", "CX23880/1/2/3 PCI Video and Audio Decoder" } ,
	{ 0x14F1, 0x8801, "", "CX23880/1/2/3 PCI Video and Audio Decoder [Audio Port]" } ,
	{ 0x14F1, 0x8802, "", "CX23880/1/2/3 PCI Video and Audio Decoder [MPEG Port]" } ,
	{ 0x14F1, 0x8804, "", "CX23880/1/2/3 PCI Video and Audio Decoder [IR Port]" } ,
	{ 0x14F1, 0x8811, "", "CX23880/1/2/3 PCI Video and Audio Decoder [Audio Port]" } ,
	{ 0x14F2, 0x0120, "", "EV1000 bridge" } ,
	{ 0x14F2, 0x0121, "", "EV1000 Parallel port" } ,
	{ 0x14F2, 0x0122, "", "EV1000 Serial port" } ,
	{ 0x14F2, 0x0123, "", "EV1000 Keyboard controller" } ,
	{ 0x14F2, 0x0124, "", "EV1000 Mouse controller" } ,
	{ 0x14F3, 0x2030, "", "2030 DVB-S Satellite Reciever" } ,
	{ 0x14F3, 0x2050, "", "2050 DVB-T Terrestrial (Cable) Reciever" } ,
	{ 0x14F3, 0x2060, "", "2060 ATSC Terrestrial (Cable) Reciever" } ,
	{ 0x14F8, 0x2077, "", "TP-240 dual span E1 VoIP PCI card" } ,
	{ 0x14FC, 0x0000, "", "QsNet Elan3 Network Adapter" } ,
	{ 0x14FC, 0x0001, "", "QsNetII Elan4 Network Adapter" } ,
	{ 0x1500, 0x1360, "", "RTL81xx RealTek Ethernet" } ,
	{ 0x1507, 0x0001, "", "MPC105 [Eagle]" } ,
	{ 0x1507, 0x0002, "", "MPC106 [Grackle]" } ,
	{ 0x1507, 0x0003, "", "MPC8240 [Kahlua]" } ,
	{ 0x1507, 0x0100, "", "MC145575 [HFC-PCI]" } ,
	{ 0x1507, 0x0431, "", "KTI829c 100VG" } ,
	{ 0x1507, 0x4801, "", "Raven" } ,
	{ 0x1507, 0x4802, "", "Falcon" } ,
	{ 0x1507, 0x4803, "", "Hawk" } ,
	{ 0x1507, 0x4806, "", "CPX8216" } ,
	{ 0x1516, 0x0800, "", "MTD-8xx 100/10M Ethernet PCI Adapter" } ,
	{ 0x1516, 0x0803, "", "SURECOM EP-320X-S 100/10M Ethernet PCI Adapter" } ,
	{ 0x1516, 0x0891, "", "MTD-8xx 100/10M Ethernet PCI Adapter" } ,
	{ 0x151A, 0x1002, "", "PCI-1002" } ,
	{ 0x151A, 0x1004, "", "PCI-1004" } ,
	{ 0x151A, 0x1008, "", "PCI-1008" } ,
	{ 0x151C, 0x0003, "", "Prodif T 2496" } ,
	{ 0x151C, 0x4000, "", "Prodif 88" } ,
	{ 0x151F, 0x0000, "", "TP560 Data/Fax/Voice 56k modem" } ,
	{ 0x1522, 0x0100, "", "PCI <-> IOBus Bridge" } ,
	{ 0x1524, 0x0510, "", "CB710 Memory Card Reader Controller" } ,
	{ 0x1524, 0x0530, "", "ENE PCI Memory Stick Card Reader Controller" } ,
	{ 0x1524, 0x0550, "", "ENE PCI Secure Digital Card Reader Controller" } ,
	{ 0x1524, 0x0610, "", "PCI Smart Card Reader Controller" } ,
	{ 0x1524, 0x1211, "", "CB1211 Cardbus Controller" } ,
	{ 0x1524, 0x1225, "", "CB1225 Cardbus Controller" } ,
	{ 0x1524, 0x1410, "", "CB1410 Cardbus Controller" } ,
	{ 0x1524, 0x1411, "", "CB-710/2/4 Cardbus Controller" } ,
	{ 0x1524, 0x1412, "", "CB-712/4 Cardbus Controller" } ,
	{ 0x1524, 0x1420, "", "CB1420 Cardbus Controller" } ,
	{ 0x1524, 0x1421, "", "CB-720/2/4 Cardbus Controller" } ,
	{ 0x1524, 0x1422, "", "CB-722/4 Cardbus Controller" } ,
	{ 0x1538, 0x0303, "", "ARS106S Ultra ATA 133/100/66 Host Controller" } ,
	{ 0x153B, 0x1144, "", "Aureon 5.1" } ,
	{ 0x153B, 0x1147, "", "Aureon 5.1 Sky" } ,
	{ 0x153B, 0x1158, "", "Philips Semiconductors SAA7134 (rev 01) [Terratec Cinergy 600 TV]" } ,
	{ 0x153F, 0x0001, "", "SOC-it 101 System Controller" } ,
	{ 0x1543, 0x3052, "", "Intel 537 [Winmodem]" } ,
	{ 0x1543, 0x4C22, "", "Si3036 MC'97 DAA" } ,
	{ 0x1571, 0xA001, "", "CCSI PCI20-485 ARCnet" } ,
	{ 0x1571, 0xA002, "", "CCSI PCI20-485D ARCnet" } ,
	{ 0x1571, 0xA003, "", "CCSI PCI20-485X ARCnet" } ,
	{ 0x1571, 0xA004, "", "CCSI PCI20-CXB ARCnet" } ,
	{ 0x1571, 0xA005, "", "CCSI PCI20-CXS ARCnet" } ,
	{ 0x1571, 0xA006, "", "CCSI PCI20-FOG-SMA ARCnet" } ,
	{ 0x1571, 0xA007, "", "CCSI PCI20-FOG-ST ARCnet" } ,
	{ 0x1571, 0xA008, "", "CCSI PCI20-TB5 ARCnet" } ,
	{ 0x1571, 0xA009, "", "CCSI PCI20-5-485 5Mbit ARCnet" } ,
	{ 0x1571, 0xA00A, "", "CCSI PCI20-5-485D 5Mbit ARCnet" } ,
	{ 0x1571, 0xA00B, "", "CCSI PCI20-5-485X 5Mbit ARCnet" } ,
	{ 0x1571, 0xA00C, "", "CCSI PCI20-5-FOG-ST 5Mbit ARCnet" } ,
	{ 0x1571, 0xA00D, "", "CCSI PCI20-5-FOG-SMA 5Mbit ARCnet" } ,
	{ 0x1571, 0xA201, "", "CCSI PCI22-485 10Mbit ARCnet" } ,
	{ 0x1571, 0xA202, "", "CCSI PCI22-485D 10Mbit ARCnet" } ,
	{ 0x1571, 0xA203, "", "CCSI PCI22-485X 10Mbit ARCnet" } ,
	{ 0x1571, 0xA204, "", "CCSI PCI22-CHB 10Mbit ARCnet" } ,
	{ 0x1571, 0xA205, "", "CCSI PCI22-FOG_ST 10Mbit ARCnet" } ,
	{ 0x1571, 0xA206, "", "CCSI PCI22-THB 10Mbit ARCnet" } ,
	{ 0x1578, 0x5615, "", "VPMK3 [Video Processor Mk III]" } ,
	{ 0x157C, 0x8001, "", "Fix2000 PCI Y2K Compliance Card" } ,
	{ 0x1592, 0x0781, "", "Multi-IO Card" } ,
	{ 0x1592, 0x0782, "", "Parallel Port Card 2xEPP" } ,
	{ 0x1592, 0x0783, "", "Multi-IO Card" } ,
	{ 0x1592, 0x0785, "", "Multi-IO Card" } ,
	{ 0x1592, 0x0786, "", "Multi-IO Card" } ,
	{ 0x1592, 0x0787, "", "Multi-IO Card" } ,
	{ 0x1592, 0x0788, "", "Multi-IO Card" } ,
	{ 0x1592, 0x078A, "", "Multi-IO Card" } ,
	{ 0x15A2, 0x0001, "", "TA700 PCI Bus Analyzer/Exerciser" } ,
	{ 0x15AD, 0x0405, "", "[VMware SVGA II] PCI Display Adapter" } ,
	{ 0x15AD, 0x0710, "", "Virtual SVGA" } ,
	{ 0x15AD, 0x0720, "", "VMware High-Speed Virtual NIC [vmxnet]" } ,
	{ 0x15B3, 0x5274, "", "MT21108 InfiniBridge" } ,
	{ 0x15B3, 0x5A44, "", "MT23108 InfiniHost" } ,
	{ 0x15B3, 0x5A45, "", "MT23108 [Infinihost HCA Flash Recovery]" } ,
	{ 0x15B3, 0x5A46, "", "MT23108 PCI Bridge" } ,
	{ 0x15B3, 0x5E8D, "", "MT25204 [InfiniHost III Lx HCA Flash Recovery]" } ,
	{ 0x15B3, 0x6274, "", "MT25204 [InfiniHost III Lx HCA]" } ,
	{ 0x15B3, 0x6278, "", "MT25208 InfiniHost III Ex (Tavor compatibility mode)" } ,
	{ 0x15B3, 0x6279, "", "MT25208 [InfiniHost III Ex HCA Flash Recovery]" } ,
	{ 0x15B3, 0x6282, "", "MT25208 InfiniHost III Ex" } ,
	{ 0x15BC, 0x1100, "", "E8001-66442 PCI Express CIC" } ,
	{ 0x15BC, 0x2922, "", "64 Bit, 133MHz PCI-X Exerciser & Protocol Checker" } ,
	{ 0x15BC, 0x2928, "", "64 Bit, 66MHz PCI Exerciser & Analyzer" } ,
	{ 0x15BC, 0x2929, "", "64 Bit, 133MHz PCI-X Analyzer & Exerciser" } ,
	{ 0x15C5, 0x8010, "", "1394b - 1394 Firewire 3-Port Host Adapter Card" } ,
	{ 0x15C7, 0x0349, "", "Tateyama C-PCI PLC/NC card Rev.01A" } ,
	{ 0x15DC, 0x0001, "", "Argus 300 PCI Cryptography Module" } ,
	{ 0x15E8, 0x0130, "", "Wireless PCI Card" } ,
	{ 0x15E9, 0x1841, "", "ADMA-100 DiscStaQ ATA Controller" } ,
	{ 0x15EC, 0x3101, "", "FC3101 Profibus DP 1 Channel PCI" } ,
	{ 0x15EC, 0x5102, "", "FC5102" } ,
	{ 0x1619, 0x0400, "", "FarSync T2P (2 port X.21/V.35/V.24)" } ,
	{ 0x1619, 0x0440, "", "FarSync T4P (4 port X.21/V.35/V.24)" } ,
	{ 0x1619, 0x0610, "", "FarSync T1U (1 port X.21/V.35/V.24)" } ,
	{ 0x1619, 0x0620, "", "FarSync T2U (1 port X.21/V.35/V.24)" } ,
	{ 0x1619, 0x0640, "", "FarSync T4U (4 port X.21/V.35/V.24)" } ,
	{ 0x1619, 0x1610, "", "FarSync TE1 (T1,E1)" } ,
	{ 0x1619, 0x2610, "", "FarSync DSL-S1 (SHDSL)" } ,
	{ 0x1626, 0x8410, "", "RTL81xx Fast Ethernet" } ,
	{ 0x1629, 0x1003, "", "Format synchronizer v3.0" } ,
	{ 0x1629, 0x2002, "", "Fast Universal Data Output" } ,
	{ 0x1637, 0x3874, "", "Linksys 802.11b WMP11 PCI Wireless card" } ,
	{ 0x1638, 0x1100, "", "SMC2602W EZConnect / Addtron AWA-100 / Eumitcom PCI WL11000" } ,
	{ 0x163C, 0x3052, "", "SmartLink SmartPCI562 56K Modem" } ,
	{ 0x163C, 0x5449, "", "SmartPCI561 Modem" } ,
	{ 0x165A, 0xC100, "", "PIXCI(R) CL1 Camera Link Video Capture Board [custom QL5232]" } ,
	{ 0x165A, 0xD200, "", "PIXCI(R) D2X Digital Video Capture Board [custom QL5232]" } ,
	{ 0x165A, 0xD300, "", "PIXCI(R) D3X Digital Video Capture Board [custom QL5232]" } ,
	{ 0x165F, 0x1020, "", "LMLM4 MPEG-4 encoder" } ,
	{ 0x1668, 0x0100, "", "Mini-PCI bridge" } ,
	{ 0x166D, 0x0001, "", "SiByte BCM1125/1125H/1250 System-on-a-Chip PCI" } ,
	{ 0x166D, 0x0002, "", "SiByte BCM1125H/1250 System-on-a-Chip HyperTransport" } ,
	{ 0x1677, 0x104E, "", "5LS172.6 B&R Dual CAN Interface Card" } ,
	{ 0x1677, 0x12D7, "", "5LS172.61 B&R Dual CAN Interface Card" } ,
	{ 0x167B, 0x2102, "", "ZyDAS ZD1202" } ,
	{ 0x1681, 0x0010, "", "Hercules 3d Prophet II Ultra 64MB (350 MHz NV15BR core)" } ,
	{ 0x1688, 0x1170, "", "WLAN 802.11b card" } ,
	{ 0x168C, 0x0007, "", "AR5000 802.11a Wireless Adapter" } ,
	{ 0x168C, 0x0011, "", "AR5210 802.11a NIC" } ,
	{ 0x168C, 0x0012, "", "AR5211 802.11ab NIC" } ,
	{ 0x168C, 0x0013, "", "AR5212 802.11abg NIC" } ,
	{ 0x168C, 0x1014, "", "AR5212 802.11abg NIC" } ,
	{ 0x169C, 0x0044, "", "Revolution Storage Processing Card" } ,
	{ 0x16AB, 0x1100, "", "GL24110P" } ,
	{ 0x16AB, 0x1101, "", "PLX9052 PCMCIA-to-PCI Wireless LAN" } ,
	{ 0x16AB, 0x1102, "", "PCMCIA-to-PCI Wireless Network Bridge" } ,
	{ 0x16AB, 0x8501, "", "WL-8305 Wireless LAN PCI Adapter" } ,
	{ 0x16AE, 0x1141, "", "SafeXcel-1141" } ,
	{ 0x16CA, 0x0001, "", "Rocket Drive DL" } ,
	{ 0x16E3, 0x1E0F, "", "LEON2FT Processor" } ,
	{ 0x16EC, 0x00FF, "", "USR997900 10/100 Mbps PCI Network Card" } ,
	{ 0x16EC, 0x0116, "", "USR997902 10/100/1000 Mbps PCI Network Card" } ,
	{ 0x16EC, 0x3685, "", "Wireless Access PCI Adapter Model 022415" } ,
	{ 0x16ED, 0x1001, "", "UMIO communication card" } ,
	{ 0x16F4, 0x8000, "", "VW2010" } ,
	{ 0x170B, 0x0100, "", "NSP2000-SSL crypto accelerator" } ,
	{ 0x1725, 0x7174, "", "VSC7174 PCI/PCI-X Serial ATA Host Bus Controller" } ,
	{ 0x172A, 0x13C8, "", "AEP SureWare Runner 1000V3" } ,
	{ 0x1737, 0x0013, "", "WMP54G Wireless Pci Card" } ,
	{ 0x1737, 0x0015, "", "WMP54GS Wireless Pci Card" } ,
	{ 0x1737, 0x1032, "", "Gigabit Network Adapter" } ,
	{ 0x1737, 0x1064, "", "Gigabit Network Adapter" } ,
	{ 0x1737, 0xAB08, "", "21x4x DEC-Tulip compatible 10/100 Ethernet" } ,
	{ 0x1737, 0xAB09, "", "21x4x DEC-Tulip compatible 10/100 Ethernet" } ,
	{ 0x173B, 0x03E8, "", "AC1000 Gigabit Ethernet" } ,
	{ 0x173B, 0x03E9, "", "AC1001 Gigabit Ethernet" } ,
	{ 0x173B, 0x03EA, "", "AC9100 Gigabit Ethernet" } ,
	{ 0x173B, 0x03EB, "", "AC1003 Gigabit Ethernet" } ,
	{ 0x1743, 0x8139, "", "ROL/F-100 Fast Ethernet Adapter with ROL" } ,
	{ 0x1796, 0x0001, "", "SIS1100 [Gigabit link]" } ,
	{ 0x1796, 0x0002, "", "HOTlink" } ,
	{ 0x1796, 0x0003, "", "Counter Timer" } ,
	{ 0x1796, 0x0004, "", "CAMAC Controller" } ,
	{ 0x1796, 0x0005, "", "PROFIBUS" } ,
	{ 0x1796, 0x0006, "", "AMCC HOTlink" } ,
	{ 0x1799, 0x6001, "", "Wireless PCI Card - F5D6001" } ,
	{ 0x1799, 0x6020, "", "Wireless PCMCIA Card - F5D6020" } ,
	{ 0x1799, 0x6060, "", "Wireless PDA Card - F5D6060" } ,
	{ 0x1799, 0x7000, "", "Wireless PCI Card - F5D7000" } ,
	{ 0x1799, 0x7010, "", "BCM4306 802.11b/g Wireless Lan Controller F5D7010" } ,
	{ 0x17A0, 0x8033, "", "GL880S USB 1.1 controller" } ,
	{ 0x17A0, 0x8034, "", "GL880S USB 2.0 controller" } ,
	{ 0x17B3, 0xAB08, "", "PN672TX 10/100 Ethernet" } ,
	{ 0x17B4, 0x0011, "", "WebEnhance 100 GZIP Compression Card" } ,
	{ 0x17CC, 0x2280, "", "USB 2.0" } ,
	{ 0x17D3, 0x1110, "", "ARC-1110 4-Port PCI-X to SATA RAID Controller" } ,
	{ 0x17D3, 0x1120, "", "ARC-1120 8-Port PCI-X to SATA RAID Controller" } ,
	{ 0x17D3, 0x1130, "", "ARC-1130 12-Port PCI-X to SATA RAID Controller" } ,
	{ 0x17D3, 0x1160, "", "ARC-1160 16-Port PCI-X to SATA RAID Controller" } ,
	{ 0x17D3, 0x1210, "", "ARC-1210 4-Port PCI-Express to SATA RAID Controller" } ,
	{ 0x17D3, 0x1220, "", "ARC-1220 8-Port PCI-Express to SATA RAID Controller" } ,
	{ 0x17D3, 0x1230, "", "ARC-1230 12-Port PCI-Express to SATA RAID Controller" } ,
	{ 0x17D3, 0x1260, "", "ARC-1260 16-Port PCI-Express to SATA RAID Controller" } ,
	{ 0x17D5, 0x5831, "", "Xframe 10 Gigabit Ethernet PCI-X" } ,
	{ 0x17D5, 0x5832, "", "Xframe II 10 Gigabit Ethernet PCI-X" } ,
	{ 0x17FE, 0x2120, "", "WMP11v4 802.11b PCI card" } ,
	{ 0x17FE, 0x2220, "", "[AirConn] INPROCOMM IPN 2220 Wireless LAN Adapter (rev 01)" } ,
	{ 0x1813, 0x4000, "", "HaM controllerless modem" } ,
	{ 0x1813, 0x4100, "", "HaM plus Data Fax Modem" } ,
	{ 0x1814, 0x0101, "", "Wireless PCI Adpator RT2400 / RT2460" } ,
	{ 0x1814, 0x0201, "", "Ralink RT2500 802.11 Cardbus Reference Card" } ,
	{ 0x1822, 0x4E35, "", "Mantis DTV PCI Bridge Controller [Ver 1.0]" } ,
	{ 0x182D, 0x3069, "", "ISDN PCI DC-105V2" } ,
	{ 0x182D, 0x9790, "", "WL-121 Wireless Network Adapter 100g+ [Ver.3]" } ,
	{ 0x183B, 0x08A7, "", "MVC100 DVI" } ,
	{ 0x183B, 0x08A8, "", "MVC101 SDI" } ,
	{ 0x183B, 0x08A9, "", "MVC102 DVI+Audio" } ,
	{ 0x1864, 0x2110, "", "ISNAP 2110" } ,
	{ 0x1867, 0x5A44, "", "MT23108 InfiniHost HCA" } ,
	{ 0x1867, 0x5A45, "", "MT23108 InfiniHost HCA flash recovery" } ,
	{ 0x1867, 0x5A46, "", "MT23108 InfiniHost HCA bridge" } ,
	{ 0x1867, 0x6278, "", "MT25208 InfiniHost III Ex (Tavor compatibility mode)" } ,
	{ 0x1867, 0x6282, "", "MT25208 InfiniHost III Ex" } ,
	{ 0x1888, 0x0301, "", "VMFX1 FPGA PMC module" } ,
	{ 0x1888, 0x0601, "", "VSM2 dual PMC carrier" } ,
	{ 0x1888, 0x0710, "", "VS14x series PowerPC PCI board" } ,
	{ 0x1888, 0x0720, "", "VS24x series PowerPC PCI board" } ,
	{ 0x18AC, 0xD500, "", "FusionHDTV 5" } ,
	{ 0x18AC, 0xD810, "", "FusionHDTV 3 Gold" } ,
	{ 0x18AC, 0xD820, "", "FusionHDTV 3 Gold-T" } ,
	{ 0x18B8, 0xB001, "", "AMSO 1100 iWARP/RDMA Gigabit Ethernet Coprocessor" } ,
	{ 0x18CA, 0x0020, "", "Volari Z7" } ,
	{ 0x18CA, 0x0040, "", "Volari V3XT/V5/V8" } ,
	{ 0x18D2, 0x3069, "", "DC-105v2 ISDN controller" } ,
	{ 0x18DD, 0x4C6F, "", "Artimi RTMI-100 UWB adapter" } ,
	{ 0x18E6, 0x0001, "", "OSCI [Octal Serial Communication Interface]" } ,
	{ 0x18F7, 0x0001, "", "Fastcom ESCC-PCI-335" } ,
	{ 0x18F7, 0x0002, "", "Fastcom 422/4-PCI-335" } ,
	{ 0x18F7, 0x0004, "", "Fastcom 422/2-PCI-335" } ,
	{ 0x18F7, 0x0005, "", "Fastcom IGESCC-PCI-ISO/1" } ,
	{ 0x18F7, 0x000A, "", "Fastcom 232/4-PCI-335" } ,
	{ 0x1966, 0x1975, "", "DVG64 family" } ,
	{ 0x196A, 0x0101, "", "NodalCore C-1000 Content Classification Accelerator" } ,
	{ 0x196A, 0x0102, "", "NodalCore C-2000 Content Classification Accelerator" } ,
	{ 0x1989, 0x0001, "", "RapidFile Bridge" } ,
	{ 0x1989, 0x8001, "", "RapidFile" } ,
	{ 0x19AE, 0x0520, "", "4135 HFT Interface Controller" } ,
	{ 0x1A08, 0x0000, "", "SC15064" } ,
	{ 0x1C1C, 0x0001, "", "82C101" } ,
	{ 0x1D44, 0xA400, "", "PM2x24/PM3224" } ,
	{ 0x1DE1, 0x0391, "", "TRM-S1040" } ,
	{ 0x1DE1, 0x2020, "", "DC-390" } ,
	{ 0x1DE1, 0x690C, "", "690c" } ,
	{ 0x1DE1, 0xDC29, "", "DC290" } ,
	{ 0x1FC0, 0x0300, "", "E2200 Dual E1/Rawpipe Card" } ,
	{ 0x1FC1, 0x000D, "", "InfiniPath HT-400" } ,
	{ 0x1FCE, 0x0001, "", "Spectrum Analyzer PC Card (SAgE)" } ,
	{ 0x2348, 0x2010, "", "8142 100VG/AnyLAN" } ,
	{ 0x3388, 0x0013, "", "HiNT HC4 PCI to ISDN bridge, Multimedia audio controller" } ,
	{ 0x3388, 0x0014, "", "HiNT HC4 PCI to ISDN bridge, Network controller" } ,
	{ 0x3388, 0x0020, "", "HB6 Universal PCI-PCI bridge (transparent mode)" } ,
	{ 0x3388, 0x0021, "", "HB6 Universal PCI-PCI bridge (non-transparent mode)" } ,
	{ 0x3388, 0x0022, "", "HiNT HB4 PCI-PCI Bridge (PCI6150)" } ,
	{ 0x3388, 0x0026, "", "HB2 PCI-PCI Bridge" } ,
	{ 0x3388, 0x101A, "", "E.Band [AudioTrak Inca88]" } ,
	{ 0x3388, 0x101B, "", "E.Band [AudioTrak Inca88]" } ,
	{ 0x3388, 0x8011, "", "VXPro II Chipset" } ,
	{ 0x3388, 0x8012, "", "VXPro II Chipset" } ,
	{ 0x3388, 0x8013, "", "VXPro II IDE" } ,
	{ 0x3842, 0xC370, "", "e-GeFORCE 6600 256 DDR PCI-e" } ,
	{ 0x3D3D, 0x0001, "", "GLINT 300SX" } ,
	{ 0x3D3D, 0x0002, "", "GLINT 500TX" } ,
	{ 0x3D3D, 0x0003, "", "GLINT Delta" } ,
	{ 0x3D3D, 0x0004, "", "Permedia" } ,
	{ 0x3D3D, 0x0005, "", "Permedia" } ,
	{ 0x3D3D, 0x0006, "", "GLINT MX" } ,
	{ 0x3D3D, 0x0007, "", "3D Extreme" } ,
	{ 0x3D3D, 0x0008, "", "GLINT Gamma G1" } ,
	{ 0x3D3D, 0x0009, "", "Permedia II 2D+3D" } ,
	{ 0x3D3D, 0x000A, "", "GLINT R3" } ,
	{ 0x3D3D, 0x000C, "", "GLINT R3 [Oxygen VX1]" } ,
	{ 0x3D3D, 0x000D, "", "GLint R4 rev A" } ,
	{ 0x3D3D, 0x0011, "", "GLint R4 rev B" } ,
	{ 0x3D3D, 0x0012, "", "GLint R5 rev A" } ,
	{ 0x3D3D, 0x0013, "", "GLint R5 rev B" } ,
	{ 0x3D3D, 0x0020, "", "VP10 visual processor" } ,
	{ 0x3D3D, 0x0022, "", "VP10 visual processor" } ,
	{ 0x3D3D, 0x0024, "", "VP9 visual processor" } ,
	{ 0x3D3D, 0x0100, "", "Permedia II 2D+3D" } ,
	{ 0x3D3D, 0x07A1, "", "Wildcat III 6210" } ,
	{ 0x3D3D, 0x07A2, "", "Sun XVR-500 Graphics Accelerator" } ,
	{ 0x3D3D, 0x07A3, "", "Wildcat IV 7210" } ,
	{ 0x3D3D, 0x1004, "", "Permedia" } ,
	{ 0x3D3D, 0x3D04, "", "Permedia" } ,
	{ 0x3D3D, 0xFFFF, "", "Glint VGA" } ,
	{ 0x4005, 0x0300, "", "ALS300 PCI Audio Device" } ,
	{ 0x4005, 0x0308, "", "ALS300+ PCI Audio Device" } ,
	{ 0x4005, 0x0309, "", "PCI Input Controller" } ,
	{ 0x4005, 0x1064, "", "ALG-2064" } ,
	{ 0x4005, 0x2064, "", "ALG-2064i" } ,
	{ 0x4005, 0x2128, "", "ALG-2364A GUI Accelerator" } ,
	{ 0x4005, 0x2301, "", "ALG-2301" } ,
	{ 0x4005, 0x2302, "", "ALG-2302" } ,
	{ 0x4005, 0x2303, "", "AVG-2302 GUI Accelerator" } ,
	{ 0x4005, 0x2364, "", "ALG-2364A" } ,
	{ 0x4005, 0x2464, "", "ALG-2464" } ,
	{ 0x4005, 0x2501, "", "ALG-2564A/25128A" } ,
	{ 0x4005, 0x4000, "", "ALS4000 Audio Chipset" } ,
	{ 0x4005, 0x4710, "", "ALC200/200P" } ,
	{ 0x4033, 0x1360, "", "RTL8139 Ethernet" } ,
	{ 0x4144, 0x0044, "", "ADM-XRCIIPro" } ,
	{ 0x416C, 0x0100, "", "AladdinCARD" } ,
	{ 0x416C, 0x0200, "", "CPC" } ,
	{ 0x4444, 0x0016, "", "iTVC16 (CX23416) MPEG-2 Encoder" } ,
	{ 0x4444, 0x0803, "", "iTVC15 MPEG-2 Encoder" } ,
	{ 0x4916, 0x1960, "", "RedCreek PCI adapter" } ,
	{ 0x494F, 0x10E8, "", "LPCI-COM-8SM" } ,
	{ 0x4A14, 0x5000, "", "NV5000SC" } ,
	{ 0x4C53, 0x0000, "", "PLUSTEST device" } ,
	{ 0x4C53, 0x0001, "", "PLUSTEST-MM device" } ,
	{ 0x4D51, 0x0200, "", "MQ-200" } ,
	{ 0x4DDC, 0x0100, "", "DD-42924I5-300 (ARINC 429 Data Bus)" } ,
	{ 0x4DDC, 0x0801, "", "BU-65570I1 MIL-STD-1553 Test and Simulation" } ,
	{ 0x4DDC, 0x0802, "", "BU-65570I2 MIL-STD-1553 Test and Simulation" } ,
	{ 0x4DDC, 0x0811, "", "BU-65572I1 MIL-STD-1553 Test and Simulation" } ,
	{ 0x4DDC, 0x0812, "", "BU-65572I2 MIL-STD-1553 Test and Simulation" } ,
	{ 0x4DDC, 0x0881, "", "BU-65570T1 MIL-STD-1553 Test and Simulation" } ,
	{ 0x4DDC, 0x0882, "", "BU-65570T2 MIL-STD-1553 Test and Simulation" } ,
	{ 0x4DDC, 0x0891, "", "BU-65572T1 MIL-STD-1553 Test and Simulation" } ,
	{ 0x4DDC, 0x0892, "", "BU-65572T2 MIL-STD-1553 Test and Simulation" } ,
	{ 0x4DDC, 0x0901, "", "BU-65565C1 MIL-STD-1553 Data Bus" } ,
	{ 0x4DDC, 0x0902, "", "BU-65565C2 MIL-STD-1553 Data Bus" } ,
	{ 0x4DDC, 0x0903, "", "BU-65565C3 MIL-STD-1553 Data Bus" } ,
	{ 0x4DDC, 0x0904, "", "BU-65565C4 MIL-STD-1553 Data Bus" } ,
	{ 0x4DDC, 0x0B01, "", "BU-65569I1 MIL-STD-1553 Data Bus" } ,
	{ 0x4DDC, 0x0B02, "", "BU-65569I2 MIL-STD-1553 Data Bus" } ,
	{ 0x4DDC, 0x0B03, "", "BU-65569I3 MIL-STD-1553 Data Bus" } ,
	{ 0x4DDC, 0x0B04, "", "BU-65569I4 MIL-STD-1553 Data Bus" } ,
	{ 0x5046, 0x1001, "", "PCI Radio" } ,
	{ 0x5053, 0x2010, "", "Daytona Audio Adapter" } ,
	{ 0x5145, 0x3031, "", "Concert AudioPCI" } ,
	{ 0x5301, 0x0001, "", "ProMotion aT3D" } ,
	{ 0x5333, 0x0551, "", "Plato/PX (system)" } ,
	{ 0x5333, 0x5631, "", "86c325 [ViRGE]" } ,
	{ 0x5333, 0x8800, "", "86c866 [Vision 866]" } ,
	{ 0x5333, 0x8801, "", "86c964 [Vision 964]" } ,
	{ 0x5333, 0x8810, "", "86c764_0 [Trio 32 vers 0]" } ,
	{ 0x5333, 0x8811, "", "86c764/765 [Trio32/64/64V+]" } ,
	{ 0x5333, 0x8812, "", "86cM65 [Aurora64V+]" } ,
	{ 0x5333, 0x8813, "", "86c764_3 [Trio 32/64 vers 3]" } ,
	{ 0x5333, 0x8814, "", "86c767 [Trio 64UV+]" } ,
	{ 0x5333, 0x8815, "", "86cM65 [Aurora 128]" } ,
	{ 0x5333, 0x883D, "", "86c988 [ViRGE/VX]" } ,
	{ 0x5333, 0x8870, "", "FireGL" } ,
	{ 0x5333, 0x8880, "", "86c868 [Vision 868 VRAM] vers 0" } ,
	{ 0x5333, 0x8881, "", "86c868 [Vision 868 VRAM] vers 1" } ,
	{ 0x5333, 0x8882, "", "86c868 [Vision 868 VRAM] vers 2" } ,
	{ 0x5333, 0x8883, "", "86c868 [Vision 868 VRAM] vers 3" } ,
	{ 0x5333, 0x88B0, "", "86c928 [Vision 928 VRAM] vers 0" } ,
	{ 0x5333, 0x88B1, "", "86c928 [Vision 928 VRAM] vers 1" } ,
	{ 0x5333, 0x88B2, "", "86c928 [Vision 928 VRAM] vers 2" } ,
	{ 0x5333, 0x88B3, "", "86c928 [Vision 928 VRAM] vers 3" } ,
	{ 0x5333, 0x88C0, "", "86c864 [Vision 864 DRAM] vers 0" } ,
	{ 0x5333, 0x88C1, "", "86c864 [Vision 864 DRAM] vers 1" } ,
	{ 0x5333, 0x88C2, "", "86c864 [Vision 864-P DRAM] vers 2" } ,
	{ 0x5333, 0x88C3, "", "86c864 [Vision 864-P DRAM] vers 3" } ,
	{ 0x5333, 0x88D0, "", "86c964 [Vision 964 VRAM] vers 0" } ,
	{ 0x5333, 0x88D1, "", "86c964 [Vision 964 VRAM] vers 1" } ,
	{ 0x5333, 0x88D2, "", "86c964 [Vision 964-P VRAM] vers 2" } ,
	{ 0x5333, 0x88D3, "", "86c964 [Vision 964-P VRAM] vers 3" } ,
	{ 0x5333, 0x88F0, "", "86c968 [Vision 968 VRAM] rev 0" } ,
	{ 0x5333, 0x88F1, "", "86c968 [Vision 968 VRAM] rev 1" } ,
	{ 0x5333, 0x88F2, "", "86c968 [Vision 968 VRAM] rev 2" } ,
	{ 0x5333, 0x88F3, "", "86c968 [Vision 968 VRAM] rev 3" } ,
	{ 0x5333, 0x8900, "", "86c755 [Trio 64V2/DX]" } ,
	{ 0x5333, 0x8901, "", "86c775/86c785 [Trio 64V2/DX or /GX]" } ,
	{ 0x5333, 0x8902, "", "Plato/PX" } ,
	{ 0x5333, 0x8903, "", "Trio 3D business multimedia" } ,
	{ 0x5333, 0x8904, "", "Trio 64 3D" } ,
	{ 0x5333, 0x8905, "", "Trio 64V+ family" } ,
	{ 0x5333, 0x8906, "", "Trio 64V+ family" } ,
	{ 0x5333, 0x8907, "", "Trio 64V+ family" } ,
	{ 0x5333, 0x8908, "", "Trio 64V+ family" } ,
	{ 0x5333, 0x8909, "", "Trio 64V+ family" } ,
	{ 0x5333, 0x890A, "", "Trio 64V+ family" } ,
	{ 0x5333, 0x890B, "", "Trio 64V+ family" } ,
	{ 0x5333, 0x890C, "", "Trio 64V+ family" } ,
	{ 0x5333, 0x890D, "", "Trio 64V+ family" } ,
	{ 0x5333, 0x890E, "", "Trio 64V+ family" } ,
	{ 0x5333, 0x890F, "", "Trio 64V+ family" } ,
	{ 0x5333, 0x8A01, "", "ViRGE/DX or /GX" } ,
	{ 0x5333, 0x8A10, "", "ViRGE/GX2" } ,
	{ 0x5333, 0x8A13, "", "86c368 [Trio 3D/2X]" } ,
	{ 0x5333, 0x8A20, "", "86c794 [Savage 3D]" } ,
	{ 0x5333, 0x8A21, "", "86c390 [Savage 3D/MV]" } ,
	{ 0x5333, 0x8A22, "", "Savage 4" } ,
	{ 0x5333, 0x8A23, "", "Savage 4" } ,
	{ 0x5333, 0x8A25, "", "ProSavage PM133" } ,
	{ 0x5333, 0x8A26, "", "ProSavage KM133" } ,
	{ 0x5333, 0x8C00, "", "ViRGE/M3" } ,
	{ 0x5333, 0x8C01, "", "ViRGE/MX" } ,
	{ 0x5333, 0x8C02, "", "ViRGE/MX+" } ,
	{ 0x5333, 0x8C03, "", "ViRGE/MX+MV" } ,
	{ 0x5333, 0x8C10, "", "86C270-294 Savage/MX-MV" } ,
	{ 0x5333, 0x8C11, "", "82C270-294 Savage/MX" } ,
	{ 0x5333, 0x8C12, "", "86C270-294 Savage/IX-MV" } ,
	{ 0x5333, 0x8C13, "", "86C270-294 Savage/IX" } ,
	{ 0x5333, 0x8C22, "", "SuperSavage MX/128" } ,
	{ 0x5333, 0x8C24, "", "SuperSavage MX/64" } ,
	{ 0x5333, 0x8C26, "", "SuperSavage MX/64C" } ,
	{ 0x5333, 0x8C2A, "", "SuperSavage IX/128 SDR" } ,
	{ 0x5333, 0x8C2B, "", "SuperSavage IX/128 DDR" } ,
	{ 0x5333, 0x8C2C, "", "SuperSavage IX/64 SDR" } ,
	{ 0x5333, 0x8C2D, "", "SuperSavage IX/64 DDR" } ,
	{ 0x5333, 0x8C2E, "", "SuperSavage IX/C SDR" } ,
	{ 0x5333, 0x8C2F, "", "SuperSavage IX/C DDR" } ,
	{ 0x5333, 0x8D01, "", "86C380 [ProSavageDDR K4M266]" } ,
	{ 0x5333, 0x8D02, "", "VT8636A [ProSavage KN133] AGP4X VGA Controller (TwisterK)" } ,
	{ 0x5333, 0x8D03, "", "VT8751 [ProSavageDDR P4M266]" } ,
	{ 0x5333, 0x8D04, "", "VT8375 [ProSavage8 KM266/KL266]" } ,
	{ 0x5333, 0x9102, "", "86C410 Savage 2000" } ,
	{ 0x5333, 0xCA00, "", "SonicVibes" } ,
	{ 0x544C, 0x0350, "", "TL880-based HDTV/ATSC tuner" } ,
	{ 0x5455, 0x4458, "", "S5933" } ,
	{ 0x5544, 0x0001, "", "I-30xx Scanner Interface" } ,
	{ 0x5555, 0x0003, "", "TURBOstor HFP-832 [HiPPI NIC]" } ,
	{ 0x5654, 0x3132, "", "OpenSwitch12" } ,
	{ 0x6374, 0x6773, "", "GPPCI" } ,
	{ 0x6666, 0x0001, "", "PCCOM4" } ,
	{ 0x6666, 0x0002, "", "PCCOM8" } ,
	{ 0x6666, 0x0004, "", "PCCOM2" } ,
	{ 0x7063, 0x2000, "", "HD-2000" } ,
	{ 0x7063, 0x3000, "", "HD-3000" } ,
	{ 0x8008, 0x0010, "", "WDOG1 [PCI-Watchdog 1]" } ,
	{ 0x8008, 0x0011, "", "PWDOG2 [PCI-Watchdog 2]" } ,
	{ 0x8086, 0x0007, "", "82379AB" } ,
	{ 0x8086, 0x0008, "", "Extended Express System Support Controller" } ,
	{ 0x8086, 0x0039, "", "21145 Fast Ethernet" } ,
	{ 0x8086, 0x0122, "", "82437FX" } ,
	{ 0x8086, 0x0309, "", "80303 I/O Processor PCI-to-PCI Bridge" } ,
	{ 0x8086, 0x030D, "", "80312 I/O Companion Chip PCI-to-PCI Bridge" } ,
	{ 0x8086, 0x0326, "", "6700/6702PXH I/OxAPIC Interrupt Controller A" } ,
	{ 0x8086, 0x0327, "", "6700PXH I/OxAPIC Interrupt Controller B" } ,
	{ 0x8086, 0x0329, "", "6700PXH PCI Express-to-PCI Bridge A" } ,
	{ 0x8086, 0x032A, "", "6700PXH PCI Express-to-PCI Bridge B" } ,
	{ 0x8086, 0x032C, "", "6702PXH PCI Express-to-PCI Bridge A" } ,
	{ 0x8086, 0x0330, "", "80332 [Dobson] I/O processor (A-Segment Bridge)" } ,
	{ 0x8086, 0x0331, "", "80332 [Dobson] I/O processor (A-Segment IOAPIC)" } ,
	{ 0x8086, 0x0332, "", "80332 [Dobson] I/O processor (B-Segment Bridge)" } ,
	{ 0x8086, 0x0333, "", "80332 [Dobson] I/O processor (B-Segment IOAPIC)" } ,
	{ 0x8086, 0x0334, "", "80332 [Dobson] I/O processor (ATU)" } ,
	{ 0x8086, 0x0335, "", "80331 [Lindsay] I/O processor (PCI-X Bridge)" } ,
	{ 0x8086, 0x0336, "", "80331 [Lindsay] I/O processor (ATU)" } ,
	{ 0x8086, 0x0340, "", "41210 [Lanai] Serial to Parallel PCI Bridge (A-Segment Bridge)" } ,
	{ 0x8086, 0x0341, "", "41210 [Lanai] Serial to Parallel PCI Bridge (B-Segment Bridge)" } ,
	{ 0x8086, 0x0370, "", "80333 Segment-A PCI Express-to-PCI Express Bridge" } ,
	{ 0x8086, 0x0371, "", "80333 A-Bus IOAPIC" } ,
	{ 0x8086, 0x0372, "", "80333 Segment-B PCI Express-to-PCI Express Bridge" } ,
	{ 0x8086, 0x0373, "", "80333 B-Bus IOAPIC" } ,
	{ 0x8086, 0x0374, "", "80333 Address Translation Unit" } ,
	{ 0x8086, 0x0482, "", "82375EB/SB PCI to EISA Bridge" } ,
	{ 0x8086, 0x0483, "", "82424TX/ZX [Saturn] CPU to PCI bridge" } ,
	{ 0x8086, 0x0484, "", "82378ZB/IB, 82379AB (SIO, SIO.A) PCI to ISA Bridge" } ,
	{ 0x8086, 0x0486, "", "82425EX/ZX [Aries] PCIset with ISA bridge" } ,
	{ 0x8086, 0x04A3, "", "82434LX/NX [Mercury/Neptune] Processor to PCI bridge" } ,
	{ 0x8086, 0x04D0, "", "82437FX [Triton FX]" } ,
	{ 0x8086, 0x0500, "", "E8870 Processor bus control" } ,
	{ 0x8086, 0x0501, "", "E8870 Memory controller" } ,
	{ 0x8086, 0x0502, "", "E8870 Scalability Port 0" } ,
	{ 0x8086, 0x0503, "", "E8870 Scalability Port 1" } ,
	{ 0x8086, 0x0510, "", "E8870IO Hub Interface Port 0 registers (8-bit compatibility port)" } ,
	{ 0x8086, 0x0511, "", "E8870IO Hub Interface Port 1 registers" } ,
	{ 0x8086, 0x0512, "", "E8870IO Hub Interface Port 2 registers" } ,
	{ 0x8086, 0x0513, "", "E8870IO Hub Interface Port 3 registers" } ,
	{ 0x8086, 0x0514, "", "E8870IO Hub Interface Port 4 registers" } ,
	{ 0x8086, 0x0515, "", "E8870IO General SIOH registers" } ,
	{ 0x8086, 0x0516, "", "E8870IO RAS registers" } ,
	{ 0x8086, 0x0530, "", "E8870SP Scalability Port 0 registers" } ,
	{ 0x8086, 0x0531, "", "E8870SP Scalability Port 1 registers" } ,
	{ 0x8086, 0x0532, "", "E8870SP Scalability Port 2 registers" } ,
	{ 0x8086, 0x0533, "", "E8870SP Scalability Port 3 registers" } ,
	{ 0x8086, 0x0534, "", "E8870SP Scalability Port 4 registers" } ,
	{ 0x8086, 0x0535, "", "E8870SP Scalability Port 5 registers" } ,
	{ 0x8086, 0x0536, "", "E8870SP Interleave registers 0 and 1" } ,
	{ 0x8086, 0x0537, "", "E8870SP Interleave registers 2 and 3" } ,
	{ 0x8086, 0x0600, "", "RAID Controller" } ,
	{ 0x8086, 0x061F, "", "80303 I/O Processor" } ,
	{ 0x8086, 0x0960, "", "80960RP [i960 RP Microprocessor/Bridge]" } ,
	{ 0x8086, 0x0962, "", "80960RM [i960RM Bridge]" } ,
	{ 0x8086, 0x0964, "", "80960RP [i960 RP Microprocessor/Bridge]" } ,
	{ 0x8086, 0x1000, "", "82542 Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x1001, "", "82543GC Gigabit Ethernet Controller (Fiber)" } ,
	{ 0x8086, 0x1002, "", "Pro 100 LAN+Modem 56 Cardbus II" } ,
	{ 0x8086, 0x1004, "", "82543GC Gigabit Ethernet Controller (Copper)" } ,
	{ 0x8086, 0x1008, "", "82544EI Gigabit Ethernet Controller (Copper)" } ,
	{ 0x8086, 0x1009, "", "82544EI Gigabit Ethernet Controller (Fiber)" } ,
	{ 0x8086, 0x100A, "", "82540EM Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x100C, "", "82544GC Gigabit Ethernet Controller (Copper)" } ,
	{ 0x8086, 0x100D, "", "82544GC Gigabit Ethernet Controller (LOM)" } ,
	{ 0x8086, 0x100E, "", "82540EM Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x100F, "", "82545EM Gigabit Ethernet Controller (Copper)" } ,
	{ 0x8086, 0x1010, "", "82546EB Gigabit Ethernet Controller (Copper)" } ,
	{ 0x8086, 0x1011, "", "82545EM Gigabit Ethernet Controller (Fiber)" } ,
	{ 0x8086, 0x1012, "", "82546EB Gigabit Ethernet Controller (Fiber)" } ,
	{ 0x8086, 0x1013, "", "82541EI Gigabit Ethernet Controller (Copper)" } ,
	{ 0x8086, 0x1014, "", "82541ER Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x1015, "", "82540EM Gigabit Ethernet Controller (LOM)" } ,
	{ 0x8086, 0x1016, "", "82540EP Gigabit Ethernet Controller (LOM)" } ,
	{ 0x8086, 0x1017, "", "82540EP Gigabit Ethernet Controller (LOM)" } ,
	{ 0x8086, 0x1018, "", "82541EI Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x1019, "", "82547EI Gigabit Ethernet Controller (LOM)" } ,
	{ 0x8086, 0x101A, "", "82547EI Gigabit Ethernet Controller (Mobile)" } ,
	{ 0x8086, 0x101D, "", "82546EB Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x101E, "", "82540EP Gigabit Ethernet Controller (Mobile)" } ,
	{ 0x8086, 0x1026, "", "82545GM Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x1027, "", "82545GM Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x1028, "", "82545GM Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x1029, "", "82559 Ethernet Controller" } ,
	{ 0x8086, 0x1030, "", "82559 InBusiness 10/100" } ,
	{ 0x8086, 0x1031, "", "82801CAM (ICH3) PRO/100 VE (LOM) Ethernet Controller" } ,
	{ 0x8086, 0x1032, "", "82801CAM (ICH3) PRO/100 VE Ethernet Controller" } ,
	{ 0x8086, 0x1033, "", "82801CAM (ICH3) PRO/100 VM (LOM) Ethernet Controller" } ,
	{ 0x8086, 0x1034, "", "82801CAM (ICH3) PRO/100 VM Ethernet Controller" } ,
	{ 0x8086, 0x1035, "", "82801CAM (ICH3)/82562EH (LOM)  Ethernet Controller" } ,
	{ 0x8086, 0x1036, "", "82801CAM (ICH3) 82562EH Ethernet Controller" } ,
	{ 0x8086, 0x1037, "", "82801CAM (ICH3) Chipset Ethernet Controller" } ,
	{ 0x8086, 0x1038, "", "82801CAM (ICH3) PRO/100 VM (KM) Ethernet Controller" } ,
	{ 0x8086, 0x1039, "", "82801DB PRO/100 VE (LOM) Ethernet Controller" } ,
	{ 0x8086, 0x103A, "", "82801DB PRO/100 VE (CNR) Ethernet Controller" } ,
	{ 0x8086, 0x103B, "", "82801DB PRO/100 VM (LOM) Ethernet Controller" } ,
	{ 0x8086, 0x103C, "", "82801DB PRO/100 VM (CNR) Ethernet Controller" } ,
	{ 0x8086, 0x103D, "", "82801DB PRO/100 VE (MOB) Ethernet Controller" } ,
	{ 0x8086, 0x103E, "", "82801DB PRO/100 VM (MOB) Ethernet Controller" } ,
	{ 0x8086, 0x1040, "", "536EP Data Fax Modem" } ,
	{ 0x8086, 0x1043, "", "PRO/Wireless LAN 2100 3B Mini PCI Adapter" } ,
	{ 0x8086, 0x1048, "", "PRO/10GbE LR Server Adapter" } ,
	{ 0x8086, 0x1050, "", "82562EZ 10/100 Ethernet Controller" } ,
	{ 0x8086, 0x1051, "", "82801EB/ER (ICH5/ICH5R) integrated LAN Controller" } ,
	{ 0x8086, 0x1052, "", "PRO/100 VM Network Connection" } ,
	{ 0x8086, 0x1053, "", "PRO/100 VM Network Connection" } ,
	{ 0x8086, 0x1059, "", "82551QM Ethernet Controller" } ,
	{ 0x8086, 0x105E, "", "82571EB Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x105F, "", "82571EB Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x1060, "", "82571EB Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x1064, "", "82562ET/EZ/GT/GZ - PRO/100 VE (LOM) Ethernet Controller" } ,
	{ 0x8086, 0x1065, "", "82562ET/EZ/GT/GZ - PRO/100 VE Ethernet Controller" } ,
	{ 0x8086, 0x1066, "", "82562 EM/EX/GX - PRO/100 VM (LOM) Ethernet Controller" } ,
	{ 0x8086, 0x1067, "", "82562 EM/EX/GX - PRO/100 VM Ethernet Controller" } ,
	{ 0x8086, 0x1068, "", "82562ET/EZ/GT/GZ - PRO/100 VE (LOM) Ethernet Controller Mobile" } ,
	{ 0x8086, 0x1069, "", "82562EM/EX/GX - PRO/100 VM (LOM) Ethernet Controller Mobile" } ,
	{ 0x8086, 0x106A, "", "82562G - PRO/100 VE (LOM) Ethernet Controller" } ,
	{ 0x8086, 0x106B, "", "82562G - PRO/100 VE Ethernet Controller Mobile" } ,
	{ 0x8086, 0x1075, "", "82547GI Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x1076, "", "82541GI/PI Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x1077, "", "82541GI Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x1078, "", "82541EI Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x1079, "", "82546GB Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x107A, "", "82546GB Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x107B, "", "82546GB Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x107C, "", "82541PI Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x107D, "", "82572EI Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x107E, "", "82572EI Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x107F, "", "82572EI Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x1080, "", "FA82537EP 56K V.92 Data/Fax Modem PCI" } ,
	{ 0x8086, 0x1081, "", "Enterprise Southbridge LAN Copper" } ,
	{ 0x8086, 0x1082, "", "Enterprise Southbridge LAN fiber" } ,
	{ 0x8086, 0x1083, "", "Enterprise Southbridge LAN SERDES" } ,
	{ 0x8086, 0x1084, "", "Enterprise Southbridge IDE Redirection" } ,
	{ 0x8086, 0x1085, "", "Enterprise Southbridge Serial Port Redirection" } ,
	{ 0x8086, 0x1086, "", "Enterprise Southbridge IPMI/KCS0" } ,
	{ 0x8086, 0x1087, "", "Enterprise Southbridge UHCI Redirection" } ,
	{ 0x8086, 0x1089, "", "Enterprise Southbridge BT" } ,
	{ 0x8086, 0x108A, "", "82546EB Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x108B, "", "82573V Gigabit Ethernet Controller (Copper)" } ,
	{ 0x8086, 0x108C, "", "82573E Gigabit Ethernet Controller (Copper)" } ,
	{ 0x8086, 0x1096, "", "Enterprise Southbridge DPT LAN Copper" } ,
	{ 0x8086, 0x1097, "", "Enterprise Southbridge DPT LAN fiber" } ,
	{ 0x8086, 0x1098, "", "Enterprise Southbridge DPT LAN SERDES" } ,
	{ 0x8086, 0x1099, "", "82546GB Quad Port Server Adapter" } ,
	{ 0x8086, 0x109A, "", "82573L Gigabit Ethernet Controller" } ,
	{ 0x8086, 0x1107, "", "PRO/1000 MF Server Adapter (LX)" } ,
	{ 0x8086, 0x1130, "", "82815 815 Chipset Host Bridge and Memory Controller Hub" } ,
	{ 0x8086, 0x1131, "", "82815 815 Chipset AGP Bridge" } ,
	{ 0x8086, 0x1132, "", "82815 CGC [Chipset Graphics Controller]" } ,
	{ 0x8086, 0x1161, "", "82806AA PCI64 Hub Advanced Programmable Interrupt Controller" } ,
	{ 0x8086, 0x1162, "", "Xscale 80200 Big Endian Companion Chip" } ,
	{ 0x8086, 0x1200, "", "Intel IXP1200 Network Processor" } ,
	{ 0x8086, 0x1209, "", "8255xER/82551IT Fast Ethernet Controller" } ,
	{ 0x8086, 0x1221, "", "82092AA PCI to PCMCIA Bridge" } ,
	{ 0x8086, 0x1222, "", "82092AA IDE Controller" } ,
	{ 0x8086, 0x1223, "", "SAA7116" } ,
	{ 0x8086, 0x1225, "", "82452KX/GX [Orion]" } ,
	{ 0x8086, 0x1226, "", "82596 PRO/10 PCI" } ,
	{ 0x8086, 0x1227, "", "82865 EtherExpress PRO/100A" } ,
	{ 0x8086, 0x1228, "", "82556 EtherExpress PRO/100 Smart" } ,
	{ 0x8086, 0x1229, "", "82557/8/9 [Ethernet Pro 100]" } ,
	{ 0x8086, 0x122D, "", "430FX - 82437FX TSC [Triton I]" } ,
	{ 0x8086, 0x122E, "", "82371FB PIIX ISA [Triton I]" } ,
	{ 0x8086, 0x1230, "", "82371FB PIIX IDE [Triton I]" } ,
	{ 0x8086, 0x1231, "", "DSVD Modem" } ,
	{ 0x8086, 0x1234, "", "430MX - 82371MX Mobile PCI I/O IDE Xcelerator (MPIIX)" } ,
	{ 0x8086, 0x1235, "", "430MX - 82437MX Mob. System Ctrlr (MTSC) & 82438MX Data Path (MTDP)" } ,
	{ 0x8086, 0x1237, "", "440FX - 82441FX PMC [Natoma]" } ,
	{ 0x8086, 0x1239, "", "82371FB PIIX IDE Interface" } ,
	{ 0x8086, 0x123B, "", "82380PB PCI to PCI Docking Bridge" } ,
	{ 0x8086, 0x123C, "", "82380AB (MISA) Mobile PCI-to-ISA Bridge" } ,
	{ 0x8086, 0x123D, "", "683053 Programmable Interrupt Device" } ,
	{ 0x8086, 0x123E, "", "82466GX (IHPC) Integrated Hot-Plug Controller" } ,
	{ 0x8086, 0x123F, "", "82466GX Integrated Hot-Plug Controller (IHPC)" } ,
	{ 0x8086, 0x1240, "", "82752 (752) AGP Graphics Accelerator" } ,
	{ 0x8086, 0x124B, "", "82380FB (MPCI2) Mobile Docking Controller" } ,
	{ 0x8086, 0x1250, "", "430HX - 82439HX TXC [Triton II]" } ,
	{ 0x8086, 0x1360, "", "82806AA PCI64 Hub PCI Bridge" } ,
	{ 0x8086, 0x1361, "", "82806AA PCI64 Hub Controller (HRes)" } ,
	{ 0x8086, 0x1460, "", "82870P2 P64H2 Hub PCI Bridge" } ,
	{ 0x8086, 0x1461, "", "82870P2 P64H2 I/OxAPIC" } ,
	{ 0x8086, 0x1462, "", "82870P2 P64H2 Hot Plug Controller" } ,
	{ 0x8086, 0x1960, "", "80960RP [i960RP Microprocessor]" } ,
	{ 0x8086, 0x1962, "", "80960RM [i960RM Microprocessor]" } ,
	{ 0x8086, 0x1A21, "", "82840 840 (Carmel) Chipset Host Bridge (Hub A)" } ,
	{ 0x8086, 0x1A23, "", "82840 840 (Carmel) Chipset AGP Bridge" } ,
	{ 0x8086, 0x1A24, "", "82840 840 (Carmel) Chipset PCI Bridge (Hub B)" } ,
	{ 0x8086, 0x1A30, "", "82845 845 (Brookdale) Chipset Host Bridge" } ,
	{ 0x8086, 0x1A31, "", "82845 845 (Brookdale) Chipset AGP Bridge" } ,
	{ 0x8086, 0x1A38, "", "Server DMA Controller" } ,
	{ 0x8086, 0x1A48, "", "PRO/10GbE SR Server Adapter" } ,
	{ 0x8086, 0x2410, "", "82801AA ISA Bridge (LPC)" } ,
	{ 0x8086, 0x2411, "", "82801AA IDE" } ,
	{ 0x8086, 0x2412, "", "82801AA USB" } ,
	{ 0x8086, 0x2413, "", "82801AA SMBus" } ,
	{ 0x8086, 0x2415, "", "82801AA AC'97 Audio" } ,
	{ 0x8086, 0x2416, "", "82801AA AC'97 Modem" } ,
	{ 0x8086, 0x2418, "", "82801AA PCI Bridge" } ,
	{ 0x8086, 0x2420, "", "82801AB ISA Bridge (LPC)" } ,
	{ 0x8086, 0x2421, "", "82801AB IDE" } ,
	{ 0x8086, 0x2422, "", "82801AB USB" } ,
	{ 0x8086, 0x2423, "", "82801AB SMBus" } ,
	{ 0x8086, 0x2425, "", "82801AB AC'97 Audio" } ,
	{ 0x8086, 0x2426, "", "82801AB AC'97 Modem" } ,
	{ 0x8086, 0x2428, "", "82801AB PCI Bridge" } ,
	{ 0x8086, 0x2440, "", "82801BA ISA Bridge (LPC)" } ,
	{ 0x8086, 0x2442, "", "82801BA/BAM USB (Hub #1)" } ,
	{ 0x8086, 0x2443, "", "82801BA/BAM SMBus" } ,
	{ 0x8086, 0x2444, "", "82801BA/BAM USB (Hub #2)" } ,
	{ 0x8086, 0x2445, "", "82801BA/BAM AC'97 Audio" } ,
	{ 0x8086, 0x2446, "", "82801BA/BAM AC'97 Modem" } ,
	{ 0x8086, 0x2448, "", "82801 Mobile PCI Bridge" } ,
	{ 0x8086, 0x2449, "", "82801BA/BAM/CA/CAM Ethernet Controller" } ,
	{ 0x8086, 0x244A, "", "82801BAM IDE U100" } ,
	{ 0x8086, 0x244B, "", "82801BA IDE U100" } ,
	{ 0x8086, 0x244C, "", "82801BAM ISA Bridge (LPC)" } ,
	{ 0x8086, 0x244E, "", "82801 PCI Bridge" } ,
	{ 0x8086, 0x2450, "", "82801E ISA Bridge (LPC)" } ,
	{ 0x8086, 0x2452, "", "82801E USB" } ,
	{ 0x8086, 0x2453, "", "82801E SMBus" } ,
	{ 0x8086, 0x2459, "", "82801E Ethernet Controller 0" } ,
	{ 0x8086, 0x245B, "", "82801E IDE U100" } ,
	{ 0x8086, 0x245D, "", "82801E Ethernet Controller 1" } ,
	{ 0x8086, 0x245E, "", "82801E PCI Bridge" } ,
	{ 0x8086, 0x2480, "", "82801CA LPC Interface Controller" } ,
	{ 0x8086, 0x2482, "", "82801CA/CAM USB (Hub #1)" } ,
	{ 0x8086, 0x2483, "", "82801CA/CAM SMBus Controller" } ,
	{ 0x8086, 0x2484, "", "82801CA/CAM USB (Hub #2)" } ,
	{ 0x8086, 0x2485, "", "82801CA/CAM AC'97 Audio Controller" } ,
	{ 0x8086, 0x2486, "", "82801CA/CAM AC'97 Modem Controller" } ,
	{ 0x8086, 0x2487, "", "82801CA/CAM USB (Hub #3)" } ,
	{ 0x8086, 0x248A, "", "82801CAM IDE U100" } ,
	{ 0x8086, 0x248B, "", "82801CA Ultra ATA Storage Controller" } ,
	{ 0x8086, 0x248C, "", "82801CAM ISA Bridge (LPC)" } ,
	{ 0x8086, 0x24C0, "", "82801DB/DBL (ICH4/ICH4-L) LPC Interface Bridge" } ,
	{ 0x8086, 0x24C1, "", "82801DBL (ICH4-L) IDE Controller" } ,
	{ 0x8086, 0x24C2, "", "82801DB/DBL/DBM (ICH4/ICH4-L/ICH4-M) USB UHCI Controller #1" } ,
	{ 0x8086, 0x24C3, "", "82801DB/DBL/DBM (ICH4/ICH4-L/ICH4-M) SMBus Controller" } ,
	{ 0x8086, 0x24C4, "", "82801DB/DBL/DBM (ICH4/ICH4-L/ICH4-M) USB UHCI Controller #2" } ,
	{ 0x8086, 0x24C5, "", "82801DB/DBL/DBM (ICH4/ICH4-L/ICH4-M) AC'97 Audio Controller" } ,
	{ 0x8086, 0x24C6, "", "82801DB/DBL/DBM (ICH4/ICH4-L/ICH4-M) AC'97 Modem Controller" } ,
	{ 0x8086, 0x24C7, "", "82801DB/DBL/DBM (ICH4/ICH4-L/ICH4-M) USB UHCI Controller #3" } ,
	{ 0x8086, 0x24CA, "", "82801DBM (ICH4-M) IDE Controller" } ,
	{ 0x8086, 0x24CB, "", "82801DB (ICH4) IDE Controller" } ,
	{ 0x8086, 0x24CC, "", "82801DBM (ICH4-M) LPC Interface Bridge" } ,
	{ 0x8086, 0x24CD, "", "82801DB/DBM (ICH4/ICH4-M) USB2 EHCI Controller" } ,
	{ 0x8086, 0x24D0, "", "82801EB/ER (ICH5/ICH5R) LPC Interface Bridge" } ,
	{ 0x8086, 0x24D1, "", "82801EB (ICH5) SATA Controller" } ,
	{ 0x8086, 0x24D2, "", "82801EB/ER (ICH5/ICH5R) USB UHCI Controller #1" } ,
	{ 0x8086, 0x24D3, "", "82801EB/ER (ICH5/ICH5R) SMBus Controller" } ,
	{ 0x8086, 0x24D4, "", "82801EB/ER (ICH5/ICH5R) USB UHCI Controller #2" } ,
	{ 0x8086, 0x24D5, "", "82801EB/ER (ICH5/ICH5R) AC'97 Audio Controller" } ,
	{ 0x8086, 0x24D6, "", "82801EB/ER (ICH5/ICH5R) AC'97 Modem Controller" } ,
	{ 0x8086, 0x24D7, "", "82801EB/ER (ICH5/ICH5R) USB UHCI Controller #3" } ,
	{ 0x8086, 0x24DB, "", "82801EB/ER (ICH5/ICH5R) IDE Controller" } ,
	{ 0x8086, 0x24DC, "", "82801EB (ICH5) LPC Interface Bridge" } ,
	{ 0x8086, 0x24DD, "", "82801EB/ER (ICH5/ICH5R) USB2 EHCI Controller" } ,
	{ 0x8086, 0x24DE, "", "82801EB/ER (ICH5/ICH5R) USB UHCI Controller #4" } ,
	{ 0x8086, 0x24DF, "", "82801ER (ICH5R) SATA Controller" } ,
	{ 0x8086, 0x2500, "", "82820 820 (Camino) Chipset Host Bridge (MCH)" } ,
	{ 0x8086, 0x2501, "", "82820 820 (Camino) Chipset Host Bridge (MCH)" } ,
	{ 0x8086, 0x250B, "", "82820 820 (Camino) Chipset Host Bridge" } ,
	{ 0x8086, 0x250F, "", "82820 820 (Camino) Chipset AGP Bridge" } ,
	{ 0x8086, 0x2520, "", "82805AA MTH Memory Translator Hub" } ,
	{ 0x8086, 0x2521, "", "82804AA MRH-S Memory Repeater Hub for SDRAM" } ,
	{ 0x8086, 0x2530, "", "82850 850 (Tehama) Chipset Host Bridge (MCH)" } ,
	{ 0x8086, 0x2531, "", "82860 860 (Wombat) Chipset Host Bridge (MCH)" } ,
	{ 0x8086, 0x2532, "", "82850 850 (Tehama) Chipset AGP Bridge" } ,
	{ 0x8086, 0x2533, "", "82860 860 (Wombat) Chipset AGP Bridge" } ,
	{ 0x8086, 0x2534, "", "82860 860 (Wombat) Chipset PCI Bridge" } ,
	{ 0x8086, 0x2540, "", "E7500 Memory Controller Hub" } ,
	{ 0x8086, 0x2541, "", "E7500/E7501 Host RASUM Controller" } ,
	{ 0x8086, 0x2543, "", "E7500/E7501 Hub Interface B PCI-to-PCI Bridge" } ,
	{ 0x8086, 0x2544, "", "E7500/E7501 Hub Interface B RASUM Controller" } ,
	{ 0x8086, 0x2545, "", "E7500/E7501 Hub Interface C PCI-to-PCI Bridge" } ,
	{ 0x8086, 0x2546, "", "E7500/E7501 Hub Interface C RASUM Controller" } ,
	{ 0x8086, 0x2547, "", "E7500/E7501 Hub Interface D PCI-to-PCI Bridge" } ,
	{ 0x8086, 0x2548, "", "E7500/E7501 Hub Interface D RASUM Controller" } ,
	{ 0x8086, 0x254C, "", "E7501 Memory Controller Hub" } ,
	{ 0x8086, 0x2550, "", "E7505 Memory Controller Hub" } ,
	{ 0x8086, 0x2551, "", "E7505/E7205 Series RAS Controller" } ,
	{ 0x8086, 0x2552, "", "E7505/E7205 PCI-to-AGP Bridge" } ,
	{ 0x8086, 0x2553, "", "E7505 Hub Interface B PCI-to-PCI Bridge" } ,
	{ 0x8086, 0x2554, "", "E7505 Hub Interface B PCI-to-PCI Bridge RAS Controller" } ,
	{ 0x8086, 0x255D, "", "E7205 Memory Controller Hub" } ,
	{ 0x8086, 0x2560, "", "82845G/GL[Brookdale-G]/GE/PE DRAM Controller/Host-Hub Interface" } ,
	{ 0x8086, 0x2561, "", "82845G/GL[Brookdale-G]/GE/PE Host-to-AGP Bridge" } ,
	{ 0x8086, 0x2562, "", "82845G/GL[Brookdale-G]/GE Chipset Integrated Graphics Device" } ,
	{ 0x8086, 0x2570, "", "82865G/PE/P DRAM Controller/Host-Hub Interface" } ,
	{ 0x8086, 0x2571, "", "82865G/PE/P PCI to AGP Controller" } ,
	{ 0x8086, 0x2572, "", "82865G Integrated Graphics Controller" } ,
	{ 0x8086, 0x2573, "", "82865G/PE/P PCI to CSA Bridge" } ,
	{ 0x8086, 0x2576, "", "82865G/PE/P Processor to I/O Memory Interface" } ,
	{ 0x8086, 0x2578, "", "82875P/E7210 Memory Controller Hub" } ,
	{ 0x8086, 0x2579, "", "82875P Processor to AGP Controller" } ,
	{ 0x8086, 0x257B, "", "82875P/E7210 Processor to PCI to CSA Bridge" } ,
	{ 0x8086, 0x257E, "", "82875P/E7210 Processor to I/O Memory Interface" } ,
	{ 0x8086, 0x2580, "", "915G/P/GV/GL/PL/910GL Processor to I/O Controller" } ,
	{ 0x8086, 0x2581, "", "915G/P/GV/GL/PL/910GL PCI Express Root Port" } ,
	{ 0x8086, 0x2582, "", "82915G/GV/910GL Express Chipset Family Graphics Controller" } ,
	{ 0x8086, 0x2584, "", "925X/XE Memory Controller Hub" } ,
	{ 0x8086, 0x2585, "", "925X/XE PCI Express Root Port" } ,
	{ 0x8086, 0x2588, "", "E7220/E7221 Memory Controller Hub" } ,
	{ 0x8086, 0x2589, "", "E7220/E7221 PCI Express Root Port" } ,
	{ 0x8086, 0x258A, "", "E7221 Integrated Graphics Controller" } ,
	{ 0x8086, 0x2590, "", "Mobile 915GM/PM/GMS/910GML Express Processor to DRAM Controller" } ,
	{ 0x8086, 0x2591, "", "Mobile 915GM/PM Express PCI Express Root Port" } ,
	{ 0x8086, 0x2592, "", "Mobile 915GM/GMS/910GML Express Graphics Controller" } ,
	{ 0x8086, 0x25A1, "", "6300ESB LPC Interface Controller" } ,
	{ 0x8086, 0x25A2, "", "6300ESB PATA Storage Controller" } ,
	{ 0x8086, 0x25A3, "", "6300ESB SATA Storage Controller" } ,
	{ 0x8086, 0x25A4, "", "6300ESB SMBus Controller" } ,
	{ 0x8086, 0x25A6, "", "6300ESB AC'97 Audio Controller" } ,
	{ 0x8086, 0x25A7, "", "6300ESB AC'97 Modem Controller" } ,
	{ 0x8086, 0x25A9, "", "6300ESB USB Universal Host Controller" } ,
	{ 0x8086, 0x25AA, "", "6300ESB USB Universal Host Controller" } ,
	{ 0x8086, 0x25AB, "", "6300ESB Watchdog Timer" } ,
	{ 0x8086, 0x25AC, "", "6300ESB I/O Advanced Programmable Interrupt Controller" } ,
	{ 0x8086, 0x25AD, "", "6300ESB USB2 Enhanced Host Controller" } ,
	{ 0x8086, 0x25AE, "", "6300ESB 64-bit PCI-X Bridge" } ,
	{ 0x8086, 0x25B0, "", "6300ESB SATA RAID Controller" } ,
	{ 0x8086, 0x25C0, "", "Workstation Memory Controller Hub" } ,
	{ 0x8086, 0x25D0, "", "Server Memory Controller Hub" } ,
	{ 0x8086, 0x25D4, "", "Server Memory Contoller Hub" } ,
	{ 0x8086, 0x25D8, "", "Server Memory Controller Hub" } ,
	{ 0x8086, 0x25E2, "", "Server PCI Express x4 Port 2" } ,
	{ 0x8086, 0x25E3, "", "Server PCI Express x4 Port 3" } ,
	{ 0x8086, 0x25E4, "", "Server PCI Express x4 Port 4" } ,
	{ 0x8086, 0x25E5, "", "Server PCI Express x4 Port 5" } ,
	{ 0x8086, 0x25E6, "", "Server PCI Express x4 Port 6" } ,
	{ 0x8086, 0x25E7, "", "Server PCI Express x4 Port 7" } ,
	{ 0x8086, 0x25E8, "", "Server AMB Memory Mapped Registers" } ,
	{ 0x8086, 0x25F0, "", "Server Error Reporting Registers" } ,
	{ 0x8086, 0x25F1, "", "Reserved Registers" } ,
	{ 0x8086, 0x25F3, "", "Reserved Registers" } ,
	{ 0x8086, 0x25F5, "", "Server FBD Registers" } ,
	{ 0x8086, 0x25F6, "", "Server FBD Registers" } ,
	{ 0x8086, 0x25F7, "", "Server PCI Express x8 Port 2-3" } ,
	{ 0x8086, 0x25F8, "", "Server PCI Express x8 Port 4-5" } ,
	{ 0x8086, 0x25F9, "", "Server PCI Express x8 Port 6-7" } ,
	{ 0x8086, 0x25FA, "", "Server PCI Express x16 Port 4-7" } ,
	{ 0x8086, 0x2600, "", "E8500/E8501 Hub Interface 1.5" } ,
	{ 0x8086, 0x2601, "", "E8500/E8501 PCI Express x4 Port D" } ,
	{ 0x8086, 0x2602, "", "E8500/E8501 PCI Express x4 Port C0" } ,
	{ 0x8086, 0x2603, "", "E8500/E8501 PCI Express x4 Port C1" } ,
	{ 0x8086, 0x2604, "", "E8500/E8501 PCI Express x4 Port B0" } ,
	{ 0x8086, 0x2605, "", "E8500/E8501 PCI Express x4 Port B1" } ,
	{ 0x8086, 0x2606, "", "E8500/E8501 PCI Express x4 Port A0" } ,
	{ 0x8086, 0x2607, "", "E8500/E8501 PCI Express x4 Port A1" } ,
	{ 0x8086, 0x2608, "", "E8500/E8501 PCI Express x8 Port C" } ,
	{ 0x8086, 0x2609, "", "E8500/E8501 PCI Express x8 Port B" } ,
	{ 0x8086, 0x260A, "", "E8500/E8501 PCI Express x8 Port A" } ,
	{ 0x8086, 0x260C, "", "E8500/E8501 IMI Registers" } ,
	{ 0x8086, 0x2610, "", "E8500/E8501 Front Side Bus, Boot, and Interrupt Registers" } ,
	{ 0x8086, 0x2611, "", "E8500/E8501 Address Mapping Registers" } ,
	{ 0x8086, 0x2612, "", "E8500/E8501 RAS Registers" } ,
	{ 0x8086, 0x2613, "", "E8500/E8501 Reserved Registers" } ,
	{ 0x8086, 0x2614, "", "E8500/E8501 Reserved Registers" } ,
	{ 0x8086, 0x2615, "", "E8500/E8501 Miscellaneous Registers" } ,
	{ 0x8086, 0x2617, "", "E8500/E8501 Reserved Registers" } ,
	{ 0x8086, 0x2618, "", "E8500/E8501 Reserved Registers" } ,
	{ 0x8086, 0x2619, "", "E8500/E8501 Reserved Registers" } ,
	{ 0x8086, 0x261A, "", "E8500/E8501 Reserved Registers" } ,
	{ 0x8086, 0x261B, "", "E8500/E8501 Reserved Registers" } ,
	{ 0x8086, 0x261C, "", "E8500/E8501 Reserved Registers" } ,
	{ 0x8086, 0x261D, "", "E8500/E8501 Reserved Registers" } ,
	{ 0x8086, 0x261E, "", "E8500/E8501 Reserved Registers" } ,
	{ 0x8086, 0x2620, "", "E8500/E8501 eXternal Memory Bridge" } ,
	{ 0x8086, 0x2621, "", "E8500/E8501 XMB Miscellaneous Registers" } ,
	{ 0x8086, 0x2622, "", "E8500/E8501 XMB Memory Interleaving Registers" } ,
	{ 0x8086, 0x2623, "", "E8500/E8501 XMB DDR Initialization and Calibration" } ,
	{ 0x8086, 0x2624, "", "E8500/E8501 XMB Reserved Registers" } ,
	{ 0x8086, 0x2625, "", "E8500/E8501 XMB Reserved Registers" } ,
	{ 0x8086, 0x2626, "", "E8500/E8501 XMB Reserved Registers" } ,
	{ 0x8086, 0x2627, "", "E8500/E8501 XMB Reserved Registers" } ,
	{ 0x8086, 0x2640, "", "82801FB/FR (ICH6/ICH6R) LPC Interface Bridge" } ,
	{ 0x8086, 0x2641, "", "82801FBM (ICH6M) LPC Interface Bridge" } ,
	{ 0x8086, 0x2642, "", "82801FW/FRW (ICH6W/ICH6RW) LPC Interface Bridge" } ,
	{ 0x8086, 0x2651, "", "82801FB/FW (ICH6/ICH6W) SATA Controller" } ,
	{ 0x8086, 0x2652, "", "82801FR/FRW (ICH6R/ICH6RW) SATA Controller" } ,
	{ 0x8086, 0x2653, "", "82801FBM (ICH6M) SATA Controller" } ,
	{ 0x8086, 0x2658, "", "82801FB/FBM/FR/FW/FRW (ICH6 Family) USB UHCI #1" } ,
	{ 0x8086, 0x2659, "", "82801FB/FBM/FR/FW/FRW (ICH6 Family) USB UHCI #2" } ,
	{ 0x8086, 0x265A, "", "82801FB/FBM/FR/FW/FRW (ICH6 Family) USB UHCI #3" } ,
	{ 0x8086, 0x265B, "", "82801FB/FBM/FR/FW/FRW (ICH6 Family) USB UHCI #4" } ,
	{ 0x8086, 0x265C, "", "82801FB/FBM/FR/FW/FRW (ICH6 Family) USB2 EHCI Controller" } ,
	{ 0x8086, 0x2660, "", "82801FB/FBM/FR/FW/FRW (ICH6 Family) PCI Express Port 1" } ,
	{ 0x8086, 0x2662, "", "82801FB/FBM/FR/FW/FRW (ICH6 Family) PCI Express Port 2" } ,
	{ 0x8086, 0x2664, "", "82801FB/FBM/FR/FW/FRW (ICH6 Family) PCI Express Port 3" } ,
	{ 0x8086, 0x2666, "", "82801FB/FBM/FR/FW/FRW (ICH6 Family) PCI Express Port 4" } ,
	{ 0x8086, 0x2668, "", "82801FB/FBM/FR/FW/FRW (ICH6 Family) High Definition Audio Controller" } ,
	{ 0x8086, 0x266A, "", "82801FB/FBM/FR/FW/FRW (ICH6 Family) SMBus Controller" } ,
	{ 0x8086, 0x266C, "", "82801FB/FBM/FR/FW/FRW (ICH6 Family) LAN Controller" } ,
	{ 0x8086, 0x266D, "", "82801FB/FBM/FR/FW/FRW (ICH6 Family) AC'97 Modem Controller" } ,
	{ 0x8086, 0x266E, "", "82801FB/FBM/FR/FW/FRW (ICH6 Family) AC'97 Audio Controller" } ,
	{ 0x8086, 0x266F, "", "82801FB/FBM/FR/FW/FRW (ICH6 Family) IDE Controller" } ,
	{ 0x8086, 0x2670, "", "Enterprise Southbridge LPC" } ,
	{ 0x8086, 0x2680, "", "Enterprise Southbridge SATA cc=IDE" } ,
	{ 0x8086, 0x2681, "", "Enterprise Southbridge SATA cc=AHCI" } ,
	{ 0x8086, 0x2682, "", "Enterprise Southbridge SATA cc=RAID" } ,
	{ 0x8086, 0x2683, "", "Enterprise Southbridge SATA cc=RAID" } ,
	{ 0x8086, 0x2688, "", "Enterprise Southbridge UHCI USB #1" } ,
	{ 0x8086, 0x2689, "", "Enterprise Southbridge UHCI USB #2" } ,
	{ 0x8086, 0x268A, "", "Enterprise Southbridge UHCI USB #3" } ,
	{ 0x8086, 0x268B, "", "Enterprise Southbridge UHCI USB #4" } ,
	{ 0x8086, 0x268C, "", "Enterprise Southbridge EHCI USB" } ,
	{ 0x8086, 0x2690, "", "Enterprise Southbridge PCI Express Root Port 1" } ,
	{ 0x8086, 0x2692, "", "Enterprise Southbridge PCI Express Root Port 2" } ,
	{ 0x8086, 0x2694, "", "Enterprise Southbridge PCI Express Root Port 3" } ,
	{ 0x8086, 0x2696, "", "Enterprise Southbridge PCI Express Root Port 4" } ,
	{ 0x8086, 0x2698, "", "Enterprise Southbridge AC '97 Audio" } ,
	{ 0x8086, 0x2699, "", "Enterprise Southbridge AC '97 Modem" } ,
	{ 0x8086, 0x269A, "", "Enterprise Southbridge High Definition Audio" } ,
	{ 0x8086, 0x269B, "", "Enterprise Southbridge SMBus" } ,
	{ 0x8086, 0x269E, "", "Enterprise Southbridge PATA" } ,
	{ 0x8086, 0x2770, "", "945G/P Memory Controller Hub" } ,
	{ 0x8086, 0x2771, "", "945G/P PCI Express Graphics Port" } ,
	{ 0x8086, 0x2772, "", "945G Integrated Graphics Controller" } ,
	{ 0x8086, 0x2774, "", "955X Memory Controller Hub" } ,
	{ 0x8086, 0x2775, "", "955X PCI Express Graphics Port" } ,
	{ 0x8086, 0x2776, "", "945G Integrated Graphics Controller" } ,
	{ 0x8086, 0x2778, "", "E7230 Memory Controller Hub" } ,
	{ 0x8086, 0x2779, "", "E7230 PCI Express Root Port" } ,
	{ 0x8086, 0x277A, "", "PCI Express Graphics Port" } ,
	{ 0x8086, 0x277C, "", "Memory Controller Hub" } ,
	{ 0x8086, 0x277D, "", "PCI Express Graphics Port" } ,
	{ 0x8086, 0x2782, "", "82915G Express Chipset Family Graphics Controller" } ,
	{ 0x8086, 0x2792, "", "Mobile 915GM/GMS/910GML Express Graphics Controller" } ,
	{ 0x8086, 0x27A0, "", "Mobile Memory Controller Hub" } ,
	{ 0x8086, 0x27A1, "", "Mobile PCI Express Graphics Port" } ,
	{ 0x8086, 0x27A2, "", "Mobile Integrated Graphics Controller" } ,
	{ 0x8086, 0x27A6, "", "Mobile Integrated Graphics Controller" } ,
	{ 0x8086, 0x27B0, "", "82801GH (ICH7DH) LPC Interface Bridge" } ,
	{ 0x8086, 0x27B8, "", "82801GB/GR (ICH7 Family) LPC Interface Bridge" } ,
	{ 0x8086, 0x27B9, "", "82801GBM (ICH7-M) LPC Interface Bridge" } ,
	{ 0x8086, 0x27BD, "", "82801GHM (ICH7-M DH) LPC Interface Bridge" } ,
	{ 0x8086, 0x27C0, "", "82801GB/GR/GH (ICH7 Family) Serial ATA Storage Controllers cc=IDE" } ,
	{ 0x8086, 0x27C1, "", "82801GR/GH (ICH7 Family) Serial ATA Storage Controllers cc=AHCI" } ,
	{ 0x8086, 0x27C3, "", "82801GR/GH (ICH7 Family) Serial ATA Storage Controllers cc=RAID" } ,
	{ 0x8086, 0x27C4, "", "82801GBM/GHM (ICH7 Family) Serial ATA Storage Controllers cc=IDE" } ,
	{ 0x8086, 0x27C5, "", "82801GBM/GHM (ICH7 Family) Serial ATA Storage Controllers cc=AHCI" } ,
	{ 0x8086, 0x27C6, "", "82801GHM (ICH7-M DH) Serial ATA Storage Controllers cc=RAID" } ,
	{ 0x8086, 0x27C8, "", "82801G (ICH7 Family) USB UHCI #1" } ,
	{ 0x8086, 0x27C9, "", "82801G (ICH7 Family) USB UHCI #2" } ,
	{ 0x8086, 0x27CA, "", "82801G (ICH7 Family) USB UHCI #3" } ,
	{ 0x8086, 0x27CB, "", "82801G (ICH7 Family) USB UHCI #4" } ,
	{ 0x8086, 0x27CC, "", "82801G (ICH7 Family) USB2 EHCI Controller" } ,
	{ 0x8086, 0x27D0, "", "82801G (ICH7 Family) PCI Express Port 1" } ,
	{ 0x8086, 0x27D2, "", "82801G (ICH7 Family) PCI Express Port 2" } ,
	{ 0x8086, 0x27D4, "", "82801G (ICH7 Family) PCI Express Port 3" } ,
	{ 0x8086, 0x27D6, "", "82801G (ICH7 Family) PCI Express Port 4" } ,
	{ 0x8086, 0x27D8, "", "82801G (ICH7 Family) High Definition Audio Controller" } ,
	{ 0x8086, 0x27DA, "", "82801G (ICH7 Family) SMBus Controller" } ,
	{ 0x8086, 0x27DC, "", "82801G (ICH7 Family) LAN Controller" } ,
	{ 0x8086, 0x27DD, "", "82801G (ICH7 Family) AC'97 Modem Controller" } ,
	{ 0x8086, 0x27DE, "", "82801G (ICH7 Family) AC'97 Audio Controller" } ,
	{ 0x8086, 0x27DF, "", "82801G (ICH7 Family) IDE Controller" } ,
	{ 0x8086, 0x27E0, "", "82801GR/GH/GHM (ICH7 Family) PCI Express Port 5" } ,
	{ 0x8086, 0x27E2, "", "82801GR/GH/GHM (ICH7 Family) PCI Express Port 6" } ,
	{ 0x8086, 0x3092, "", "Integrated RAID" } ,
	{ 0x8086, 0x3200, "", "GD31244 PCI-X SATA HBA" } ,
	{ 0x8086, 0x3340, "", "82855PM Processor to I/O Controller" } ,
	{ 0x8086, 0x3341, "", "82855PM Processor to AGP Controller" } ,
	{ 0x8086, 0x3500, "", "Enterprise Southbridge PCI Express Upstream Port" } ,
	{ 0x8086, 0x3501, "", "Enterprise Southbridge PCI Express Upstream Port" } ,
	{ 0x8086, 0x3504, "", "Enterprise Southbridge IOxAPIC" } ,
	{ 0x8086, 0x3505, "", "Enterprise Southbridge IOxAPIC" } ,
	{ 0x8086, 0x350C, "", "Enterprise Southbridge PCI Express to PCI-X Bridge" } ,
	{ 0x8086, 0x350D, "", "Enterprise Southbridge PCI Express to PCI-X Bridge" } ,
	{ 0x8086, 0x3510, "", "Enterprise Southbridge PCI Express Downstream Port E1" } ,
	{ 0x8086, 0x3511, "", "Enterprise Southbridge PCI Express Downstream Port E1" } ,
	{ 0x8086, 0x3514, "", "Enterprise Southbridge PCI Express Downstream Port E2" } ,
	{ 0x8086, 0x3515, "", "Enterprise Southbridge PCI Express Downstream Port E2" } ,
	{ 0x8086, 0x3518, "", "Enterprise Southbridge PCI Express Downstream Port E3" } ,
	{ 0x8086, 0x3519, "", "Enterprise Southbridge PCI Express Downstream Port E3" } ,
	{ 0x8086, 0x3575, "", "82830 830 Chipset Host Bridge" } ,
	{ 0x8086, 0x3576, "", "82830 830 Chipset AGP Bridge" } ,
	{ 0x8086, 0x3577, "", "82830 CGC [Chipset Graphics Controller]" } ,
	{ 0x8086, 0x3578, "", "82830 830 Chipset Host Bridge" } ,
	{ 0x8086, 0x3580, "", "82852/82855 GM/GME/PM/GMV Processor to I/O Controller" } ,
	{ 0x8086, 0x3581, "", "82852/82855 GM/GME/PM/GMV Processor to AGP Controller" } ,
	{ 0x8086, 0x3582, "", "82852/855GM Integrated Graphics Device" } ,
	{ 0x8086, 0x3584, "", "82852/82855 GM/GME/PM/GMV Processor to I/O Controller" } ,
	{ 0x8086, 0x3585, "", "82852/82855 GM/GME/PM/GMV Processor to I/O Controller" } ,
	{ 0x8086, 0x3590, "", "E7520 Memory Controller Hub" } ,
	{ 0x8086, 0x3591, "", "E7525/E7520 Error Reporting Registers" } ,
	{ 0x8086, 0x3592, "", "E7320 Memory Controller Hub" } ,
	{ 0x8086, 0x3593, "", "E7320 Error Reporting Registers" } ,
	{ 0x8086, 0x3594, "", "E7520 DMA Controller" } ,
	{ 0x8086, 0x3595, "", "E7525/E7520/E7320 PCI Express Port A" } ,
	{ 0x8086, 0x3596, "", "E7525/E7520/E7320 PCI Express Port A1" } ,
	{ 0x8086, 0x3597, "", "E7525/E7520 PCI Express Port B" } ,
	{ 0x8086, 0x3598, "", "E7520 PCI Express Port B1" } ,
	{ 0x8086, 0x3599, "", "E7520 PCI Express Port C" } ,
	{ 0x8086, 0x359A, "", "E7520 PCI Express Port C1" } ,
	{ 0x8086, 0x359B, "", "E7525/E7520/E7320 Extended Configuration Registers" } ,
	{ 0x8086, 0x359E, "", "E7525 Memory Controller Hub" } ,
	{ 0x8086, 0x4220, "", "PRO/Wireless 2200BG" } ,
	{ 0x8086, 0x4223, "", "PRO/Wireless 2915ABG MiniPCI Adapter" } ,
	{ 0x8086, 0x4224, "", "PRO/Wireless 2915ABG MiniPCI Adapter" } ,
	{ 0x8086, 0x5200, "", "EtherExpress PRO/100 Intelligent Server" } ,
	{ 0x8086, 0x5201, "", "EtherExpress PRO/100 Intelligent Server" } ,
	{ 0x8086, 0x530D, "", "80310 IOP [IO Processor]" } ,
	{ 0x8086, 0x7000, "", "82371SB PIIX3 ISA [Natoma/Triton II]" } ,
	{ 0x8086, 0x7010, "", "82371SB PIIX3 IDE [Natoma/Triton II]" } ,
	{ 0x8086, 0x7020, "", "82371SB PIIX3 USB [Natoma/Triton II]" } ,
	{ 0x8086, 0x7030, "", "430VX - 82437VX TVX [Triton VX]" } ,
	{ 0x8086, 0x7050, "", "Intercast Video Capture Card" } ,
	{ 0x8086, 0x7051, "", "PB 642365-003 (Business Video Conferencing Card)" } ,
	{ 0x8086, 0x7100, "", "430TX - 82439TX MTXC" } ,
	{ 0x8086, 0x7110, "", "82371AB/EB/MB PIIX4 ISA" } ,
	{ 0x8086, 0x7111, "", "82371AB/EB/MB PIIX4 IDE" } ,
	{ 0x8086, 0x7112, "", "82371AB/EB/MB PIIX4 USB" } ,
	{ 0x8086, 0x7113, "", "82371AB/EB/MB PIIX4 ACPI" } ,
	{ 0x8086, 0x7120, "", "82810 GMCH [Graphics Memory Controller Hub]" } ,
	{ 0x8086, 0x7121, "", "82810 CGC [Chipset Graphics Controller]" } ,
	{ 0x8086, 0x7122, "", "82810 DC-100 GMCH [Graphics Memory Controller Hub]" } ,
	{ 0x8086, 0x7123, "", "82810 DC-100 CGC [Chipset Graphics Controller]" } ,
	{ 0x8086, 0x7124, "", "82810E DC-133 GMCH [Graphics Memory Controller Hub]" } ,
	{ 0x8086, 0x7125, "", "82810E DC-133 CGC [Chipset Graphics Controller]" } ,
	{ 0x8086, 0x7126, "", "82810 DC-133 System and Graphics Controller" } ,
	{ 0x8086, 0x7128, "", "82810-M DC-100 System and Graphics Controller" } ,
	{ 0x8086, 0x712A, "", "82810-M DC-133 System and Graphics Controller" } ,
	{ 0x8086, 0x7180, "", "440LX/EX - 82443LX/EX Host bridge" } ,
	{ 0x8086, 0x7181, "", "440LX/EX - 82443LX/EX AGP bridge" } ,
	{ 0x8086, 0x7190, "", "440BX/ZX/DX - 82443BX/ZX/DX Host bridge" } ,
	{ 0x8086, 0x7191, "", "440BX/ZX/DX - 82443BX/ZX/DX AGP bridge" } ,
	{ 0x8086, 0x7192, "", "440BX/ZX/DX - 82443BX/ZX/DX Host bridge (AGP disabled)" } ,
	{ 0x8086, 0x7194, "", "82440MX Host Bridge" } ,
	{ 0x8086, 0x7195, "", "82440MX AC'97 Audio Controller" } ,
	{ 0x8086, 0x7196, "", "82440MX AC'97 Modem Controller" } ,
	{ 0x8086, 0x7198, "", "82440MX ISA Bridge" } ,
	{ 0x8086, 0x7199, "", "82440MX EIDE Controller" } ,
	{ 0x8086, 0x719A, "", "82440MX USB Universal Host Controller" } ,
	{ 0x8086, 0x719B, "", "82440MX Power Management Controller" } ,
	{ 0x8086, 0x71A0, "", "440GX - 82443GX Host bridge" } ,
	{ 0x8086, 0x71A1, "", "440GX - 82443GX AGP bridge" } ,
	{ 0x8086, 0x71A2, "", "440GX - 82443GX Host bridge (AGP disabled)" } ,
	{ 0x8086, 0x7600, "", "82372FB PIIX5 ISA" } ,
	{ 0x8086, 0x7601, "", "82372FB PIIX5 IDE" } ,
	{ 0x8086, 0x7602, "", "82372FB PIIX5 USB" } ,
	{ 0x8086, 0x7603, "", "82372FB PIIX5 SMBus" } ,
	{ 0x8086, 0x7800, "", "82740 (i740) AGP Graphics Accelerator" } ,
	{ 0x8086, 0x84C4, "", "450KX/GX [Orion] - 82454KX/GX PCI bridge" } ,
	{ 0x8086, 0x84C5, "", "450KX/GX [Orion] - 82453KX/GX Memory controller" } ,
	{ 0x8086, 0x84CA, "", "450NX - 82451NX Memory & I/O Controller" } ,
	{ 0x8086, 0x84CB, "", "450NX - 82454NX/84460GX PCI Expander Bridge" } ,
	{ 0x8086, 0x84E0, "", "460GX - 84460GX System Address Controller (SAC)" } ,
	{ 0x8086, 0x84E1, "", "460GX - 84460GX System Data Controller (SDC)" } ,
	{ 0x8086, 0x84E2, "", "460GX - 84460GX AGP Bridge (GXB function 2)" } ,
	{ 0x8086, 0x84E3, "", "460GX - 84460GX Memory Address Controller (MAC)" } ,
	{ 0x8086, 0x84E4, "", "460GX - 84460GX Memory Data Controller (MDC)" } ,
	{ 0x8086, 0x84E6, "", "460GX - 82466GX Wide and fast PCI eXpander Bridge (WXB)" } ,
	{ 0x8086, 0x84EA, "", "460GX - 84460GX AGP Bridge (GXB function 1)" } ,
	{ 0x8086, 0x8500, "", "IXP4XX Intel Network Processor (IXP420/421/422/425/IXC1100)" } ,
	{ 0x8086, 0x9000, "", "IXP2000 Family Network Processor" } ,
	{ 0x8086, 0x9001, "", "IXP2400 Network Processor" } ,
	{ 0x8086, 0x9004, "", "IXP2800 Network Processor" } ,
	{ 0x8086, 0x9621, "", "Integrated RAID" } ,
	{ 0x8086, 0x9622, "", "Integrated RAID" } ,
	{ 0x8086, 0x9641, "", "Integrated RAID" } ,
	{ 0x8086, 0x96A1, "", "Integrated RAID" } ,
	{ 0x8086, 0xB152, "", "21152 PCI-to-PCI Bridge" } ,
	{ 0x8086, 0xB154, "", "21154 PCI-to-PCI Bridge" } ,
	{ 0x8086, 0xB555, "", "21555 Non transparent PCI-to-PCI Bridge" } ,
	{ 0x8800, 0x2008, "", "Video assistent component" } ,
	{ 0x8C4A, 0x1980, "", "W89C940 misprogrammed [ne2k]" } ,
	{ 0x8E2E, 0x3000, "", "ET32P2" } ,
	{ 0x9004, 0x0078, "", "AHA-2940U_CN" } ,
	{ 0x9004, 0x1078, "", "AIC-7810" } ,
	{ 0x9004, 0x1160, "", "AIC-1160 [Family Fibre Channel Adapter]" } ,
	{ 0x9004, 0x2178, "", "AIC-7821" } ,
	{ 0x9004, 0x3860, "", "AHA-2930CU" } ,
	{ 0x9004, 0x3B78, "", "AHA-4844W/4844UW" } ,
	{ 0x9004, 0x5075, "", "AIC-755x" } ,
	{ 0x9004, 0x5078, "", "AHA-7850" } ,
	{ 0x9004, 0x5175, "", "AIC-755x" } ,
	{ 0x9004, 0x5178, "", "AIC-7851" } ,
	{ 0x9004, 0x5275, "", "AIC-755x" } ,
	{ 0x9004, 0x5278, "", "AIC-7852" } ,
	{ 0x9004, 0x5375, "", "AIC-755x" } ,
	{ 0x9004, 0x5378, "", "AIC-7850" } ,
	{ 0x9004, 0x5475, "", "AIC-755x" } ,
	{ 0x9004, 0x5478, "", "AIC-7850" } ,
	{ 0x9004, 0x5575, "", "AVA-2930" } ,
	{ 0x9004, 0x5578, "", "AIC-7855" } ,
	{ 0x9004, 0x5647, "", "ANA-7711 TCP Offload Engine" } ,
	{ 0x9004, 0x5675, "", "AIC-755x" } ,
	{ 0x9004, 0x5678, "", "AIC-7856" } ,
	{ 0x9004, 0x5775, "", "AIC-755x" } ,
	{ 0x9004, 0x5778, "", "AIC-7850" } ,
	{ 0x9004, 0x5800, "", "AIC-5800" } ,
	{ 0x9004, 0x5900, "", "ANA-5910/5930/5940 ATM155 & 25 LAN Adapter" } ,
	{ 0x9004, 0x5905, "", "ANA-5910A/5930A/5940A ATM Adapter" } ,
	{ 0x9004, 0x6038, "", "AIC-3860" } ,
	{ 0x9004, 0x6075, "", "AIC-1480 / APA-1480" } ,
	{ 0x9004, 0x6078, "", "AIC-7860" } ,
	{ 0x9004, 0x6178, "", "AIC-7861" } ,
	{ 0x9004, 0x6278, "", "AIC-7860" } ,
	{ 0x9004, 0x6378, "", "AIC-7860" } ,
	{ 0x9004, 0x6478, "", "AIC-786x" } ,
	{ 0x9004, 0x6578, "", "AIC-786x" } ,
	{ 0x9004, 0x6678, "", "AIC-786x" } ,
	{ 0x9004, 0x6778, "", "AIC-786x" } ,
	{ 0x9004, 0x6915, "", "ANA620xx/ANA69011A" } ,
	{ 0x9004, 0x7078, "", "AHA-294x / AIC-7870" } ,
	{ 0x9004, 0x7178, "", "AHA-2940/2940W / AIC-7871" } ,
	{ 0x9004, 0x7278, "", "AHA-3940/3940W / AIC-7872" } ,
	{ 0x9004, 0x7378, "", "AHA-3985 / AIC-7873" } ,
	{ 0x9004, 0x7478, "", "AHA-2944/2944W / AIC-7874" } ,
	{ 0x9004, 0x7578, "", "AHA-3944/3944W / AIC-7875" } ,
	{ 0x9004, 0x7678, "", "AHA-4944W/UW / AIC-7876" } ,
	{ 0x9004, 0x7710, "", "ANA-7711F Network Accelerator Card (NAC) - Optical" } ,
	{ 0x9004, 0x7711, "", "ANA-7711C Network Accelerator Card (NAC) - Copper" } ,
	{ 0x9004, 0x7778, "", "AIC-787x" } ,
	{ 0x9004, 0x7810, "", "AIC-7810" } ,
	{ 0x9004, 0x7815, "", "AIC-7815 RAID+Memory Controller IC" } ,
	{ 0x9004, 0x7850, "", "AIC-7850" } ,
	{ 0x9004, 0x7855, "", "AHA-2930" } ,
	{ 0x9004, 0x7860, "", "AIC-7860" } ,
	{ 0x9004, 0x7870, "", "AIC-7870" } ,
	{ 0x9004, 0x7871, "", "AHA-2940" } ,
	{ 0x9004, 0x7872, "", "AHA-3940" } ,
	{ 0x9004, 0x7873, "", "AHA-3980" } ,
	{ 0x9004, 0x7874, "", "AHA-2944" } ,
	{ 0x9004, 0x7880, "", "AIC-7880P" } ,
	{ 0x9004, 0x7890, "", "AIC-7890" } ,
	{ 0x9004, 0x7891, "", "AIC-789x" } ,
	{ 0x9004, 0x7892, "", "AIC-789x" } ,
	{ 0x9004, 0x7893, "", "AIC-789x" } ,
	{ 0x9004, 0x7894, "", "AIC-789x" } ,
	{ 0x9004, 0x7895, "", "AHA-2940U/UW / AHA-39xx / AIC-7895" } ,
	{ 0x9004, 0x7896, "", "AIC-789x" } ,
	{ 0x9004, 0x7897, "", "AIC-789x" } ,
	{ 0x9004, 0x8078, "", "AIC-7880U" } ,
	{ 0x9004, 0x8178, "", "AHA-2940U/UW/D / AIC-7881U" } ,
	{ 0x9004, 0x8278, "", "AHA-3940U/UW/UWD / AIC-7882U" } ,
	{ 0x9004, 0x8378, "", "AHA-3940U/UW / AIC-7883U" } ,
	{ 0x9004, 0x8478, "", "AHA-2944UW / AIC-7884U" } ,
	{ 0x9004, 0x8578, "", "AHA-3944U/UWD / AIC-7885" } ,
	{ 0x9004, 0x8678, "", "AHA-4944UW / AIC-7886" } ,
	{ 0x9004, 0x8778, "", "AHA-2940UW Pro / AIC-788x" } ,
	{ 0x9004, 0x8878, "", "AHA-2930UW / AIC-7888" } ,
	{ 0x9004, 0x8B78, "", "ABA-1030" } ,
	{ 0x9004, 0xEC78, "", "AHA-4944W/UW" } ,
	{ 0x9005, 0x0010, "", "AHA-2940U2/U2W" } ,
	{ 0x9005, 0x0011, "", "AHA-2930U2" } ,
	{ 0x9005, 0x0013, "", "78902" } ,
	{ 0x9005, 0x001F, "", "AHA-2940U2/U2W / 7890/7891" } ,
	{ 0x9005, 0x0020, "", "AIC-7890" } ,
	{ 0x9005, 0x002F, "", "AIC-7890" } ,
	{ 0x9005, 0x0030, "", "AIC-7890" } ,
	{ 0x9005, 0x003F, "", "AIC-7890" } ,
	{ 0x9005, 0x0050, "", "AHA-3940U2x/395U2x" } ,
	{ 0x9005, 0x0051, "", "AHA-3950U2D" } ,
	{ 0x9005, 0x0053, "", "AIC-7896 SCSI Controller" } ,
	{ 0x9005, 0x005F, "", "AIC-7896U2/7897U2" } ,
	{ 0x9005, 0x0080, "", "AIC-7892A U160/m" } ,
	{ 0x9005, 0x0081, "", "AIC-7892B U160/m" } ,
	{ 0x9005, 0x0083, "", "AIC-7892D U160/m" } ,
	{ 0x9005, 0x008F, "", "AIC-7892P U160/m" } ,
	{ 0x9005, 0x00C0, "", "AHA-3960D / AIC-7899A U160/m" } ,
	{ 0x9005, 0x00C1, "", "AIC-7899B U160/m" } ,
	{ 0x9005, 0x00C3, "", "AIC-7899D U160/m" } ,
	{ 0x9005, 0x00C5, "", "RAID subsystem HBA" } ,
	{ 0x9005, 0x00CF, "", "AIC-7899P U160/m" } ,
	{ 0x9005, 0x0241, "", "Serial ATA II RAID 1420SA" } ,
	{ 0x9005, 0x0250, "", "ServeRAID Controller" } ,
	{ 0x9005, 0x0279, "", "ServeRAID 6M" } ,
	{ 0x9005, 0x0283, "", "AAC-RAID" } ,
	{ 0x9005, 0x0284, "", "AAC-RAID" } ,
	{ 0x9005, 0x0285, "", "AAC-RAID" } ,
	{ 0x9005, 0x0286, "", "AAC-RAID (Rocket)" } ,
	{ 0x9005, 0x0503, "", "Scamp chipset SCSI controller" } ,
	{ 0x9005, 0x0910, "", "AUA-3100B" } ,
	{ 0x9005, 0x091E, "", "AUA-3100B" } ,
	{ 0x9005, 0x8000, "", "ASC-29320A U320" } ,
	{ 0x9005, 0x800F, "", "AIC-7901 U320" } ,
	{ 0x9005, 0x8010, "", "ASC-39320 U320" } ,
	{ 0x9005, 0x8011, "", "ASC-39320D" } ,
	{ 0x9005, 0x8012, "", "ASC-29320 U320" } ,
	{ 0x9005, 0x8013, "", "ASC-29320B U320" } ,
	{ 0x9005, 0x8014, "", "ASC-29320LP U320" } ,
	{ 0x9005, 0x8015, "", "ASC-39320B U320" } ,
	{ 0x9005, 0x8016, "", "ASC-39320A U320" } ,
	{ 0x9005, 0x8017, "", "ASC-29320ALP U320" } ,
	{ 0x9005, 0x801C, "", "ASC-39320D U320" } ,
	{ 0x9005, 0x801D, "", "AIC-7902B U320" } ,
	{ 0x9005, 0x801E, "", "AIC-7901A U320" } ,
	{ 0x9005, 0x801F, "", "AIC-7902 U320" } ,
	{ 0x9005, 0x8080, "", "ASC-29320A U320 w/HostRAID" } ,
	{ 0x9005, 0x808F, "", "AIC-7901 U320 w/HostRAID" } ,
	{ 0x9005, 0x8090, "", "ASC-39320 U320 w/HostRAID" } ,
	{ 0x9005, 0x8091, "", "ASC-39320D U320 w/HostRAID" } ,
	{ 0x9005, 0x8092, "", "ASC-29320 U320 w/HostRAID" } ,
	{ 0x9005, 0x8093, "", "ASC-29320B U320 w/HostRAID" } ,
	{ 0x9005, 0x8094, "", "ASC-29320LP U320 w/HostRAID" } ,
	{ 0x9005, 0x8095, "", "ASC-39320(B) U320 w/HostRAID" } ,
	{ 0x9005, 0x8096, "", "ASC-39320A U320 w/HostRAID" } ,
	{ 0x9005, 0x8097, "", "ASC-29320ALP U320 w/HostRAID" } ,
	{ 0x9005, 0x809C, "", "ASC-39320D(B) U320 w/HostRAID" } ,
	{ 0x9005, 0x809D, "", "AIC-7902(B) U320 w/HostRAID" } ,
	{ 0x9005, 0x809E, "", "AIC-7901A U320 w/HostRAID" } ,
	{ 0x9005, 0x809F, "", "AIC-7902 U320 w/HostRAID" } ,
	{ 0x907F, 0x2015, "", "IDE-2015PL" } ,
	{ 0x9412, 0x6565, "", "6565" } ,
	{ 0x9699, 0x6565, "", "6565" } ,
	{ 0x9710, 0x7780, "", "USB IRDA-port" } ,
	{ 0x9710, 0x9805, "", "PCI 1 port parallel adapter" } ,
	{ 0x9710, 0x9815, "", "PCI 9815 Multi-I/O Controller" } ,
	{ 0x9710, 0x9835, "", "PCI 9835 Multi-I/O Controller" } ,
	{ 0x9710, 0x9845, "", "PCI 9845 Multi-I/O Controller" } ,
	{ 0x9710, 0x9855, "", "PCI 9855 Multi-I/O Controller" } ,
	{ 0x9902, 0x0001, "", "SG2010 PCI over Starfabric Bridge" } ,
	{ 0x9902, 0x0002, "", "SG2010 PCI to Starfabric Gateway" } ,
	{ 0x9902, 0x0003, "", "SG1010 Starfabric Switch and PCI Bridge" } ,
	{ 0xA727, 0x0013, "", "3CRPAG175 Wireless PC Card" } ,
	{ 0xAECB, 0x6250, "", "VITC/LTC Timecode Reader card [PCI-VLTC/RDR]" } ,
	{ 0xCDDD, 0x0101, "", "DeepSea 1 High Speed Stereo Vision Frame Grabber" } ,
	{ 0xCDDD, 0x0200, "", "DeepSea 2 High Speed Stereo Vision Frame Grabber" } ,
	{ 0xD161, 0x0205, "", "Wildcard TE205P" } ,
	{ 0xD161, 0x0210, "", "Wildcard TE210P" } ,
	{ 0xD161, 0x0405, "", "Wildcard TE405P (2nd Gen)" } ,
	{ 0xD161, 0x0410, "", "Wildcard TE410P (2nd Gen)" } ,
	{ 0xD4D4, 0x0601, "", "PCI Mezzanine Card" } ,
	{ 0xDEAF, 0x9050, "", "PC Weasel Virtual VGA" } ,
	{ 0xDEAF, 0x9051, "", "PC Weasel Serial Port" } ,
	{ 0xDEAF, 0x9052, "", "PC Weasel Watchdog Timer" } ,
	{ 0xE000, 0xE000, "", "W89C940" } ,
	{ 0xE159, 0x0001, "", "Tiger3XX Modem/ISDN interface" } ,
	{ 0xE159, 0x0002, "", "Tiger100APC ISDN chipset" } ,
	{ 0xEA60, 0x9896, "", "Digi32" } ,
	{ 0xEA60, 0x9897, "", "Digi32 Pro" } ,
	{ 0xEA60, 0x9898, "", "Digi32/8" } ,
	{ 0xEACE, 0x3100, "", "DAG 3.10 OC-3/OC-12" } ,
	{ 0xEACE, 0x3200, "", "DAG 3.2x OC-3/OC-12" } ,
	{ 0xEACE, 0x320E, "", "DAG 3.2E Fast Ethernet" } ,
	{ 0xEACE, 0x340E, "", "DAG 3.4E Fast Ethernet" } ,
	{ 0xEACE, 0x341E, "", "DAG 3.41E Fast Ethernet" } ,
	{ 0xEACE, 0x3500, "", "DAG 3.5 OC-3/OC-12" } ,
	{ 0xEACE, 0x351C, "", "DAG 3.5ECM Fast Ethernet" } ,
	{ 0xEACE, 0x4100, "", "DAG 4.10 OC-48" } ,
	{ 0xEACE, 0x4110, "", "DAG 4.11 OC-48" } ,
	{ 0xEACE, 0x4220, "", "DAG 4.2 OC-48" } ,
	{ 0xEACE, 0x422E, "", "DAG 4.2E Dual Gigabit Ethernet" } ,
	{ 0xEC80, 0xEC00, "", "F5D6000" } ,
	{ 0xEDD8, 0xA091, "", "1000PV [Stingray]" } ,
	{ 0xEDD8, 0xA099, "", "2000PV [Stingray]" } ,
	{ 0xEDD8, 0xA0A1, "", "2000MT" } ,
	{ 0xEDD8, 0xA0A9, "", "2000MI" } ,
	{ 0xF1D0, 0xC0FE, "", "Xena HS/HD-R" } ,
	{ 0xF1D0, 0xC0FF, "", "Kona/Xena 2" } ,
	{ 0xF1D0, 0xCAFE, "", "Kona SD" } ,
	{ 0xF1D0, 0xCFEE, "", "Xena LS/SD-22-DA/SD-DA" } ,
	{ 0xF1D0, 0xDCAF, "", "Kona HD" } ,
	{ 0xF1D0, 0xDFEE, "", "Xena HD-DA" } ,
	{ 0xF1D0, 0xEFAC, "", "Xena SD-MM/SD-22-MM" } ,
	{ 0xF1D0, 0xFACD, "", "Xena HD-MM" } ,
	{ 0xFA57, 0x0001, "", "PMC [Pattern Matching Chip]" } ,
	{ 0xFEDA, 0xA0FA, "", "BCM4210 iLine10 HomePNA 2.0" } ,
	{ 0xFEDA, 0xA10E, "", "BCM4230 iLine10 HomePNA 2.0" } ,
	{ 0xFEDE, 0x0003, "", "TABIC PCI v3" } ,
	{ 0xFFFE, 0x0405, "", "Virtual SVGA 4.0" } ,
	{ 0xFFFE, 0x0710, "", "Virtual SVGA" } ,
	{ 0xFFFF, 0xFFFF, "NO-DEVICE", "No device on PCI bus" } ,
} ;

/* Use this value for loop control during searching: */
#define	PCI_DEVTABLE_LEN	(sizeof(PciDevTable)/sizeof(PCI_DEVTABLE))


